#!/bin/sh
TINE_HOME_DIR=/usr/etc/tine
TINE_HOME_ENTRY=TINE_HOME=\"$TINE_HOME_DIR\"
SCRIPT_DIR=/opt/scripts
ENVIRONMENT_FILE=/etc/environment
INIT_DIR=/etc/init.d
USER_HOME=/home/ucs
DESKTOP_DIR=$USER_HOME/Desktop
AUTOSTART_DIR=$USER_HOME/.config/autostart

# TINE_HOME setzen, falls nicht vorhanden
if grep -q "TINE_HOME" $ENVIRONMENT_FILE; then  
	echo "TINE_HOME exists already"  
else  
	echo "TINE_HOME doesn't exist, will create it."
	echo $TINE_HOME_ENTRY >> $ENVIRONMENT_FILE    
fi

rm -Rf $SCRIPT_DIR
mkdir -p $SCRIPT_DIR

# Ini-File kopieren, FEC_NAME erfragen und diesen ersetzen
cp -u ./config/ucs.ini $TINE_HOME_DIR
echo "Enter the unique FEC_NAME (e.g. MODxx)?"
read answer
sed -i -e "/FEC_NAME =/ s/= .*/= ${answer}/" $TINE_HOME_DIR/ucs.ini 

# Start/Stop Skripte kopieren
cp ./scripts/startGUI.sh $SCRIPT_DIR
chmod a+x $SCRIPT_DIR/startGUI.sh

cp ./scripts/startTineServer.sh $SCRIPT_DIR
chmod a+x $SCRIPT_DIR/startTineServer.sh

cp ./scripts/stopTineServer.sh $SCRIPT_DIR
chmod a+x $SCRIPT_DIR/stopTineServer.sh

chown -R ucs:ucs $SCRIPT_DIR

# ENS-Daemon Start Links lschen, falls vorhanden
update-rc.d -f ens remove

# TineServer Daemon installieren
cp ./scripts/tineserver $INIT_DIR
chmod a+x $INIT_DIR/tineserver
update-rc.d tineserver defaults 21

# Verknpfungen auf Desktop installieren
cp ./scripts/GUI.desktop $DESKTOP_DIR
chown ucs:ucs $DESKTOP_DIR/GUI.desktop

cp ./scripts/JClient.desktop $DESKTOP_DIR
chown ucs:ucs $DESKTOP_DIR/JClient.desktop

mkdir -p $AUTOSTART_DIR
cp ./scripts/GUI_Autostart.desktop $AUTOSTART_DIR
chown -R ucs:ucs $AUTOSTART_DIR
