package ch.thomson.ucs.alarms;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.osgi.util.NLS;

public class Alarms extends NLS {
	
	public class BitVectorPosition {
		private int arrayIndex;
		private int mask;
		
		public BitVectorPosition(int arrayIndex, int mask) {
			this.arrayIndex = arrayIndex;
			this.mask = mask;
		}
		
		public int getArrayIndex() {
			return arrayIndex;
		}
		public int getMask() {
			return mask;
		}
		
		
		@Override
		public boolean equals(Object obj) {
			if(!(obj instanceof BitVectorPosition))
				return false;
			
			BitVectorPosition bvp = (BitVectorPosition) obj;
			if(bvp.getArrayIndex() != this.getArrayIndex())
				return false;
			
			if(bvp.getMask() != this.getMask())
				return false;
			
			return true;
		}

		@Override
		public String toString() {
			return "ArrayIndex=" + arrayIndex + ", Mask=" + mask;
		}
	}
	
	private BitVectorPosition createBitVectorPosition(int arrayIndex, int mask) {
		return new BitVectorPosition(arrayIndex, mask);
	}
	
	public static String translateToMessageID(int arrayIndex, int bitPosition) {
		return String.format("M%04d", arrayIndex * 32 + bitPosition + 1);
	}
	
	public static BitVectorPosition translateToBitVectorPosition(String messageId) {
		return map.get(messageId);
	}
	
	private static final String BUNDLE_NAME = "ch.thomson.ucs.alarms.resources.messages"; //$NON-NLS-1$
	
	protected static Map<String, BitVectorPosition> map = new HashMap<String, BitVectorPosition>();
	protected static List<String> ids = new LinkedList<String>();

	static {
        NLS.initializeMessages(BUNDLE_NAME, Alarms.class);
        
        // Map fr die Bitvector Positionen erzeugen
        Alarms alarms = new Alarms();
        Class<?> c = Alarms.class;
        int arrayIndex = 0;
        int mask = 0;
        for(Field field : c.getDeclaredFields()) {
        	// Feldnamen filtern
        	if(!field.getName().matches("M[0-9]{4}") && !field.getName().matches("UNDEFINED"))
        		continue;
        	
        	BitVectorPosition bvp = alarms.createBitVectorPosition(arrayIndex / 32, (int) Math.pow(2, mask % 32));
        	map.put(field.getName(), bvp);
        	ids.add(field.getName());
        	arrayIndex++;
        	mask++;
        }
    }
	
	public static String getString(String key) {
		// Die statische Varible ber Reflection suchen
		Class<?> c = Alarms.class;
		try {
			Field field = c.getDeclaredField(key);
			return (String) field.get(null);
		} catch (Exception e) {
			return "!" + key + "!"; //Key konnte nicht gefunden werden
		}
	}
	
	public static String[] getIds() {
		return ids.toArray(new String[0]);
	}

	public static String M0001;
	public static String M0002;
	public static String M0003;
	public static String M0004;
	public static String M0005;
	public static String M0006;
	public static String M0007;
	public static String M0008;
	public static String M0009;
	public static String M0010;
	public static String M0011;
	public static String M0012;
	public static String M0013;
	public static String M0014;
	public static String M0015;
	public static String M0016;
	public static String M0017;
	public static String M0018;
	public static String M0019;
	public static String M0020;
	public static String M0021;
	public static String M0022;
	public static String M0023;
	public static String M0024;
	public static String M0025;
	public static String M0026;
	public static String M0027;
	public static String M0028;
	public static String M0029;
	public static String M0030;
	public static String M0031;
	public static String M0032;
	public static String M0033;
	public static String M0034;
	public static String M0035;
	public static String M0036;
	public static String M0037;
	public static String M0038;
	public static String M0039;
	public static String M0040;
	public static String M0041;
	public static String M0042;
	public static String M0043;
	public static String M0044;
	public static String M0045;
	public static String M0046;
	public static String M0047;
	public static String M0048;
	public static String M0049;
	public static String M0050;
	public static String M0051;
	public static String M0052;
	public static String M0053;
	public static String M0054;
	public static String M0055;
	public static String M0056;
	public static String M0057;
	public static String M0058;
	public static String M0059;
	public static String M0060;
	public static String M0061;
	public static String M0062;
	public static String M0063;
	public static String M0064;
	public static String M0065;
	public static String M0066;
	public static String M0067;
	public static String M0068;
	public static String M0069;
	public static String M0070;
	public static String M0071;
	public static String M0072;
	public static String M0073;
	public static String M0074;
	public static String M0075;
	public static String M0076;
	public static String M0077;
	public static String M0078;
	public static String M0079;
	public static String M0080;
	public static String M0081;
	public static String M0082;
	public static String M0083;
	public static String M0084;
	public static String M0085;
	public static String M0086;
	public static String M0087;
	public static String M0088;
	public static String M0089;
	public static String M0090;
	public static String M0091;
	public static String M0092;
	public static String M0093;
	public static String M0094;
	public static String M0095;
	public static String M0096;
	public static String M0097;
	public static String M0098;
	public static String M0099;
	public static String M0100;
	public static String M0101;
	public static String M0102;
	public static String M0103;
	public static String M0104;
	public static String M0105;
	public static String M0106;
	public static String M0107;
	public static String M0108;
	public static String M0109;
	public static String M0110;
	public static String M0111;
	public static String M0112;
	public static String M0113;
	public static String M0114;
	public static String M0115;
	public static String M0116;
	public static String M0117;
	public static String M0118;
	public static String M0119;
	public static String M0120;
	public static String M0121;
	public static String M0122;
	public static String M0123;
	public static String M0124;
	public static String M0125;
	public static String M0126;
	public static String M0127;
	public static String M0128;
	public static String M0129;
	public static String M0130;
	public static String M0131;
	public static String M0132;
	public static String M0133;
	public static String M0134;
	public static String M0135;
	public static String M0136;
	public static String M0137;
	public static String M0138;
	public static String M0139;
	public static String M0140;
	public static String M0141;
	public static String M0142;
	public static String M0143;
	public static String M0144;
	public static String M0145;
	public static String M0146;
	public static String M0147;
	public static String M0148;
	public static String M0149;
	public static String M0150;
	public static String M0151;
	public static String M0152;
	public static String M0153;
	public static String M0154;
	public static String M0155;
	public static String M0156;
	public static String M0157;
	public static String M0158;
	public static String M0159;
	public static String M0160;
	public static String M0161;
	public static String M0162;
	public static String M0163;
	public static String M0164;
	public static String M0165;
	public static String M0166;
	public static String M0167;
	public static String M0168;
	public static String M0169;
	public static String M0170;
	public static String M0171;
	public static String M0172;
	public static String M0173;
	public static String M0174;
	public static String M0175;
	public static String M0176;
	public static String M0177;
	public static String M0178;
	public static String M0179;
	public static String M0180;
	public static String M0181;
	public static String M0182;
	public static String M0183;
	public static String M0184;
	public static String M0185;
	public static String M0186;
	public static String M0187;
	public static String M0188;
	public static String M0189;
	public static String M0190;
	public static String M0191;
	public static String M0192;
	public static String M0193;
	public static String M0194;
	public static String M0195;
	public static String M0196;
	public static String M0197;
	public static String M0198;
	public static String M0199;
	public static String M0200;
	public static String M0201;
	public static String M0202;
	public static String M0203;
	public static String M0204;
	public static String M0205;
	public static String M0206;
	public static String M0207;
	public static String M0208;
	public static String M0209;
	public static String M0210;
	public static String M0211;
	public static String M0212;
	public static String M0213;
	public static String M0214;
	public static String M0215;
	public static String M0216;
	public static String M0217;
	public static String M0218;
	public static String M0219;
	public static String M0220;
	public static String M0221;
	public static String M0222;
	public static String M0223;
	public static String M0224;
	public static String M0225;
	public static String M0226;
	public static String M0227;
	public static String M0228;
	public static String M0229;
	public static String M0230;
	public static String M0231;
	public static String M0232;
	public static String M0233;
	public static String M0234;
	public static String M0235;
	public static String M0236;
	public static String M0237;
	public static String M0238;
	public static String M0239;
	public static String M0240;
	public static String M0241;
	public static String M0242;
	public static String M0243;
	public static String M0244;
	public static String M0245;
	public static String M0246;
	public static String M0247;
	public static String M0248;
	public static String M0249;
	public static String M0250;
	public static String M0251;
	public static String M0252;
	public static String M0253;
	public static String M0254;
	public static String M0255;
	public static String M0256;
	public static String M0257;
	public static String M0258;
	public static String M0259;
	public static String M0260;
	public static String M0261;
	public static String M0262;
	public static String M0263;
	public static String M0264;
	public static String M0265;
	public static String M0266;
	public static String M0267;
	public static String M0268;
	public static String M0269;
	public static String M0270;
	public static String M0271;
	public static String M0272;
	public static String M0273;
	public static String M0274;
	public static String M0275;
	public static String M0276;
	public static String M0277;
	public static String M0278;
	public static String M0279;
	public static String M0280;
	public static String M0281;
	public static String M0282;
	public static String M0283;
	public static String M0284;
	public static String M0285;
	public static String M0286;
	public static String M0287;
	public static String M0288;
	public static String M0289;
	public static String M0290;
	public static String M0291;
	public static String M0292;
	public static String M0293;
	public static String M0294;
	public static String M0295;
	public static String M0296;
	public static String M0297;
	public static String M0298;
	public static String M0299;
	public static String M0300;
	public static String M0301;
	public static String M0302;
	public static String M0303;
	public static String M0304;
	public static String M0305;
	public static String M0306;
	public static String M0307;
	public static String M0308;
	public static String M0309;
	public static String M0310;
	public static String M0311;
	public static String M0312;
	public static String M0313;
	public static String M0314;
	public static String M0315;
	public static String M0316;
	public static String M0317;
	public static String M0318;
	public static String M0319;
	public static String M0320;
	public static String M0321;
	public static String M0322;
	public static String M0323;
	public static String M0324;
	public static String M0325;
	public static String M0326;
	public static String M0327;
	public static String M0328;
	public static String M0329;
	public static String M0330;
	public static String M0331;
	public static String M0332;
	public static String M0333;
	public static String M0334;
	public static String M0335;
	public static String M0336;
	public static String M0337;
	public static String M0338;
	public static String M0339;
	public static String M0340;
	public static String M0341;
	public static String M0342;
	public static String M0343;
	public static String M0344;
	public static String M0345;
	public static String M0346;
	public static String M0347;
	public static String M0348;
	public static String M0349;
	public static String M0350;
	public static String M0351;
	public static String M0352;
	public static String M0353;
	public static String M0354;
	public static String M0355;
	public static String M0356;
	public static String M0357;
	public static String M0358;
	public static String M0359;
	public static String M0360;
	public static String M0361;
	public static String M0362;
	public static String M0363;
	public static String M0364;
	public static String M0365;
	public static String M0366;
	public static String M0367;
	public static String M0368;
	public static String M0369;
	public static String M0370;
	public static String M0371;
	public static String M0372;
	public static String M0373;
	public static String M0374;
	public static String M0375;
	public static String M0376;
	public static String M0377;
	public static String M0378;
	public static String M0379;
	public static String M0380;
	public static String M0381;
	public static String M0382;
	public static String M0383;
	public static String M0384;
	public static String M0385;
	public static String M0386;
	public static String M0387;
	public static String M0388;
	public static String M0389;
	public static String M0390;
	public static String M0391;
	public static String M0392;
	public static String M0393;
	public static String M0394;
	public static String M0395;
	public static String M0396;
	public static String M0397;
	public static String M0398;
	public static String M0399;
	public static String M0400;
	public static String M0401;
	public static String M0402;
	public static String M0403;
	public static String M0404;
	public static String M0405;
	public static String M0406;
	public static String M0407;
	public static String M0408;
	public static String M0409;
	public static String M0410;
	public static String M0411;
	public static String M0412;
	public static String M0413;
	public static String M0414;
	public static String M0415;
	public static String M0416;
	public static String M0417;
	public static String M0418;
	public static String M0419;
	public static String M0420;
	public static String M0421;
	public static String M0422;
	public static String M0423;
	public static String M0424;
	public static String M0425;
	public static String M0426;
	public static String M0427;
	public static String M0428;
	public static String M0429;
	public static String M0430;
	public static String M0431;
	public static String M0432;
	public static String M0433;
	public static String M0434;
	public static String M0435;
	public static String M0436;
	public static String M0437;
	public static String M0438;
	public static String M0439;
	public static String M0440;
	public static String M0441;
	public static String M0442;
	public static String M0443;
	public static String M0444;
	public static String M0445;
	public static String M0446;
	public static String M0447;
	public static String M0448;
	public static String M0449;
	public static String M0450;
	public static String M0451;
	public static String M0452;
	public static String M0453;
	public static String M0454;
	public static String M0455;
	public static String M0456;
	public static String M0457;
	public static String M0458;
	public static String M0459;
	public static String M0460;
	public static String M0461;
	public static String M0462;
	public static String M0463;
	public static String M0464;
	public static String M0465;
	public static String M0466;
	public static String M0467;
	public static String M0468;
	public static String M0469;
	public static String M0470;
	public static String M0471;
	public static String M0472;
	public static String M0473;
	public static String M0474;
	public static String M0475;
	public static String M0476;
	public static String M0477;
	public static String M0478;
	public static String M0479;
	public static String M0480;
	public static String M0481;
	public static String M0482;
	public static String M0483;
	public static String M0484;
	public static String M0485;
	public static String M0486;
	public static String M0487;
	public static String M0488;
	public static String M0489;
	public static String M0490;
	public static String M0491;
	public static String M0492;
	public static String M0493;
	public static String M0494;
	public static String M0495;
	public static String M0496;
	public static String M0497;
	public static String M0498;
	public static String M0499;
	public static String M0500;
	public static String M0501;
	public static String M0502;
	public static String M0503;
	public static String M0504;
	public static String M0505;
	public static String M0506;
	public static String M0507;
	public static String M0508;
	public static String M0509;
	public static String M0510;
	public static String M0511;
	public static String M0512;
	public static String M0513;
	public static String M0514;
	public static String M0515;
	public static String M0516;
	public static String M0517;
	public static String M0518;
	public static String M0519;
	public static String M0520;
	public static String M0521;
	public static String M0522;
	public static String M0523;
	public static String M0524;
	public static String M0525;
	public static String M0526;
	public static String M0527;
	public static String M0528;
	public static String M0529;
	public static String M0530;
	public static String M0531;
	public static String M0532;
	public static String M0533;
	public static String M0534;
	public static String M0535;
	public static String M0536;
	public static String M0537;
	public static String M0538;
	public static String M0539;
	public static String M0540;
	public static String M0541;
	public static String M0542;
	public static String M0543;
	public static String M0544;
	public static String M0545;
	public static String M0546;
	public static String M0547;
	public static String M0548;
	public static String M0549;
	public static String M0550;
	public static String M0551;
	public static String M0552;
	public static String M0553;
	public static String M0554;
	public static String M0555;
	public static String M0556;
	public static String M0557;
	public static String M0558;
	public static String M0559;
	public static String M0560;
	public static String M0561;
	public static String M0562;
	public static String M0563;
	public static String M0564;
	public static String M0565;
	public static String M0566;
	public static String M0567;
	public static String M0568;
	public static String M0569;
	public static String M0570;
	public static String M0571;
	public static String M0572;
	public static String M0573;
	public static String M0574;
	public static String M0575;
	public static String M0576;
	public static String M0577;
	public static String M0578;
	public static String M0579;
	public static String M0580;
	public static String M0581;
	public static String M0582;
	public static String M0583;
	public static String M0584;
	public static String M0585;
	public static String M0586;
	public static String M0587;
	public static String M0588;
	public static String M0589;
	public static String M0590;
	public static String M0591;
	public static String M0592;
	public static String M0593;
	public static String M0594;
	public static String M0595;
	public static String M0596;
	public static String M0597;
	public static String M0598;
	public static String M0599;
	public static String M0600;
	public static String M0601;
	public static String M0602;
	public static String M0603;
	public static String M0604;
	public static String M0605;
	public static String M0606;
	public static String M0607;
	public static String M0608;
	public static String M0609;
	public static String M0610;
	public static String M0611;
	public static String M0612;
	public static String M0613;
	public static String M0614;
	public static String M0615;
	public static String M0616;
	public static String M0617;
	public static String M0618;
	public static String M0619;
	public static String M0620;
	public static String M0621;
	public static String M0622;
	public static String M0623;
	public static String M0624;
	public static String M0625;
	public static String M0626;
	public static String M0627;
	public static String M0628;
	public static String M0629;
	public static String M0630;
	public static String M0631;
	public static String M0632;
	public static String M0633;
	public static String M0634;
	public static String M0635;
	public static String M0636;
	public static String M0637;
	public static String M0638;
	public static String M0639;
	public static String M0640;
	public static String M0641;
	public static String M0642;
	public static String M0643;
	public static String M0644;
	public static String M0645;
	public static String M0646;
	public static String M0647;
	public static String M0648;
	public static String M0649;
	public static String M0650;
	public static String M0651;
	public static String M0652;
	public static String M0653;
	public static String M0654;
	public static String M0655;
	public static String M0656;
	public static String M0657;
	public static String M0658;
	public static String M0659;
	public static String M0660;
	public static String M0661;
	public static String M0662;
	public static String M0663;
	public static String M0664;
	public static String M0665;
	public static String M0666;
	public static String M0667;
	public static String M0668;
	public static String M0669;
	public static String M0670;
	public static String M0671;
	public static String M0672;
	public static String M0673;
	public static String M0674;
	public static String M0675;
	public static String M0676;
	public static String M0677;
	public static String M0678;
	public static String M0679;
	public static String M0680;
	public static String M0681;
	public static String M0682;
	public static String M0683;
	public static String M0684;
	public static String M0685;
	public static String M0686;
	public static String M0687;
	public static String M0688;
	public static String M0689;
	public static String M0690;
	public static String M0691;
	public static String M0692;
	public static String M0693;
	public static String M0694;
	public static String M0695;
	public static String M0696;
	public static String M0697;
	public static String M0698;
	public static String M0699;
	public static String M0700;
	public static String M0701;
	public static String M0702;
	public static String M0703;
	public static String M0704;
	public static String M0705;
	public static String M0706;
	public static String M0707;
	public static String M0708;
	public static String M0709;
	public static String M0710;
	public static String M0711;
	public static String M0712;
	public static String M0713;
	public static String M0714;
	public static String M0715;
	public static String M0716;
	public static String M0717;
	public static String M0718;
	public static String M0719;
	public static String M0720;
	public static String M0721;
	public static String M0722;
	public static String M0723;
	public static String M0724;
	public static String M0725;
	public static String M0726;
	public static String M0727;
	public static String M0728;
	public static String M0729;
	public static String M0730;
	public static String M0731;
	public static String M0732;
	public static String M0733;
	public static String M0734;
	public static String M0735;
	public static String M0736;
	public static String M0737;
	public static String M0738;
	public static String M0739;
	public static String M0740;
	public static String M0741;
	public static String M0742;
	public static String M0743;
	public static String M0744;
	public static String M0745;
	public static String M0746;
	public static String M0747;
	public static String M0748;
	public static String M0749;
	public static String M0750;
	public static String M0751;
	public static String M0752;
	public static String M0753;
	public static String M0754;
	public static String M0755;
	public static String M0756;
	public static String M0757;
	public static String M0758;
	public static String M0759;
	public static String M0760;
	public static String M0761;
	public static String M0762;
	public static String M0763;
	public static String M0764;
	public static String M0765;
	public static String M0766;
	public static String M0767;
	public static String M0768;
	public static String M0769;
	public static String M0770;
	public static String M0771;
	public static String M0772;
	public static String M0773;
	public static String M0774;
	public static String M0775;
	public static String M0776;
	public static String M0777;
	public static String M0778;
	public static String M0779;
	public static String M0780;
	public static String M0781;
	public static String M0782;
	public static String M0783;
	public static String M0784;
	public static String M0785;
	public static String M0786;
	public static String M0787;
	public static String M0788;
	public static String M0789;
	public static String M0790;
	public static String M0791;
	public static String M0792;
	public static String M0793;
	public static String M0794;
	public static String M0795;
	public static String M0796;
	public static String M0797;
	public static String M0798;
	public static String M0799;
	public static String M0800;
	public static String M0801;
	public static String M0802;
	public static String M0803;
	public static String M0804;
	public static String M0805;
	public static String M0806;
	public static String M0807;
	public static String M0808;
	public static String M0809;
	public static String M0810;
	public static String M0811;
	public static String M0812;
	public static String M0813;
	public static String M0814;
	public static String M0815;
	public static String M0816;
	public static String M0817;
	public static String M0818;
	public static String M0819;
	public static String M0820;
	public static String M0821;
	public static String M0822;
	public static String M0823;
	public static String M0824;
	public static String M0825;
	public static String M0826;
	public static String M0827;
	public static String M0828;
	public static String M0829;
	public static String M0830;
	public static String M0831;
	public static String M0832;
	public static String M0833;
	public static String M0834;
	public static String M0835;
	public static String M0836;
	public static String M0837;
	public static String M0838;
	public static String M0839;
	public static String M0840;
	public static String M0841;
	public static String M0842;
	public static String M0843;
	public static String M0844;
	public static String M0845;
	public static String M0846;
	public static String M0847;
	public static String M0848;
	public static String M0849;
	public static String M0850;
	public static String M0851;
	public static String M0852;
	public static String M0853;
	public static String M0854;
	public static String M0855;
	public static String M0856;
	public static String M0857;
	public static String M0858;
	public static String M0859;
	public static String M0860;
	public static String M0861;
	public static String M0862;
	public static String M0863;
	public static String M0864;
	public static String M0865;
	public static String M0866;
	public static String M0867;
	public static String M0868;
	public static String M0869;
	public static String M0870;
	public static String M0871;
	public static String M0872;
	public static String M0873;
	public static String M0874;
	public static String M0875;
	public static String M0876;
	public static String M0877;
	public static String M0878;
	public static String M0879;
	public static String M0880;
	public static String M0881;
	public static String M0882;
	public static String M0883;
	public static String M0884;
	public static String M0885;
	public static String M0886;
	public static String M0887;
	public static String M0888;
	public static String M0889;
	public static String M0890;
	public static String M0891;
	public static String M0892;
	public static String M0893;
	public static String M0894;
	public static String M0895;
	public static String M0896;
	public static String M0897;
	public static String M0898;
	public static String M0899;
	public static String M0900;
	public static String M0901;
	public static String M0902;
	public static String M0903;
	public static String M0904;
	public static String M0905;
	public static String M0906;
	public static String M0907;
	public static String M0908;
	public static String M0909;
	public static String M0910;
	public static String M0911;
	public static String M0912;
	public static String M0913;
	public static String M0914;
	public static String M0915;
	public static String M0916;
	public static String M0917;
	public static String M0918;
	public static String M0919;
	public static String M0920;
	public static String M0921;
	public static String M0922;
	public static String M0923;
	public static String M0924;
	public static String M0925;
	public static String M0926;
	public static String M0927;
	public static String M0928;
	public static String M0929;
	public static String M0930;
	public static String M0931;
	public static String M0932;
	public static String M0933;
	public static String M0934;
	public static String M0935;
	public static String M0936;
	public static String M0937;
	public static String M0938;
	public static String M0939;
	public static String M0940;
	public static String M0941;
	public static String M0942;
	public static String M0943;
	public static String M0944;
	public static String M0945;
	public static String M0946;
	public static String M0947;
	public static String M0948;
	public static String M0949;
	public static String M0950;
	public static String M0951;
	public static String M0952;
	public static String M0953;
	public static String M0954;
	public static String M0955;
	public static String M0956;
	public static String M0957;
	public static String M0958;
	public static String M0959;
	public static String M0960;
	public static String M0961;
	public static String M0962;
	public static String M0963;
	public static String M0964;
	public static String M0965;
	public static String M0966;
	public static String M0967;
	public static String M0968;
	public static String M0969;
	public static String M0970;
	public static String M0971;
	public static String M0972;
	public static String M0973;
	public static String M0974;
	public static String M0975;
	public static String M0976;
	public static String M0977;
	public static String M0978;
	public static String M0979;
	public static String M0980;
	public static String M0981;
	public static String M0982;
	public static String M0983;
	public static String M0984;
	public static String M0985;
	public static String M0986;
	public static String M0987;
	public static String M0988;
	public static String M0989;
	public static String M0990;
	public static String M0991;
	public static String M0992;
	public static String M0993;
	public static String M0994;
	public static String M0995;
	public static String M0996;
	public static String M0997;
	public static String M0998;
	public static String M0999;
	public static String M1000;
	public static String M1001;
	public static String M1002;
	public static String M1003;
	public static String M1004;
	public static String M1005;
	public static String M1006;
	public static String M1007;
	public static String M1008;
	public static String M1009;
	public static String M1010;
	public static String M1011;
	public static String M1012;
	public static String M1013;
	public static String M1014;
	public static String M1015;
	public static String M1016;
	public static String M1017;
	public static String M1018;
	public static String M1019;
	public static String M1020;
	public static String M1021;
	public static String M1022;
	public static String M1023;
	public static String UNDEFINED;
}
