package ch.thomson.ucs.alarms;

import java.util.HashMap;
import java.util.Map;

import ch.thomson.ucs.alarms.client.dao.entries.AlarmHistoryEntry;
import ch.thomson.ucs.alarms.client.dao.entries.AlarmPendingEntry;
import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

public class WarningAlarmVectorHandler extends AlarmVectorHandler {
	
	protected Map<String, AlarmPendingEntry> pendingEntries = new HashMap<String, AlarmPendingEntry>();
	
	public WarningAlarmVectorHandler(PropertyNumericDAO property, int messageListOffset, Descriptor descriptor) throws Exception {
		super(property, messageListOffset, Category.WARNING, descriptor);
	}

	@Override
	public void alarmHasCome(String messageId) throws Exception {
		AlarmPendingEntry ape = new AlarmPendingEntry(property.getTimeStamp(), messageId, property.getEquipmentName(), category.getName(), Descriptor.COME.getName());
		pendingEntries.put(messageId, ape);
		getAlarmPendingDAO().setEntry(ape);		
		getAlarmHistoryDAO().setEntry(new AlarmHistoryEntry(property.getTimeStamp(), messageId, property.getEquipmentName(), category.getName(), Descriptor.COME.getName()));
		getAlarmSumHandler().setSumWarning();
	}

	@Override
	public void alarmHasGone(String messageId) throws Exception {
		pendingEntries.remove(messageId);
		getAlarmPendingDAO().setEntry(new AlarmPendingEntry(property.getTimeStamp(), messageId, property.getEquipmentName(), category.getName(), Descriptor.GONE.getName()));
		getAlarmHistoryDAO().setEntry(new AlarmHistoryEntry(property.getTimeStamp(), messageId, property.getEquipmentName(), category.getName(), Descriptor.GONE.getName()));		
		getAlarmSumHandler().warningIsGone();
	}

	@Override
	public void reset() {
		super.reset();
		
		boolean setSumWarning = false;
		// Anstehende Warnungen wieder eintragen
		for(AlarmPendingEntry ape : pendingEntries.values()) {
			try {
				getAlarmPendingDAO().setEntry(ape);
				setSumWarning = true;
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				if(setSumWarning)
					getAlarmSumHandler().setSumWarning();
			}
		}
	}
}
