package ch.thomson.ucs.alarms.client;

import java.sql.Connection;
import java.sql.DriverManager;

import ch.thomson.ucs.alarms.client.dao.AlarmHistoryDAO;
import ch.thomson.ucs.alarms.client.dao.AlarmMessageDAO;
import ch.thomson.ucs.alarms.client.dao.AlarmPendingDAO;
import ch.thomson.ucs.alarms.client.dao.impl.AlarmHistoryDAOImpl;
import ch.thomson.ucs.alarms.client.dao.impl.AlarmMessageDAOImpl;
import ch.thomson.ucs.alarms.client.dao.impl.AlarmPendingDAOImpl;

public class ClientUtil {
	
	/**
	 * Kreiert eine Datenbankverbindung auf den Localhost.
	 * @return Connection Objekt auf die Datenbank
	 * @throws Exception
	 */
	public static Connection createConnection() throws Exception {
		return createConnection("127.0.0.1");
	}
	
	/**
	 * Kreiert eine Datenbankverbindung auf den gewnschten Host.
	 * @param host
	 * @return Connection Objekt auf die Datenbank
	 * @throws Exception
	 */
	public static Connection createConnection(String host) throws Exception {
		Class.forName("org.postgresql.Driver");
		Connection connection = DriverManager.getConnection("jdbc:postgresql://" + host + "/ucs", "ucs", "ucs");
		return connection;
	}
	
	public static AlarmPendingDAO createAlarmPendingDAO() {
		return new AlarmPendingDAOImpl();
	}
	
	public static AlarmHistoryDAO createAlarmHistoryDAO() {
		return new AlarmHistoryDAOImpl();
	}
	
	public static AlarmMessageDAO createAlarmMessageDAO() {
		return new AlarmMessageDAOImpl();
	}
}
