package ch.thomson.ucs.alarms.client.dao.entries;

import java.sql.Timestamp;

public class AlarmPendingEntry {
	
	protected Timestamp timestamp;
	protected String id;
	protected String category;
	protected String eqm;
	protected String descriptor;
	protected String message;
	
	public AlarmPendingEntry(Timestamp timestamp, String id, String eqm, String category, String descriptor, String message) {
		this.timestamp = timestamp;
		this.id = id;
		this.eqm = eqm;
		this.category = category;
		this.descriptor = descriptor;
		this.message = message;
	}
	
	public AlarmPendingEntry(long timestamp, String id, String eqm, String category, String descriptor) {
		this(new Timestamp(timestamp), id, eqm, category, descriptor, null);
	}

	public Timestamp getTimestamp() {
		return timestamp;
	}

	public String getId() {
		return id;
	}
	
	public String getEqm() {
		return eqm;
	}

	public String getCategory() {
		return category;
	}

	public String getDescriptor() {
		return descriptor;
	}

	public String getMessage() {
		return message;
	}

	@Override
	public String toString() {
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (timestamp: ");
		result.append(timestamp);
		result.append(", id: ");
		result.append(id);
		result.append(", eqm: ");
		result.append(eqm);
		result.append(", category: ");
		result.append(category);
		result.append(", descriptor: ");
		result.append(descriptor);
		result.append(", message: ");
		result.append(message);
		result.append(')');
		return result.toString();
	}

	@Override
	public boolean equals(Object obj) {
		if(this == obj)
			return true;
		if (obj == null)
	        return false;
	    if (getClass() != obj.getClass())
	        return false;
	    
		AlarmPendingEntry other = (AlarmPendingEntry) obj;
		if(!id.equals(other.id))
			return false;
		
		if(!descriptor.equals(other.descriptor))
			return false;
		
		return true;
	}
}
