package ch.thomson.ucs.alarms.client.dao.impl;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;

import ch.thomson.ucs.alarms.client.dao.AlarmMessageDAO;

public class AlarmMessageDAOImpl extends BasicDAOImpl implements AlarmMessageDAO {
	
	@Override
	public void setEntry(String id, String message) throws SQLException {
		String update = "UPDATE messages SET message=? WHERE id=?;";
		String insert = "INSERT INTO messages VALUES (?, ?);";
		
		PreparedStatement psUpdate = null;
		PreparedStatement psInsert = null;
		
		try {
			psUpdate = connection.prepareStatement(update);
			psUpdate.setString(1, message);
			psUpdate.setString(2, id);
			int	result = psUpdate.executeUpdate();
	
		
			// Falls kein Eintrag gendert wurde, muss er erstellt werden
			if(result == 0) {
				psInsert = connection.prepareStatement(insert);
				psInsert.setString(1, id);
				psInsert.setString(2, message);
				psInsert.executeUpdate();
			}
			
		} finally {
			if(psUpdate != null)
				psUpdate.close();
			if(psInsert != null)
				psInsert.close();
		}
	}
	
	public void setupTable() throws SQLException {
		StringBuilder query = new StringBuilder();
		query.append("CREATE TABLE IF NOT EXISTS messages (");
		query.append("id VARCHAR(16) NOT NULL, ");
		query.append("message VARCHAR(255) NOT NULL, ");
		query.append("CONSTRAINT me_pk PRIMARY KEY (id));");
		
		Statement st = null;
		try {
			st = connection.createStatement();
			st.executeUpdate(query.toString());
		} finally {
			if(st != null)
				st.close();
		}
	}
}
