package ch.thomson.ucs.alarms.client.dao.impl;

import java.sql.Connection;
import java.sql.SQLException;

import ch.thomson.ucs.alarms.client.ClientUtil;
import ch.thomson.ucs.alarms.client.dao.BasicDAO;

public abstract class BasicDAOImpl implements BasicDAO {

	protected Connection connection;
	
	@Override
	public void open() throws Exception {
		connection = ClientUtil.createConnection();
		setupTable();
	}

	@Override
	public void open(String host) throws Exception {
		connection = ClientUtil.createConnection(host);
		setupTable();
	}

	@Override
	public void close() {
		if(!isClosed()) {
			try {
				connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			} finally {
				connection = null;
			}
		}
	}

	@Override
	public boolean isClosed() {
		return connection == null;
	}

	@Override
	public void setAutoCommit(boolean autoCommit) throws SQLException {
		connection.setAutoCommit(autoCommit);
	}

	@Override
	public void commit() throws SQLException {
		connection.commit();
	}
}
