package ch.thomson.ucs.desy.specialfunctions;

/**
 * Diese Klasse berprft alle Werte eines Property Arrays auf einen Schwellwert.
 * @author FischerU
 *
 */
public class AnalogArrayConditionsHandler extends AnalogConditionsHandler {
	
	public AnalogArrayConditionsHandler(String analogValue, String warningLow, String warningHigh, String faultLow, String faultHigh, String condition) throws Exception {
		super(analogValue, warningLow, warningHigh, faultLow, faultHigh, condition);
	}

	@Override
	protected AnalogConditions checkWarning() {
		if (pnWarningLow != null) {
			for (int i = 0; i < pnAnalogValue.getLength(); i++) {
				if (pnAnalogValue.getFloat(i) < pnWarningLow.getFloat()) {
					return AnalogConditions.WARNING_LOW;
				}
			}
		}

		if (pnWarningHigh != null) {
			for (int i = 0; i < pnAnalogValue.getLength(); i++) {
				if (pnAnalogValue.getFloat() > pnWarningHigh.getFloat()) {
					return AnalogConditions.WARNING_HIGH;
				}
			}
		}

		return AnalogConditions.OK;
	}

	@Override
	protected AnalogConditions checkFault() {
		if (pnFaultLow != null) {
			for (int i = 0; i < pnAnalogValue.getLength(); i++) {
				if (pnAnalogValue.getFloat(i) < pnFaultLow.getFloat()) {
					return AnalogConditions.FAULT_LOW;
				}
			}
		}

		if (pnFaultHigh != null) {
			for (int i = 0; i < pnAnalogValue.getLength(); i++) {
				if (pnAnalogValue.getFloat() > pnFaultHigh.getFloat()) {
					return AnalogConditions.FAULT_HIGH;
				}
			}
		}

		return AnalogConditions.OK;
	}
}
