package ch.thomson.ucs.desy.specialfunctions;

import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

public class PMStatusParser extends SpecialFunctionPropertyObserved {

	protected PropertyNumericDAO pnLastOk;
	
	public PMStatusParser(String vector, String lastOk) throws Exception {
		this.pnLastOk = PropertyNumericDAO.createPropertyNumericDAO(lastOk, true);
		this.doParse(this.addObservedProperty(vector));
	}
	
	@Override
	protected void refresh(PropertyNumericDAO property, float[] newValues, float[] oldValues) {
		doParse(property);
	}
	
	private void doParse(PropertyNumericDAO property) {
		int[] source = property.getValuesAsInt();
		float[] result = new float[property.getLength()];
		for(int i=0; i<result.length && i<source.length; ++i) {
			int val = source[i];
			result[i] = (val >>> 17) & 0x7;
		}
		pnLastOk.setValuesAsFloat(result);
	}
}
