package ch.thomson.ucs.desy.specialfunctions;

import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

public class PMVersionTypeParser extends SpecialFunctionPropertyObserved {

	protected PropertyNumericDAO pnVersion;
	protected PropertyNumericDAO pnConf;
	
	public PMVersionTypeParser(String vector, String version, String conf) throws Exception {
		this.pnVersion = PropertyNumericDAO.createPropertyNumericDAO(version, true);
		this.pnConf = PropertyNumericDAO.createPropertyNumericDAO(conf, true);
		this.doParse(this.addObservedProperty(vector));
	}
	
	@Override
	protected void refresh(PropertyNumericDAO property, float[] newValues, float[] oldValues) {
		doParse(property);
	}
	
	private void doParse(PropertyNumericDAO property) {
		// Parse Version
		int[] source = property.getValuesAsInt();
		float[] result = new float[property.getLength()];
		
		for(int i=0; i<result.length && i<source.length; ++i) {
			int val = source[i];
			result[i] = ((val >>> 7) & 0x7) + 0.1f * ((val >>> 4) & 0x7);
		}
		pnVersion.setValuesAsFloat(result);
		
		// Parse Config
		for(int i=0; i<result.length && i<source.length; ++i) {
			int val = source[i];
			result[i] = (val & 0x3);
		}
		pnConf.setValuesAsFloat(result);
	}
}
