package ch.thomson.ucs.desy.specialfunctions;

import ch.thomson.ucs.desy.business.Activator.States;
import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

public class PSMPulseCounterPersistence extends SpecialFunctionPropertyObserved {

	private PropertyNumericDAO pnGetPSMCounter;
	private PropertyNumericDAO pnSetPSMCounter;
	private int pulseState;
	
	public PSMPulseCounterPersistence(String setPSMCounter, String getPSMCounter, String actState, States state) throws Exception {
		this.pulseState = state.ordinal();
		this.addObservedProperty(actState);
		pnSetPSMCounter = PropertyNumericDAO.createPropertyNumericDAO(setPSMCounter, false);
		pnGetPSMCounter = PropertyNumericDAO.createPropertyNumericDAO(getPSMCounter, false);
	}
	
	@Override
	protected void refresh(PropertyNumericDAO property, float[] newValues, float[] oldValues) {
		// Wenn vom Pulse State in einen tieferen State gewechselt wird, muss der Counter in den Set-Wert geschrieben werden.
		if(oldValues[0] == pulseState && newValues[0] < pulseState)
			pnSetPSMCounter.setInt(pnGetPSMCounter.getInt());
	}
}
