package ch.thomson.ucs.desy.specialfunctions;

import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

/**
 * Spezialisierung fr das ndern des Skalierungsfaktors der Messsamples zur
 * Laufzeit.
 * 
 * @author FischerU
 * 
 */
public class SampleScaleFactorChanger extends ScaleFactorChanger {

	private static double SCALE_MAX = 33336.6; // SCI-Hardware-Magicnumber (2^13-1 * 4 * 1.0174765 = 33336.6)
	
	public SampleScaleFactorChanger(String source, String target) throws Exception {
		super(source, target);
	}

	@Override
	protected void refresh(PropertyNumericDAO property, float[] newValues, float[] oldValues) {
		assert newValues.length == 1;
		newValues[0] = (float) (SCALE_MAX / newValues[0]);
		super.refresh(property, newValues, oldValues);
	}
}
