package ch.thomson.ucs.desy.specialfunctions;

import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;

/**
 * Diese Specialfunction-Klasse kann benutzt werden, um den Faktor fr die
 * Skalierung zur Laufzeit zu ndern. Instanzen dieser Klasse beobachten eine
 * bestimmte Property (source) und setzen bei einer Wert-nderung bei der
 * Target-Property den Skalierungsfaktor.
 * 
 * @author FischerU
 * 
 */
public class ScaleFactorChanger extends SpecialFunctionPropertyObserved {

	protected PropertyNumericDAO pnFrom;
	protected PropertyNumericDAO result;
	
	public ScaleFactorChanger(String source, String target) throws Exception {
		PropertyNumericDAO pnFrom = this.addObservedProperty(source);
		result = PropertyNumericDAO.createPropertyNumericDAO(target, false);
		this.refresh(pnFrom, pnFrom.getValuesAsFloat(), new float[pnFrom.getLength()]);
	}
	
	@Override
	protected void refresh(PropertyNumericDAO property, float[] newValues, float[] oldValues) {
		assert newValues.length == 1;
		result.setScaleFactor(newValues[0]);
	}
}
