package ch.thomson.ucs.desy.specialfunctions;

import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener;
import ch.thomson.ucs.tine.server.internal.client.PropertyNumericDAO;


public abstract class SpecialFunctionDeviceUpdated implements SpecialFunction, DeviceUpdateListener {
	
	private Device device;
	
	@Override
	public void dispose() {
		device.getDeviceUpdateListeners().remove(this);
	}
	
	public PropertyNumericDAO findProperty(String path, boolean notification) throws Exception {
		PropertyNumericDAO dao = PropertyNumericDAO.createPropertyNumericDAO(path, notification);
		
		// Bei der 1. Property das Device ermitteln
		if(device == null) 
			device = dao.getDevice();
		
		// Sicherstellen, dass alle Properties im selben Device enthalten sind.
		if(device != dao.getDevice())
			throw new Exception(this.getClass().getName() + ": Different devices are not allowed");
		
		return dao;
	}
	
	public void initialize() {
		device.getDeviceUpdateListeners().add(this);
	}
}
