package ch.thomson.ucs.desy.specialfunctions.fastchannel;

import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Result;
import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Sample;
import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Selection;

public abstract class FastChannelCalculation {
	
	private FastChannelCalculationSet parent;
	
	public FastChannelCalculation(FastChannelCalculationSet parent) {
		parent.addFastChannelCalculation(this);
		this.parent = parent;
	}
	
	public abstract void refresh();
	
	public void dispose() {
		parent.removeFastChannelCalculation(this);
	}
	
	public Sample findSample(String path) throws Exception {
		return this.parent.findSample(path);
	}
	
	public Selection findSelection(String path) throws Exception {
		return this.parent.findSelection(path);
	}
	
	public Result createResult(String path) throws Exception {
		return this.parent.createResult(path);
	}
}
