package ch.thomson.ucs.desy.specialfunctions.fastchannel;

import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Result;
import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Sample;
import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Selection;



public class PulseActSelection extends FastChannelCalculation {
	protected Selection pnActTrigger;
	protected Sample pnSamples;
	protected Result pnResult;
	
	public PulseActSelection(FastChannelCalculationSet parent, String actTrigger, String samples, String result) throws Exception {
		super(parent);
		pnActTrigger = this.findSelection(actTrigger);
		pnSamples = this.findSample(samples);
		pnResult = this.createResult(result);
	}

	@Override
	public void refresh() {
		float[] samples = pnSamples.getCachedValues();
		pnResult.setResult(samples[pnActTrigger.getCachedValueInt()]);
	}
}
