package ch.thomson.ucs.desy.specialfunctions.fastchannel;

import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Result;
import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Sample;
import ch.thomson.ucs.desy.specialfunctions.fastchannel.FastChannelCalculationSet.Selection;


public class PulseAverageCalculation extends FastChannelCalculation {

	private Selection pnStart;
	private Selection pnLength;
	private Sample pnSamples;
	private Result pnResult;
	
	public PulseAverageCalculation(FastChannelCalculationSet parent, String start, String length, String samples, String result) throws Exception {
		super(parent);
		pnStart = this.findSelection(start);
		pnLength = this.findSelection(length);
		pnSamples = this.findSample(samples);
		pnResult = this.createResult(result);
	}

	@Override
	public void refresh() {
		
		float average = 0.0f;
		float[] samples = pnSamples.getCachedValues();
		
		int start = pnStart.getCachedValueInt();
		int length = pnLength.getCachedValueInt();
		
		for(int i=start; i < start + length && i < samples.length; ++i) {
			average += samples[i];
		}
		average = average / length;
		pnResult.setResult(average);
	}
}
