package ch.thomson.ucs.desy.ui;

import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.eclipse.ui.IViewReference;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import ch.thomson.ucs.security.LogonLevelListener;
import ch.thomson.ucs.security.LogonManager;

public class Perspective implements IPerspectiveFactory, LogonLevelListener {

	public void createInitialLayout(IPageLayout layout) {
		layout.setEditorAreaVisible(false);
		layout.setFixed(true);
		LogonManager.getInstance().addLogonLevelListener(this);
	}

	@Override
	public void logonLevelChanged(int logonLevel) {
		// TODO Auto-generated method stub
		if(logonLevel >= 3) {
			try {
				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView("ch.thomson.ucs.desy.ui.ViewIBS");
			} 
			catch (PartInitException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
		}
		else {
			// hide View		
			IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
			IViewReference[] viewRefs = window.getActivePage().getViewReferences();
			        
			for(int i = 0; i < viewRefs.length; i++) {
				IViewReference ref = viewRefs[i];
			        if("ch.thomson.ucs.desy.ui.ViewIBS".equals(ref.getId())) {
			                ref.getPage().hideView(ref);
			        }
			}		
		}
		
		if(logonLevel == 9) {
			try {
				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView("ch.thomson.ucs.desy.ui.ViewFactoryPSM");
				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView("ch.thomson.ucs.desy.ui.ViewFactorySCI");
			} 
			catch (PartInitException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
		}
		else {
			// hide View		
			IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
			IViewReference[] viewRefs = window.getActivePage().getViewReferences();
			        
			for(int i = 0; i < viewRefs.length; i++) {
				IViewReference ref = viewRefs[i];
			        if("ch.thomson.ucs.desy.ui.ViewFactoryPSM".equals(ref.getId()) || 
			           "ch.thomson.ucs.desy.ui.ViewFactorySCI".equals(ref.getId())) {
			                ref.getPage().hideView(ref);
			        }
			}		
		}				
	}
}
