package ch.thomson.ucs.desy.ui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.wb.swt.SWTResourceManager;

import ch.thomson.ucs.tine.client.databinding.eclipse.ThView;
import ch.thomson.ucs.tine.databinding.swt.ThComposite;
import ch.thomson.ucs.tine.databinding.swt.ThGroup;
import ch.thomson.ucs.tine.databinding.swt.ThLabelMsg;
import ch.thomson.ucs.tine.databinding.swt.ThLed;
import ch.thomson.ucs.tine.databinding.swt.ThLedLabel;
import ch.thomson.ucs.tine.databinding.swt.ThText;
import ch.thomson.ucs.tine.databinding.swt.ThTextUnit;

public class ViewData extends ThView {
	private Combo combo;
	ThComposite thComposite = null;

	public ViewData() {
		// TODO Auto-generated constructor stub
	}

	@Override
	public void createPartControl(Composite parent) {
		// TODO Auto-generated method stub
//		super.createPartControl(parent);
		
		thComposite = new ThComposite(parent, SWT.NONE);
		
		ThGroup thgrpSelectPowerModule = new ThGroup(thComposite, SWT.NONE);
		thgrpSelectPowerModule.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		thgrpSelectPowerModule.setText("Select Power Module");
		thgrpSelectPowerModule.setBounds(10, 3, 516, 65);
		
		Label lblPowerModuleNumber = new Label(thgrpSelectPowerModule, SWT.NONE);
		lblPowerModuleNumber.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		lblPowerModuleNumber.setBounds(9, 25, 277, 31);
		lblPowerModuleNumber.setText("Power Module Number");
		
		combo = new Combo(thgrpSelectPowerModule, SWT.READ_ONLY);
		combo.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		combo.setItems(new String[] {"Power Module 1", "Power Module 2", "Power Module 3", "Power Module 4", "Power Module 5", "Power Module 6", "Power Module 7", "Power Module 8", "Power Module 9", "Power Module 10", "Power Module 11", "Power Module 12", "Power Module 13", "Power Module 14", "Power Module 15", "Power Module 16", "Power Module 17", "Power Module 18", "Power Module 19", "Power Module 20", "Power Module 21", "Power Module 22", "Power Module 23", "Power Module 24", "Power Module 25", "Power Module 26", "Power Module 27", "Power Module 28"});
		combo.setVisibleItemCount(28);
		combo.setBounds(292, 22, 214, 31);
		combo.select(0);
		combo.addSelectionListener(new SelectionAdapter() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				if(e.widget instanceof Combo) {
					try {
						navigateControl(thComposite.getChildren(), combo.getSelectionIndex());
					} catch (NumberFormatException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}
			
		});
		
		ThGroup thgrpPowerModuleStatus = new ThGroup(thComposite, SWT.NONE);
		thgrpPowerModuleStatus.setText("Power Module Status");
		thgrpPowerModuleStatus.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		thgrpPowerModuleStatus.setBounds(10, 260, 516, 299);
		
		ThLedLabel thldlblStatus = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thldlblStatus.setInverted(true);
		thldlblStatus.setMaskValue("0x01");
		thldlblStatus.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thldlblStatus.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thldlblStatus.setLabelText("Temp Cap. Heat Sink");
		thldlblStatus.setBounds(10, 29, 246, 18);
		
		ThLedLabel thLedLabel = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel.setInverted(true);
		thLedLabel.setMaskValue("0x02");
		thLedLabel.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel.setLabelText("BOOSTER Current");
		thLedLabel.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel.setBounds(10, 56, 246, 18);
		
		ThLedLabel thLedLabel_1 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_1.setInverted(true);
		thLedLabel_1.setMaskValue("0x04");
		thLedLabel_1.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_1.setLabelText("BOOSTER IGBT Driver");
		thLedLabel_1.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_1.setBounds(10, 83, 246, 18);
		
		ThLedLabel thLedLabel_2 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_2.setInverted(true);
		thLedLabel_2.setMaskValue("0x08");
		thLedLabel_2.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_2.setLabelText("Capacitor Bank Voltage");
		thLedLabel_2.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_2.setBounds(10, 110, 246, 18);
		
		ThLedLabel thLedLabel_3 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_3.setInverted(true);
		thLedLabel_3.setMaskValue("0x20");
		thLedLabel_3.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_3.setLabelText("Startup Voltage");
		thLedLabel_3.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_3.setBounds(10, 138, 246, 18);
		
		ThLedLabel thLedLabel_4 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_4.setInverted(true);
		thLedLabel_4.setMaskValue("0x40");
		thLedLabel_4.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_4.setLabelText("Mains Contactor");
		thLedLabel_4.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_4.setBounds(10, 166, 246, 18);
		
		ThLedLabel thLedLabel_5 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_5.setInverted(true);
		thLedLabel_5.setMaskValue("0x80");
		thLedLabel_5.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_5.setLabelText("V C1 / Inverse Fiber Optic");
		thLedLabel_5.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_5.setBounds(10, 194, 246, 18);
		
		ThLedLabel thLedLabel_6 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_6.setInverted(true);
		thLedLabel_6.setMaskValue("0x0100");
		thLedLabel_6.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_6.setLabelText("ZSE Fiber Optic");
		thLedLabel_6.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_6.setBounds(10, 222, 246, 18);
		
		ThLedLabel thLedLabel_7 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_7.setInverted(true);
		thLedLabel_7.setMaskValue("0x0200");
		thLedLabel_7.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_7.setLabelText("PSM Fiber Optic");
		thLedLabel_7.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_7.setBounds(262, 29, 215, 18);
		
		ThLedLabel thLedLabel_8 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_8.setInverted(true);
		thLedLabel_8.setMaskValue("0x0400");
		thLedLabel_8.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_8.setLabelText("Output IGBT Error");
		thLedLabel_8.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_8.setBounds(262, 56, 215, 18);

		ThLedLabel thLedLabel_20 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_20.setInverted(true);
		thLedLabel_20.setMaskValue("0x0800");
		thLedLabel_20.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_20.setLabelText("SKIIP Temperature");
		thLedLabel_20.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_20.setBounds(262, 83, 215, 18);
				
		ThLedLabel thLedLabel_11 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_11.setInverted(true);
		thLedLabel_11.setMaskValue("0x1000");
		thLedLabel_11.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_11.setLabelText("SKIIP Temp. Heat Sink");
		thLedLabel_11.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_11.setBounds(262, 110, 215, 18);
		
		ThLedLabel thLedLabel_12 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_12.setInverted(true);
		thLedLabel_12.setMaskValue("0x2000");
		thLedLabel_12.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_12.setLabelText("SKIIP Temp. Measurement");
		thLedLabel_12.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_12.setBounds(262, 137, 242, 18);
		
		ThLedLabel thLedLabel_13 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_13.setInverted(true);
		thLedLabel_13.setMaskValue("0x4000");
		thLedLabel_13.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_13.setLabelText("Correlation");
		thLedLabel_13.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_13.setBounds(262, 164, 215, 18);
		
		ThLedLabel thLedLabel_14 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_14.setInverted(true);
		thLedLabel_14.setMaskValue("0x8000");
		thLedLabel_14.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_14.setLabelText("SKIIP Current");
		thLedLabel_14.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_14.setBounds(262, 192, 215, 18);
		
		ThLedLabel thLedLabel_15 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_15.setInverted(true);
		thLedLabel_15.setMaskValue("0x10000");
		thLedLabel_15.setSignalName("PSM/Device1/PSMG_VECT_PM_STATUS");
		thLedLabel_15.setLabelText("Heartbeat");
		thLedLabel_15.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_15.setBounds(262, 220, 215, 18);
		
		ThLedLabel thLedLabel_16 = new ThLedLabel(thgrpPowerModuleStatus, SWT.NONE);
		thLedLabel_16.setSignalName("PSM/Device1/PSMG_VECT_PM_VERS_X_TYPE");
		thLedLabel_16.setMaskValue("0x04");
		thLedLabel_16.setLabelText("Testmode");
		thLedLabel_16.setInverted(true);
		thLedLabel_16.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_16.setBounds(10, 261, 246, 18);
		
		ThLabelMsg thLabelMsg_1 = new ThLabelMsg(thgrpPowerModuleStatus, SWT.BORDER | SWT.CENTER);
		thLabelMsg_1.setValueList(new String[] {"0", "1", "2", "3", "4"});
		thLabelMsg_1.setSignalName("DUMMIES/Device1/PSMD_STAT_PM_LAST");
		thLabelMsg_1.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thLabelMsg_1.setCaptionList(new String[] {"Clear", "Startup", "Startup2", "Booster", "Ready"});
		thLabelMsg_1.setBounds(357, 253, 120, 35);
		
		Label lblLastOk = new Label(thgrpPowerModuleStatus, SWT.NONE);
		lblLastOk.setText("Last OK:");
		lblLastOk.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblLastOk.setBounds(263, 261, 77, 19);
		
		ThGroup thgrpPowerModuleData = new ThGroup(thComposite, SWT.NONE);
		thgrpPowerModuleData.setText("Power Module Data");
		thgrpPowerModuleData.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		thgrpPowerModuleData.setBounds(539, 3, 483, 556);
		
		ThTextUnit thTextUnit_1 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_1.setEditable(false);
		thTextUnit_1.setText("1234");
		thTextUnit_1.setSignalName("PSM/Device1/PSMG_TIME_PM_SKIIP_ON");
		thTextUnit_1.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_1.setBounds(285, 62, 120, 35);
		
		ThTextUnit thTextUnit_2 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_2.setEditable(false);
		thTextUnit_2.setText("1234");
		thTextUnit_2.setSignalName("PSM/Device1/PSMG_NMBR_PM_CYCLES_ON");
		thTextUnit_2.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_2.setBounds(285, 103, 120, 35);
		
		ThTextUnit thTextUnit_3 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_3.setEditable(false);
		thTextUnit_3.setText("1234");
		thTextUnit_3.setSignalName("PSM/Device1/PSMG_TEMP_PM_SKIIP");
		thTextUnit_3.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_3.setBounds(285, 144, 120, 35);
		
		ThTextUnit thTextUnit_4 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_4.setEditable(false);
		thTextUnit_4.setText("1234");
		thTextUnit_4.setSignalName("PSM/Device1/PSMG_VOLT_PM_BOOSTER_IN");
		thTextUnit_4.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_4.setBounds(285, 185, 120, 35);
		
		ThTextUnit thTextUnit_5 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_5.setEditable(false);
		thTextUnit_5.setText("1234");
		thTextUnit_5.setSignalName("PSM/Device1/PSMG_VOLT_PM_BOOSTER");
		thTextUnit_5.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_5.setBounds(285, 226, 120, 35);
		
		ThTextUnit thTextUnit_6 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_6.setEditable(false);
		thTextUnit_6.setText("1234");
		thTextUnit_6.setSignalName("PSM/Device1/PSMG_VOLT_PM_BOOSTER_MIN");
		thTextUnit_6.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_6.setBounds(285, 267, 120, 35);
		
		ThTextUnit thTextUnit_7 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_7.setEditable(false);
		thTextUnit_7.setText("1234");
		thTextUnit_7.setSignalName("PSM/Device1/PSMG_VOLT_PM_BOOSTER_MAX");
		thTextUnit_7.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_7.setBounds(285, 309, 120, 35);
		
		ThTextUnit thTextUnit_8 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_8.setEditable(false);
		thTextUnit_8.setText("1234");
		thTextUnit_8.setSignalName("PSM/Device1/PSMG_CURR_PM_BOOSTER_MAX");
		thTextUnit_8.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_8.setBounds(285, 350, 120, 35);
		
		ThTextUnit thTextUnit_9 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_9.setEditable(false);
		thTextUnit_9.setText("1234");
		thTextUnit_9.setSignalName("PSM/Device1/PSMG_POWR_PM_IN");
		thTextUnit_9.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_9.setBounds(285, 391, 120, 35);
		
		ThTextUnit thTextUnit_12 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_12.setEditable(false);
		thTextUnit_12.setText("1234");
		thTextUnit_12.setSignalName("DUMMIES/Device1/PSMD_VERS_PM");
		thTextUnit_12.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_12.setBounds(285, 473, 120, 35);
		
		ThTextUnit thTextUnit_13 = new ThTextUnit(thgrpPowerModuleData, SWT.BORDER | SWT.RIGHT);
		thTextUnit_13.setEditable(false);
		thTextUnit_13.setText("1234");
		thTextUnit_13.setSignalName("PSM/Device1/PSMG_CURR_PM_SKIIP_MAX");
		thTextUnit_13.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thTextUnit_13.setBounds(285, 21, 120, 35);
		
		Label lblNewLabel = new Label(thgrpPowerModuleData, SWT.NONE);
		lblNewLabel.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblNewLabel.setBounds(17, 26, 264, 24);
		lblNewLabel.setText("Max. SKIIP Current:");
		
		Label lblTimeSkiipOn = new Label(thgrpPowerModuleData, SWT.NONE);
		lblTimeSkiipOn.setText("Time SKIIP On:");
		lblTimeSkiipOn.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblTimeSkiipOn.setBounds(17, 67, 264, 24);
		
		Label lblNrOfSkiip = new Label(thgrpPowerModuleData, SWT.NONE);
		lblNrOfSkiip.setText("Nr. of SKIIP cycles:");
		lblNrOfSkiip.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblNrOfSkiip.setBounds(17, 108, 264, 24);
		
		Label lblSkiipTemperature = new Label(thgrpPowerModuleData, SWT.NONE);
		lblSkiipTemperature.setText("SKIIP Temperature:");
		lblSkiipTemperature.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblSkiipTemperature.setBounds(17, 149, 264, 24);
		
		Label lblBoosterInputVoltage_1 = new Label(thgrpPowerModuleData, SWT.NONE);
		lblBoosterInputVoltage_1.setText("BOOSTER Input Voltage:");
		lblBoosterInputVoltage_1.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblBoosterInputVoltage_1.setBounds(17, 190, 264, 24);
		
		Label lblBoosterInputVoltage = new Label(thgrpPowerModuleData, SWT.NONE);
		lblBoosterInputVoltage.setText("BOOSTER Voltage:");
		lblBoosterInputVoltage.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblBoosterInputVoltage.setBounds(17, 231, 264, 24);
		
		Label lblMinBoosterVoltage = new Label(thgrpPowerModuleData, SWT.NONE);
		lblMinBoosterVoltage.setText("Min. BOOSTER Voltage:");
		lblMinBoosterVoltage.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblMinBoosterVoltage.setBounds(17, 272, 264, 24);
		
		Label lblMaxBoosterVoltage = new Label(thgrpPowerModuleData, SWT.NONE);
		lblMaxBoosterVoltage.setText("Max. BOOSTER Voltage:");
		lblMaxBoosterVoltage.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblMaxBoosterVoltage.setBounds(17, 314, 264, 24);
		
		Label lblMinBoosterCurrent = new Label(thgrpPowerModuleData, SWT.NONE);
		lblMinBoosterCurrent.setText("Min. BOOSTER Current:");
		lblMinBoosterCurrent.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblMinBoosterCurrent.setBounds(17, 355, 264, 24);
		
		Label lblInputPower = new Label(thgrpPowerModuleData, SWT.NONE);
		lblInputPower.setText("Input Power:");
		lblInputPower.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblInputPower.setBounds(17, 396, 264, 24);
		
		Label lblConfiguration = new Label(thgrpPowerModuleData, SWT.NONE);
		lblConfiguration.setText("Configuration:");
		lblConfiguration.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblConfiguration.setBounds(17, 437, 264, 24);
		
		Label lblSoftwareVersion = new Label(thgrpPowerModuleData, SWT.NONE);
		lblSoftwareVersion.setText("Software Version:");
		lblSoftwareVersion.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		lblSoftwareVersion.setBounds(17, 478, 264, 24);
		
		ThLabelMsg thLabelMsg = new ThLabelMsg(thgrpPowerModuleData, SWT.BORDER | SWT.CENTER);
		thLabelMsg.setValueList(new String[] {"0", "1", "2"});
		thLabelMsg.setCaptionList(new String[] {"Normal", "Norm Inv", "Inverse"});
		thLabelMsg.setSignalName("DUMMIES/Device1/PSMD_CONF_PM");
		thLabelMsg.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		thLabelMsg.setBounds(285, 432, 120, 35);
		
		ThGroup thgrpPowerModuleState = new ThGroup(thComposite, SWT.NONE);
		thgrpPowerModuleState.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		thgrpPowerModuleState.setText("Power Module State");
		thgrpPowerModuleState.setBounds(10, 73, 515, 95);
		
		ThLedLabel thLedLabel_9 = new ThLedLabel(thgrpPowerModuleState, SWT.NONE);
		thLedLabel_9.setInverted(false);
		thLedLabel_9.setMaskValue("0x08");
		thLedLabel_9.setSignalName("PSM/Device1/PSMG_STAT_PM");
		thLedLabel_9.setLabelText("Ready");
		thLedLabel_9.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_9.setBounds(10, 22, 162, 18);
		
		ThLedLabel thLedLabel_38 = new ThLedLabel(thgrpPowerModuleState, SWT.NONE);
		thLedLabel_38.setInverted(false);
		thLedLabel_38.setMaskValue("0x20");
		thLedLabel_38.setSignalName("PSM/Device1/PSMG_STAT_PM");
		thLedLabel_38.setLabelText("V OK");
		thLedLabel_38.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_38.setBounds(10, 70, 162, 18);
		
		ThLedLabel thLedLabel_18 = new ThLedLabel(thgrpPowerModuleState, SWT.NONE);
		thLedLabel_18.setInverted(true);
		thLedLabel_18.setMaskValue("0x04");
		thLedLabel_18.setSignalName("PSM/Device1/PSMG_STAT_PM");
		thLedLabel_18.setLabelText("V Fault");
		thLedLabel_18.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_18.setBounds(262, 70, 156, 18);
		
		ThLedLabel thLedLabel_10 = new ThLedLabel(thgrpPowerModuleState, SWT.NONE);
		thLedLabel_10.setInverted(false);
		thLedLabel_10.setMaskValue("0x10");
		thLedLabel_10.setSignalName("PSM/Device1/PSMG_STAT_PM");
		thLedLabel_10.setLabelText("RX OK");
		thLedLabel_10.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_10.setBounds(10, 46, 162, 18);
		
		ThLedLabel thLedLabel_17 = new ThLedLabel(thgrpPowerModuleState, SWT.NONE);
		thLedLabel_17.setInverted(true);
		thLedLabel_17.setMaskValue("0x01");
		thLedLabel_17.setSignalName("PSM/Device1/PSMG_STAT_PM");
		thLedLabel_17.setLabelText("Ready Fault");
		thLedLabel_17.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_17.setBounds(262, 22, 162, 18);
		
		ThLedLabel thLedLabel_19 = new ThLedLabel(thgrpPowerModuleState, SWT.NONE);
		thLedLabel_19.setInverted(true);
		thLedLabel_19.setMaskValue("0x02");
		thLedLabel_19.setSignalName("PSM/Device1/PSMG_STAT_PM");
		thLedLabel_19.setLabelText("RX Fault");
		thLedLabel_19.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_19.setBounds(262, 46, 156, 18);
		
		ThGroup thgrpPowerModuleSkiip = new ThGroup(thComposite, SWT.NONE);
		thgrpPowerModuleSkiip.setText("Power Module SKIIP State");
		thgrpPowerModuleSkiip.setFont(SWTResourceManager.getFont("Tahoma", 12, SWT.BOLD));
		thgrpPowerModuleSkiip.setBounds(11, 174, 515, 80);
		
		ThLedLabel thLedLabel_21 = new ThLedLabel(thgrpPowerModuleSkiip, SWT.NONE);
		thLedLabel_21.setInverted(true);
		thLedLabel_21.setMaskValue("0x01");
		thLedLabel_21.setSignalName("PSM/Device1/PSMG_STAT_PM_SKIIP");
		thLedLabel_21.setLabelText("Defect");
		thLedLabel_21.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_21.setBounds(10, 22, 246, 18);
		
		ThLedLabel thLedLabel_22 = new ThLedLabel(thgrpPowerModuleSkiip, SWT.NONE);
		thLedLabel_22.setInverted(true);
		thLedLabel_22.setMaskValue("0x02");
		thLedLabel_22.setSignalName("PSM/Device1/PSMG_STAT_PM_SKIIP");
		thLedLabel_22.setLabelText("Startup");
		thLedLabel_22.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_22.setBounds(10, 49, 246, 18);
		
		ThLedLabel thLedLabel_23 = new ThLedLabel(thgrpPowerModuleSkiip, SWT.NONE);
		thLedLabel_23.setInverted(false);
		thLedLabel_23.setMaskValue("0x08");
		thLedLabel_23.setSignalName("PSM/Device1/PSMG_STAT_PM_SKIIP");
		thLedLabel_23.setLabelText("ZSE Fiber Optic OK");
		thLedLabel_23.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_23.setBounds(262, 49, 243, 18);
		
		ThLedLabel thLedLabel_24 = new ThLedLabel(thgrpPowerModuleSkiip, SWT.NONE);
		thLedLabel_24.setInverted(false);
		thLedLabel_24.setMaskValue("0x04");
		thLedLabel_24.setSignalName("PSM/Device1/PSMG_STAT_PM_SKIIP");
		thLedLabel_24.setLabelText("ZSE Ready");
		thLedLabel_24.setFont(SWTResourceManager.getFont("Tahoma", 11, SWT.BOLD));
		thLedLabel_24.setBounds(262, 22, 243, 18);

		super.createPartControl(parent);
	}

	@Override
	public void setFocus() {
		// TODO Auto-generated method stub

	}
	

	private void navigateControl(Control[] controls, int index) throws Exception {
		for(Control c : controls) {
			if(c instanceof ThText) {
				((ThText) c).setSignalIndex(index);
			}
			else if(c instanceof ThLed) {
				((ThLed) c).setSignalIndex(index);
			}
			else if(c instanceof ThLabelMsg) {
				((ThLabelMsg) c).setSignalIndex(index);
			}			
			else if(c instanceof Composite) {
				navigateControl(((Composite) c).getChildren(), index); // Rekursion
			}
		}
	}
}
