/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.ftdi.emf.ftdi.impl;

import ch.thomson.ucs.ftdi.FTDIException;
import ch.thomson.ucs.ftdi.UsbDevice;
import ch.thomson.ucs.ftdi.emf.ftdi.Descriptor;
import ch.thomson.ucs.ftdi.emf.ftdi.Device;
import ch.thomson.ucs.ftdi.emf.ftdi.Firmware;
import ch.thomson.ucs.ftdi.emf.ftdi.FtdiFactory;
import ch.thomson.ucs.ftdi.emf.ftdi.FtdiPackage;
import ch.thomson.ucs.ftdi.emf.ftdi.util.Activator;

import ch.thomson.ucs.utils.logging.IPluginLogger;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Device</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.ftdi.emf.ftdi.impl.DeviceImpl#getFirmware <em>Firmware</em>}</li>
 *   <li>{@link ch.thomson.ucs.ftdi.emf.ftdi.impl.DeviceImpl#getDescriptor <em>Descriptor</em>}</li>
 *   <li>{@link ch.thomson.ucs.ftdi.emf.ftdi.impl.DeviceImpl#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.ftdi.emf.ftdi.impl.DeviceImpl#getIndex <em>Index</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DeviceImpl extends EObjectImpl implements Device {
	
	private final static IPluginLogger logger = Activator.getLogger();

	private UsbDevice usbDevice = null;
	
	/**
	 * The cached value of the '{@link #getFirmware() <em>Firmware</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFirmware()
	 * @generated
	 * @ordered
	 */
	protected Firmware firmware;

	/**
	 * The cached value of the '{@link #getDescriptor() <em>Descriptor</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescriptor()
	 * @generated
	 * @ordered
	 */
	protected Descriptor descriptor;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getIndex() <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndex()
	 * @generated
	 * @ordered
	 */
	protected static final int INDEX_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getIndex() <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndex()
	 * @generated
	 * @ordered
	 */
	protected int index = INDEX_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DeviceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return FtdiPackage.Literals.DEVICE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Firmware getFirmware() {
		return firmware;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetFirmware(Firmware newFirmware, NotificationChain msgs) {
		Firmware oldFirmware = firmware;
		firmware = newFirmware;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, FtdiPackage.DEVICE__FIRMWARE, oldFirmware, newFirmware);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFirmware(Firmware newFirmware) {
		if (newFirmware != firmware) {
			NotificationChain msgs = null;
			if (firmware != null)
				msgs = ((InternalEObject)firmware).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - FtdiPackage.DEVICE__FIRMWARE, null, msgs);
			if (newFirmware != null)
				msgs = ((InternalEObject)newFirmware).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - FtdiPackage.DEVICE__FIRMWARE, null, msgs);
			msgs = basicSetFirmware(newFirmware, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FtdiPackage.DEVICE__FIRMWARE, newFirmware, newFirmware));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Descriptor getDescriptor() {
		return descriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDescriptor(Descriptor newDescriptor, NotificationChain msgs) {
		Descriptor oldDescriptor = descriptor;
		descriptor = newDescriptor;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, FtdiPackage.DEVICE__DESCRIPTOR, oldDescriptor, newDescriptor);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescriptor(Descriptor newDescriptor) {
		if (newDescriptor != descriptor) {
			NotificationChain msgs = null;
			if (descriptor != null)
				msgs = ((InternalEObject)descriptor).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - FtdiPackage.DEVICE__DESCRIPTOR, null, msgs);
			if (newDescriptor != null)
				msgs = ((InternalEObject)newDescriptor).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - FtdiPackage.DEVICE__DESCRIPTOR, null, msgs);
			msgs = basicSetDescriptor(newDescriptor, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FtdiPackage.DEVICE__DESCRIPTOR, newDescriptor, newDescriptor));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public String getName() {
/*		if((getIndex() % 2) == 0)
			name = String.format("[%d] %s Port[A]", getIndex(), getDescriptor().getProduct());
		else
			name = String.format("[%d] %s Port[B]", getIndex(), getDescriptor().getProduct());
*/		name = getDescriptor().getProduct();	
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FtdiPackage.DEVICE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getIndex() {
		return index;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIndex(int newIndex) {
		int oldIndex = index;
		index = newIndex;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FtdiPackage.DEVICE__INDEX, oldIndex, index));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int open() {
		usbDevice = new UsbDevice(this.getIndex());
		try
		{
			usbDevice.init();
		}
		catch(FTDIException e)
		{
//			System.out.println("System.out DeviceImpl.open() FTDIException e = " + e.getMessage());
//			logger.info("DeviceImpl.open() FTDIException e = " + e.getMessage());
			return -1;
		}
		if(usbDevice.getDescriptor() != null)
		{
			Descriptor descriptor = FtdiFactory.eINSTANCE.createDescriptor();
			descriptor.setBuffer(usbDevice.getDescriptor().getEepromBuffer());
			descriptor.setBoardId(usbDevice.getDescriptor().getUABoardId());
			descriptor.setBoardSerial(usbDevice.getDescriptor().getUABoardSerial());
			descriptor.setBoardVersion(usbDevice.getDescriptor().getUABoardVersion());
			descriptor.setProduct(usbDevice.getDescriptor().getProduct());
			descriptor.setSelfPowered(usbDevice.getDescriptor().getSelfPowered());
			this.setDescriptor(descriptor);
		}
		if(usbDevice.getFirmware() != null)
		{
			Firmware firmware = FtdiFactory.eINSTANCE.createFirmware();
			firmware.setBoardNo(usbDevice.getFirmware().getBoardNo());
			firmware.setBoardStatus(usbDevice.getFirmware().getBoardStatus());
			firmware.setDateHdl(usbDevice.getFirmware().getDateHdl());
			firmware.setDateSw(usbDevice.getFirmware().getDateSw());
			firmware.setId(usbDevice.getFirmware().getId());
			firmware.setInterfaceVer(usbDevice.getFirmware().getInterfaceVer());
			firmware.setProgStatus(usbDevice.getFirmware().getProgStatus());
			firmware.setVersion(usbDevice.getFirmware().getVersion());
			this.setFirmware(firmware);
		}
		return 0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void writeEeprom(byte[] bufUserData) {
		if(usbDevice != null)
		{
			usbDevice.getDescriptor().setProduct(this.getDescriptor().getProduct());
			usbDevice.getDescriptor().setUABoardId(this.getDescriptor().getBoardId());
			usbDevice.getDescriptor().setUABoardVersion(this.getDescriptor().getBoardVersion());
			usbDevice.getDescriptor().setUABoardSerial(this.getDescriptor().getBoardSerial());
			usbDevice.getDescriptor().setSelfPowered(this.getDescriptor().isSelfPowered());
			// set default values
			usbDevice.getDescriptor().setPortMode(0, (byte)8);	// SPI
			usbDevice.getDescriptor().setPortMode(1, (byte)9);	// async Fifo
			usbDevice.getDescriptor().setUserDataBuffer(bufUserData);
			
			byte[] buf = usbDevice.getDescriptor().getEepromBuffer();
			try {
				usbDevice.write_eeprom(buf);
			} catch (FTDIException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			descriptor.setBuffer(buf);
			
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case FtdiPackage.DEVICE__FIRMWARE:
				return basicSetFirmware(null, msgs);
			case FtdiPackage.DEVICE__DESCRIPTOR:
				return basicSetDescriptor(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case FtdiPackage.DEVICE__FIRMWARE:
				return getFirmware();
			case FtdiPackage.DEVICE__DESCRIPTOR:
				return getDescriptor();
			case FtdiPackage.DEVICE__NAME:
				return getName();
			case FtdiPackage.DEVICE__INDEX:
				return getIndex();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case FtdiPackage.DEVICE__FIRMWARE:
				setFirmware((Firmware)newValue);
				return;
			case FtdiPackage.DEVICE__DESCRIPTOR:
				setDescriptor((Descriptor)newValue);
				return;
			case FtdiPackage.DEVICE__NAME:
				setName((String)newValue);
				return;
			case FtdiPackage.DEVICE__INDEX:
				setIndex((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case FtdiPackage.DEVICE__FIRMWARE:
				setFirmware((Firmware)null);
				return;
			case FtdiPackage.DEVICE__DESCRIPTOR:
				setDescriptor((Descriptor)null);
				return;
			case FtdiPackage.DEVICE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case FtdiPackage.DEVICE__INDEX:
				setIndex(INDEX_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case FtdiPackage.DEVICE__FIRMWARE:
				return firmware != null;
			case FtdiPackage.DEVICE__DESCRIPTOR:
				return descriptor != null;
			case FtdiPackage.DEVICE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case FtdiPackage.DEVICE__INDEX:
				return index != INDEX_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", index: ");
		result.append(index);
		result.append(')');
		return result.toString();
	}
	
} //DeviceImpl
