package ch.thomson.ucs.ftdi.ui;

import java.io.PrintStream;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleConstants;
import org.eclipse.ui.console.MessageConsole;
import org.eclipse.ui.console.MessageConsoleStream;

public class Perspective implements IPerspectiveFactory {

	public void createInitialLayout(IPageLayout layout) {
		layout.setEditorAreaVisible(false);
		layout.setFixed(true);
		
		String editorArea = layout.getEditorArea();  
		IFolderLayout folder = layout.createFolder("messages", IPageLayout.TOP, 0.5f, editorArea);  
		folder.addPlaceholder(View.ID + ":*");  
		folder.addView(View.ID);   
		IFolderLayout consoleFolder = layout.createFolder("console", IPageLayout.BOTTOM, 0.8f, "messages");
		consoleFolder.addView(IConsoleConstants.ID_CONSOLE_VIEW);  
		
		layout.getViewLayout(IConsoleConstants.ID_CONSOLE_VIEW).setCloseable(false);

		MessageConsole myConsole = new MessageConsole("", null); // declare
	    
        ConsolePlugin.getDefault().getConsoleManager().addConsoles(new IConsole[] { myConsole });
        MessageConsoleStream stream = myConsole.newMessageStream();
        PrintStream myS = new PrintStream(stream);
        System.setOut(myS); // link standard output stream to the console
 //       System.setErr(myS); // link error output stream to the console
	}

}
