package ch.thomson.ucs.ftdi.ui;

import java.util.ArrayList;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.observable.IObservable;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.observable.masterdetail.IObservableFactory;
import org.eclipse.core.databinding.observable.value.WritableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.emf.databinding.EMFProperties;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.databinding.viewers.ObservableListTreeContentProvider;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.jface.databinding.viewers.TreeStructureAdvisor;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleConstants;
import org.eclipse.ui.console.MessageConsole;
import org.eclipse.ui.part.ViewPart;

import ch.thomson.ucs.ftdi.emf.ftdi.Device;
import ch.thomson.ucs.ftdi.emf.ftdi.DeviceList;
import ch.thomson.ucs.ftdi.emf.ftdi.FtdiFactory;
import ch.thomson.ucs.ftdi.emf.ftdi.FtdiPackage;
import ch.thomson.ucs.ftdi.emf.ftdi.FtdiPackage.Literals;
import ch.thomson.ucs.ftdi.emf.ftdi.impl.FtdiPackageImpl;
import ch.thomson.ucs.ftdi.ui.Converters.ShortToStringConverter;
import ch.thomson.ucs.ftdi.ui.Converters.StringToShortConverter;

import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.core.databinding.beans.PojoObservables;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.core.databinding.UpdateValueStrategy;
import ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter;
import ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter;
import ch.thomson.ucs.ftdi.ui.Converters.IntToBooleanConverter;
import ch.thomson.ucs.ftdi.ui.Converters.BooleanToIntConverter;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Group;


public class View extends ViewPart {
	public static final String ID = "ch.thomson.ucs.ftdi.ui.view";

	private int indexColumn = 0;
	private Button btnCheckButton;
	private Button btnWriteButton;
	
	private TreeViewer treeViewer;
	private TabFolder tabFolder; 
	private TableViewer tableViewer; 

	private DataBindingContext m_bindingContext;
	
	private DeviceList deviceList = null;
	Device device = null;
	
	private WritableValue data = new WritableValue();

	// EEPROM
	private Text textProduct;
	private Text textBoardId;
	private Text textBoardVersion;
	private Text textBoardSerial;
	
	// Firmware
	private Text textFirmwareId;
	private Text textFirmwareVersion;
	private Text textDateHdl;
	private Text textDateSw;
	private Text textInterfaceVer;
	private Text textBoardNo;
	private Text textBoardStatus;
	private Text textCrc;
	private Text textProgStatus;
	private Combo comboSelfPowered;
	
	private ArrayList<int[]> iArray;
	private Composite composite_1;
	private Composite composite_2;
	private Table table_1;
	private Group group;
	
	private Text[] textUserData = new Text[24];
		
	public View() {
	}
	

	/**
	 * The content provider class is responsible for providing objects to the
	 * view. It can wrap existing objects in adapters or simply return objects
	 * as-is. These objects may be sensitive to the current input of the view,
	 * or ignore it and always show the same content (like Task List, for
	 * example).
	 */
	class ViewContentProvider implements IStructuredContentProvider {
		public void inputChanged(Viewer v, Object oldInput, Object newInput) {
		}

		public void dispose() {
		}

		public Object[] getElements(Object parent) {
			if (parent instanceof Object[]) {
				return (Object[]) parent;
			}
	        return new Object[0];
		}
	}

	class ViewLabelProvider extends LabelProvider implements
			ITableLabelProvider {
		public String getColumnText(Object obj, int index) {
			return getText(obj);
		}

		public Image getColumnImage(Object obj, int index) {
			return getImage(obj);
		}

		public Image getImage(Object obj) {
			return PlatformUI.getWorkbench().getSharedImages().getImage(
					ISharedImages.IMG_OBJ_ELEMENT);
		}
	}

	/**
	 * This is a callback that will allow us to create the viewer and initialize
	 * it.
	 */
	public void createPartControl(Composite parent) {
        
		IWorkbenchPage workbenchPage = this.getSite().getPage();
        IViewPart viewPart = workbenchPage.findView( IConsoleConstants.ID_CONSOLE_VIEW );
        IViewSite viewSite = viewPart.getViewSite();
        IActionBars actionBars = viewSite.getActionBars();
        IToolBarManager toolBarManager = actionBars.getToolBarManager();
        IContributionItem[] contributionItems = toolBarManager.getItems();
        contributionItems = toolBarManager.getItems();
        for (int i = 0; i < contributionItems.length; i++)
        if ( i >= 2 )
        	toolBarManager.remove( contributionItems[i] );
        
        IConsole [] conArr = ConsolePlugin.getDefault().getConsoleManager().getConsoles();
        if((conArr.length > 0) && (conArr[0] instanceof MessageConsole))
        {
        	MessageConsole msgCon = (MessageConsole) conArr[0]; 
        	msgCon.clearConsole();
        }
        
        FtdiPackageImpl.init();
		deviceList = FtdiFactory.eINSTANCE.createDeviceList();
		device = deviceList.getDevice().get(0);
		
		iArray = new ArrayList<int[]>();
		setTableData();
		
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(2, false));

		// Tree handling
		treeViewer = new TreeViewer(composite, SWT.BORDER);
		Tree tree = treeViewer.getTree();
		GridData gd_tree = new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1);
		gd_tree.widthHint = 188;
		tree.setLayoutData(gd_tree);		
		
		// Observables factory     
		IObservableFactory observableFactory = new IObservableFactory() {  
			@Override        
			public IObservable createObservable(Object target) {             
				if (target instanceof Device)                 
					return EMFProperties.list(FtdiPackageImpl.Literals.DEVICE_LIST__DEVICE).observe(target);            
				else if (target instanceof IObservable)                 
					return (IObservable) target;             
				return null;         
				}     
			}; 		
			
		// Advisor     
		TreeStructureAdvisor advisor = new TreeStructureAdvisor() {         
			@Override        
			public Boolean hasChildren(Object element) {             
/*				if (element instanceof Device) {                 
					return true;             
					}             
				return super.hasChildren(element);
*/				return false;				         
				}				     
			};  		
			
		// Content provider needs an observables factory and an advisor to     
		// generate the proper input     
		ObservableListTreeContentProvider contentProvider = new ObservableListTreeContentProvider( 
				observableFactory, advisor);      
		// Observable maps, in order to listen to changes of model properties     
		IObservableMap[] maps = new IObservableMap[1];      
		maps[0] = EMFProperties.value(FtdiPackage.Literals.DEVICE_LIST__DEVICE).observeDetail(
																	contentProvider.getKnownElements()); 
//		maps[1] = EMFProperties.value(FtdiPackageImpl.Literals.DESCRIPTOR__PRODUCT).observeDetail(
//				contentProvider.getKnownElements());
//		maps[0] = EMFProperties.value(FeaturePath.fromList(FtdiPackage.Literals.DEVICE_LIST__DEVICE, 
//		FtdiPackage.Literals.DESCRIPTOR__PRODUCT)).observeDetail(contentProvider.getKnownElements()); 		
		
//		IObservableMap[] maps = EMFObservables.observeMaps(contentProvider.getKnownElements(), 
//				new EStructuralFeature[]{Literals.DESCRIPTOR__PRODUCT, Literals.DESCRIPTOR__BOARD_ID, Literals.DESCRIPTOR__BOARD_VERSION});
																	
		IObservableList observableList = EMFObservables.observeList(Realm.getDefault(), deviceList, Literals.DEVICE_LIST__DEVICE);		
		
		// Label provider     
		ObservableMapLabelProvider labelProvider = new ObservableMapLabelProvider(maps) {
			public String getColumnText(Object element, int columnIndex) {             
				if (element instanceof Device) {                 
					Device dev = (Device) element;                 
//					return dev.getDescriptor().getProduct();         
					return dev.getName();
				} 
				return super.getColumnText(element, columnIndex); 
			}
			@Override
			public String getText(Object element) {
				if (element instanceof Device) {
					Device category = (Device) element;
//					return category.getDescriptor().getProduct();
					return category.getName();
				}
				return "";
			}

			@Override
			public Image getImage(Object element) {
				if (element instanceof DeviceCategory) {
					return PlatformUI.getWorkbench().getSharedImages()
							.getImage(ISharedImages.IMG_OBJ_FOLDER);
				}
				return PlatformUI.getWorkbench().getSharedImages()
				.getImage(ISharedImages.IMG_OBJ_FILE);
			}
			
		}; 
		
//		IObservableMap[] observeMaps = EMFObservables.observeMaps(contentProvider.getKnownElements(), new EStructuralFeature[]{Literals.DATA__NAME, Literals.DATA__DESCRIPTION, Literals.DATA__VALUE});
//		viewer.setLabelProvider(new ObservableMapLabelProvider(observeMaps));
		//
//		IObservableList signalListDataObserveList = EMFObservables.observeList(Realm.getDefault(), signalList, Literals.SIGNAL_LIST__DATA);
//		viewer.setInput(signalListDataObserveList);
		
		// Initiating the tree     
		treeViewer.setContentProvider(contentProvider);     
		treeViewer.setLabelProvider(labelProvider);     
		treeViewer.setInput(observableList); 
		
//		treeViewer.setContentProvider(new FtdiTreeContentProvider());
//		treeViewer.setLabelProvider(new FtdiTreeLabelProvider());
		
		// Expand the tree 
		// viewer.setAutoExpandLevel(2);
		
		// Provide the input to the ContentProvider
//		treeViewer.setInput(new FtdiTreeModel());
//		treeViewer.setInput(deviceList);
		
		treeViewer.addSelectionChangedListener(new ISelectionChangedListener() {
			public void selectionChanged(SelectionChangedEvent event) {
				StructuredSelection ss = (StructuredSelection) event.getSelection();
				if(ss.getFirstElement() instanceof Device) {
					data.setValue(ss.getFirstElement());
					Device dev = (Device) ss.getFirstElement();
					if(((dev.getIndex() % 2) == 0) && (tabFolder.getItemCount() < 2))
						setTabFpgaHeader();
					else if(((dev.getIndex() % 2) == 1) && (tabFolder.getItemCount() > 1))
						tabFolder.getItem(1).dispose();
					device = dev;
					setTableData();
					tableViewer.refresh(false);
				}
			}
		});
		
		tabFolder = new TabFolder(composite, SWT.NONE);
		tabFolder.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		TabItem tbtmNewItem = new TabItem(tabFolder, SWT.NONE);
		tbtmNewItem.setText("EEPROM");
		
		composite_1 = new Composite(tabFolder, SWT.NONE);
		tbtmNewItem.setControl(composite_1);
		GridLayout gl_composite_1 = new GridLayout(3, false);
		gl_composite_1.marginTop = 5;
		composite_1.setLayout(gl_composite_1);
		
		Label lblNewLabel = new Label(composite_1, SWT.NONE);
		lblNewLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblNewLabel.setText("Product");
		
		textProduct = new Text(composite_1, SWT.BORDER);
		textProduct.setEditable(false);
		GridData gd_textProduct = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textProduct.widthHint = 200;
		textProduct.setLayoutData(gd_textProduct);
		
		group = new Group(composite_1, SWT.NONE);
		group.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 4));
		group.setText("User Area - Byte [0 - 23]");
		
		for(int i=0; i<24; i++)
		{
			textUserData[i] = new Text(group, SWT.BORDER);
			textUserData[i].setEditable(false);
			textUserData[i].setBounds(16 + ((i%8)*41), 18 + ((i/8)*25), 35, 19);
		}
	
/*		
		text = new Text(group, SWT.BORDER);
		text.setEditable(false);
		text.setBounds(16, 18, 35, 19);
		
		text_1 = new Text(group, SWT.BORDER);
		text_1.setEditable(false);
		text_1.setBounds(57, 18, 35, 19);
		
		text_2 = new Text(group, SWT.BORDER);
		text_2.setEditable(false);
		text_2.setBounds(98, 18, 35, 19);
		
		text_3 = new Text(group, SWT.BORDER);
		text_3.setEditable(false);
		text_3.setBounds(139, 18, 35, 19);
		
		text_4 = new Text(group, SWT.BORDER);
		text_4.setEditable(false);
		text_4.setBounds(180, 18, 35, 19);
		
		text_5 = new Text(group, SWT.BORDER);
		text_5.setEditable(false);
		text_5.setBounds(221, 18, 35, 19);
		
		text_6 = new Text(group, SWT.BORDER);
		text_6.setEditable(false);
		text_6.setBounds(262, 18, 35, 19);
		
		text_7 = new Text(group, SWT.BORDER);
		text_7.setEditable(false);
		text_7.setBounds(303, 18, 35, 19);
		
		text_8 = new Text(group, SWT.BORDER);
		text_8.setEditable(false);
		text_8.setBounds(16, 43, 35, 19);
		
		text_9 = new Text(group, SWT.BORDER);
		text_9.setEditable(false);
		text_9.setBounds(57, 43, 35, 19);
		
		text_10 = new Text(group, SWT.BORDER);
		text_10.setEditable(false);
		text_10.setBounds(98, 43, 35, 19);
		
		text_11 = new Text(group, SWT.BORDER);
		text_11.setEditable(false);
		text_11.setBounds(139, 43, 35, 19);
		
		text_12 = new Text(group, SWT.BORDER);
		text_12.setEditable(false);
		text_12.setBounds(180, 43, 35, 19);
		
		text_13 = new Text(group, SWT.BORDER);
		text_13.setEditable(false);
		text_13.setBounds(221, 43, 35, 19);
		
		text_14 = new Text(group, SWT.BORDER);
		text_14.setEditable(false);
		text_14.setBounds(262, 43, 35, 19);
		
		text_15 = new Text(group, SWT.BORDER);
		text_15.setEditable(false);
		text_15.setBounds(303, 43, 35, 19);
		
		text_16 = new Text(group, SWT.BORDER);
		text_16.setEditable(false);
		text_16.setBounds(16, 68, 35, 19);
		
		text_17 = new Text(group, SWT.BORDER);
		text_17.setEditable(false);
		text_17.setBounds(57, 68, 35, 19);
		
		text_18 = new Text(group, SWT.BORDER);
		text_18.setEditable(false);
		text_18.setBounds(98, 68, 35, 19);
		
		text_19 = new Text(group, SWT.BORDER);
		text_19.setEditable(false);
		text_19.setBounds(139, 68, 35, 19);
		
		text_20 = new Text(group, SWT.BORDER);
		text_20.setEditable(false);
		text_20.setBounds(180, 68, 35, 19);
		
		text_21 = new Text(group, SWT.BORDER);
		text_21.setEditable(false);
		text_21.setBounds(221, 68, 35, 19);
		
		text_22 = new Text(group, SWT.BORDER);
		text_22.setEditable(false);
		text_22.setBounds(262, 68, 35, 19);
		
		text_23 = new Text(group, SWT.BORDER);
		text_23.setEditable(false);
		text_23.setBounds(303, 68, 35, 19);
*/		
		Label lblBoardId = new Label(composite_1, SWT.NONE);
		lblBoardId.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblBoardId.setText("Board ID");
		
		textBoardId = new Text(composite_1, SWT.BORDER);
		textBoardId.setEditable(false);
		GridData gd_textBoardId = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textBoardId.widthHint = 200;
		textBoardId.setLayoutData(gd_textBoardId);
		
		Label lblBoardVersion = new Label(composite_1, SWT.NONE);
		lblBoardVersion.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblBoardVersion.setText("Board Version");
		
		textBoardVersion = new Text(composite_1, SWT.BORDER);
		textBoardVersion.setEditable(false);
		GridData gd_textBoardVersion = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textBoardVersion.widthHint = 200;
		textBoardVersion.setLayoutData(gd_textBoardVersion);
		
		Label lblBoardSerial = new Label(composite_1, SWT.NONE);
		lblBoardSerial.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblBoardSerial.setText("Board Serial");
		
		textBoardSerial = new Text(composite_1, SWT.BORDER);
		textBoardSerial.setEditable(false);
		GridData gd_textBoardSerial = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textBoardSerial.widthHint = 200;
		textBoardSerial.setLayoutData(gd_textBoardSerial);
		
		Label lblSelfPowered = new Label(composite_1, SWT.NONE);
		lblSelfPowered.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblSelfPowered.setText("Self Powered");
		
		comboSelfPowered = new Combo(composite_1, SWT.READ_ONLY);
		comboSelfPowered.setEnabled(false);
		comboSelfPowered.setVisibleItemCount(2);
		comboSelfPowered.setItems(new String[] {"false", "true"});
		GridData gd_comboSelfPowered = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_comboSelfPowered.widthHint = 183;
		comboSelfPowered.setLayoutData(gd_comboSelfPowered);
		comboSelfPowered.select(0);
		
		createTableViewer(composite_1);
		
		TabItem tbtmNewItem_1 = new TabItem(tabFolder, SWT.NONE);
		tbtmNewItem_1.setText("FPGA Header");
		
		composite_2 = new Composite(tabFolder, SWT.NONE);
		tbtmNewItem_1.setControl(composite_2);
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.marginTop = 5;
		composite_2.setLayout(gl_composite_2);
		
		Label lblId = new Label(composite_2, SWT.NONE);
		lblId.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblId.setText("ID");
		
		textFirmwareId = new Text(composite_2, SWT.BORDER);
		textFirmwareId.setEditable(false);
		GridData gd_textFirmwareId = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textFirmwareId.widthHint = 200;
		textFirmwareId.setLayoutData(gd_textFirmwareId);
		
		Label lblFirmwareVersion = new Label(composite_2, SWT.NONE);
		lblFirmwareVersion.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblFirmwareVersion.setText("Firmware Version");
		
		textFirmwareVersion = new Text(composite_2, SWT.BORDER);
		textFirmwareVersion.setEditable(false);
		GridData gd_textFirmwareVersion = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textFirmwareVersion.widthHint = 200;
		textFirmwareVersion.setLayoutData(gd_textFirmwareVersion);
		
		Label lblDateHdl = new Label(composite_2, SWT.NONE);
		lblDateHdl.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDateHdl.setText("Date HDL");
		
		textDateHdl = new Text(composite_2, SWT.BORDER);
		textDateHdl.setEditable(false);
		GridData gd_textDateHdl = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textDateHdl.widthHint = 200;
		textDateHdl.setLayoutData(gd_textDateHdl);
		
		Label lblDateSoftware = new Label(composite_2, SWT.NONE);
		lblDateSoftware.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDateSoftware.setText("Date Software");
		
		textDateSw = new Text(composite_2, SWT.BORDER);
		textDateSw.setEditable(false);
		GridData gd_textDateSw = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textDateSw.widthHint = 200;
		textDateSw.setLayoutData(gd_textDateSw);
		
		Label lblInterfaceVersion = new Label(composite_2, SWT.NONE);
		lblInterfaceVersion.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblInterfaceVersion.setText("Interface Version");
		
		textInterfaceVer = new Text(composite_2, SWT.BORDER);
		textInterfaceVer.setEditable(false);
		GridData gd_textInterfaceVer = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textInterfaceVer.widthHint = 200;
		textInterfaceVer.setLayoutData(gd_textInterfaceVer);
		
		Label lblBoardNumber = new Label(composite_2, SWT.NONE);
		lblBoardNumber.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblBoardNumber.setText("Board Number");
		
		textBoardNo = new Text(composite_2, SWT.BORDER);
		textBoardNo.setEditable(false);
		GridData gd_textBoardNo = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textBoardNo.widthHint = 200;
		textBoardNo.setLayoutData(gd_textBoardNo);
		
		Label lblBoardStatus = new Label(composite_2, SWT.NONE);
		lblBoardStatus.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblBoardStatus.setText("Board Status");
		
		textBoardStatus = new Text(composite_2, SWT.BORDER);
		textBoardStatus.setEditable(false);
		GridData gd_textBoardStatus = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textBoardStatus.widthHint = 200;
		textBoardStatus.setLayoutData(gd_textBoardStatus);
		
		Label lblCrc = new Label(composite_2, SWT.NONE);
		lblCrc.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblCrc.setText("CRC");
		
		textCrc = new Text(composite_2, SWT.BORDER);
		textCrc.setEditable(false);
		GridData gd_textCrc = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textCrc.widthHint = 200;
		textCrc.setLayoutData(gd_textCrc);
		
		Label lblProgramStatus = new Label(composite_2, SWT.NONE);
		lblProgramStatus.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblProgramStatus.setText("Program Status");
		
		textProgStatus = new Text(composite_2, SWT.BORDER);
		textProgStatus.setEditable(false);
		GridData gd_textProgStatus = new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1);
		gd_textProgStatus.widthHint = 200;
		textProgStatus.setLayoutData(gd_textProgStatus);
		new Label(composite_2, SWT.NONE);
		
		Button btnFpgaButton = new Button(composite_2, SWT.NONE);
		btnFpgaButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Shell shell = new Shell(composite_2.getDisplay());
				FileDialog fileDialog = new FileDialog(shell);
//				fileDialog.setFilterPath("/etc");
				fileDialog.setFilterExtensions(new String[] { "*.svf" });
				fileDialog.setFilterNames(new String[] { "Firmware files (*.svf)" });
				fileDialog.setText("FileDialog");
				String selectedFile = fileDialog.open();
				if (selectedFile != null) {
				    System.out.println(selectedFile + " was selected.");
				    MessageBox dialog = new MessageBox(shell, SWT.ICON_QUESTION | SWT.OK| SWT.CANCEL);
				    dialog.setText("Open svf Firmware File");
				    dialog.setMessage(selectedFile + " was selected.");
				    int returnCode = dialog.open();				    
				}				
			}
		});
		btnFpgaButton.setText("Write FPGA");
		
		treeViewer.getTree().setFocus();
		m_bindingContext = initDataBindings();
		
	}

	private void setTableData() {
		byte[] buf = device.getDescriptor().getBuffer();
		iArray.clear();
		for(int i=0; i<16; i++)
		{
			int[] iArr = new int[16];
			for(int j=0; j<16; j++)
			{
				if(buf.length <= ((i*16)+j))
					break;
				else
					iArr[j] = (buf[(i*16)+j]) & 0xFF;
			}
			iArray.add(iArr);
		}	
		if(textUserData != null)
		{
			for(int i=0; i<24; i++)
			{
				if(textUserData[i] != null)
					textUserData[i].setText(Byte.toString(buf[i + 230]));
			}
		}
	}

	private void setTabFpgaHeader() {
		TabItem tbtmNewItem_1 = new TabItem(tabFolder, SWT.NONE);
		tbtmNewItem_1.setText("FPGA Header");
		//tbtmNewItem_1.
		
		Composite composite_2 = new Composite(tabFolder, SWT.NONE);
		tbtmNewItem_1.setControl(composite_2);
		composite_2.setLayout(new GridLayout(2, false));
		
		Label lblId = new Label(composite_2, SWT.NONE);
		lblId.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblId.setText("ID");
		
		textFirmwareId = new Text(composite_2, SWT.BORDER);
		textFirmwareId.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblFirmwareVersion = new Label(composite_2, SWT.NONE);
		lblFirmwareVersion.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblFirmwareVersion.setText("Firmware Version");
		
		textFirmwareVersion = new Text(composite_2, SWT.BORDER);
		textFirmwareVersion.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblDateHdl = new Label(composite_2, SWT.NONE);
		lblDateHdl.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDateHdl.setText("Date HDL");
		
		textDateHdl = new Text(composite_2, SWT.BORDER);
		textDateHdl.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblDateSoftware = new Label(composite_2, SWT.NONE);
		lblDateSoftware.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDateSoftware.setText("Date Software");
		
		textDateSw = new Text(composite_2, SWT.BORDER);
		textDateSw.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblInterfaceVersion = new Label(composite_2, SWT.NONE);
		lblInterfaceVersion.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblInterfaceVersion.setText("Interface Version");
		
		textInterfaceVer = new Text(composite_2, SWT.BORDER);
		textInterfaceVer.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblBoardNumber = new Label(composite_2, SWT.NONE);
		lblBoardNumber.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblBoardNumber.setText("Board Number");
		
		textBoardNo = new Text(composite_2, SWT.BORDER);
		textBoardNo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblBoardStatus = new Label(composite_2, SWT.NONE);
		lblBoardStatus.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblBoardStatus.setText("Board Status");
		
		textBoardStatus = new Text(composite_2, SWT.BORDER);
		textBoardStatus.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblCrc = new Label(composite_2, SWT.NONE);
		lblCrc.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblCrc.setText("CRC");
		
		textCrc = new Text(composite_2, SWT.BORDER);
		textCrc.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblProgramStatus = new Label(composite_2, SWT.NONE);
		lblProgramStatus.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblProgramStatus.setText("Program Status");
		
		textProgStatus = new Text(composite_2, SWT.BORDER);
		textProgStatus.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));		
		
		IObservableValue textFirmwareIdObserveTextObserveWidget = SWTObservables.observeText(textFirmwareId, SWT.Modify);
		IObservableValue dataFirmwareidObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.id", int.class);
		UpdateValueStrategy strategy_8 = new UpdateValueStrategy();
		strategy_8.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_9 = new UpdateValueStrategy();
		strategy_9.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textFirmwareIdObserveTextObserveWidget, dataFirmwareidObserveDetailValue, strategy_8, strategy_9);
		//
		IObservableValue textFirmwareVersionObserveTextObserveWidget = SWTObservables.observeText(textFirmwareVersion, SWT.Modify);
		IObservableValue dataFirmwareversionObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.version", int.class);
		UpdateValueStrategy strategy_10 = new UpdateValueStrategy();
		strategy_10.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_11 = new UpdateValueStrategy();
		strategy_11.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textFirmwareVersionObserveTextObserveWidget, dataFirmwareversionObserveDetailValue, strategy_10, strategy_11);
		//
		IObservableValue textDateHdlObserveTextObserveWidget = SWTObservables.observeText(textDateHdl, SWT.Modify);
		IObservableValue dataFirmwaredateHdlObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.dateHdl", int.class);
		UpdateValueStrategy strategy_12 = new UpdateValueStrategy();
		strategy_12.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_13 = new UpdateValueStrategy();
		strategy_13.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textDateHdlObserveTextObserveWidget, dataFirmwaredateHdlObserveDetailValue, strategy_12, strategy_13);
		//
		IObservableValue textDateSwObserveTextObserveWidget = SWTObservables.observeText(textDateSw, SWT.Modify);
		IObservableValue dataFirmwaredateSwObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.dateSw", int.class);
		UpdateValueStrategy strategy_14 = new UpdateValueStrategy();
		strategy_14.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_15 = new UpdateValueStrategy();
		strategy_15.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textDateSwObserveTextObserveWidget, dataFirmwaredateSwObserveDetailValue, strategy_14, strategy_15);
		//
		IObservableValue textInterfaceVerObserveTextObserveWidget = SWTObservables.observeText(textInterfaceVer, SWT.Modify);
		IObservableValue dataFirmwareinterfaceVerObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.interfaceVer", int.class);
		UpdateValueStrategy strategy_16 = new UpdateValueStrategy();
		strategy_16.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_17 = new UpdateValueStrategy();
		strategy_17.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textInterfaceVerObserveTextObserveWidget, dataFirmwareinterfaceVerObserveDetailValue, strategy_16, strategy_17);
		//
		IObservableValue textBoardNoObserveTextObserveWidget = SWTObservables.observeText(textBoardNo, SWT.Modify);
		IObservableValue dataFirmwareboardNoObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.boardNo", int.class);
		UpdateValueStrategy strategy_18 = new UpdateValueStrategy();
		strategy_18.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_19 = new UpdateValueStrategy();
		strategy_19.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textBoardNoObserveTextObserveWidget, dataFirmwareboardNoObserveDetailValue, strategy_18, strategy_19);
		//
		IObservableValue textBoardStatusObserveTextObserveWidget = SWTObservables.observeText(textBoardStatus, SWT.Modify);
		IObservableValue dataFirmwareboardStatusObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.boardStatus", int.class);
		UpdateValueStrategy strategy_20 = new UpdateValueStrategy();
		strategy_20.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_21 = new UpdateValueStrategy();
		strategy_21.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textBoardStatusObserveTextObserveWidget, dataFirmwareboardStatusObserveDetailValue, strategy_20, strategy_21);
		//
		IObservableValue textCrcObserveTextObserveWidget = SWTObservables.observeText(textCrc, SWT.Modify);
		IObservableValue dataFirmwarecrcObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.crc", int.class);
		UpdateValueStrategy strategy_22 = new UpdateValueStrategy();
		strategy_22.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_23 = new UpdateValueStrategy();
		strategy_23.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textCrcObserveTextObserveWidget, dataFirmwarecrcObserveDetailValue, strategy_22, strategy_23);
		//
		IObservableValue textProgStatusObserveTextObserveWidget = SWTObservables.observeText(textProgStatus, SWT.Modify);
		IObservableValue dataFirmwareprogStatusObserveDetailValue = PojoObservables.observeDetailValue(data, "firmware.progStatus", int.class);
		UpdateValueStrategy strategy_24 = new UpdateValueStrategy();
		strategy_24.setConverter(new StringtoIntConverter());
		UpdateValueStrategy strategy_25 = new UpdateValueStrategy();
		strategy_25.setConverter(new IntToStringConverter());
		m_bindingContext.bindValue(textProgStatusObserveTextObserveWidget, dataFirmwareprogStatusObserveDetailValue, strategy_24, strategy_25);		
	}

	/**
	 * Passing the focus request to the viewer's control.
	 */
	public void setFocus() {
		//viewer.getControl().setFocus();
	}
	
	private void createTableViewer(Composite parent) {
		new Label(composite_1, SWT.NONE);
		new Label(composite_1, SWT.NONE);
		
		btnCheckButton = new Button(composite_1, SWT.CHECK);
		btnCheckButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
/*				if (btnCheckButton.getSelection()) {
					textProduct.setEditable(true);
					textBoardId.setEditable(true);
					textBoardVersion.setEditable(true);
					textBoardSerial.setEditable(true);
					comboSelfPowered.setEnabled(true);
					btnWriteButton.setEnabled(true);
                } else {
					textProduct.setEditable(false);
					textBoardId.setEditable(false);
					textBoardVersion.setEditable(false);
					textBoardSerial.setEditable(false);
                	comboSelfPowered.setEnabled(false);
					btnWriteButton.setEnabled(false);
                }
*/				textProduct.setEditable(btnCheckButton.getSelection());
				textBoardId.setEditable(btnCheckButton.getSelection());
				textBoardVersion.setEditable(btnCheckButton.getSelection());
				textBoardSerial.setEditable(btnCheckButton.getSelection());
				comboSelfPowered.setEnabled(btnCheckButton.getSelection());
				btnWriteButton.setEnabled(btnCheckButton.getSelection());
				for(int i=0; i<24; i++)
					textUserData[i].setEditable(btnCheckButton.getSelection());
			}
		});
		btnCheckButton.setText("Modify");
		new Label(composite_1, SWT.NONE);
		new Label(composite_1, SWT.NONE);
		
		btnWriteButton = new Button(composite_1, SWT.NONE);
		btnWriteButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if(device != null)
				{
					byte[] buf = new byte[24];
					for(int i=0; i<24; i++)
					{
						buf[i] = Byte.decode(textUserData[i].getText());
						textUserData[i].setEditable(false);
					}
					device.writeEeprom(buf);
					setTableData();
					tableViewer.refresh(false);
					btnCheckButton.setSelection(false);
					textProduct.setEditable(false);
					textBoardId.setEditable(false);
					textBoardVersion.setEditable(false);
					textBoardSerial.setEditable(false);
                	comboSelfPowered.setEnabled(false);
					btnWriteButton.setEnabled(false);
					treeViewer.refresh(true);
				}
			}
		});
		btnWriteButton.setEnabled(false);
		btnWriteButton.setText("Write EEPROM");
		new Label(composite_1, SWT.NONE);
		
		table_1 = new Table(composite_1, SWT.BORDER | SWT.FULL_SELECTION);
		table_1.setHeaderVisible(true);
		table_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		table_1.setLinesVisible(true);
		table_1.setTouchEnabled(true);
		table_1.setLayoutData(new GridData(SWT.RIGHT, SWT.BOTTOM, true, true, 1, 1));
		
		TableColumn tblclmnNewColumn = new TableColumn(table_1, SWT.RIGHT);
		tblclmnNewColumn.setWidth(48);
		tblclmnNewColumn.setResizable(false);
		
		TableItem tableItem = new TableItem(table_1, SWT.NONE);
		tableItem.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		tableItem.setText(new String[] {});
		tableItem.setText("000-015");
		
		TableItem tableItem_1 = new TableItem(table_1, 0);
		tableItem_1.setText(new String[] {});
		tableItem_1.setText("016-031");
		tableItem_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_2 = new TableItem(table_1, 0);
		tableItem_2.setText(new String[] {});
		tableItem_2.setText("032-047");
		tableItem_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_3 = new TableItem(table_1, 0);
		tableItem_3.setText(new String[] {});
		tableItem_3.setText("048-063");
		tableItem_3.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_4 = new TableItem(table_1, 0);
		tableItem_4.setText(new String[] {});
		tableItem_4.setText("064-079");
		tableItem_4.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_5 = new TableItem(table_1, 0);
		tableItem_5.setText(new String[] {});
		tableItem_5.setText("080-095");
		tableItem_5.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_6 = new TableItem(table_1, 0);
		tableItem_6.setText(new String[] {});
		tableItem_6.setText("096-111");
		tableItem_6.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_7 = new TableItem(table_1, 0);
		tableItem_7.setText(new String[] {});
		tableItem_7.setText("112-127");
		tableItem_7.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_8 = new TableItem(table_1, 0);
		tableItem_8.setText(new String[] {});
		tableItem_8.setText("128-143");
		tableItem_8.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_9 = new TableItem(table_1, 0);
		tableItem_9.setText(new String[] {});
		tableItem_9.setText("144-159");
		tableItem_9.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_10 = new TableItem(table_1, 0);
		tableItem_10.setText(new String[] {});
		tableItem_10.setText("160-175");
		tableItem_10.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_11 = new TableItem(table_1, 0);
		tableItem_11.setText(new String[] {});
		tableItem_11.setText("176-191");
		tableItem_11.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_12 = new TableItem(table_1, 0);
		tableItem_12.setText(new String[] {});
		tableItem_12.setText("192-207");
		tableItem_12.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_13 = new TableItem(table_1, 0);
		tableItem_13.setText(new String[] {});
		tableItem_13.setText("208-223");
		tableItem_13.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_14 = new TableItem(table_1, 0);
		tableItem_14.setText(new String[] {});
		tableItem_14.setText("224-239");
		tableItem_14.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		
		TableItem tableItem_15 = new TableItem(table_1, 0);
		tableItem_15.setText(new String[] {});
		tableItem_15.setText("240-255");
		tableItem_15.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
	
		tableViewer = new TableViewer(parent, SWT.BORDER | SWT.FULL_SELECTION);
		Table table = tableViewer.getTable();
		createColumns(parent, tableViewer);
		table.setHeaderVisible(true);
		table.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, true, true, 2, 1));
		table.setLinesVisible(true);

		tableViewer.setContentProvider(new ArrayContentProvider());
		// Get the content for the viewer, setInput will call getElements in the
		// contentProvider
		tableViewer.setInput(iArray);
		// Make the selection available to other views
		getSite().setSelectionProvider(tableViewer);
	}

	// This will create the columns for the table
	private void createColumns(final Composite parent, final TableViewer viewer) {

		TableViewerColumn col = null;
		
		for(indexColumn=0; indexColumn<16; indexColumn++)
		{
			col = createTableViewerColumn(String.format("%02d", indexColumn), 30, indexColumn);
			col.setLabelProvider(new ColumnLabelProvider() {
				int i = indexColumn;
				@Override
				public String getText(Object element) {
					int [] array = (int[]) element;
					return String.format("%02x", array[i]);
				}
			});			
		}
	}

	private TableViewerColumn createTableViewerColumn(String title, int bound, final int colNumber) {
		final TableViewerColumn viewerColumn = new TableViewerColumn(tableViewer,
				SWT.NONE);
		final TableColumn column = viewerColumn.getColumn();
		column.setText(title);
		column.setWidth(bound);
		column.setResizable(true);
		column.setMoveable(true);
		return viewerColumn;

	}
	protected DataBindingContext initDataBindings() {
		org.eclipse.core.databinding.DataBindingContext bindingContext = new org.eclipse.core.databinding.DataBindingContext();
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textProduct, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue devicegetDescriptorProductObserveValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "descriptor.product", java.lang.String.class);
		bindingContext.bindValue(textObserveTextObserveWidget, devicegetDescriptorProductObserveValue, null, null);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textBoardIdObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textBoardId, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataDescriptorboardIdObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "descriptor.boardId", short.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_1 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_1.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringToShortConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.ShortToStringConverter());
		bindingContext.bindValue(textBoardIdObserveTextObserveWidget, dataDescriptorboardIdObserveDetailValue, strategy_1, strategy);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textBoardVersionObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textBoardVersion, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataBoardVersionObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "descriptor.boardVersion", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_2 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_2.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_3 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_3.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textBoardVersionObserveTextObserveWidget, dataBoardVersionObserveDetailValue, strategy_2, strategy_3);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textBoardSerialObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textBoardSerial, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataNameObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "descriptor.boardSerial", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_4 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_4.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_5 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_5.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textBoardSerialObserveTextObserveWidget, dataNameObserveDetailValue, strategy_4, strategy_5);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue comboSelfPoweredObserveSingleSelectionIndexObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeSingleSelectionIndex(comboSelfPowered);
		org.eclipse.core.databinding.observable.value.IObservableValue dataDescriptorselfPoweredObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "descriptor.selfPowered", boolean.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_6 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_6.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToBooleanConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_7 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_7.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.BooleanToIntConverter());
		bindingContext.bindValue(comboSelfPoweredObserveSingleSelectionIndexObserveWidget, dataDescriptorselfPoweredObserveDetailValue, strategy_6, strategy_7);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textFirmwareIdObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textFirmwareId, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwareidObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.id", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_8 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_8.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_9 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_9.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textFirmwareIdObserveTextObserveWidget, dataFirmwareidObserveDetailValue, strategy_8, strategy_9);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textFirmwareVersionObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textFirmwareVersion, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwareversionObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.version", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_10 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_10.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_11 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_11.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textFirmwareVersionObserveTextObserveWidget, dataFirmwareversionObserveDetailValue, strategy_10, strategy_11);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textDateHdlObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textDateHdl, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwaredateHdlObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.dateHdl", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_12 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_12.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_13 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_13.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textDateHdlObserveTextObserveWidget, dataFirmwaredateHdlObserveDetailValue, strategy_12, strategy_13);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textDateSwObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textDateSw, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwaredateSwObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.dateSw", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_14 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_14.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_15 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_15.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textDateSwObserveTextObserveWidget, dataFirmwaredateSwObserveDetailValue, strategy_14, strategy_15);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textInterfaceVerObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textInterfaceVer, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwareinterfaceVerObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.interfaceVer", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_16 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_16.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_17 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_17.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textInterfaceVerObserveTextObserveWidget, dataFirmwareinterfaceVerObserveDetailValue, strategy_16, strategy_17);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textBoardNoObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textBoardNo, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwareboardNoObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.boardNo", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_18 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_18.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_19 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_19.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textBoardNoObserveTextObserveWidget, dataFirmwareboardNoObserveDetailValue, strategy_18, strategy_19);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textBoardStatusObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textBoardStatus, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwareboardStatusObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.boardStatus", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_20 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_20.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_21 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_21.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textBoardStatusObserveTextObserveWidget, dataFirmwareboardStatusObserveDetailValue, strategy_20, strategy_21);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textCrcObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textCrc, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwarecrcObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.crc", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_22 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_22.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_23 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_23.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textCrcObserveTextObserveWidget, dataFirmwarecrcObserveDetailValue, strategy_22, strategy_23);
		//
		org.eclipse.core.databinding.observable.value.IObservableValue textProgStatusObserveTextObserveWidget = org.eclipse.jface.databinding.swt.SWTObservables.observeText(textProgStatus, org.eclipse.swt.SWT.Modify);
		org.eclipse.core.databinding.observable.value.IObservableValue dataFirmwareprogStatusObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "firmware.progStatus", int.class);
		org.eclipse.core.databinding.UpdateValueStrategy strategy_24 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_24.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.StringtoIntConverter());
		org.eclipse.core.databinding.UpdateValueStrategy strategy_25 = new org.eclipse.core.databinding.UpdateValueStrategy();
		strategy_25.setConverter(new ch.thomson.ucs.ftdi.ui.Converters.IntToStringConverter());
		bindingContext.bindValue(textProgStatusObserveTextObserveWidget, dataFirmwareprogStatusObserveDetailValue, strategy_24, strategy_25);
		//
//		org.eclipse.core.databinding.observable.value.IObservableValue textObserveTextObserveWidget_1 = org.eclipse.jface.databinding.swt.SWTObservables.observeText(text, org.eclipse.swt.SWT.Modify);
//		org.eclipse.core.databinding.observable.value.IObservableValue dataBufferObserveDetailValue = org.eclipse.core.databinding.beans.PojoObservables.observeDetailValue(data, "descriptor.buffer", Byte[].class);
//		bindingContext.bindValue(textObserveTextObserveWidget_1, dataBufferObserveDetailValue, null, null);
		//
//		org.eclipse.core.databinding.observable.value.IObservableValue textObserveTextObserveWidget_2 = org.eclipse.jface.databinding.swt.SWTObservables.observeText(text, org.eclipse.swt.SWT.Modify);
//		org.eclipse.core.databinding.observable.value.IObservableValue deviceBufferObserveValue = org.eclipse.emf.databinding.EMFProperties.value(org.eclipse.emf.databinding.FeaturePath.fromList(ch.thomson.ucs.ftdi.emf.ftdi.FtdiPackage.Literals.DEVICE__DESCRIPTOR, ch.thomson.ucs.ftdi.emf.ftdi.FtdiPackage.Literals.DESCRIPTOR__BUFFER)).observe(device);
//		bindingContext.bindValue(textObserveTextObserveWidget_2, deviceBufferObserveValue, null, null);
		//
		return bindingContext;
	}
}