package ch.thomson.ucs.ftdi;

import org.eclipse.core.runtime.Platform;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

import ch.thomson.ucs.utils.logging.IPluginLogger;
import ch.thomson.ucs.utils.logging.Log4jTransfer;
import ch.thomson.ucs.utils.logging.PluginLogger;


/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	private static IPluginLogger logger;

	// The plug-in ID
	public static final String PLUGIN_ID = "com.ftdichip.device"; //$NON-NLS-1$

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	public static IPluginLogger getLogger() {
		return logger;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		// Logger initialisieren
		Platform.addLogListener(Log4jTransfer.getInstance());
		logger = PluginLogger.getLogger(context.getBundle());
				
		logger.info("start load ftdichipj");
		try
		{
			System.loadLibrary("ftdichipj");
		}
		catch(UnsatisfiedLinkError e)
		{
			logger.info("Exception ftdichipj not exist");
			e.printStackTrace();
		}
		catch(NullPointerException e)
		{
			logger.info("Exception ftdichipj is null");
			e.printStackTrace();			
		}
		catch(SecurityException e)
		{
			logger.info("Exception ftdichipj permission not sufficent");
			e.printStackTrace();			
		}
		logger.info("stop load ftdichipj");
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}

}
