package ch.thomson.ucs.ftdi;

import java.io.IOException;

/**
 * Signals errors accessing a ftd2xx device.
 * 
 * @author Mike Werner
 */
public class FTDIException extends IOException {

    private static final long serialVersionUID = 1L;

    /**
     * Creates a new <code>FTD2xxException</code>.
     * 
     * @param message
     *            The error message.
     */
    public FTDIException(String message) {

        super(message);
    }

    /**
     * Creates a new <code>FTD2xxException</code>.
     * 
     * @param cause
     *            The initial cause of the error.
     */
    public FTDIException(Throwable cause) {

        initCause(cause);
    }

    /**
     * Creates a new <code>FTD2xxException</code>.
     * 
     * @param message
     *            The error message.
     * @param cause
     *            The initial cause of the error.
     */
    public FTDIException(String message, Throwable cause) {

        super(message);

        initCause(cause);
    }
}
