package ch.thomson.ucs.security.dao;

import java.sql.SQLException;
import java.util.Collection;

import ch.thomson.ucs.security.dao.entries.User;

public interface UserDAO extends BasicDAO {
	/**
	 * Kreiert einen neuen Benutzer und wirft eine Exception, falls dieser schon existiert.
	 * @param user
	 * @throws SQLException
	 */
	public void createUser(User user) throws SQLException;
	
	/**
	 * Fgt einen neuen Benutzer hinzu. Falls der Benutzer bereits existiert, wird er berschrieben.
	 * @param user
	 * @throws SQLException
	 */
	public void addUser(User user) throws SQLException;
	public void deleteUser(String name) throws SQLException;
	public User getUser(String name) throws SQLException;
	public Collection<User> getAllEntries() throws SQLException;
}
