package ch.thomson.ucs.security.dao.entries;

import ch.thomson.ucs.security.helpers.BeanObject;

public class Role extends BeanObject implements Comparable<Role> {
	private int logonLevel;
	private String name = "None";
	private int logoffTime;
	
	public int getLogonLevel() {
		return logonLevel;
	}
	
	public void setLogonLevel(int logonLevel) {
		firePropertyChange("logonLevel", this.logonLevel, this.logonLevel = logonLevel);
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		firePropertyChange("name", this.name, this.name = name);
	}
	
	public int getLogoffTime() {
		return logoffTime;
	}

	public void setLogoffTime(int logoffTime) {
		firePropertyChange("logoffTime", this.logoffTime, this.logoffTime = logoffTime);
	}

	@Override
	public String toString() {
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (logonLevel: ");
		result.append(logonLevel);
		result.append(", name: ");
		result.append(name);
		result.append(", logoffTime: ");
		result.append(logoffTime);
		result.append(")");
		return result.toString();
	}

	@Override
	public int compareTo(Role role) {
		if(role.getLogonLevel() < this.getLogonLevel()) 
			return -1;
		
		if(role.getLogonLevel() > this.getLogonLevel()) 
			return 1;
		
		return 0;
	}
}
