package ch.thomson.ucs.security.dao.entries;

import ch.thomson.ucs.security.helpers.BeanObject;
import ch.thomson.ucs.security.helpers.Encryptor;

public class User extends BeanObject {
	private String name = "None";
	private String fullName = "None";
	private String password = "";
	private Role role;
	
	public User() {
		role = new Role();
	}
	
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		firePropertyChange("password", this.password, this.password = password);
	}
	
	public void setPasswordUnencrypted(String password) {
		try {
			this.setPassword(Encryptor.toEncryptedString(password));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public String getFullName() {
		return fullName;
	}
	
	public void setFullName(String fullName) {
		firePropertyChange("fullName", this.fullName, this.fullName = fullName);
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		firePropertyChange("name", this.name, this.name = name);
	}
	
	public Role getRole() {
		return role;
	}
	
	public void setRole(Role role) {
		firePropertyChange("role", this.role, this.role = role);
	}
	
	@Override
	public String toString() {
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", fullName: ");
		result.append(fullName);
		result.append(", password: ");
		result.append(password);
		result.append(", role: ");
		result.append(role.toString());
		result.append(")");
		return result.toString();
	}
}
