package ch.thomson.ucs.security.dao.impl;

import java.sql.Connection;
import java.sql.SQLException;

import ch.thomson.ucs.alarms.client.ClientUtil;
import ch.thomson.ucs.security.dao.BasicDAO;

public abstract class BasicDAOImpl implements BasicDAO {
	
	protected Connection connection;
	
	@Override
	public void open() throws Exception {
		connection = ClientUtil.createConnection();
	}

	@Override
	public void open(String host) throws Exception {
		connection = ClientUtil.createConnection(host);
	}

	@Override
	public void close() {
		if(!isClosed()) {
			try {
				connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			} finally {
				connection = null;
			}
		}
	}

	@Override
	public boolean isClosed() {
		return connection == null;
	}
}
