package ch.thomson.swing.graphics;

import java.awt.Color;


/**
 * Ein einfacher Bargraph
 * 
 * Mit dieser Klasse kann ein einfacher Bargraph dargestellt werden
 * 
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public interface IBarGraph extends IGraphicsScaleRectangular, IGraphicsRectangle, IMarker, IScaleLabelProviderConsumer, IValueLabelProviderConsumer {

	public double getValue();
	public void setValue(double value);
	
	public String getUnit();
	public void setUnit(String unit);

	public int getGap();
	public void setGap(int value);
	
	public int getGapPosition();
	public void setGapPosition(int value);
	
	public void setShowBorder(boolean value);
	public boolean isShowBorder();
	
	public void setColorBackgroundBar(Color FillColor);
	public Color getColorBackgroundBar();
	
	public abstract boolean isFilledBackgroundBar();
	public abstract void setFillBackgroundBar(boolean fill);
	
}