package ch.thomson.swing.graphics;

import javax.swing.SwingConstants;

/**
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public interface IGraphicsLine extends IGraphicStroke, IGraphicsOrientation{

	public static final int LEFT = SwingConstants.LEFT;
	public static final int CENTER = SwingConstants.CENTER;
	public static final int RIGHT = SwingConstants.RIGHT;
	public static final int TOP = SwingConstants.TOP;
	public static final int BOTTOM = SwingConstants.BOTTOM;

	/**
	 * Gibt die aktuelle Position zurck
	 * 
	 * @return Die Aktuelle Position
	 */
	public abstract int getPosition();

	/**
	 * Setzt die aktuelle Position. Diese ist abhngig von der Orientierung der
	 * Grafik. Es muss ein <b>int</b> Wert bergeben
	 * werden. Dabei ist <em>LEFT</em> = 2 und <em>RIGHT</em> = 4 bei
	 * Vertikaler Orientierung und <em>TOP</em> = 1 und <em>BOTTOM</em> = 3. 
	 * Die Einstellung <em>CENTER</em> = 0 positioniert das Element in die Mitte.
	 * 
	 * @param position als <b>int</b> Wert
	 */
	public abstract void setPosition(int position);
}