package ch.thomson.swing.graphics.impl;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import ch.thomson.swing.graphics.IGraphicsBase;


/**
 * <p>
 * Kleine Hilfsklasse um graphische Elemente auf den Bildschirm oder auf die Druckerausgabe zu
 * zeichnen
 * </p>
 * 
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public class GraphicsBase implements IGraphicsBase{

	private int width;
	private int height;
	private Component Parent = null;
	private boolean staterepaint;
	private Color LineColor = Color.BLACK;
	private Color FillColor = Color.RED;
	
	public GraphicsBase(){
		width = 0;
		height = 0;
	}
	
	public GraphicsBase(int w, int h){
		width = w;
		height = h;
	}
	
	protected void repaint() {
		staterepaint = true;
		if (Parent != null) {
			Parent.repaint();
		}
	}

	protected void resetStateRepaint(){
		staterepaint = false;
	}

	protected boolean isStateRepaint(){
		return staterepaint;
	}
	
	public int getWidth() {
		return width;
	}

	public void setWidth(int Width) {
		if (width != Width) {
			width = Width;
			if((height!=0)&&(width !=0)){
				repaint();
			}
		}
	}

	public int getHeight() {
		return height;
	}

	public void setHeight(int Height) {
		if (height != Height) {
			height = Height;
			if((height!=0)&&(width !=0)){
				repaint();
			}
		}
	}

	public Component getParent() {
		return Parent;
	}
	
	public void setParent(Component c) {
		Parent = c;
	}

	/* (non-Javadoc)
	 * @see thgui.thIcons.Icons.GraphicsBase#getLineColor()
	 */
	public Color getLineColor() {
		return LineColor;
	}

	/* (non-Javadoc)
	 * @see thgui.thIcons.Icons.GraphicsBase#setLineColor(java.awt.Color)
	 */
	public void setLineColor(Color lineColor) {
		if (LineColor != lineColor) {
			LineColor = lineColor;
			repaint();
		}
	}

	/* (non-Javadoc)
	 * @see thgui.thIcons.Icons.GraphicsBase#getFillColor()
	 */
	public Color getFillColor() {
		return FillColor;
	}

	/* (non-Javadoc)
	 * @see thgui.thIcons.Icons.GraphicsBase#setFillColor(java.awt.Color)
	 */
	public void setFillColor(Color fillColor) {
		if (FillColor != fillColor) {
			FillColor = fillColor;
			repaint();
		}
	}
	
	public void paintGraphics(Graphics g,  int x, int y) {
		resetStateRepaint();
	}
	
	protected boolean isPositivValue(double value){
		if(value >= 0){
			return true;
		}
		return false;
	}

	protected boolean isPositivValue(float value){
		if(value >= 0){
			return true;
		}
		return false;
	}

	protected boolean isPositivValue(long value){
		if(value >= 0){
			return true;
		}
		return false;
	}

	protected boolean isNormValue(double value){
		if((value<=1.0)&&(value>=0)){
			return true;
		}
		return false;
	}

}

