package ch.thomson.swing.jlabel;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

import ch.thomson.swing.graphics.IBarGraph;
import ch.thomson.swing.graphics.IScaleLabelProvider;
import ch.thomson.swing.graphics.IValueLabelProvider;
import ch.thomson.swing.graphics.impl.BarGraph;
import ch.thomson.swing.graphics.impl.GraphicsScaleRectangular;


/**
 * @author Dominic Meier
 * @version $version$ ($date$)
 */
public class JLabelBarGraph extends JLabelScaleRectangular implements IBarGraph{
	public JLabelBarGraph() {
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private BarGraph barGraph = null;
	
	
	protected GraphicsScaleRectangular getScaleRectangular(){
		if(barGraph == null){
			barGraph = new BarGraph(getHeight(), getWidth());
			barGraph.setParent(this);
			barGraph.setFont(this.getFont());
		}
		return barGraph;
	}
	
	@Override
	public void paint(Graphics g) {
		Base = getScaleRectangular();
		super.paint(g);
	}

	@Override
	public int getGap() {
		return ((IBarGraph)getScaleRectangular()).getGap();
	}

	@Override
	public double getValue() {
		return ((IBarGraph)getScaleRectangular()).getValue();
	}

	@Override
	public void setGap(int value) {
		((IBarGraph)getScaleRectangular()).setGap(value);
	}

	@Override
	public void setValue(double value) {
		((IBarGraph)getScaleRectangular()).setValue(value);
	}

	@Override
	public boolean isFilled() {
		return ((IBarGraph)getScaleRectangular()).isFilled();
	}

	@Override
	public void setFill(boolean fill) {
		((IBarGraph)getScaleRectangular()).setFill(fill);
	}

	@Override
	public boolean isShowBorder() {
		return ((IBarGraph)getScaleRectangular()).isShowBorder();
	}

	@Override
	public void setShowBorder(boolean value) {
		((IBarGraph)getScaleRectangular()).setShowBorder(value);
	}

	@Override
	public Color getColorBackgroundBar() {
		return ((IBarGraph)getScaleRectangular()).getColorBackgroundBar();
	}

	@Override
	public boolean isFilledBackgroundBar() {
		return ((IBarGraph)getScaleRectangular()).isFilledBackgroundBar();
	}

	@Override
	public void setColorBackgroundBar(Color FillColor) {
		((IBarGraph)getScaleRectangular()).setColorBackgroundBar(FillColor);
		
	}

	@Override
	public void setFillBackgroundBar(boolean fill) {
		((IBarGraph)getScaleRectangular()).setFillBackgroundBar(fill);
	}

	@Override
	public double getMarkersPosition(BarGraph.Marker marker) {
		return ((IBarGraph)getScaleRectangular()).getMarkersPosition(marker);
	}

	@Override
	public double[] getMarkersPosition() {
		return ((IBarGraph)getScaleRectangular()).getMarkersPosition();
	}

	@Override
	public void setMarkersPosition(BarGraph.Marker marker, double position) {
		((IBarGraph)getScaleRectangular()).setMarkersPosition(marker, position);
	}

	@Override
	public void setMarkersPosition(double[] position) {
		((IBarGraph)getScaleRectangular()).setMarkersPosition(position);
	}

	@Override
	public boolean isMarkerVisible() {
		return ((IBarGraph)getScaleRectangular()).isMarkerVisible();
	}

	@Override
	public void setMarkerVisible(boolean visible) {
		((IBarGraph)getScaleRectangular()).setMarkerVisible(visible);
	}

	@Override
	public IScaleLabelProvider getScaleLabelProvider(int index) {
		return ((IBarGraph)getScaleRectangular()).getScaleLabelProvider(index);
	}

	@Override
	public IScaleLabelProvider[] getScaleLabelProvider() {
		return ((IBarGraph)getScaleRectangular()).getScaleLabelProvider();
	}

	@Override
	public boolean isScaleLabelVisible() {
		return ((IBarGraph)getScaleRectangular()).isScaleLabelVisible();
	}

	@Override
	public void setScaleLabelVisible(boolean visible) {
		((IBarGraph)getScaleRectangular()).setScaleLabelVisible(visible);
	}

	@Override
	public void setScaleLabelProvider(int index, IScaleLabelProvider provider) {
		((IBarGraph)getScaleRectangular()).setScaleLabelProvider(index, provider);
	}

	@Override
	public void setScaleLabelProvider(IScaleLabelProvider[] provider) {
		((IBarGraph)getScaleRectangular()).setScaleLabelProvider(provider);
	}

	@Override
	public void setFont(Font font) {
		((BarGraph)getScaleRectangular()).setFont(font);
		super.setFont(font);
	}

	@Override
	public boolean isMarkersVisible(BarGraph.Marker marker) {
		return ((IBarGraph)getScaleRectangular()).isMarkersVisible(marker);
	}

	@Override
	public void setMarkersVisible(BarGraph.Marker marker, boolean visible) {
		((IBarGraph)getScaleRectangular()).setMarkersVisible(marker, visible);
	}

	@Override
	public boolean[] getMarkersVisible() {
		return ((IBarGraph)getScaleRectangular()).getMarkersVisible();
	}

	@Override
	public void setMarkersVisible(boolean[] visible) {
		((IBarGraph)getScaleRectangular()).setMarkersVisible(visible);
	}

	@Override
	public int getGapPosition() {
		return ((IBarGraph)getScaleRectangular()).getGapPosition();
	}

	@Override
	public void setGapPosition(int value) {
		((IBarGraph)getScaleRectangular()).setGapPosition(value);
	}

	@Override
	public String getUnit() {
		return ((IBarGraph)getScaleRectangular()).getUnit();
	}

	@Override
	public void setUnit(String unit) {
		((IBarGraph)getScaleRectangular()).setUnit(unit);
	}

	@Override
	public void setValueLabelProvider(IValueLabelProvider provider) {
		((IBarGraph)getScaleRectangular()).setValueLabelProvider(provider);
	}

	@Override
	public IValueLabelProvider getValueLabelProvider() {
		return ((IBarGraph)getScaleRectangular()).getValueLabelProvider();
	}

	@Override
	public int getMarkerScale() {
		return ((IBarGraph)getScaleRectangular()).getMarkerScale();
	}

	@Override
	public void setMarkerScale(int val) {
		((IBarGraph)getScaleRectangular()).setMarkerScale(val);
		
	}
}
