package ch.thomson.ucs.alarms.models;

import java.util.Collections;
import java.util.List;

import ch.thomson.ucs.alarms.client.ClientUtil;
import ch.thomson.ucs.alarms.client.dao.AlarmPendingDAO;
import ch.thomson.ucs.alarms.client.dao.entries.AlarmPendingEntry;

public class AlarmPendingModel {
	
	private static AlarmPendingModel instance;
	
	private AlarmPendingDAO dao;
	
	private AlarmPendingModel() {
		dao = ClientUtil.createAlarmPendingDAO();
	}
	
	public static synchronized AlarmPendingModel getInstance() {
		if(instance == null)
			instance = new AlarmPendingModel();
		return instance;
	}
	
	public List<AlarmPendingEntry> getEntries() {
		List<AlarmPendingEntry> result = Collections.emptyList();
		
		try {
			if(dao.isClosed())
				dao.open();
				result = dao.getAllEntries();
				
		} catch (Exception e) {
			e.printStackTrace();
			dao.close();
		}
		
		return result;
	}
}
