package ch.thomson.ucs.tine.client.databinding.converters;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.core.databinding.conversion.Converter;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.resource.LocalResourceManager;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Control;

import ch.thomson.ucs.tine.client.databinding.Activator;

public abstract class ImageConverter extends Converter {

	private Map<Integer, Image> images = null;
	private LocalResourceManager resources = null;
	private Image defaultImage = null;
	
	public ImageConverter(Object fromType, Object toType) {
		super(fromType, toType);
	}
	
	public void addImage(int id, String path, Control owner) {
		if(resources == null)
			resources = new LocalResourceManager(JFaceResources.getResources(), owner);
		
		Image image = resources.createImage(Activator.getImageDescriptor(path));
		this.addImage(id, image);
	}
	
	public void addImage(int id, Image image) {
		if(images == null) {
			images = new HashMap<Integer, Image>();
			defaultImage = image; // Erstes Bild ist Standardbild...
		}
		
		images.put(id, image);
	}
	
	public Image getImage(int id) {
		Image image = images.get(id);
		return image == null ? defaultImage : image;
	}
}
