package ch.thomson.ucs.tine.client.databinding.eclipse;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import ch.thomson.ucs.tine.client.util.SignalListParser;
import ch.thomson.ucs.tine.databinding.swt.IComposite;

public class ThView extends ViewPart {
	public ThView() {
		// TODO Auto-generated constructor stub
		this.setTitleImage(PlatformUI.getWorkbench().getSharedImages()
				.getImage(ISharedImages.IMG_OBJ_FOLDER));
	}

	@Override
	public void createPartControl(Composite parent) {
		Shell shell = this.getSite().getShell();
		try {
			this.navigateControl(parent.getChildren());
		} catch (Exception e) {
			MessageDialog.openError(shell, "Error", e.getMessage() + ". \n\nPossible reasons: \n- TINE-Server is down or is not reachable. \n- The SignalList does not match with the SignalList of the TINE-Server.");
			PlatformUI.getWorkbench().close();
		}
	}

	@Override
	public void setFocus() {
		// TODO Auto-generated method stub
		
	}

	private void navigateControl(Control[] controls) throws Exception {
		for(Control c : controls) {
			if(c instanceof IComposite) {
				((IComposite) c).initialize(SignalListParser.getClientInstance());
			}
			
			if(c instanceof Composite) {
				navigateControl(((Composite) c).getChildren()); // Rekursion
			}
		}
	}
}
