package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.jface.fieldassist.ControlDecoration;
import org.eclipse.jface.fieldassist.FieldDecorationRegistry;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Control;

import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;

public class ConnectionControlDecoration extends ControlDecoration {
	private Property prop;
	private Adapter listener;
	private Realm realm;
	
	public ConnectionControlDecoration(Control control, int position, Property property) {
		super(control, position);
		this.prop = property;
		this.realm = Realm.getDefault();
		
		// Bildchen erzeugen
		Image errorImage = FieldDecorationRegistry.getDefault().getFieldDecoration(FieldDecorationRegistry.DEC_ERROR).getImage();
		setImage(errorImage);
		
		// Hover einschalten fr Tooltip
		setShowHover(true);
		
		listener = new AdapterImpl() {

			@Override
			public void notifyChanged(Notification msg) {
				if ((Literals.PROPERTY__LINK_ERROR_CODE == msg.getFeature() || Literals.PROPERTY__LINK_STATUS == msg.getFeature()) && !msg.isTouch()) {
					realm.exec(new Runnable() {

						@Override
						public void run() {
							refresh();
						}
					});
				}
			}
		};
		
		prop.eAdapters().add(listener);
		
		// Initialisieren
		refresh();
	}
	
	@Override
	public void dispose() {
		if(prop != null)
			prop.eAdapters().remove(listener);
		super.dispose();
	}

	private void refresh() {
		if (prop.getLinkErrorCode() != 0) {
			setDescriptionText(prop.getLinkStatus());
			show();
		}
		else
			hide();
	}
}
