package ch.thomson.ucs.tine.databinding.swt;

import java.util.LinkedList;
import java.util.List;

public class FlashManager {
	private static FlashManager instance = null;
	
	protected List<IFlashListener> flashListener = new LinkedList<IFlashListener>();	
	private long oldTime = 0;
	private boolean toggle = true;
	
    /**
     * Default-Konstruktor, der nicht auerhalb dieser Klasse
     * aufgerufen werden kann
     */
    private FlashManager() 
    {
    	// flashing thread starten
    	Thread thread = new Thread(new Runnable() {
			@Override
			public void run() {
				while(true)
				{
					try
					{
					   Thread.sleep(10);
					}
					catch ( InterruptedException e )
					{
					      System.out.println("DBCenter Polling-Thread InterruptedException: Unterbrechung in sleep()");
					}
					long lTime = System.currentTimeMillis();
					if(lTime > (oldTime + 500))
					{
						notifyListener();
						oldTime = lTime;
					}
				}
			}
		});
    	thread.start();
    	
    }
 
    /**
     * Statische Methode, liefert die einzige Instanz dieser
     * Klasse zurck
     */
    public static synchronized FlashManager getInstance() {
        if (instance == null) {
            instance = new FlashManager();
        }
        return instance;
    }
    
    public void add(IFlashListener listener)
    {
		if(flashListener.contains(listener) == false)
		{
	    	synchronized(flashListener)
	    	{
	    		flashListener.add(listener);
	    	}
		}
    }
    public void remove(IFlashListener listener)
    {
    	if(flashListener.contains(listener) == true)
    		flashListener.remove(listener);
    }
    
    private void notifyListener()
    {
    	synchronized(flashListener)
    	{
	    	for(IFlashListener l:flashListener)
	    	{
	    		l.flashing(toggle);
	    	}
			toggle = !toggle;
    	}
    }
} 