package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import ch.thomson.ucs.security.LogonLevelListener;
import ch.thomson.ucs.security.LogonManager;
import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.databinding.converters.IndexedConverter;

public class ThButton extends Button implements IDataBinding, LogonLevelListener {
	private String signalName;
	
	private DataBindingContext bindingContext = new DataBindingContext();
	@SuppressWarnings("unused")
	private ConnectionControlDecoration connnectionDecoration;
	protected IndexedConverter modelToTargetConverter;
	protected IndexedConverter targetToModelConverter;
	protected int signalIndex;
	private Property property = null;
		
	public ThButton(Composite parent, int style) {
		super(parent, style);
		
		this.addMouseListener(new MouseAdapter() {

			@Override
			public void mouseUp(MouseEvent e) {
				if((property != null))									
					property.setValueForce(new float[]{1.0f});
			}
		});
		LogonManager.getInstance().addLogonLevelListener(this);
	}
	
	public String getSignalName() {
		return signalName;
	}

	public void setSignalName(String signalName) {
		this.signalName = signalName;
	}
	
	public int getSignalIndex() {
		return signalIndex;
	}

	public void setSignalIndex(int signalIndex) {
		this.signalIndex = signalIndex;
		if(modelToTargetConverter != null)
			modelToTargetConverter.setIndex(signalIndex);
		
		if(targetToModelConverter != null)
			targetToModelConverter.setIndex(signalIndex);
		
		bindingContext.updateTargets();
		this.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(DisposeEvent e) {
				LogonManager.getInstance().removeLogonLevelListener(ThButton.this);
			}
		});
		
		logonLevelChanged(LogonManager.getInstance().getLogonLevel());
	}

	@Override
	protected void checkSubclass() {}

	@Override
	public void bindValues(Client client) throws Exception {
		property = client.findProperty(signalName);
		
		this.setEnabled(property.isWritable());
		
		this.connnectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
	}
	@Override
	public void logonLevelChanged(int logonLevel) {
		if(property != null) {
			if(property.getLogonLevel() > logonLevel) {
				Realm.getDefault().asyncExec(new Runnable() {
					@Override
					public void run() {
						if(!ThButton.this.isDisposed())
							ThButton.this.setEnabled(false);
					}
				});
			}
			else {
				Realm.getDefault().asyncExec(new Runnable() {
					@Override
					public void run() {
						if(!ThButton.this.isDisposed())
							ThButton.this.setEnabled(true);
					}
				});
			}
		}
	}	
}
