package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.wb.swt.SWTResourceManager;

import ch.thomson.ucs.security.LogonLevelListener;
import ch.thomson.ucs.security.LogonManager;
import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.databinding.converters.IndexedConverter;

public class ThButtonState extends Button implements IDataBinding, IFlashListener, LogonLevelListener{
	private Adapter getAdapter = null;
	private Adapter setAdapter = null;
	private Property getProperty = null;
	private Property setProperty = null;
	
	private String signalName;
	private String cmdSignalName;

	private float cmdValue;
	private float[] cmdValueActive = new float[1];
	private float[] getValue = new float[1];
	
	private Image imageUp;
	private Image imageUpActive;
	private Image imageDown;
	private Image imageInternal;

	private Realm realm;
	private DataBindingContext bindingContext = new DataBindingContext();
	@SuppressWarnings("unused")
	private ConnectionControlDecoration connnectionDecoration;
	protected IndexedConverter modelToTargetConverter;
	protected IndexedConverter targetToModelConverter;
	protected int signalIndex;
	
	private Client internalClient;
	private Color activeColor; 
	
	private boolean toggle = true;
	
	public ThButtonState(Composite parent, int style) {
		super(parent, style);
		this.realm = Realm.getDefault();
	
		this.addSelectionListener(new SelectionAdapter() 
		{

			@Override
			public void widgetSelected(SelectionEvent e) {
				if((internalClient != null))
				{
					try {
						float[] tmpVal = new float[1];
						tmpVal[0] = ThButtonState.this.getCmdValue();
						internalClient.findProperty(ThButtonState.this.getCmdSignalName()).setValueForce(tmpVal);
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
				// TODO Auto-generated method stub
				
			}
		});
		
		this.addMouseListener(new MouseAdapter() 
		{

			@Override
			public void mouseDown(MouseEvent e) {
				// TODO Auto-generated method stub
				imageInternal = ThButtonState.this.getImage();
				ThButtonState.this.setImage(imageDown);
				super.mouseDown(e);
			}

			@Override
			public void mouseUp(MouseEvent e) {
				// TODO Auto-generated method stub
				ThButtonState.this.setImage(imageInternal);
				super.mouseUp(e);
			}
		});
		LogonManager.getInstance().addLogonLevelListener(this);
	}
	
	private static Image makeButtonImage(String text, Button button, Color background, int fuzz) {
		Display display = button.getDisplay();
		Rectangle bounds = button.getBounds();
		int width = bounds.width - fuzz;
		int height = bounds.height - fuzz;

		// Get the size of the text
		GC gc = new GC(button);
		Point textSize = gc.textExtent(text, SWT.DRAW_MNEMONIC);
		gc.dispose();

		// Create the requested image
		Image image = new Image(display, width, height);
		gc = new GC(image);
		gc.setBackground(background);
		gc.setForeground(button.getForeground());
		gc.fillRectangle(0, 0, width, height);
		gc.setFont(button.getFont());
		gc.drawText(text, (width - textSize.x)/2, (height - textSize.y)/2, 
		true);
		gc.dispose();

		return image;
	}	

	public String getSignalName() {
		return signalName;
	}

	public void setSignalName(String signalName) {
		this.signalName = signalName;
	}

	public String getCmdSignalName() {
		return cmdSignalName;
	}

	public void setCmdSignalName(String cmdSignalName) {
		this.cmdSignalName = cmdSignalName;
	}
	
	public int getSignalIndex() {
		return signalIndex;
	}

	public void setSignalIndex(int signalIndex) {
		this.signalIndex = signalIndex;
		if(modelToTargetConverter != null)
			modelToTargetConverter.setIndex(signalIndex);
		
		if(targetToModelConverter != null)
			targetToModelConverter.setIndex(signalIndex);
		
		bindingContext.updateTargets();
	}

	public Color getActiveColor() {
		return activeColor;
	}

	public void setActiveColor(Color activeColor) {
		this.activeColor = activeColor;
	}

	public float getCmdValue() {
		return cmdValue;
	}

	public void setCmdValue(float cmdValue) {
		this.cmdValue = cmdValue;
	}
	
	@Override
	protected void checkSubclass() {}
	
	@Override
	public void bindValues(Client client) throws Exception {
		imageUp = ThButtonState.makeButtonImage(this.getText(), this, SWTResourceManager.getColor(SWT.COLOR_WIDGET_LIGHT_SHADOW), 6);
		imageUpActive = ThButtonState.makeButtonImage(this.getText(), this, this.getActiveColor(), 6);
		imageDown = ThButtonState.makeButtonImage(this.getText(), this, SWTResourceManager.getColor(SWT.COLOR_WIDGET_NORMAL_SHADOW), 6);
		this.setImage(imageUp);
		this.internalClient = client;
		this.realm = Realm.getDefault();
		this.setText("");
		FlashManager mgr = FlashManager.getInstance();
		mgr.add(this);

		getProperty = client.findProperty(signalName);
		getValue = (float[])getProperty.getValue();
		getAdapter = new AdapterImpl() {
			@Override
			public void notifyChanged(Notification msg) {
				if(Literals.PROPERTY__VALUE == msg.getFeature() && !msg.isTouch()) {
					getValue = (float[]) msg.getNewValue();;
				}
			}
		};
		getProperty.eAdapters().add(getAdapter);
		
		setProperty = client.findProperty(cmdSignalName);
		cmdValueActive = (float[])setProperty.getValue();
		setAdapter = new AdapterImpl() {
			@Override
			public void notifyChanged(Notification msg) {
				if(Literals.PROPERTY__VALUE == msg.getFeature() && !msg.isTouch()) {
					cmdValueActive = (float[]) msg.getNewValue();;
				}
			}
		};
		setProperty.eAdapters().add(setAdapter);
				
		this.addDisposeListener(new DisposeListener() {

			@Override
			public void widgetDisposed(DisposeEvent e) {
				getProperty.eAdapters().remove(getAdapter);
				setProperty.eAdapters().remove(setAdapter);
				LogonManager.getInstance().removeLogonLevelListener(ThButtonState.this);
			}
		});
		
		logonLevelChanged(LogonManager.getInstance().getLogonLevel());
		
	}
	private void setImageUp()
	{
		setImage(imageUp);
	}
	private void setImageUpActive()
	{
		setImage(imageUpActive);
	}

	@Override
	public void flashing(boolean active) {
		// TODO Auto-generated method stub
		toggle = active;
		realm.exec(new Runnable() {
			@Override
			public void run() {
				if(ThButtonState.this.isDisposed())
					return;
				
				if(getValue[0] == cmdValue)
					setImageUpActive();
				else if(cmdValueActive[0] == cmdValue)
				{
					if(toggle)
						setImageUpActive();
					else
						setImageUp();
				}
				else
					setImageUp();
				update();
			}
		});
	}	
	@Override
	public void logonLevelChanged(int logonLevel) {
		if(setProperty != null) {
			if(setProperty.getLogonLevel() > logonLevel) {
				realm.asyncExec(new Runnable() {
					@Override
					public void run() {
						if(!ThButtonState.this.isDisposed())
							ThButtonState.this.setEnabled(false);
					}
				});
			}
			else {
				realm.asyncExec(new Runnable() {
					@Override
					public void run() {
						if(!ThButtonState.this.isDisposed())
							ThButtonState.this.setEnabled(true);
					}
				});
			}
		}
	}	
}