package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.observable.Realm;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import ch.thomson.ucs.security.LogonLevelListener;
import ch.thomson.ucs.security.LogonManager;
import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.databinding.converters.IndexedConverter;

public class ThButtonValue extends Button implements IDataBinding, LogonLevelListener {
	private String signalName;
	
	private DataBindingContext bindingContext = new DataBindingContext();
	@SuppressWarnings("unused")
	private ConnectionControlDecoration connnectionDecoration;
	protected IndexedConverter modelToTargetConverter;
	protected IndexedConverter targetToModelConverter;
	protected int signalIndex;
	private Property property = null;
	private float value;
		
	public ThButtonValue(Composite parent, int style) {
		super(parent, style);

		
		this.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if((property != null))
				{
					try {
						float[] gVal = (float[]) property.getValue();
						float[] tmpVal = gVal.clone();
						tmpVal[signalIndex] = value;
						property.setValueForce(tmpVal);
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}
		});
		LogonManager.getInstance().addLogonLevelListener(this);		
	}
	
	public String getSignalName() {
		return signalName;
	}

	public void setSignalName(String signalName) {
		this.signalName = signalName;
	}
	
	public int getSignalIndex() {
		return signalIndex;
	}

	public void setSignalIndex(int signalIndex) {
		this.signalIndex = signalIndex;
		if(modelToTargetConverter != null)
			modelToTargetConverter.setIndex(signalIndex);
		
		if(targetToModelConverter != null)
			targetToModelConverter.setIndex(signalIndex);
		
		bindingContext.updateTargets();
	}

	@Override
	protected void checkSubclass() {}

	@Override
	public void bindValues(Client client) throws Exception {
		property = client.findProperty(signalName);
		
		this.setEnabled(property.isWritable());
//		this.pack();
		
		this.connnectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
		this.addDisposeListener(new DisposeListener() {

			@Override
			public void widgetDisposed(DisposeEvent e) {
				LogonManager.getInstance().removeLogonLevelListener(ThButtonValue.this);
			}
		});
		
		logonLevelChanged(LogonManager.getInstance().getLogonLevel());
	}

	public float getValue() {
		return value;
	}

	public void setValue(float value) {
		this.value = value;
	}
	@Override
	public void logonLevelChanged(int logonLevel) {
		if(property != null) {
			if(property.getLogonLevel() > logonLevel) {
				Realm.getDefault().asyncExec(new Runnable() {
					@Override
					public void run() {
						if(!ThButtonValue.this.isDisposed())
							ThButtonValue.this.setEnabled(false);
					}
				});
			}
			else {
				Realm.getDefault().asyncExec(new Runnable() {
					@Override
					public void run() {
						if(!ThButtonValue.this.isDisposed())
							ThButtonValue.this.setEnabled(true);
					}
				});
			}
		}
	}	
}
