package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.databinding.converters.ConverterFactory;
import ch.thomson.ucs.tine.client.databinding.converters.IndexedConverter;

public class ThLabel extends Label implements IDataBinding{

	protected String signalName;
	protected DataBindingContext dataBindingContext = new DataBindingContext();
	protected ConnectionControlDecoration connectionDecoration;
	protected IndexedConverter indexedConverter;
	protected int signalIndex;
	
	public ThLabel(Composite parent, int style) {
		super(parent, style);
	}
	
	public String getSignalName() {
		return signalName;
	}

	public void setSignalName(String signalName) {
		this.signalName = signalName;
	}

	@Override
	protected void checkSubclass() {}

	@Override
	public void bindValues(Client client) throws Exception {
		Property property = client.findProperty(signalName);
		
		connectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
		
		IObservableValue observeWidget = SWTObservables.observeText(this);
		IObservableValue observeValue = EMFObservables.observeValue(property, Literals.PROPERTY__VALUE);
		
		UpdateValueStrategy modelToTarget = new UpdateValueStrategy();
		
		indexedConverter = ConverterFactory.createIndexedConverter(property.getValue().getClass(), String.class, getSignalIndex(), property);	
		modelToTarget.setConverter(indexedConverter);
		dataBindingContext.bindValue(observeWidget, observeValue, null, modelToTarget);
		
		this.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(DisposeEvent e) {
				dataBindingContext.dispose();
			}
		});
	}

	public int getSignalIndex() {
		if(indexedConverter != null)
			signalIndex = indexedConverter.getIndex();
		return signalIndex;
	}

	public void setSignalIndex(int signalIndex) {
		this.signalIndex = signalIndex;
		if(indexedConverter != null)
			indexedConverter.setIndex(signalIndex);
		dataBindingContext.updateTargets();
	}
}
