package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Composite;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;
import ch.thomson.ucs.tine.client.databinding.converters.ConverterFactory;
import ch.thomson.ucs.tine.client.databinding.converters.IndexedColorConverter;


public class ThLabelBackground extends ThLabel {

	protected Color backgroundActive;
	
	public ThLabelBackground(Composite parent, int style) {
		super(parent, style);
	}
	
	public Color getBackgroundActive() {
		return backgroundActive;
	}


	public void setBackgroundActive(Color backgroundActive) {
		this.backgroundActive = backgroundActive;
	}

	@Override
	public void bindValues(Client client) throws Exception {
		Property property = client.findProperty(signalName);
		
		connectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
		
		IObservableValue observeWidget = SWTObservables.observeBackground(this);
		IObservableValue observeValue = EMFObservables.observeValue(property, Literals.PROPERTY__VALUE);
				
		IndexedColorConverter converter = (IndexedColorConverter) ConverterFactory.createIndexedConverter(property.getValue().getClass(), Color.class, signalIndex, property);	
		converter.addColor(0, this.getBackground());
		converter.addColor(1, this.getBackgroundActive());
		indexedConverter = converter;
	
		UpdateValueStrategy modelToTarget = new UpdateValueStrategy();
		modelToTarget.setConverter(converter);

		dataBindingContext.bindValue(observeWidget, observeValue, null, modelToTarget);
	}

}
