package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;
import ch.thomson.ucs.tine.client.databinding.converters.ConverterFactory;
import ch.thomson.ucs.tine.client.databinding.converters.MsgIndexedFloatToString;

public class ThLabelMsg extends ThLabel {
	
	private String[] captionList;
	private String[] valueList;

	public ThLabelMsg(Composite parent, int style) {
		super(parent, style);
		// TODO Auto-generated constructor stub
	}

	public String[] getCaptionList() {
		return captionList;
	}

	public void setCaptionList(String[] captionList) {
		this.captionList = captionList;
	}

	public String[] getValueList() {
		return valueList;
	}

	public void setValueList(String[] valueList) {
		this.valueList = valueList;
	}

	@Override
	public void bindValues(Client client) throws Exception {
		Property property = client.findProperty(signalName);
		
		connectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
		
//		IObservableValue observeWidget = SWTObservables.observeBackground(this);
		IObservableValue observeWidget = SWTObservables.observeText(this);
		IObservableValue observeValue = EMFObservables.observeValue(property, Literals.PROPERTY__VALUE);
				
		MsgIndexedFloatToString converter = (MsgIndexedFloatToString) ConverterFactory.createMsgIndexedConverter(property.getValue().getClass(), String.class, signalIndex, property);
		for(int i=0; i<valueList.length; i++) {
			converter.addMessage(Integer.decode(valueList[i]), captionList[i]);
		}
		indexedConverter = converter;
	
		UpdateValueStrategy modelToTarget = new UpdateValueStrategy();
		modelToTarget.setConverter(converter);

		dataBindingContext.bindValue(observeWidget, observeValue, null, modelToTarget);
	}
	
}
