package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.widgets.Composite;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;
import ch.thomson.ucs.tine.client.databinding.converters.ConverterFactory;
import ch.thomson.ucs.tine.client.databinding.converters.VersionIndexedFloatToString;

public class ThLabelVersion extends ThLabel {

	public ThLabelVersion(Composite parent, int style) {
		super(parent, style);
		// TODO Auto-generated constructor stub
	}

	@Override
	public void bindValues(Client client) throws Exception {
		Property property = client.findProperty(signalName);
		
		connectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
		
		IObservableValue observeWidget = SWTObservables.observeText(this);
		IObservableValue observeValue = EMFObservables.observeValue(property, Literals.PROPERTY__VALUE);
		
		UpdateValueStrategy modelToTarget = new UpdateValueStrategy();
		
		VersionIndexedFloatToString converter = (VersionIndexedFloatToString) ConverterFactory.createVersionIndexedConverter(property.getValue().getClass(), String.class, signalIndex, property);
		indexedConverter = converter;
		modelToTarget.setConverter(indexedConverter);
		dataBindingContext.bindValue(observeWidget, observeValue, null, modelToTarget);
		
		this.addDisposeListener(new DisposeListener() {
			@Override
			public void widgetDisposed(DisposeEvent e) {
				dataBindingContext.dispose();
			}
		});
	}	
}
