package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.wb.swt.ResourceManager;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.databinding.converters.ConverterFactory;
import ch.thomson.ucs.tine.client.databinding.converters.IndexedImageConverter;

public class ThLed extends ThLabel {

	private String maskValue;
	private boolean inverted = false;
	private boolean valueCondition = false;

	protected Image activeLed = null;
	protected Image inactiveLed = null;
	

	
	public ThLed(Composite parent, int style) {
		super(parent, style);
		this.setImage(getInactiveLed());
	}
	
	public Image getActiveLed() {
		if(activeLed == null)
			activeLed = ResourceManager.getPluginImage("ch.thomson.ucs.tine.client.databinding", "icons/LedRed32x32.png");
		return activeLed;
	}

	public void setActiveLed(Image activeLed) {
		this.activeLed = activeLed;
	}

	public Image getInactiveLed() {
		if(inactiveLed == null)
			inactiveLed = ResourceManager.getPluginImage("ch.thomson.ucs.tine.client.databinding", "icons/LedGreen32x32.png");
		return inactiveLed;
	}

	public void setInactiveLed(Image inactiveLed) {
		this.inactiveLed = inactiveLed;
	}

	@Override
	public void bindValues(Client client) throws Exception {
		Property property = client.findProperty(signalName);
		
		connectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
		
		IObservableValue observeWidget = SWTObservables.observeImage(this);
		IObservableValue observeValue = EMFObservables.observeValue(property, Literals.PROPERTY__VALUE);
		
		IndexedImageConverter converter = (IndexedImageConverter) ConverterFactory.createIndexedConverter(property.getValue().getClass(), Image.class, signalIndex, property);

		converter.addImage(0, getInactiveLed());
		converter.addImage(1, getActiveLed());
		
		converter.setInverted(inverted);
		converter.setValueCondition(valueCondition);
		converter.setMaskValue(Integer.decode(maskValue));
		
		indexedConverter = converter;
		
		UpdateValueStrategy modelToTarget = new UpdateValueStrategy();
		modelToTarget.setConverter(converter);
		
		dataBindingContext.bindValue(observeWidget, observeValue, null, modelToTarget);
	}

	public boolean isInverted() {
		return inverted;
	}

	public void setInverted(boolean inverted) {
		this.inverted = inverted;
	}

	public String getMaskValue() {
		return maskValue;
	}

	public void setMaskValue(String maskValue) {
		this.maskValue = maskValue;
	}	
	
	public boolean isValueCondition() {
		return valueCondition;
	}

	public void setValueCondition(boolean valueCondition) {
		this.valueCondition = valueCondition;
	}	
}
