package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class ThLedLabel extends ThComposite {

	private ThLed led;
	private Label lblLabel;

	@Override
	public void setFont(Font font) {
		lblLabel.setFont(font);
		super.setFont(font);
	}

	
	/**
	 * @wbp.parser.constructor
	 */
	public ThLedLabel(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(2, false);
		gridLayout.marginWidth = 0;
		gridLayout.marginHeight = 0;
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 10;
		setLayout(gridLayout);
		led = new ThLed(this, SWT.NONE);
		lblLabel = new Label(this, SWT.NONE);
		lblLabel.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		lblLabel.setText("Label");
	}
	
	public String getLabelText() {
		return lblLabel.getText();
	}

	public void setLabelText(String labelText) {
		lblLabel.setText(labelText);
	}
	
	public void setInverted(boolean inverted) {
		led.setInverted(inverted);
	}
	
	public boolean isInverted() {
		return led.isInverted();
	}
	
	public void setValueCondition(boolean cond) {
		led.setValueCondition(cond);
	}
	
	public boolean isValueCondition() {
		return led.isValueCondition();
	}

	public void setMaskValue(String mask) {
		led.setMaskValue(mask);
	}
	
	public String getMaskValue() {
		return led.getMaskValue();
	}
	
	public void setSignalName(String signalName) {
		led.setSignalName(signalName);
	}
	
	public String getSignalName() {
		return led.getSignalName();
	}
	
	public void setAlignment(int alignment) {
		led.setAlignment(alignment);
	}
	
	public int getAlignment() {
		return led.getAlignment();
	}
	
	public Image getActiveLed() {
		return led.getActiveLed();
	}

	public void setActiveLed(Image activeLed) {
		led.setActiveLed(activeLed);
	}

	public Image getInactiveLed() {
		return led.getInactiveLed();
	}

	public void setInactiveLed(Image inactiveLed) {
		led.setInactiveLed(inactiveLed);
	}
	
}
