package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.core.databinding.UpdateValueStrategy;
import org.eclipse.core.databinding.observable.value.IObservableValue;
import org.eclipse.emf.databinding.EMFObservables;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.resource.LocalResourceManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.wb.swt.ResourceManager;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.ClientPackage.Literals;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.databinding.converters.ConverterFactory;
import ch.thomson.ucs.tine.client.databinding.converters.IndexedImageConverter;

public class ThLedMask extends ThLabel {

	private int maskValue;
	private Image greenLed;
	private Image redLed;
	private boolean inverted = false;
	
	LocalResourceManager resources;
	
	public ThLedMask(Composite parent, int style) {
		super(parent, style);
		resources = new LocalResourceManager(JFaceResources.getResources(), this);
		greenLed = ResourceManager.getPluginImage("ch.thomson.ucs.tine.client.databinding", "icons/LedGreen32x32.png");
		redLed = ResourceManager.getPluginImage("ch.thomson.ucs.tine.client.databinding", "icons/LedRed32x32.png");
		this.setImage(redLed);
	}


	@Override
	public void bindValues(Client client) throws Exception {
		Property property = client.findProperty(signalName);
		
		connectionDecoration = new ConnectionControlDecoration(this, SWT.LEFT | SWT.TOP, property);
		
		IObservableValue observeWidget = SWTObservables.observeImage(this);
		IObservableValue observeValue = EMFObservables.observeValue(property, Literals.PROPERTY__VALUE);
		
		IndexedImageConverter converter = (IndexedImageConverter) ConverterFactory.createIndexedConverter(property.getValue().getClass(), Image.class, signalIndex, property);	
		converter.addImage(0, greenLed);
		converter.addImage(1, redLed);
//		converter.setMask(mask);
		indexedConverter = converter;
		
		UpdateValueStrategy modelToTarget = new UpdateValueStrategy();
		modelToTarget.setConverter(converter);
		
		dataBindingContext.bindValue(observeWidget, observeValue, null, modelToTarget);
	}

	public int getMaskValue() {
		return maskValue;
	}


	public void setMaskValue(int maskValue) {
		this.maskValue = maskValue;
	}


	public boolean isInverted() {
		return inverted;
	}


	public void setInverted(boolean inverted) {
		this.inverted = inverted;
	}
}
