package ch.thomson.ucs.tine.databinding.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

import ch.thomson.ucs.tine.client.Client;

public class ThTextUnit extends ThText {

	private Composite composite;
	private Text txtUnit;
	
	/**
	 * @wbp.parser.constructor
	 */
	public ThTextUnit(Composite parent, int style) {
		super(parent, style);
		composite = parent;
	}
	
	public Text getTxtUnit() {
		if(txtUnit == null) {
			txtUnit = new Text(composite, SWT.BORDER | SWT.CENTER | SWT.READ_ONLY);
			txtUnit.setFont(SWTResourceManager.getFont("Tahoma", 18, SWT.BOLD));
		}
		return txtUnit;
	}
	
	@Override
	protected void checkSubclass() {}

	@Override
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		
		getTxtUnit().setBounds(x + width, y, 2 * height, height);
	}
	
	@Override
	public void setFont(Font font) {
		super.setFont(font);
		
		getTxtUnit().setFont(font);
	}

	@Override
	public void bindValues(Client client) throws Exception {
		super.bindValues(client);
		String txt = client.findProperty(getSignalName()).getUnit();
		if(("none".contentEquals(txt) == false) && ("1".contentEquals(txt) == false))
			txtUnit.setText(txt);
	}
}
