package ch.thomson.ucs.tine.databinding.swt.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.wb.swt.SWTResourceManager;

import ch.thomson.ucs.tine.databinding.swt.INumKey;

public class NumericPad extends Dialog implements SelectionListener, Listener {


	private static NumericPad instance;
	private INumKey numKey;
	private String valueText; 
	private boolean clean = true;
	private Button btReturn;

	@Override
	protected Point getInitialLocation(Point initialSize) {
		return new Point(1280, 1024);
	}

	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	private NumericPad(Shell parentShell, INumKey nKey) {
		super(parentShell);
		setBlockOnOpen(false);
		setShellStyle(SWT.BORDER | SWT.CLOSE);
		this.numKey = nKey;
		this.numKey.setActive(true);
	}

	public static synchronized NumericPad instance(Shell parentShell, INumKey nKey)/* throws Exception */{
		if(instance == null) {
			instance = new NumericPad(parentShell, nKey);
		}
		else {
			if(instance.numKey != nKey) {
				instance.numKey.setActive(false);
				instance.numKey = nKey;
			}
			if(!instance.btReturn.isDisposed())
				instance.btReturn.setFocus();
		}
		instance.valueText = nKey.getText();
		instance.clean = true;
		return instance;
	}
	
	@Override
	protected void configureShell(Shell newShell) {
		// TODO Auto-generated method stub
		super.configureShell(newShell);
		newShell.setText("Numeric Pad");
	}
	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		GridLayout gridLayout = (GridLayout) container.getLayout();
		gridLayout.verticalSpacing = 1;
		gridLayout.horizontalSpacing = 1;
		gridLayout.numColumns = 4;
		
		Button bt7 = new Button(container, SWT.CENTER);
		bt7.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		GridData gd_bt7 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt7.heightHint = 60;
		gd_bt7.widthHint = 60;
		bt7.setLayoutData(gd_bt7);
		bt7.setText("7");
		bt7.addSelectionListener(this);
		
		Button bt8 = new Button(container, SWT.NONE);
		GridData gd_bt8 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt8.heightHint = 60;
		gd_bt8.widthHint = 60;
		bt8.setLayoutData(gd_bt8);
		bt8.setText("8");
		bt8.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt8.addSelectionListener(this);
		
		Button bt9 = new Button(container, SWT.NONE);
		GridData gd_bt9 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt9.widthHint = 60;
		gd_bt9.heightHint = 60;
		bt9.setLayoutData(gd_bt9);
		bt9.setText("9");
		bt9.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt9.addSelectionListener(this);
		
		Button btBackspace = new Button(container, SWT.NONE);
		GridData gd_btBackspace = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_btBackspace.widthHint = 60;
		gd_btBackspace.heightHint = 60;
		btBackspace.setLayoutData(gd_btBackspace);
		btBackspace.setText("BS");
		btBackspace.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		btBackspace.addSelectionListener(this);
		
		Button bt4 = new Button(container, SWT.NONE);
		GridData gd_bt4 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt4.heightHint = 60;
		gd_bt4.widthHint = 60;
		bt4.setLayoutData(gd_bt4);
		bt4.setText("4");
		bt4.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt4.addSelectionListener(this);
		
		Button bt5 = new Button(container, SWT.NONE);
		GridData gd_bt5 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt5.heightHint = 60;
		gd_bt5.widthHint = 60;
		bt5.setLayoutData(gd_bt5);
		bt5.setText("5");
		bt5.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt5.addSelectionListener(this);
		
		Button bt6 = new Button(container, SWT.NONE);
		GridData gd_bt6 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt6.heightHint = 60;
		gd_bt6.widthHint = 60;
		bt6.setLayoutData(gd_bt6);
		bt6.setText("6");
		bt6.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt6.addSelectionListener(this);
		
		btReturn = new Button(container, SWT.NONE);
		GridData gd_btReturn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 2);
		gd_btReturn.widthHint = 60;
		gd_btReturn.heightHint = 121;
		btReturn.setLayoutData(gd_btReturn);
		btReturn.setText("RET");
		btReturn.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		btReturn.addSelectionListener(this);
		btReturn.setFocus();
		
		Button bt1 = new Button(container, SWT.NONE);
		GridData gd_bt1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt1.widthHint = 60;
		gd_bt1.heightHint = 60;
		bt1.setLayoutData(gd_bt1);
		bt1.setText("1");
		bt1.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt1.addSelectionListener(this);
		
		Button bt2 = new Button(container, SWT.NONE);
		GridData gd_bt2 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt2.widthHint = 60;
		gd_bt2.heightHint = 60;
		bt2.setLayoutData(gd_bt2);
		bt2.setText("2");
		bt2.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt2.addSelectionListener(this);
		
		Button bt3 = new Button(container, SWT.NONE);
		GridData gd_bt3 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt3.widthHint = 60;
		gd_bt3.heightHint = 60;
		bt3.setLayoutData(gd_bt3);
		bt3.setText("3");
		bt3.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt3.addSelectionListener(this);
		
		Button bt0 = new Button(container, SWT.NONE);
		GridData gd_bt0 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_bt0.widthHint = 60;
		gd_bt0.heightHint = 60;
		bt0.setLayoutData(gd_bt0);
		bt0.setText("0");
		bt0.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		bt0.addSelectionListener(this);
		
		Button btMinus = new Button(container, SWT.NONE);
		GridData gd_btMinus = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_btMinus.widthHint = 60;
		gd_btMinus.heightHint = 60;
		btMinus.setLayoutData(gd_btMinus);
		btMinus.setText("+/-");
		btMinus.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		btMinus.addSelectionListener(this);
		
		Button btPoint = new Button(container, SWT.NONE);
		GridData gd_btPoint = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_btPoint.widthHint = 60;
		gd_btPoint.heightHint = 60;
		btPoint.setLayoutData(gd_btPoint);
		btPoint.setText(".");
		btPoint.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		btPoint.addSelectionListener(this);
		
		Button btEsc = new Button(container, SWT.NONE);
		GridData gd_btEsc = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_btEsc.widthHint = 60;
		gd_btEsc.heightHint = 60;
		btEsc.setLayoutData(gd_btEsc);
		btEsc.setText("ESC");
		btEsc.setFont(SWTResourceManager.getFont("Tahoma", 14, SWT.BOLD));
		btEsc.addSelectionListener(this);
				        
		//add a global listener for key down events
		Display.getDefault().removeFilter(SWT.KeyUp, this);
		Display.getDefault().addFilter(SWT.KeyUp, this);
		return container;
	}

	/**
	 * Create contents of the button bar.
	 * @param parent
	 */
	@Override
	protected void createButtonsForButtonBar(Composite parent) {
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(264, 332);
	}

	@Override
	public void widgetSelected(SelectionEvent e) {
		// TODO Auto-generated method stub
//		btReturn.setFocus();
		if(e.widget instanceof Button) {
			Button bt = (Button) e.widget;
			if(bt.getText() == "ESC") {
				this.handleShellCloseEvent();
			}
			else {
				if(bt.getText() == "RET")
					setValue(SWT.CR);
				else if(bt.getText() == "BS")
					setValue(SWT.BS);
				else if(bt.getText() == "+/-")
					setValue('-');
				else
					setValue(bt.getText().charAt(0));
			}
		}
	}

	@Override
	public void widgetDefaultSelected(SelectionEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void handleShellCloseEvent() {
		valueText = "";
		Display.getDefault().removeFilter(SWT.KeyUp, this);
		super.handleShellCloseEvent();
	}
	
	
	private void setValue(char val) {
		if(val == SWT.CR) {
			numKey.setValue(valueText);
			clean = true;
		}
		else {
			if(clean) {
				clean = false;
				valueText = "";
			}
			if(val == SWT.BS) {
				if(valueText.length() > 0) {
					String txt = valueText.substring(0, valueText.length() - 1);
					valueText = txt;
					numKey.setTextValue(valueText);
				}
			}
			else if(((val >= '0') && (val <= '9')) || (val == '.')){
				valueText = valueText + val;
				numKey.setTextValue(valueText);
			}
			else if(val == '-') {
				if(valueText.startsWith("-"))
					valueText = valueText.substring(1);
				else
					valueText = val + valueText;
				numKey.setTextValue(valueText);
			}
		}
	}

	@Override
	public void handleEvent(Event event) {
		setValue(event.character);
	}
}
