/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.statemachine;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>State</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getConditions <em>Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getStateMachine <em>State Machine</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getCommands <em>Commands</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getNextState <em>Next State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getPreviousState <em>Previous State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getStartTime <em>Start Time</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getActualFaultConditions <em>Actual Fault Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getActualWarningConditions <em>Actual Warning Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getActualPendingConditions <em>Actual Pending Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#isStarted <em>Started</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getStopTime <em>Stop Time</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getStartDelay <em>Start Delay</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getStopDelay <em>Stop Delay</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#isMainState <em>Main State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getAllWarningConditions <em>All Warning Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getAllSupervisionConditions <em>All Supervision Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getAllPreconditions <em>All Preconditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.State#getAllFaultConditions <em>All Fault Conditions</em>}</li>
 * </ul>
 * </p>
 *
 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState()
 * @model abstract="true"
 * @generated
 */
public interface State extends StateMachineObject {
	/**
	 * Returns the value of the '<em><b>Conditions</b></em>' containment reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Condition}.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.client.statemachine.Condition#getState <em>State</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Conditions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Conditions</em>' containment reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_Conditions()
	 * @see ch.thomson.ucs.tine.client.statemachine.Condition#getState
	 * @model opposite="state" containment="true"
	 * @generated
	 */
	EList<Condition> getConditions();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.State#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>State Machine</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.client.statemachine.StateMachine#getStates <em>States</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State Machine</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>State Machine</em>' container reference.
	 * @see #setStateMachine(StateMachine)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_StateMachine()
	 * @see ch.thomson.ucs.tine.client.statemachine.StateMachine#getStates
	 * @model opposite="states" required="true" transient="false"
	 * @generated
	 */
	StateMachine getStateMachine();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.State#getStateMachine <em>State Machine</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>State Machine</em>' container reference.
	 * @see #getStateMachine()
	 * @generated
	 */
	void setStateMachine(StateMachine value);

	/**
	 * Returns the value of the '<em><b>Commands</b></em>' containment reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Command}.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.client.statemachine.Command#getState <em>State</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Commands</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Commands</em>' containment reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_Commands()
	 * @see ch.thomson.ucs.tine.client.statemachine.Command#getState
	 * @model opposite="state" containment="true"
	 * @generated
	 */
	EList<Command> getCommands();

	/**
	 * Returns the value of the '<em><b>Next State</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.client.statemachine.State#getPreviousState <em>Previous State</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Next State</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Next State</em>' reference.
	 * @see #setNextState(State)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_NextState()
	 * @see ch.thomson.ucs.tine.client.statemachine.State#getPreviousState
	 * @model opposite="previousState"
	 * @generated
	 */
	State getNextState();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.State#getNextState <em>Next State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Next State</em>' reference.
	 * @see #getNextState()
	 * @generated
	 */
	void setNextState(State value);

	/**
	 * Returns the value of the '<em><b>Previous State</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.client.statemachine.State#getNextState <em>Next State</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Previous State</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Previous State</em>' reference.
	 * @see #setPreviousState(State)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_PreviousState()
	 * @see ch.thomson.ucs.tine.client.statemachine.State#getNextState
	 * @model opposite="nextState"
	 * @generated
	 */
	State getPreviousState();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.State#getPreviousState <em>Previous State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Previous State</em>' reference.
	 * @see #getPreviousState()
	 * @generated
	 */
	void setPreviousState(State value);

	/**
	 * Returns the value of the '<em><b>Start Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time</em>' attribute.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_StartTime()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	long getStartTime();

	/**
	 * Returns the value of the '<em><b>Actual Fault Conditions</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Condition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual Fault Conditions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual Fault Conditions</em>' reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_ActualFaultConditions()
	 * @model changeable="false"
	 * @generated
	 */
	EList<Condition> getActualFaultConditions();

	/**
	 * Returns the value of the '<em><b>Actual Warning Conditions</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Condition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual Warning Conditions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual Warning Conditions</em>' reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_ActualWarningConditions()
	 * @model changeable="false"
	 * @generated
	 */
	EList<Condition> getActualWarningConditions();

	/**
	 * Returns the value of the '<em><b>Actual Pending Conditions</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Condition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual Pending Conditions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual Pending Conditions</em>' reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_ActualPendingConditions()
	 * @model changeable="false"
	 * @generated
	 */
	EList<Condition> getActualPendingConditions();

	/**
	 * Returns the value of the '<em><b>Started</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Started</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Started</em>' attribute.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_Started()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	boolean isStarted();

	/**
	 * Returns the value of the '<em><b>Stop Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stop Delay</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stop Delay</em>' containment reference.
	 * @see #setStopDelay(Setting)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_StopDelay()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Setting getStopDelay();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.State#getStopDelay <em>Stop Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stop Delay</em>' containment reference.
	 * @see #getStopDelay()
	 * @generated
	 */
	void setStopDelay(Setting value);

	/**
	 * Returns the value of the '<em><b>Main State</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Main State</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Main State</em>' attribute.
	 * @see #setMainState(boolean)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_MainState()
	 * @model default="true"
	 * @generated
	 */
	boolean isMainState();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.State#isMainState <em>Main State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Main State</em>' attribute.
	 * @see #isMainState()
	 * @generated
	 */
	void setMainState(boolean value);

	/**
	 * Returns the value of the '<em><b>All Warning Conditions</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Warning}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>All Warning Conditions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>All Warning Conditions</em>' reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_AllWarningConditions()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	EList<Warning> getAllWarningConditions();

	/**
	 * Returns the value of the '<em><b>All Supervision Conditions</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Supervision}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>All Supervision Conditions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>All Supervision Conditions</em>' reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_AllSupervisionConditions()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	EList<Supervision> getAllSupervisionConditions();

	/**
	 * Returns the value of the '<em><b>All Preconditions</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Precondition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>All Preconditions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>All Preconditions</em>' reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_AllPreconditions()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	EList<Precondition> getAllPreconditions();

	/**
	 * Returns the value of the '<em><b>All Fault Conditions</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.client.statemachine.Condition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>All Fault Conditions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>All Fault Conditions</em>' reference list.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_AllFaultConditions()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	EList<Condition> getAllFaultConditions();

	/**
	 * Returns the value of the '<em><b>Stop Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stop Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stop Time</em>' attribute.
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_StopTime()
	 * @model transient="true" changeable="false"
	 * @generated
	 */
	long getStopTime();

	/**
	 * Returns the value of the '<em><b>Start Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Delay</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Delay</em>' containment reference.
	 * @see #setStartDelay(Setting)
	 * @see ch.thomson.ucs.tine.client.statemachine.StatemachinePackage#getState_StartDelay()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Setting getStartDelay();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.client.statemachine.State#getStartDelay <em>Start Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Delay</em>' containment reference.
	 * @see #getStartDelay()
	 * @generated
	 */
	void setStartDelay(Setting value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	StateStatus start();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	StateStatus check();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	StateStatus stop();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean hasNextState();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean hasPreviousState();

} // State
