/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.statemachine.impl;

import ch.thomson.ucs.tine.client.statemachine.Condition;
import ch.thomson.ucs.tine.client.statemachine.ConditionStatus;
import ch.thomson.ucs.tine.client.statemachine.GeneralState;
import ch.thomson.ucs.tine.client.statemachine.StateStatus;
import ch.thomson.ucs.tine.client.statemachine.StatemachinePackage;
import ch.thomson.ucs.tine.client.statemachine.Warning;

import org.eclipse.emf.ecore.EClass;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>General State</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class GeneralStateImpl extends StateImpl implements GeneralState {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GeneralStateImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StatemachinePackage.Literals.GENERAL_STATE;
	}

	@Override
	public StateStatus check() {
		// Fehler- und Warnungsliste lschen
		this.getActualFaultConditions().clear();
		this.getActualWarningConditions().clear();
		this.getActualPendingConditions().clear();

		// Fehler und Warnungen checken
		for (Condition condition : this.getConditions()) {
			ConditionStatus conditionStatus = condition.check();

			// Auf Fehler oder Warnungen prfen und in entsprechende Tabelle
			// eintragen
			if (ConditionStatus.FAULT.equals(conditionStatus)) {
				// Nur Warnung?
				if (condition instanceof Warning)
					this.getActualWarningConditions().add(condition);

				else
					this.getActualFaultConditions().add(condition);
			}
			
			// Waiting for OK? -> Pending Condition
			else if (ConditionStatus.WAITING_FOR_OK.equals(conditionStatus)) {
				this.getActualPendingConditions().add(condition);
			}
		}

		// Rckgabewerte sind nach Prioritt
		if (this.getActualFaultConditions().size() > 0)
			return StateStatus.FAULT;

		if (this.getActualPendingConditions().size() > 0)
			return StateStatus.PENDING;

		return StateStatus.OK;
	}

} //GeneralStateImpl
