/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.statemachine.impl;

import ch.thomson.ucs.tine.client.statemachine.Command;
import ch.thomson.ucs.tine.client.statemachine.Condition;
import ch.thomson.ucs.tine.client.statemachine.Setting;
import ch.thomson.ucs.tine.client.statemachine.ConditionStatus;
import ch.thomson.ucs.tine.client.statemachine.Precondition;
import ch.thomson.ucs.tine.client.statemachine.State;
import ch.thomson.ucs.tine.client.statemachine.StateMachine;
import ch.thomson.ucs.tine.client.statemachine.StateStatus;
import ch.thomson.ucs.tine.client.statemachine.StatemachineFactory;
import ch.thomson.ucs.tine.client.statemachine.StatemachinePackage;

import ch.thomson.ucs.tine.client.statemachine.Supervision;
import ch.thomson.ucs.tine.client.statemachine.Warning;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>State</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getConditions <em>Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getStateMachine <em>State Machine</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getCommands <em>Commands</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getNextState <em>Next State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getPreviousState <em>Previous State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getStartTime <em>Start Time</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getActualFaultConditions <em>Actual Fault Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getActualWarningConditions <em>Actual Warning Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getActualPendingConditions <em>Actual Pending Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#isStarted <em>Started</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getStopTime <em>Stop Time</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getStartDelay <em>Start Delay</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getStopDelay <em>Stop Delay</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#isMainState <em>Main State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getAllWarningConditions <em>All Warning Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getAllSupervisionConditions <em>All Supervision Conditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getAllPreconditions <em>All Preconditions</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.statemachine.impl.StateImpl#getAllFaultConditions <em>All Fault Conditions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class StateImpl extends StateMachineObjectImpl implements State {
	/**
	 * The cached value of the '{@link #getConditions() <em>Conditions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Condition> conditions;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCommands() <em>Commands</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCommands()
	 * @generated
	 * @ordered
	 */
	protected EList<Command> commands;

	/**
	 * The cached value of the '{@link #getNextState() <em>Next State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNextState()
	 * @generated
	 * @ordered
	 */
	protected State nextState;

	/**
	 * The cached value of the '{@link #getPreviousState() <em>Previous State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPreviousState()
	 * @generated
	 * @ordered
	 */
	protected State previousState;

	/**
	 * The default value of the '{@link #getStartTime() <em>Start Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTime()
	 * @generated
	 * @ordered
	 */
	protected static final long START_TIME_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getStartTime() <em>Start Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTime()
	 * @generated
	 * @ordered
	 */
	protected long startTime = START_TIME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getActualFaultConditions() <em>Actual Fault Conditions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualFaultConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Condition> actualFaultConditions;

	/**
	 * The cached value of the '{@link #getActualWarningConditions() <em>Actual Warning Conditions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualWarningConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Condition> actualWarningConditions;

	/**
	 * The cached value of the '{@link #getActualPendingConditions() <em>Actual Pending Conditions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualPendingConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Condition> actualPendingConditions;

	/**
	 * The default value of the '{@link #isStarted() <em>Started</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isStarted()
	 * @generated
	 * @ordered
	 */
	protected static final boolean STARTED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isStarted() <em>Started</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isStarted()
	 * @generated
	 * @ordered
	 */
	protected boolean started = STARTED_EDEFAULT;

	/**
	 * The default value of the '{@link #getStopTime() <em>Stop Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStopTime()
	 * @generated
	 * @ordered
	 */
	protected static final long STOP_TIME_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getStopTime() <em>Stop Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStopTime()
	 * @generated
	 * @ordered
	 */
	protected long stopTime = STOP_TIME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStartDelay() <em>Start Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartDelay()
	 * @generated
	 * @ordered
	 */
	protected Setting startDelay;

	/**
	 * The cached value of the '{@link #getStopDelay() <em>Stop Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStopDelay()
	 * @generated
	 * @ordered
	 */
	protected Setting stopDelay;

	/**
	 * The default value of the '{@link #isMainState() <em>Main State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMainState()
	 * @generated
	 * @ordered
	 */
	protected static final boolean MAIN_STATE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isMainState() <em>Main State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMainState()
	 * @generated
	 * @ordered
	 */
	protected boolean mainState = MAIN_STATE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAllWarningConditions() <em>All Warning Conditions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAllWarningConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Warning> allWarningConditions;

	/**
	 * The cached value of the '{@link #getAllSupervisionConditions() <em>All Supervision Conditions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAllSupervisionConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Supervision> allSupervisionConditions;

	/**
	 * The cached value of the '{@link #getAllPreconditions() <em>All Preconditions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAllPreconditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Precondition> allPreconditions;

	/**
	 * The cached value of the '{@link #getAllFaultConditions() <em>All Fault Conditions</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAllFaultConditions()
	 * @generated
	 * @ordered
	 */
	protected EList<Condition> allFaultConditions;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StateImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StatemachinePackage.Literals.STATE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Condition> getConditions() {
		if (conditions == null) {
			conditions = new EObjectContainmentWithInverseEList<Condition>(Condition.class, this, StatemachinePackage.STATE__CONDITIONS, StatemachinePackage.CONDITION__STATE);
		}
		return conditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StateMachine getStateMachine() {
		if (eContainerFeatureID() != StatemachinePackage.STATE__STATE_MACHINE) return null;
		return (StateMachine)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStateMachine(StateMachine newStateMachine, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newStateMachine, StatemachinePackage.STATE__STATE_MACHINE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStateMachine(StateMachine newStateMachine) {
		if (newStateMachine != eInternalContainer() || (eContainerFeatureID() != StatemachinePackage.STATE__STATE_MACHINE && newStateMachine != null)) {
			if (EcoreUtil.isAncestor(this, newStateMachine))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStateMachine != null)
				msgs = ((InternalEObject)newStateMachine).eInverseAdd(this, StatemachinePackage.STATE_MACHINE__STATES, StateMachine.class, msgs);
			msgs = basicSetStateMachine(newStateMachine, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__STATE_MACHINE, newStateMachine, newStateMachine));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Command> getCommands() {
		if (commands == null) {
			commands = new EObjectContainmentWithInverseEList<Command>(Command.class, this, StatemachinePackage.STATE__COMMANDS, StatemachinePackage.COMMAND__STATE);
		}
		return commands;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getNextState() {
		if (nextState != null && nextState.eIsProxy()) {
			InternalEObject oldNextState = (InternalEObject)nextState;
			nextState = (State)eResolveProxy(oldNextState);
			if (nextState != oldNextState) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, StatemachinePackage.STATE__NEXT_STATE, oldNextState, nextState));
			}
		}
		return nextState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State basicGetNextState() {
		return nextState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNextState(State newNextState, NotificationChain msgs) {
		State oldNextState = nextState;
		nextState = newNextState;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__NEXT_STATE, oldNextState, newNextState);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNextState(State newNextState) {
		if (newNextState != nextState) {
			NotificationChain msgs = null;
			if (nextState != null)
				msgs = ((InternalEObject)nextState).eInverseRemove(this, StatemachinePackage.STATE__PREVIOUS_STATE, State.class, msgs);
			if (newNextState != null)
				msgs = ((InternalEObject)newNextState).eInverseAdd(this, StatemachinePackage.STATE__PREVIOUS_STATE, State.class, msgs);
			msgs = basicSetNextState(newNextState, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__NEXT_STATE, newNextState, newNextState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State getPreviousState() {
		if (previousState != null && previousState.eIsProxy()) {
			InternalEObject oldPreviousState = (InternalEObject)previousState;
			previousState = (State)eResolveProxy(oldPreviousState);
			if (previousState != oldPreviousState) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, StatemachinePackage.STATE__PREVIOUS_STATE, oldPreviousState, previousState));
			}
		}
		return previousState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public State basicGetPreviousState() {
		return previousState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPreviousState(State newPreviousState, NotificationChain msgs) {
		State oldPreviousState = previousState;
		previousState = newPreviousState;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__PREVIOUS_STATE, oldPreviousState, newPreviousState);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPreviousState(State newPreviousState) {
		if (newPreviousState != previousState) {
			NotificationChain msgs = null;
			if (previousState != null)
				msgs = ((InternalEObject)previousState).eInverseRemove(this, StatemachinePackage.STATE__NEXT_STATE, State.class, msgs);
			if (newPreviousState != null)
				msgs = ((InternalEObject)newPreviousState).eInverseAdd(this, StatemachinePackage.STATE__NEXT_STATE, State.class, msgs);
			msgs = basicSetPreviousState(newPreviousState, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__PREVIOUS_STATE, newPreviousState, newPreviousState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getStartTime() {
		return startTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Condition> getActualFaultConditions() {
		if (actualFaultConditions == null) {
			actualFaultConditions = new EObjectResolvingEList<Condition>(Condition.class, this, StatemachinePackage.STATE__ACTUAL_FAULT_CONDITIONS);
		}
		return actualFaultConditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Condition> getActualWarningConditions() {
		if (actualWarningConditions == null) {
			actualWarningConditions = new EObjectResolvingEList<Condition>(Condition.class, this, StatemachinePackage.STATE__ACTUAL_WARNING_CONDITIONS);
		}
		return actualWarningConditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Condition> getActualPendingConditions() {
		if (actualPendingConditions == null) {
			actualPendingConditions = new EObjectResolvingEList<Condition>(Condition.class, this, StatemachinePackage.STATE__ACTUAL_PENDING_CONDITIONS);
		}
		return actualPendingConditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isStarted() {
		return started;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Setting getStopDelay() {
		if(stopDelay == null) {
			this.setStopDelay(StatemachineFactory.eINSTANCE.createSetting());
		}
		return stopDelay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStopDelay(Setting newStopDelay, NotificationChain msgs) {
		Setting oldStopDelay = stopDelay;
		stopDelay = newStopDelay;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__STOP_DELAY, oldStopDelay, newStopDelay);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStopDelay(Setting newStopDelay) {
		if (newStopDelay != stopDelay) {
			NotificationChain msgs = null;
			if (stopDelay != null)
				msgs = ((InternalEObject)stopDelay).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.STATE__STOP_DELAY, null, msgs);
			if (newStopDelay != null)
				msgs = ((InternalEObject)newStopDelay).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.STATE__STOP_DELAY, null, msgs);
			msgs = basicSetStopDelay(newStopDelay, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__STOP_DELAY, newStopDelay, newStopDelay));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isMainState() {
		return mainState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMainState(boolean newMainState) {
		boolean oldMainState = mainState;
		mainState = newMainState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__MAIN_STATE, oldMainState, mainState));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Warning> getAllWarningConditions() {
		if (allWarningConditions == null) {
			allWarningConditions = new EObjectResolvingEList<Warning>(Warning.class, this, StatemachinePackage.STATE__ALL_WARNING_CONDITIONS);
		}
		return allWarningConditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Supervision> getAllSupervisionConditions() {
		if (allSupervisionConditions == null) {
			allSupervisionConditions = new EObjectResolvingEList<Supervision>(Supervision.class, this, StatemachinePackage.STATE__ALL_SUPERVISION_CONDITIONS);
		}
		return allSupervisionConditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Precondition> getAllPreconditions() {
		if (allPreconditions == null) {
			allPreconditions = new EObjectResolvingEList<Precondition>(Precondition.class, this, StatemachinePackage.STATE__ALL_PRECONDITIONS);
		}
		return allPreconditions;
	}

	/**
	 * <!-- begin-user-doc --> Bei den Faultconditions handelt es sich um
	 * diejenigen Conditions, die eine Rckschaltung der Statemachine auslsen
	 * knnen. Konkret sind dies Supervision- und Precondition-Instanzen. <!--
	 * end-user-doc -->
	 * @generated
	 */
	public EList<Condition> getAllFaultConditions() {
		if (allFaultConditions == null) {
			allFaultConditions = new EObjectResolvingEList<Condition>(Condition.class, this, StatemachinePackage.STATE__ALL_FAULT_CONDITIONS);
		}
		return allFaultConditions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getStopTime() {
		return stopTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Setting getStartDelay() {
		if(startDelay == null) {
			this.setStartDelay(StatemachineFactory.eINSTANCE.createSetting());
		}
		return startDelay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartDelay(Setting newStartDelay, NotificationChain msgs) {
		Setting oldStartDelay = startDelay;
		startDelay = newStartDelay;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__START_DELAY, oldStartDelay, newStartDelay);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartDelay(Setting newStartDelay) {
		if (newStartDelay != startDelay) {
			NotificationChain msgs = null;
			if (startDelay != null)
				msgs = ((InternalEObject)startDelay).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.STATE__START_DELAY, null, msgs);
			if (newStartDelay != null)
				msgs = ((InternalEObject)newStartDelay).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StatemachinePackage.STATE__START_DELAY, null, msgs);
			msgs = basicSetStartDelay(newStartDelay, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StatemachinePackage.STATE__START_DELAY, newStartDelay, newStartDelay));
	}

	/**
	 * <!-- begin-user-doc --> Diese Methode startet den State. Solange der
	 * Rckgabewert StateStatus.PENDING ist, sollte diese Methode zyklisch
	 * aufgerufen werden, bis StateStatus.OK oder StateStatus.FAULT
	 * zurckgegeben wird.
	 * 
	 * @return den StateStatus. <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public StateStatus start() {

		if (!started) {
			// Fehler- und Warninglisten lschen
			this.getActualFaultConditions().clear();
			this.getActualWarningConditions().clear();
			
			// Preconditions prfen
			StateStatus sumFault = StateStatus.OK;
			
			for (Condition condition : this.getConditions()) {			
				// Preconditions berprfen
				if (condition instanceof Precondition) {
					if (condition.check() == ConditionStatus.FAULT) {
						this.getActualFaultConditions().add(condition);
						sumFault = StateStatus.FAULT;
					}
				}
				// Schlaufe wird im Fehlerfall nicht vorzeitig verlassen, damit alle
				// fehlerhaften Preconditions in der Fehlerliste erscheinen.
			}
			
			// Startzeit ermitteln
			this.startTime = System.currentTimeMillis();
			
			// Checken, ob fehlerhafte Conditions vorhanden sind und zurckkehren
			if(sumFault == StateStatus.FAULT)
				return sumFault;

			// An dieser Stelle drfen die Kommandos auf ON gesetzt werden
			for (Command command : this.getCommands())
				command.on();

			// Kommandos wurden abgesetzt, State gilt als gestartet
			started = true;
		}
		
		// Status checken und im Fehlerfall die Commandos zurcknehmen
		StateStatus stateStatus = this.check();
		if(StateStatus.FAULT.equals(stateStatus)) {
			this.stop();
		}
		
		// Start Delay noch aktiv -> State Status Pending senden
		if(StateStatus.OK.equals(stateStatus)) {
			if((getStartDelay().getValue() != null) && ((System.currentTimeMillis() - getStartTime()) < getStartDelay().getValue())) 
				stateStatus = StateStatus.PENDING;
		}
		
		return stateStatus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract StateStatus check();
	
	/**
	 * <!-- begin-user-doc -->
	 * Diese Methode stoppt den State. Solange der
	 * Rckgabewert StateStatus.PENDING ist, sollte diese Methode zyklisch
	 * aufgerufen werden, bis StateStatus.OK zurckgegeben wird.
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public StateStatus stop() {
		if(started) {
			// Stopzeit ermitteln
			this.stopTime = System.currentTimeMillis();
		
			// Hier werden lediglich die Kommandos auf OFF gesetzt
			for(Command command : this.getCommands())
				command.off();
		
			started = false;
		}
		
		if((getStopDelay().getValue() != null) && ((System.currentTimeMillis() - getStopTime()) < getStopDelay().getValue()))
			return StateStatus.PENDING;
		
		return StateStatus.OK;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean hasNextState() {
		return (this.getNextState() != null);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean hasPreviousState() {
		return (this.getPreviousState() != null);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StatemachinePackage.STATE__CONDITIONS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getConditions()).basicAdd(otherEnd, msgs);
			case StatemachinePackage.STATE__STATE_MACHINE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetStateMachine((StateMachine)otherEnd, msgs);
			case StatemachinePackage.STATE__COMMANDS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getCommands()).basicAdd(otherEnd, msgs);
			case StatemachinePackage.STATE__NEXT_STATE:
				if (nextState != null)
					msgs = ((InternalEObject)nextState).eInverseRemove(this, StatemachinePackage.STATE__PREVIOUS_STATE, State.class, msgs);
				return basicSetNextState((State)otherEnd, msgs);
			case StatemachinePackage.STATE__PREVIOUS_STATE:
				if (previousState != null)
					msgs = ((InternalEObject)previousState).eInverseRemove(this, StatemachinePackage.STATE__NEXT_STATE, State.class, msgs);
				return basicSetPreviousState((State)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StatemachinePackage.STATE__CONDITIONS:
				return ((InternalEList<?>)getConditions()).basicRemove(otherEnd, msgs);
			case StatemachinePackage.STATE__STATE_MACHINE:
				return basicSetStateMachine(null, msgs);
			case StatemachinePackage.STATE__COMMANDS:
				return ((InternalEList<?>)getCommands()).basicRemove(otherEnd, msgs);
			case StatemachinePackage.STATE__NEXT_STATE:
				return basicSetNextState(null, msgs);
			case StatemachinePackage.STATE__PREVIOUS_STATE:
				return basicSetPreviousState(null, msgs);
			case StatemachinePackage.STATE__START_DELAY:
				return basicSetStartDelay(null, msgs);
			case StatemachinePackage.STATE__STOP_DELAY:
				return basicSetStopDelay(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case StatemachinePackage.STATE__STATE_MACHINE:
				return eInternalContainer().eInverseRemove(this, StatemachinePackage.STATE_MACHINE__STATES, StateMachine.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StatemachinePackage.STATE__CONDITIONS:
				return getConditions();
			case StatemachinePackage.STATE__NAME:
				return getName();
			case StatemachinePackage.STATE__STATE_MACHINE:
				return getStateMachine();
			case StatemachinePackage.STATE__COMMANDS:
				return getCommands();
			case StatemachinePackage.STATE__NEXT_STATE:
				if (resolve) return getNextState();
				return basicGetNextState();
			case StatemachinePackage.STATE__PREVIOUS_STATE:
				if (resolve) return getPreviousState();
				return basicGetPreviousState();
			case StatemachinePackage.STATE__START_TIME:
				return getStartTime();
			case StatemachinePackage.STATE__ACTUAL_FAULT_CONDITIONS:
				return getActualFaultConditions();
			case StatemachinePackage.STATE__ACTUAL_WARNING_CONDITIONS:
				return getActualWarningConditions();
			case StatemachinePackage.STATE__ACTUAL_PENDING_CONDITIONS:
				return getActualPendingConditions();
			case StatemachinePackage.STATE__STARTED:
				return isStarted();
			case StatemachinePackage.STATE__STOP_TIME:
				return getStopTime();
			case StatemachinePackage.STATE__START_DELAY:
				return getStartDelay();
			case StatemachinePackage.STATE__STOP_DELAY:
				return getStopDelay();
			case StatemachinePackage.STATE__MAIN_STATE:
				return isMainState();
			case StatemachinePackage.STATE__ALL_WARNING_CONDITIONS:
				return getAllWarningConditions();
			case StatemachinePackage.STATE__ALL_SUPERVISION_CONDITIONS:
				return getAllSupervisionConditions();
			case StatemachinePackage.STATE__ALL_PRECONDITIONS:
				return getAllPreconditions();
			case StatemachinePackage.STATE__ALL_FAULT_CONDITIONS:
				return getAllFaultConditions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StatemachinePackage.STATE__CONDITIONS:
				getConditions().clear();
				getConditions().addAll((Collection<? extends Condition>)newValue);
				return;
			case StatemachinePackage.STATE__NAME:
				setName((String)newValue);
				return;
			case StatemachinePackage.STATE__STATE_MACHINE:
				setStateMachine((StateMachine)newValue);
				return;
			case StatemachinePackage.STATE__COMMANDS:
				getCommands().clear();
				getCommands().addAll((Collection<? extends Command>)newValue);
				return;
			case StatemachinePackage.STATE__NEXT_STATE:
				setNextState((State)newValue);
				return;
			case StatemachinePackage.STATE__PREVIOUS_STATE:
				setPreviousState((State)newValue);
				return;
			case StatemachinePackage.STATE__START_DELAY:
				setStartDelay((Setting)newValue);
				return;
			case StatemachinePackage.STATE__STOP_DELAY:
				setStopDelay((Setting)newValue);
				return;
			case StatemachinePackage.STATE__MAIN_STATE:
				setMainState((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StatemachinePackage.STATE__CONDITIONS:
				getConditions().clear();
				return;
			case StatemachinePackage.STATE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case StatemachinePackage.STATE__STATE_MACHINE:
				setStateMachine((StateMachine)null);
				return;
			case StatemachinePackage.STATE__COMMANDS:
				getCommands().clear();
				return;
			case StatemachinePackage.STATE__NEXT_STATE:
				setNextState((State)null);
				return;
			case StatemachinePackage.STATE__PREVIOUS_STATE:
				setPreviousState((State)null);
				return;
			case StatemachinePackage.STATE__START_DELAY:
				setStartDelay((Setting)null);
				return;
			case StatemachinePackage.STATE__STOP_DELAY:
				setStopDelay((Setting)null);
				return;
			case StatemachinePackage.STATE__MAIN_STATE:
				setMainState(MAIN_STATE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StatemachinePackage.STATE__CONDITIONS:
				return conditions != null && !conditions.isEmpty();
			case StatemachinePackage.STATE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case StatemachinePackage.STATE__STATE_MACHINE:
				return getStateMachine() != null;
			case StatemachinePackage.STATE__COMMANDS:
				return commands != null && !commands.isEmpty();
			case StatemachinePackage.STATE__NEXT_STATE:
				return nextState != null;
			case StatemachinePackage.STATE__PREVIOUS_STATE:
				return previousState != null;
			case StatemachinePackage.STATE__START_TIME:
				return startTime != START_TIME_EDEFAULT;
			case StatemachinePackage.STATE__ACTUAL_FAULT_CONDITIONS:
				return actualFaultConditions != null && !actualFaultConditions.isEmpty();
			case StatemachinePackage.STATE__ACTUAL_WARNING_CONDITIONS:
				return actualWarningConditions != null && !actualWarningConditions.isEmpty();
			case StatemachinePackage.STATE__ACTUAL_PENDING_CONDITIONS:
				return actualPendingConditions != null && !actualPendingConditions.isEmpty();
			case StatemachinePackage.STATE__STARTED:
				return started != STARTED_EDEFAULT;
			case StatemachinePackage.STATE__STOP_TIME:
				return stopTime != STOP_TIME_EDEFAULT;
			case StatemachinePackage.STATE__START_DELAY:
				return startDelay != null;
			case StatemachinePackage.STATE__STOP_DELAY:
				return stopDelay != null;
			case StatemachinePackage.STATE__MAIN_STATE:
				return mainState != MAIN_STATE_EDEFAULT;
			case StatemachinePackage.STATE__ALL_WARNING_CONDITIONS:
				return allWarningConditions != null && !allWarningConditions.isEmpty();
			case StatemachinePackage.STATE__ALL_SUPERVISION_CONDITIONS:
				return allSupervisionConditions != null && !allSupervisionConditions.isEmpty();
			case StatemachinePackage.STATE__ALL_PRECONDITIONS:
				return allPreconditions != null && !allPreconditions.isEmpty();
			case StatemachinePackage.STATE__ALL_FAULT_CONDITIONS:
				return allFaultConditions != null && !allFaultConditions.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", startTime: ");
		result.append(startTime);
		result.append(", started: ");
		result.append(started);
		result.append(", stopTime: ");
		result.append(stopTime);
		result.append(", mainState: ");
		result.append(mainState);
		result.append(')');
		return result.toString();
	}

	@Override
	public void initialize() throws Exception {
		// Conditions initialisieren
		for(Condition condition : this.getConditions()) {
			// Initialisieren
			condition.initialize();
			
			if(condition instanceof Warning) 
				this.getAllWarningConditions().add((Warning) condition);
			
			else if(condition instanceof Supervision) {
				this.getAllSupervisionConditions().add((Supervision) condition);
				this.getAllFaultConditions().add(condition);
			}
			
			else if(condition instanceof Precondition) {
				this.getAllPreconditions().add((Precondition) condition);
				this.getAllFaultConditions().add(condition);
			}
		}
					
		// Commands initialisieren
		for(Command command : this.getCommands())
			command.initialize();
		
		// Start Delay initialisieren
		this.getStartDelay().initialize();
		
		// Stop Delay initialisieren
		this.getStopDelay().initialize();
	}

} //StateImpl
