package ch.thomson.ucs.tine.client.test.ui;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import ch.thomson.ucs.tine.databinding.swt.ThBarGraph;
import ch.thomson.ucs.tine.databinding.swt.ThComposite;
import ch.thomson.ucs.tine.databinding.swt.ThLabel;
import ch.thomson.ucs.tine.databinding.swt.ThLed;
import ch.thomson.ucs.tine.databinding.swt.ThSpinner;
import ch.thomson.ucs.tine.databinding.swt.ThText;

public class View extends ViewPart {
	public View() {
	}
	public static final String ID = "ch.thomson.ucs.tine.client.test.ui.view";
	private ThSpinner thSpinner;
	private ThText text;
	private Text text_1;

	/**
	 * The content provider class is responsible for providing objects to the
	 * view. It can wrap existing objects in adapters or simply return objects
	 * as-is. These objects may be sensitive to the current input of the view,
	 * or ignore it and always show the same content (like Task List, for
	 * example).
	 */
	class ViewContentProvider implements IStructuredContentProvider {
		public void inputChanged(Viewer v, Object oldInput, Object newInput) {
		}

		public void dispose() {
		}

		public Object[] getElements(Object parent) {
			if (parent instanceof Object[]) {
				return (Object[]) parent;
			}
	        return new Object[0];
		}
	}

	class ViewLabelProvider extends LabelProvider implements
			ITableLabelProvider {
		public String getColumnText(Object obj, int index) {
			return getText(obj);
		}

		public Image getColumnImage(Object obj, int index) {
			return getImage(obj);
		}

		public Image getImage(Object obj) {
			return PlatformUI.getWorkbench().getSharedImages().getImage(
					ISharedImages.IMG_OBJ_ELEMENT);
		}
	}

	/**
	 * This is a callback that will allow us to create the viewer and initialize
	 * it.
	 */
	public void createPartControl(Composite parent) {
		
		ThComposite thComposite = new ThComposite(parent, SWT.NONE);
		thComposite.setLayout(new GridLayout(2, false));
		new Label(thComposite, SWT.NONE);
		new Label(thComposite, SWT.NONE);
		
		Label lblTest = new Label(thComposite, SWT.NONE);
		lblTest.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		lblTest.setText("Target State:");
		
		thSpinner = new ThSpinner(thComposite);
		thSpinner.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_TARGET_STATE");
		
		Label lblLinacT = new Label(thComposite, SWT.NONE);
		lblLinacT.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		lblLinacT.setText("Actual State:");
		
		ThSpinner thSpinner_1 = new ThSpinner(thComposite);
		thSpinner_1.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_ACTUAL_STATE");
		
		Label lblLinacT_1 = new Label(thComposite, SWT.NONE);
		lblLinacT_1.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		lblLinacT_1.setText("AI 3.0 Scaled:");
		
		ThSpinner thSpinner_2 = new ThSpinner(thComposite);
		thSpinner_2.setSignalName("/TEST_CONTEXT/TEST_EDITOR/Device1/AA_AI_3.0");
		
		Label lblAiScaled = new Label(thComposite, SWT.NONE);
		lblAiScaled.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		lblAiScaled.setText("AI 3.0 Scaled:");
		
		text = new ThText(thComposite);
		text.setSignalName("/TEST_CONTEXT/TEST_EDITOR/Device1/AA_AI_3.0.SCALED");
		text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblAi = new Label(thComposite, SWT.NONE);
		lblAi.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		lblAi.setText("AI 3.0:");
		
		ThText thText = new ThText(thComposite);
		thText.setSignalName("/TEST_CONTEXT/TEST_EDITOR/Device1/AA_AI_3.0");
		thText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		new Label(thComposite, SWT.NONE);
		
		ThText thText_1 = new ThText(thComposite);
		thText_1.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_TARGET_STATE");
		thText_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label lblLabelTest = new Label(thComposite, SWT.NONE);
		lblLabelTest.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		lblLabelTest.setText("Label Test:");
		
		ThLabel thlblLabel = new ThLabel(thComposite, SWT.NONE);
		thlblLabel.setText("LABEL");
		thlblLabel.setSignalName("/TEST_CONTEXT/TEST_EDITOR/Device1/AA_AI_3.0");
		
		ThLed thLedLabel = new ThLed(thComposite, SWT.NONE);
		thLedLabel.setGreenValue(1);
		thLedLabel.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_TARGET_STATE");
		
		text_1 = new Text(thComposite, SWT.BORDER);
		text_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		new Label(thComposite, SWT.NONE);
		new Label(thComposite, SWT.NONE);
		new Label(thComposite, SWT.NONE);
		new Label(thComposite, SWT.NONE);
		new Label(thComposite, SWT.NONE);
		
		ThBarGraph thBarGraph = new ThBarGraph(thComposite);
		thBarGraph.setScaleAutoEnabled(true);
		thBarGraph.setScaleMax(600.0);
		thBarGraph.setPathFaultLower("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_ERROR_LOWER");
		thBarGraph.setPathFaultUpper("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_ERROR_UPPER");
		thBarGraph.setPathWarningUpper("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_WARNING_UPPER");
		thBarGraph.setPathValue("/TEST_CONTEXT/DUMMIES/Device1/D_TARGET_STATE");
		thBarGraph.setPathWarningLower("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_WARNING_LOWER");
		GridData gd_thBarGraph = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_thBarGraph.heightHint = 200;
		gd_thBarGraph.widthHint = 82;
		thBarGraph.setLayoutData(gd_thBarGraph);
		
		Label lblWarningLower = new Label(thComposite, SWT.NONE);
		lblWarningLower.setText("Warning Upper:");
		
		ThSpinner thSpinner_3 = new ThSpinner(thComposite);
		thSpinner_3.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_WARNING_UPPER");
		
		Label lblWarningUpper = new Label(thComposite, SWT.NONE);
		lblWarningUpper.setText("Warning Lower:");
		
		ThSpinner thSpinner_4 = new ThSpinner(thComposite);
		thSpinner_4.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_WARNING_LOWER");
		
		Label lblFaultLower = new Label(thComposite, SWT.NONE);
		lblFaultLower.setText("Fault Upper:");
		
		ThSpinner thSpinner_5 = new ThSpinner(thComposite);
		thSpinner_5.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_ERROR_UPPER");
		
		Label lblFaultUpper = new Label(thComposite, SWT.NONE);
		lblFaultUpper.setText("Fault Lower:");
		
		ThSpinner thSpinner_6 = new ThSpinner(thComposite);
		thSpinner_6.setSignalName("/TEST_CONTEXT/DUMMIES/Device1/D_TEST_ERROR_LOWER");
		
	}

	/**
	 * Passing the focus request to the viewer's control.
	 */
	public void setFocus() {
		//viewer.getControl().setFocus();
	}
}