/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.impl;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.ClientPackage;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.PropertyTine;
import ch.thomson.ucs.tine.server.util.UCSConfig;
import de.desy.tine.definitions.TAccess;
import de.desy.tine.queryUtils.TPropertyQuery;
import de.desy.tine.queryUtils.TQuery;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Client</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.ClientImpl#getTineProperties <em>Tine Properties</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.ClientImpl#getServerHosts <em>Server Hosts</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.ClientImpl#isInitialized <em>Initialized</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ClientImpl extends EObjectImpl implements Client {
	/**
	 * The cached value of the '{@link #getTineProperties() <em>Tine Properties</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<PropertyTine> tineProperties;
	/**
	 * The cached value of the '{@link #getServerHosts() <em>Server Hosts</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getServerHosts()
	 * @generated
	 * @ordered
	 */
	protected EList<String> serverHosts;
	/**
	 * The default value of the '{@link #isInitialized() <em>Initialized</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isInitialized()
	 * @generated
	 * @ordered
	 */
	protected static final boolean INITIALIZED_EDEFAULT = false;
	/**
	 * The cached value of the '{@link #isInitialized() <em>Initialized</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isInitialized()
	 * @generated
	 * @ordered
	 */
	protected boolean initialized = INITIALIZED_EDEFAULT;
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClientImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ClientPackage.Literals.CLIENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PropertyTine> getTineProperties() {
		if (tineProperties == null) {
			tineProperties = new EObjectContainmentEList<PropertyTine>(PropertyTine.class, this, ClientPackage.CLIENT__TINE_PROPERTIES);
		}
		return tineProperties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getServerHosts() {
		if (serverHosts == null) {
			serverHosts = new EDataTypeUniqueEList<String>(String.class, this, ClientPackage.CLIENT__SERVER_HOSTS);
		}
		return serverHosts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isInitialized() {
		return initialized;
	}

	private Map<String, Property> propertyCache = null;
	
	/**
	 * <!-- begin-user-doc --> Gibt die gesuchte Property zurck. Falls der Name
	 * <code>null</code> ist, wird auch <code>null</code> zurckgeben. Es wird
	 * eine Exception geworfen, falls keine Property mit dem bergebenen Namen
	 * gefunden werden kann. </br>Der Name muss entweder vollspezifiziert (mit
	 * fhrendem Slash und Context Angabe) oder relativ (ohne fhrenden Slash
	 * und ohne Context Angabe) sein.
	 * 
	 * @param name
	 *            Vollspezifizierter Propertyname
	 *            (/context/server/device/property) oder relativer Propertyname
	 *            ohne context (server/device/property) <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Property findProperty(String name) throws Exception {
		// Gibt es berhaupt etwas zu suchen?
		if(name == null)
			return null;
		
		UCSConfig config = UCSConfig.getInstance();
		
		// Relativer Pfad mit internen Namen?
		if(!name.startsWith("/")) {
			StringBuilder sb = new StringBuilder("/");
			
			sb.append(config.usedFecContextName);
			sb.append("/");

			String[] segments = name.split("/");			
			sb.append(config.getEqmNameInternalToExternalMap().get(segments[0]));
			sb.append("/");
			sb.append(config.getDeviceNameInternalToExternalMap().get(segments[1]));
			sb.append("/");
			sb.append(config.getPropNameInternalToExternalMap().get(segments[2]));
			name = sb.toString();	
		}
		
		// Hash Table erzeugen, falls nicht vorhanden
		if (propertyCache == null) {
			propertyCache = new HashMap<String, Property>();
		}
		
		// Property in der Hash Table suchen
		Property property = propertyCache.get(name);
		if (property != null)
			return property;
		
		// Property in Liste suchen und in der Hash Table ablegen
		for(PropertyTine p  : this.getTineProperties()) {
			if((p.getPath() + "/" + p.getName()).equals(name)) {
				propertyCache.put(name, p);
				return p;
			}
		}
		
		throw new Exception("Property " + name + " not found");
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void initialize() throws Exception {
		for(PropertyTine p : this.getTineProperties()) {
			String[] segments = p.getPath().split("/");
			if(segments.length != 4) {
				throw new Exception("Illegal TINE Path: " + p.getPath());
			}
			TPropertyQuery [] pq = TQuery.getPropertyInformation(segments[1], segments[2], segments[3], p.getName());
			if(pq == null) {
				throw new Exception("Information for Property " + p.getName() + " not found");
			}
			
			p.setMaximum(pq[0].prpMaxValue);
			p.setMinimum(pq[0].prpMinValue);
			p.setLength(pq[0].prpSize);
			p.setDescription(pq[0].prpDescription);
			p.setWritable((pq[0].prpAccess & TAccess.CA_WRITE) == TAccess.CA_WRITE);
			p.setUnit(pq[0].prpUnits);
			
			p.initialize();
			
			// Sammle die verschiedenen Server-Hosts der Properties
			this.getServerHosts().add(p.getServerHost());
		}
		
		this.initialized = true;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ClientPackage.CLIENT__TINE_PROPERTIES:
				return ((InternalEList<?>)getTineProperties()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ClientPackage.CLIENT__TINE_PROPERTIES:
				return getTineProperties();
			case ClientPackage.CLIENT__SERVER_HOSTS:
				return getServerHosts();
			case ClientPackage.CLIENT__INITIALIZED:
				return isInitialized();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ClientPackage.CLIENT__TINE_PROPERTIES:
				getTineProperties().clear();
				getTineProperties().addAll((Collection<? extends PropertyTine>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ClientPackage.CLIENT__TINE_PROPERTIES:
				getTineProperties().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ClientPackage.CLIENT__TINE_PROPERTIES:
				return tineProperties != null && !tineProperties.isEmpty();
			case ClientPackage.CLIENT__SERVER_HOSTS:
				return serverHosts != null && !serverHosts.isEmpty();
			case ClientPackage.CLIENT__INITIALIZED:
				return initialized != INITIALIZED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (serverHosts: ");
		result.append(serverHosts);
		result.append(", initialized: ");
		result.append(initialized);
		result.append(')');
		return result.toString();
	}

} //ClientImpl
