/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.impl;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import ch.thomson.ucs.tine.client.ClientPackage;
import ch.thomson.ucs.tine.client.GroupedFloats;
import ch.thomson.ucs.tine.client.PropertyFloat;
import de.desy.tine.dataUtils.TDataType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Grouped Floats</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.client.impl.GroupedFloatsImpl#getProperties <em>Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class GroupedFloatsImpl extends PropertyFloatImpl implements GroupedFloats {
	/**
	 * The cached value of the '{@link #getProperties() <em>Properties</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<PropertyFloat> properties;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GroupedFloatsImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ClientPackage.Literals.GROUPED_FLOATS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PropertyFloat> getProperties() {
		if (properties == null) {
			properties = new EObjectResolvingEList<PropertyFloat>(PropertyFloat.class, this, ClientPackage.GROUPED_FLOATS__PROPERTIES);
		}
		return properties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ClientPackage.GROUPED_FLOATS__PROPERTIES:
				return getProperties();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ClientPackage.GROUPED_FLOATS__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection<? extends PropertyFloat>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ClientPackage.GROUPED_FLOATS__PROPERTIES:
				getProperties().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ClientPackage.GROUPED_FLOATS__PROPERTIES:
				return properties != null && !properties.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	@Override
	public void unpackData(TDataType data) {
		super.unpackData(data);
		float[] groupedValues = (float[]) this.getValue();
		
		int offset = 0;
		
		for(PropertyFloat property : this.getProperties()) {
			float[] propValues = new float[property.getLength()];
			for(int i=0; i<propValues.length; ++i) {
				propValues[i] = groupedValues[i + offset];
			}
			
			// Kritischer Abschnitt
			synchronized(property) { 
				((PropertyFloatImpl) property).ignoreNotification = true;
				property.getOutDataType().setDataTimeStamp(data.getDataTimeStamp()); // Timestamp forwarden
				property.getOutDataType().putData(propValues);
				property.unpackData(property.getOutDataType());
				((PropertyFloatImpl) property).ignoreNotification = false;
			}
			
			offset += property.getLength();
		}
	}
	
} //GroupedFloatsImpl
