package ch.thomson.ucs.tine.client.util;

import org.eclipse.core.runtime.Platform;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

import ch.thomson.ucs.utils.logging.IPluginLogger;
import ch.thomson.ucs.utils.logging.Log4jTransfer;
import ch.thomson.ucs.utils.logging.PluginLogger;

import de.desy.tine.client.TLink;
import de.desy.tine.client.TLinkFactory;

public class Activator implements BundleActivator {
	
	private TLinkFactory tLinkFactory;
	private static BundleContext context;
	private static IPluginLogger logger;
	
	public static BundleContext getContext() {
		return context;
	}

	public static IPluginLogger getLogger() {
		return logger;
	}

	@Override
	public void start(BundleContext context) throws Exception {
		Activator.context = context;
		
		// Logger initialisieren
		Platform.addLogListener(Log4jTransfer.getInstance());
		logger = PluginLogger.getLogger(context.getBundle());
		
		// TLinkFactory initialisieren
		TLinkFactory.setMaximumNumberOfLinks(3000);
		tLinkFactory = TLinkFactory.getInstance();

	}

	@Override
	public void stop(BundleContext context) throws Exception {
		TLink[] tLinks = tLinkFactory.getActiveLinks();
		
		if(tLinks != null) {
			for (TLink tLink : tLinks) {
				tLink.close();
			}
		}
	}
}
