/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.util;

import ch.thomson.ucs.tine.client.*;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.ClientPackage;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.PropertyTine;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see ch.thomson.ucs.tine.client.ClientPackage
 * @generated
 */
public class ClientAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static ClientPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClientAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = ClientPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ClientSwitch<Adapter> modelSwitch =
		new ClientSwitch<Adapter>() {
			@Override
			public Adapter caseProperty(Property object) {
				return createPropertyAdapter();
			}
			@Override
			public Adapter casePropertyTine(PropertyTine object) {
				return createPropertyTineAdapter();
			}
			@Override
			public Adapter caseClient(Client object) {
				return createClientAdapter();
			}
			@Override
			public Adapter casePropertyFloat(PropertyFloat object) {
				return createPropertyFloatAdapter();
			}
			@Override
			public Adapter casePropertyNumeric(PropertyNumeric object) {
				return createPropertyNumericAdapter();
			}
			@Override
			public Adapter caseGroupedFloats(GroupedFloats object) {
				return createGroupedFloatsAdapter();
			}
			@Override
			public Adapter casePropertyGroup(PropertyGroup object) {
				return createPropertyGroupAdapter();
			}
			@Override
			public Adapter casePropertyText(PropertyText object) {
				return createPropertyTextAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.Property <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.Property
	 * @generated
	 */
	public Adapter createPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.PropertyTine <em>Property Tine</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.PropertyTine
	 * @generated
	 */
	public Adapter createPropertyTineAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.Client <em>Client</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.Client
	 * @generated
	 */
	public Adapter createClientAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.PropertyFloat <em>Property Float</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.PropertyFloat
	 * @generated
	 */
	public Adapter createPropertyFloatAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.PropertyNumeric <em>Property Numeric</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.PropertyNumeric
	 * @generated
	 */
	public Adapter createPropertyNumericAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.GroupedFloats <em>Grouped Floats</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.GroupedFloats
	 * @generated
	 */
	public Adapter createGroupedFloatsAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.PropertyGroup <em>Property Group</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.PropertyGroup
	 * @generated
	 */
	public Adapter createPropertyGroupAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.client.PropertyText <em>Property Text</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.client.PropertyText
	 * @generated
	 */
	public Adapter createPropertyTextAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //ClientAdapterFactory
