/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.client.util;

import ch.thomson.ucs.tine.client.*;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import ch.thomson.ucs.tine.client.Client;
import ch.thomson.ucs.tine.client.ClientPackage;
import ch.thomson.ucs.tine.client.Property;
import ch.thomson.ucs.tine.client.PropertyTine;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see ch.thomson.ucs.tine.client.ClientPackage
 * @generated
 */
public class ClientSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static ClientPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClientSwitch() {
		if (modelPackage == null) {
			modelPackage = ClientPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case ClientPackage.PROPERTY: {
				Property property = (Property)theEObject;
				T result = caseProperty(property);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ClientPackage.PROPERTY_TINE: {
				PropertyTine propertyTine = (PropertyTine)theEObject;
				T result = casePropertyTine(propertyTine);
				if (result == null) result = caseProperty(propertyTine);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ClientPackage.CLIENT: {
				Client client = (Client)theEObject;
				T result = caseClient(client);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ClientPackage.PROPERTY_FLOAT: {
				PropertyFloat propertyFloat = (PropertyFloat)theEObject;
				T result = casePropertyFloat(propertyFloat);
				if (result == null) result = casePropertyNumeric(propertyFloat);
				if (result == null) result = casePropertyTine(propertyFloat);
				if (result == null) result = caseProperty(propertyFloat);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ClientPackage.PROPERTY_NUMERIC: {
				PropertyNumeric propertyNumeric = (PropertyNumeric)theEObject;
				T result = casePropertyNumeric(propertyNumeric);
				if (result == null) result = casePropertyTine(propertyNumeric);
				if (result == null) result = caseProperty(propertyNumeric);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ClientPackage.GROUPED_FLOATS: {
				GroupedFloats groupedFloats = (GroupedFloats)theEObject;
				T result = caseGroupedFloats(groupedFloats);
				if (result == null) result = casePropertyFloat(groupedFloats);
				if (result == null) result = casePropertyGroup(groupedFloats);
				if (result == null) result = casePropertyNumeric(groupedFloats);
				if (result == null) result = casePropertyTine(groupedFloats);
				if (result == null) result = caseProperty(groupedFloats);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ClientPackage.PROPERTY_GROUP: {
				PropertyGroup propertyGroup = (PropertyGroup)theEObject;
				T result = casePropertyGroup(propertyGroup);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ClientPackage.PROPERTY_TEXT: {
				PropertyText propertyText = (PropertyText)theEObject;
				T result = casePropertyText(propertyText);
				if (result == null) result = casePropertyFloat(propertyText);
				if (result == null) result = casePropertyNumeric(propertyText);
				if (result == null) result = casePropertyTine(propertyText);
				if (result == null) result = caseProperty(propertyText);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProperty(Property object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Tine</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Tine</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyTine(PropertyTine object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Client</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Client</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseClient(Client object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Float</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Float</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyFloat(PropertyFloat object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Numeric</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Numeric</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyNumeric(PropertyNumeric object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Grouped Floats</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Grouped Floats</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGroupedFloats(GroupedFloats object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Group</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Group</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyGroup(PropertyGroup object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Text</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Text</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyText(PropertyText object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //ClientSwitch
