package ch.thomson.ucs.tine.editor.application;


import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.emf.common.ui.URIEditorInput;
import org.eclipse.emf.common.util.URI;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

public class FileOpenHandler extends AbstractHandler {

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		IWorkbenchWindow window = HandlerUtil.getActiveWorkbenchWindowChecked(event);
		FileDialog fileDialog = new FileDialog(window.getShell());
		fileDialog.setFilterExtensions(new String[] { "*.server", "*.statemachine" });
		fileDialog.setFilterNames(new String[] { "TINE Server Configuration Files (*.server)", "State Machine Configuration Files (*.statemachine)"});
		fileDialog.setText("FileDialog");
		String selectedFile = fileDialog.open();
		if (selectedFile != null) {
		    URI uri = URI.createFileURI(selectedFile);
		    IEditorInput editorInput = new URIEditorInput(uri);
		    IWorkbenchPage page = window.getActivePage();
		    try {
		    	if("server".equals(uri.fileExtension()))
		    		page.openEditor(editorInput, "ch.thomson.ucs.desy.tine.server.presentation.ServerEditorID");
		    	else if("statemachine".equals(uri.fileExtension()))
		    		page.openEditor(editorInput, "ch.thomson.ucs.tine.client.statemachine.presentation.StatemachineEditorID");
		    		
			} catch (PartInitException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return null;
	}

}
