package ch.thomson.ucs.tine.server.application;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

import ch.thomson.ucs.tine.server.FrontEndController;
import ch.thomson.ucs.tine.server.util.ServerResourceLoader;

public class Activator implements BundleActivator {

	private static BundleContext context;
	private static FrontEndController fec;

	static BundleContext getContext() {
		return context;
	}
	
	static FrontEndController getFrontEndController() {
		return fec;
	}

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext bundleContext) throws Exception {
		System.out.println("Hello from TINE Server!");
		Activator.context = bundleContext;

		fec = ServerResourceLoader.getFrontEndControllerInstance();
		fec.initialize();
	}

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext bundleContext) throws Exception {
		System.out.println("Tine Server will shutting down.");
		Activator.context = null;
		if(fec != null) {
			fec.shutdown();
		}
	}

}
