package ch.thomson.ucs.tine.server.driver.fast_sim;

import java.nio.ByteBuffer;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.PropertyNumeric;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.impl.DriverImpl;

public class FastSimDriver extends DriverImpl {
	protected int pulseCounter;
	protected int syncCounter;
	
	@Override
	public void initialize() throws Exception {
		this.getDevice().getEquipmentModule().setDevicePollingRate(33);

	}

	@Override
	public void writeData(DataTable dataTable) throws Exception {}

	@Override
	public void parseAddressString(RealProperty realProperty) throws Exception {}

	@Override
	public int readData(DataTable dataTable) throws Exception {
		for(RealProperty p : dataTable.getProperties()) {
			ByteBuffer bb = dataTable.getByteBuffer();
			bb.position(p.getAddressOffset());
			
			if ("SCIG_CNTR_PULSE_FAST".equals(p.getName())) {
				bb.putInt(++pulseCounter);
			}
			
			if ("SCIG_CNTR_SYNC_FAST".equals(p.getName())) {
				bb.putInt(syncCounter += 2);
			}
			
			if("SCIG_VOLT_RHVPS_FAST".equals((p.getName()))) {
				//short value = (short) Math.round(p.getMinimumValue() * ((PropertyNumeric)p).getFactor());
				//short inc = (short) Math.round((p.getMaximumValue() - p.getMinimumValue()) * ((PropertyNumeric)p).getFactor() / p.getLength());
				for(int i=0; i<p.getLength(); ++i) {
					//bb.putShort(value);
					//value += inc;
					bb.putShort((short) (Math.random() * p.getMaximumValue() * ((PropertyNumeric)p).getFactor()));
				}
			}
			
			if("SCIG_CURR_RHVPS_FAST".equals((p.getName()))) {
				//short value = (short) Math.round(p.getMinimumValue() * ((PropertyNumeric)p).getFactor());
				//short inc = (short) Math.round((p.getMaximumValue() - p.getMinimumValue()) * ((PropertyNumeric)p).getFactor() / p.getLength());
				for(int i=0; i<p.getLength(); ++i) {
					//bb.putShort(value);
					//value += inc;
					bb.putShort((short) (Math.random() * p.getMaximumValue() * ((PropertyNumeric)p).getFactor()));
				}
			}
			
			if("SCIG_VOLT_KLY_FAST".equals((p.getName()))) {
				//short value = (short) Math.round(p.getMinimumValue() * ((PropertyNumeric)p).getFactor());
				//short inc = (short) Math.round((p.getMaximumValue() - p.getMinimumValue()) * ((PropertyNumeric)p).getFactor() / p.getLength());
				for(int i=0; i<p.getLength(); ++i) {
					//bb.putShort(value);
					//value += inc;
					bb.putShort((short) (Math.random() * p.getMaximumValue() * ((PropertyNumeric)p).getFactor()));
				}
			}
			
			if("SCIG_CURR_KLY_FAST".equals((p.getName()))) {
				//short value = (short) Math.round(p.getMinimumValue() * ((PropertyNumeric)p).getFactor());
				//short inc = (short) Math.round((p.getMaximumValue() - p.getMinimumValue()) * ((PropertyNumeric)p).getFactor() / p.getLength());				
				for(int i=0; i<p.getLength(); ++i) {
					//bb.putShort(value);
					//value += inc;
					bb.putShort((short) (Math.random() * p.getMaximumValue() * ((PropertyNumeric)p).getFactor()));
				}
			}
		}
		return 0;
	}
}
