package ch.thomson.ucs.tine.server.driver.mcb_abb_t;

import java.nio.ByteBuffer;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.PropertyInt32;
import ch.thomson.ucs.tine.server.PropertyShort16;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.driver.modbus.ModbusDriver;

public class DriverMCB_ABB_T extends ModbusDriver {
	
	@Override
	public int readData(DataTable dataTable) throws Exception {
		super.readData(dataTable);
		ByteBuffer bb = dataTable.getByteBuffer();
		
		for(RealProperty rp : dataTable.getProperties()) {
			
			// Werte bei "Not Available" auf 0 setzen
			if(rp instanceof PropertyInt32) {
				int offset = rp.getAddressOffset();
				for(int i = 0; i<rp.getLength(); i++) {
					int value = bb.getInt(offset + i*4);
					if(value == 0x7FFFFFFF || value == 0xFFFFFFFF) {
						bb.putInt(offset + i*4, 0);
					}
				}
			}
			else if(rp instanceof PropertyShort16) {
				int offset = rp.getAddressOffset();
				for(int i = 0; i<rp.getLength(); i++){
					short value = bb.getShort(offset + i*2);
					if(value == 0x7FFF || value == 0xFFFF) {
						bb.putShort(offset + i*2, (short) 0);
					}
				}
				
			}
		}
		return 0;
	}
}
