package ch.thomson.ucs.tine.server.driver.psm_sim;

import java.nio.ByteBuffer;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.PropertyNumeric;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.impl.DriverImpl;
import ch.thomson.ucs.tine.server.impl.PropertyNumericImpl;

public class PSMSimDriver extends DriverImpl {

	int actualState;
	boolean initBit;
	boolean resetRequest;
	int synchCounter;
	
	@Override
	public void initialize() throws Exception {
		// TODO Auto-generated method stub

	}

	@Override
	public void writeData(DataTable dataTable) throws Exception {
		for(RealProperty p : dataTable.getProperties()) {
			if(!(p instanceof PropertyNumeric)) 
				continue;
			
			PropertyNumericImpl pn = (PropertyNumericImpl) p;
			
			if("PSMS_STAT_SELECT".equals(pn.getName()))
				actualState = pn.getValuesAsInt(this.getDevice())[0];
			
			if("PSMS_BIT_INIT_DATA_OK".equals(pn.getName()))
				initBit = pn.getValuesAsInt(this.getDevice())[0] != 0;
			
			if("PSMS_RST_FAULT".equals(pn.getName()))
				resetRequest = pn.getValuesAsInt(getDevice())[0] != 0;
		}
	}

	@Override
	public void parseAddressString(RealProperty realProperty) throws Exception {
	}

	@Override
	public int readData(DataTable dataTable) throws Exception {
		for(RealProperty p : dataTable.getProperties()) {
			ByteBuffer bb = dataTable.getByteBuffer();
			bb.position(p.getAddressOffset() - dataTable.getAbsoluteAddress());
	
			if ("PSMG_STAT_FEEDBACK".equals(p.getName())) {	
				if(initBit)
					bb.putInt(actualState); 
				else
					bb.putInt(0);
			}
			
			if("PSMG_VECT_ALARM".equals(p.getName())) {
				if(resetRequest)
					bb.putInt(0);
			}
			
			if("PSMG_VECT_FAULT".equals(p.getName())) {
				if(resetRequest)
					bb.putInt(0);
			}
			
			if("PSMG_VECT_FAULT_FIRST".equals(p.getName())) {
				if(resetRequest)
					bb.putInt(0);
			}
			
			if("PSMG_VECT_TRIP".equals(p.getName())) {
				if(resetRequest)
					bb.putInt(0);
			}
			
			if("PSMG_VECT_TRIP_FIRST".equals(p.getName())) {
				if(resetRequest)
					bb.putInt(0);
			}
			
			if("PSMG_VECT_WARNING".equals(p.getName())) {
				if(resetRequest)
					bb.putInt(0);
			}
			
			if("PSMG_VECT_FATAL_ERROR".equals(p.getName())) {
				if(resetRequest)
					bb.putInt(0);
			}
			
			if("PSMG_CNTR_SYNC".equals(p.getName())) {
				bb.putInt(synchCounter++);
			}
		}
		
		resetRequest = false;
		return 0;
	}
}
