package ch.thomson.ucs.tine.server.driver.wago_sim;

import java.nio.ByteBuffer;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.PropertyNumeric;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.impl.DriverImpl;

public class WagoSimDriver extends DriverImpl {
	protected int pulseCounter;
	
	@Override
	public void initialize() throws Exception {}

	@Override
	public void writeData(DataTable dataTable) throws Exception {}

	@Override
	public void parseAddressString(RealProperty realProperty) throws Exception {
		String[] parts = realProperty.getDriverAddress().split(":");
		realProperty.setUserDefinedAddressObject(parts[0]);
	}

	@Override
	public int readData(DataTable dataTable) throws Exception {
		for(RealProperty p : dataTable.getProperties()) {
			String address = (String) p.getUserDefinedAddressObject();
			if(!"AI".equals(address))
				continue;
			
			ByteBuffer bb = dataTable.getByteBuffer();
			bb.position(p.getAddressOffset());
			for(int i=0; i<p.getLength(); ++i) {
				bb.putShort((short) (Math.random() * p.getMaximumValue() * ((PropertyNumeric)p).getFactor()));
			}
		}
		return 0;
	}
}
