/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.provider;


import ch.thomson.ucs.tine.server.EquipmentModule;
import ch.thomson.ucs.tine.server.ServerFactory;
import ch.thomson.ucs.tine.server.ServerPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link ch.thomson.ucs.tine.server.EquipmentModule} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class EquipmentModuleItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EquipmentModuleItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addExportNamePropertyDescriptor(object);
			addLocalNamePropertyDescriptor(object);
			addDevicePollingRatePropertyDescriptor(object);
			addDriverTypePropertyDescriptor(object);
			addByteOrderPropertyDescriptor(object);
			addActualStatePropertyDescriptor(object);
			addTargetStatePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Export Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addExportNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_EquipmentModule_exportName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_EquipmentModule_exportName_feature", "_UI_EquipmentModule_type"),
				 ServerPackage.Literals.EQUIPMENT_MODULE__EXPORT_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Local Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLocalNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_EquipmentModule_localName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_EquipmentModule_localName_feature", "_UI_EquipmentModule_type"),
				 ServerPackage.Literals.EQUIPMENT_MODULE__LOCAL_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Device Polling Rate feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDevicePollingRatePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_EquipmentModule_devicePollingRate_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_EquipmentModule_devicePollingRate_feature", "_UI_EquipmentModule_type"),
				 ServerPackage.Literals.EQUIPMENT_MODULE__DEVICE_POLLING_RATE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Driver Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addDriverTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_EquipmentModule_driverType_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_EquipmentModule_driverType_feature", "_UI_EquipmentModule_type"),
				 ServerPackage.Literals.EQUIPMENT_MODULE__DRIVER_TYPE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Byte Order feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addByteOrderPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_EquipmentModule_byteOrder_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_EquipmentModule_byteOrder_feature", "_UI_EquipmentModule_type"),
				 ServerPackage.Literals.EQUIPMENT_MODULE__BYTE_ORDER,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Actual State feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addActualStatePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_EquipmentModule_actualState_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_EquipmentModule_actualState_feature", "_UI_EquipmentModule_type"),
				 ServerPackage.Literals.EQUIPMENT_MODULE__ACTUAL_STATE,
				 true,
				 false,
				 true,
				 null,
				 getString("_UI_StateCheckPropertyCategory"),
				 null));
	}

	/**
	 * This adds a property descriptor for the Target State feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addTargetStatePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_EquipmentModule_targetState_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_EquipmentModule_targetState_feature", "_UI_EquipmentModule_type"),
				 ServerPackage.Literals.EQUIPMENT_MODULE__TARGET_STATE,
				 true,
				 false,
				 true,
				 null,
				 getString("_UI_StateCheckPropertyCategory"),
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(ServerPackage.Literals.EQUIPMENT_MODULE__DEVICES);
			childrenFeatures.add(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns EquipmentModule.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/EquipmentModule"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((EquipmentModule)object).getExportName();
		return label == null || label.length() == 0 ?
			getString("_UI_EquipmentModule_type") :
			getString("_UI_EquipmentModule_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(EquipmentModule.class)) {
			case ServerPackage.EQUIPMENT_MODULE__EXPORT_NAME:
			case ServerPackage.EQUIPMENT_MODULE__LOCAL_NAME:
			case ServerPackage.EQUIPMENT_MODULE__TINE_EQUIPMENT_MODULE:
			case ServerPackage.EQUIPMENT_MODULE__TINE_BACKGROUND_TASK:
			case ServerPackage.EQUIPMENT_MODULE__DEVICE_POLLING_RATE:
			case ServerPackage.EQUIPMENT_MODULE__DRIVER_TYPE:
			case ServerPackage.EQUIPMENT_MODULE__BYTE_ORDER:
			case ServerPackage.EQUIPMENT_MODULE__TINE_PATH:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case ServerPackage.EQUIPMENT_MODULE__DEVICES:
			case ServerPackage.EQUIPMENT_MODULE__PROPERTIES:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__DEVICES,
				 ServerFactory.eINSTANCE.createDevice()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createScaledProperty()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createAliasProperty()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createPropertyInt32()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createPropertyFloat()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createPropertyByte()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createPropertyText()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createPropertyDouble()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createPropertyShort16()));

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.EQUIPMENT_MODULE__PROPERTIES,
				 ServerFactory.eINSTANCE.createGroupProperty()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return TineServerEditPlugin.INSTANCE;
	}

}
