/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.provider;


import ch.thomson.ucs.tine.server.FrontEndController;
import ch.thomson.ucs.tine.server.ServerFactory;
import ch.thomson.ucs.tine.server.ServerPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link ch.thomson.ucs.tine.server.FrontEndController} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class FrontEndControllerItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FrontEndControllerItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addSubSystemNamePropertyDescriptor(object);
			addContextNamePropertyDescriptor(object);
			addLocationPropertyDescriptor(object);
			addLocalValuePropertyDescriptor(object);
			addAllowedHostsForLocalAccessPropertyDescriptor(object);
			addLockWritePropertyPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FrontEndController_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_FrontEndController_name_feature", "_UI_FrontEndController_type"),
				 ServerPackage.Literals.FRONT_END_CONTROLLER__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Sub System Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSubSystemNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FrontEndController_subSystemName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_FrontEndController_subSystemName_feature", "_UI_FrontEndController_type"),
				 ServerPackage.Literals.FRONT_END_CONTROLLER__SUB_SYSTEM_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Context Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addContextNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FrontEndController_contextName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_FrontEndController_contextName_feature", "_UI_FrontEndController_type"),
				 ServerPackage.Literals.FRONT_END_CONTROLLER__CONTEXT_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Location feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLocationPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FrontEndController_location_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_FrontEndController_location_feature", "_UI_FrontEndController_type"),
				 ServerPackage.Literals.FRONT_END_CONTROLLER__LOCATION,
				 true,
				 false,
				 true,
				 null,
				 getString("_UI_LocationCheckPropertyCategory"),
				 null));
	}

	/**
	 * This adds a property descriptor for the Local Value feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLocalValuePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FrontEndController_localValue_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_FrontEndController_localValue_feature", "_UI_FrontEndController_type"),
				 ServerPackage.Literals.FRONT_END_CONTROLLER__LOCAL_VALUE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 getString("_UI_LocationCheckPropertyCategory"),
				 null));
	}

	/**
	 * This adds a property descriptor for the Allowed Hosts For Local Access feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addAllowedHostsForLocalAccessPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FrontEndController_allowedHostsForLocalAccess_feature"),
				 getString("_UI_FrontEndController_allowedHostsForLocalAccess_description"),
				 ServerPackage.Literals.FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Lock Write Property feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLockWritePropertyPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FrontEndController_lockWriteProperty_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_FrontEndController_lockWriteProperty_feature", "_UI_FrontEndController_type"),
				 ServerPackage.Literals.FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(ServerPackage.Literals.FRONT_END_CONTROLLER__EQUIPMENT_MODULES);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns FrontEndController.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/FrontEndController"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((FrontEndController)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_FrontEndController_type") :
			getString("_UI_FrontEndController_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(FrontEndController.class)) {
			case ServerPackage.FRONT_END_CONTROLLER__TINE_EQUIPMENT_MODULE_FACTORY:
			case ServerPackage.FRONT_END_CONTROLLER__NAME:
			case ServerPackage.FRONT_END_CONTROLLER__SUB_SYSTEM_NAME:
			case ServerPackage.FRONT_END_CONTROLLER__CONTEXT_NAME:
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_VALUE:
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_MODE:
			case ServerPackage.FRONT_END_CONTROLLER__ACCESS_ALLOWED:
			case ServerPackage.FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS:
			case ServerPackage.FRONT_END_CONTROLLER__WRITE_LOCKED:
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_CALLER:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(ServerPackage.Literals.FRONT_END_CONTROLLER__EQUIPMENT_MODULES,
				 ServerFactory.eINSTANCE.createEquipmentModule()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return TineServerEditPlugin.INSTANCE;
	}

}
