/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.provider;


import ch.thomson.ucs.tine.server.GroupProperty;
import ch.thomson.ucs.tine.server.Property;
import ch.thomson.ucs.tine.server.ServerPackage;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;

/**
 * This is the item provider adapter for a {@link ch.thomson.ucs.tine.server.GroupProperty} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class GroupPropertyItemProvider
	extends PropertyItemProvider
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GroupPropertyItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addPropertiesPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Properties feature.
	 * <!-- begin-user-doc -->
	 * Bei diesem Descriptor musste ein Filter eingebaut werden, damit nur Properties innerhalb des gleichen EQMs fr die Gruppierung zur Verfgung stehen.
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addPropertiesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_GroupProperty_properties_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_GroupProperty_properties_feature", "_UI_GroupProperty_type"),
				 ServerPackage.Literals.GROUP_PROPERTY__PROPERTIES,
				 true,
				 false,
				 true,
				 null,
				 getString("_UI_GroupPropertyCategory"),
				 null)
			{

				@Override
				public Collection<?> getChoiceOfValues(Object object) {
					String eqmName = ((GroupProperty) object).getEquipmentModule().getExportName();
					List<Object> choiceOfValues = new ArrayList<Object>(super.getChoiceOfValues(object));
					
					// Alle fremden EQM-Properties entfernen
					for(Iterator<Object> iter = choiceOfValues.iterator(); iter.hasNext();) {
						Property p = (Property) iter.next();
						if(!p.getEquipmentModule().getExportName().equals(eqmName))
							iter.remove();
					}
					
					// Die eigentliche GroupProperty soll auch nicht angezeigt werden
					choiceOfValues.remove(object);
					
					// TODO: Vielleicht sollten GroupProperties generell ausgefiltert werden
					
					return choiceOfValues;
				}	
			});
	}

	/**
	 * This returns GroupProperty.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/GroupProperty"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((GroupProperty)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_GroupProperty_type") :
			getString("_UI_GroupProperty_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
