/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.provider;

import ch.thomson.ucs.tine.server.util.ServerAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ServerItemProviderAdapterFactory extends ServerAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServerItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.FrontEndController} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FrontEndControllerItemProvider frontEndControllerItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.FrontEndController}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFrontEndControllerAdapter() {
		if (frontEndControllerItemProvider == null) {
			frontEndControllerItemProvider = new FrontEndControllerItemProvider(this);
		}

		return frontEndControllerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.EquipmentModule} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EquipmentModuleItemProvider equipmentModuleItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.EquipmentModule}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEquipmentModuleAdapter() {
		if (equipmentModuleItemProvider == null) {
			equipmentModuleItemProvider = new EquipmentModuleItemProvider(this);
		}

		return equipmentModuleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.Device} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DeviceItemProvider deviceItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.Device}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDeviceAdapter() {
		if (deviceItemProvider == null) {
			deviceItemProvider = new DeviceItemProvider(this);
		}

		return deviceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.ScaledProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ScaledPropertyItemProvider scaledPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.ScaledProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createScaledPropertyAdapter() {
		if (scaledPropertyItemProvider == null) {
			scaledPropertyItemProvider = new ScaledPropertyItemProvider(this);
		}

		return scaledPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.AliasProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AliasPropertyItemProvider aliasPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.AliasProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAliasPropertyAdapter() {
		if (aliasPropertyItemProvider == null) {
			aliasPropertyItemProvider = new AliasPropertyItemProvider(this);
		}

		return aliasPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.PropertyInt32} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyInt32ItemProvider propertyInt32ItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.PropertyInt32}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyInt32Adapter() {
		if (propertyInt32ItemProvider == null) {
			propertyInt32ItemProvider = new PropertyInt32ItemProvider(this);
		}

		return propertyInt32ItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.PropertyFloat} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyFloatItemProvider propertyFloatItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.PropertyFloat}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyFloatAdapter() {
		if (propertyFloatItemProvider == null) {
			propertyFloatItemProvider = new PropertyFloatItemProvider(this);
		}

		return propertyFloatItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.DataTable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataTableItemProvider dataTableItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.DataTable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDataTableAdapter() {
		if (dataTableItemProvider == null) {
			dataTableItemProvider = new DataTableItemProvider(this);
		}

		return dataTableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.PropertyByte} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyByteItemProvider propertyByteItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.PropertyByte}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyByteAdapter() {
		if (propertyByteItemProvider == null) {
			propertyByteItemProvider = new PropertyByteItemProvider(this);
		}

		return propertyByteItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.PropertyText} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyTextItemProvider propertyTextItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.PropertyText}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyTextAdapter() {
		if (propertyTextItemProvider == null) {
			propertyTextItemProvider = new PropertyTextItemProvider(this);
		}

		return propertyTextItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.PropertyDouble} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyDoubleItemProvider propertyDoubleItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.PropertyDouble}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyDoubleAdapter() {
		if (propertyDoubleItemProvider == null) {
			propertyDoubleItemProvider = new PropertyDoubleItemProvider(this);
		}

		return propertyDoubleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.PropertyShort16} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyShort16ItemProvider propertyShort16ItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.PropertyShort16}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyShort16Adapter() {
		if (propertyShort16ItemProvider == null) {
			propertyShort16ItemProvider = new PropertyShort16ItemProvider(this);
		}

		return propertyShort16ItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.GroupProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GroupPropertyItemProvider groupPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.GroupProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGroupPropertyAdapter() {
		if (groupPropertyItemProvider == null) {
			groupPropertyItemProvider = new GroupPropertyItemProvider(this);
		}

		return groupPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RealPropertyDAO_PostgresItemProvider realPropertyDAO_PostgresItemProvider;

	/**
	 * This creates an adapter for a {@link ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRealPropertyDAO_PostgresAdapter() {
		if (realPropertyDAO_PostgresItemProvider == null) {
			realPropertyDAO_PostgresItemProvider = new RealPropertyDAO_PostgresItemProvider(this);
		}

		return realPropertyDAO_PostgresItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (frontEndControllerItemProvider != null) frontEndControllerItemProvider.dispose();
		if (equipmentModuleItemProvider != null) equipmentModuleItemProvider.dispose();
		if (deviceItemProvider != null) deviceItemProvider.dispose();
		if (scaledPropertyItemProvider != null) scaledPropertyItemProvider.dispose();
		if (aliasPropertyItemProvider != null) aliasPropertyItemProvider.dispose();
		if (propertyInt32ItemProvider != null) propertyInt32ItemProvider.dispose();
		if (propertyFloatItemProvider != null) propertyFloatItemProvider.dispose();
		if (dataTableItemProvider != null) dataTableItemProvider.dispose();
		if (propertyByteItemProvider != null) propertyByteItemProvider.dispose();
		if (propertyTextItemProvider != null) propertyTextItemProvider.dispose();
		if (propertyDoubleItemProvider != null) propertyDoubleItemProvider.dispose();
		if (propertyShort16ItemProvider != null) propertyShort16ItemProvider.dispose();
		if (groupPropertyItemProvider != null) groupPropertyItemProvider.dispose();
		if (realPropertyDAO_PostgresItemProvider != null) realPropertyDAO_PostgresItemProvider.dispose();
	}

}
