/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server;

import java.nio.ByteBuffer;
import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Table</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#getDevice <em>Device</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#getProperties <em>Properties</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#getByteBuffer <em>Byte Buffer</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#getAbsoluteAddress <em>Absolute Address</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#isDirty <em>Dirty</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#isWritable <em>Writable</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#isDummy <em>Dummy</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.DataTable#isObserverNotificationEnabled <em>Observer Notification Enabled</em>}</li>
 * </ul>
 * </p>
 *
 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable()
 * @model
 * @generated
 */
public interface DataTable extends Observable {
	/**
	 * Returns the value of the '<em><b>Device</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.Device#getDataTables <em>Data Tables</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Device</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Device</em>' container reference.
	 * @see #setDevice(Device)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_Device()
	 * @see ch.thomson.ucs.tine.server.Device#getDataTables
	 * @model opposite="dataTables" required="true" transient="false"
	 * @generated
	 */
	Device getDevice();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.DataTable#getDevice <em>Device</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Device</em>' container reference.
	 * @see #getDevice()
	 * @generated
	 */
	void setDevice(Device value);

	/**
	 * Returns the value of the '<em><b>Properties</b></em>' reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.server.RealProperty}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Properties</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Properties</em>' reference list.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_Properties()
	 * @model
	 * @generated
	 */
	EList<RealProperty> getProperties();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.DataTable#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Byte Buffer</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Byte Buffer</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Byte Buffer</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_ByteBuffer()
	 * @model dataType="ch.thomson.ucs.tine.server.ByteBuffer" transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	ByteBuffer getByteBuffer();

	/**
	 * Returns the value of the '<em><b>Absolute Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Absolute Address</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Absolute Address</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_AbsoluteAddress()
	 * @model changeable="false"
	 * @generated
	 */
	int getAbsoluteAddress();

	/**
	 * Returns the value of the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dirty</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dirty</em>' attribute.
	 * @see #setDirty(boolean)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_Dirty()
	 * @model transient="true"
	 * @generated
	 */
	boolean isDirty();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.DataTable#isDirty <em>Dirty</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dirty</em>' attribute.
	 * @see #isDirty()
	 * @generated
	 */
	void setDirty(boolean value);

	/**
	 * Returns the value of the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Writable</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Writable</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_Writable()
	 * @model transient="true" changeable="false" derived="true"
	 * @generated
	 */
	boolean isWritable();

	/**
	 * Returns the value of the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dummy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dummy</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_Dummy()
	 * @model transient="true" changeable="false" derived="true"
	 * @generated
	 */
	boolean isDummy();

	/**
	 * Returns the value of the '<em><b>Observer Notification Enabled</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Observer Notification Enabled</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Observer Notification Enabled</em>' attribute.
	 * @see #setObserverNotificationEnabled(boolean)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDataTable_ObserverNotificationEnabled()
	 * @model default="true" transient="true"
	 * @generated
	 */
	boolean isObserverNotificationEnabled();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.DataTable#isObserverNotificationEnabled <em>Observer Notification Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Observer Notification Enabled</em>' attribute.
	 * @see #isObserverNotificationEnabled()
	 * @generated
	 */
	void setObserverNotificationEnabled(boolean value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void write(byte[] buffer, int offset);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void read(byte[] buffer, int offset);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model exceptions="ch.thomson.ucs.tine.server.Exception"
	 * @generated
	 */
	void initialize() throws Exception;

} // DataTable
