/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

import ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener;
import de.desy.tine.server.devices.TDevice;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Device</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getTineDevice <em>Tine Device</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getEquipmentModule <em>Equipment Module</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getDataTables <em>Data Tables</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getDriver <em>Driver</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getAddress <em>Address</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getActualError <em>Actual Error</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getUserDataStamp <em>User Data Stamp</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getSystemDataStamp <em>System Data Stamp</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#isTransaction <em>Transaction</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getDeviceUpdateListeners <em>Device Update Listeners</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getLinkUserDataStamp <em>Link User Data Stamp</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Device#getLinkSystemDataStamp <em>Link System Data Stamp</em>}</li>
 * </ul>
 * </p>
 *
 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice()
 * @model
 * @generated
 */
public interface Device extends EObject {
	/**
	 * Returns the value of the '<em><b>Tine Device</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Device</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Device</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_TineDevice()
	 * @model dataType="ch.thomson.ucs.tine.server.TDevice" transient="true" changeable="false"
	 * @generated
	 */
	TDevice getTineDevice();

	/**
	 * Returns the value of the '<em><b>Equipment Module</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.EquipmentModule#getDevices <em>Devices</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Equipment Module</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Equipment Module</em>' container reference.
	 * @see #setEquipmentModule(EquipmentModule)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_EquipmentModule()
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getDevices
	 * @model opposite="devices" required="true" transient="false"
	 * @generated
	 */
	EquipmentModule getEquipmentModule();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Device#getEquipmentModule <em>Equipment Module</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Equipment Module</em>' container reference.
	 * @see #getEquipmentModule()
	 * @generated
	 */
	void setEquipmentModule(EquipmentModule value);

	/**
	 * Returns the value of the '<em><b>Data Tables</b></em>' containment reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.server.DataTable}.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.DataTable#getDevice <em>Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data Tables</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Tables</em>' containment reference list.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_DataTables()
	 * @see ch.thomson.ucs.tine.server.DataTable#getDevice
	 * @model opposite="device" containment="true"
	 * @generated
	 */
	EList<DataTable> getDataTables();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Device#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Driver</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.Driver#getDevice <em>Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Driver</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Driver</em>' containment reference.
	 * @see #setDriver(Driver)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_Driver()
	 * @see ch.thomson.ucs.tine.server.Driver#getDevice
	 * @model opposite="device" containment="true"
	 * @generated
	 */
	Driver getDriver();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Device#getDriver <em>Driver</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Driver</em>' containment reference.
	 * @see #getDriver()
	 * @generated
	 */
	void setDriver(Driver value);

	/**
	 * Returns the value of the '<em><b>Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Address</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Address</em>' attribute.
	 * @see #setAddress(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_Address()
	 * @model
	 * @generated
	 */
	String getAddress();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Device#getAddress <em>Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Address</em>' attribute.
	 * @see #getAddress()
	 * @generated
	 */
	void setAddress(String value);

	/**
	 * Returns the value of the '<em><b>Actual Error</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual Error</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual Error</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_ActualError()
	 * @model dataType="ch.thomson.ucs.tine.server.Exception" transient="true" changeable="false"
	 * @generated
	 */
	Exception getActualError();

	/**
	 * Returns the value of the '<em><b>User Data Stamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>User Data Stamp</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>User Data Stamp</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_UserDataStamp()
	 * @model transient="true" changeable="false" derived="true"
	 * @generated
	 */
	int getUserDataStamp();

	/**
	 * Returns the value of the '<em><b>System Data Stamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>System Data Stamp</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>System Data Stamp</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_SystemDataStamp()
	 * @model transient="true" changeable="false" derived="true"
	 * @generated
	 */
	int getSystemDataStamp();

	/**
	 * Returns the value of the '<em><b>Transaction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transaction</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Transaction</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_Transaction()
	 * @model transient="true" changeable="false" derived="true"
	 * @generated
	 */
	boolean isTransaction();

	/**
	 * Returns the value of the '<em><b>Device Update Listeners</b></em>' attribute list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Device Update Listeners</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Device Update Listeners</em>' attribute list.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_DeviceUpdateListeners()
	 * @model dataType="ch.thomson.ucs.tine.server.DeviceUpdateListener" transient="true" derived="true"
	 * @generated
	 */
	EList<DeviceUpdateListener> getDeviceUpdateListeners();

	/**
	 * Returns the value of the '<em><b>Link User Data Stamp</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Link User Data Stamp</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Link User Data Stamp</em>' reference.
	 * @see #setLinkUserDataStamp(PropertyInt32)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_LinkUserDataStamp()
	 * @model
	 * @generated
	 */
	PropertyInt32 getLinkUserDataStamp();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Device#getLinkUserDataStamp <em>Link User Data Stamp</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Link User Data Stamp</em>' reference.
	 * @see #getLinkUserDataStamp()
	 * @generated
	 */
	void setLinkUserDataStamp(PropertyInt32 value);

	/**
	 * Returns the value of the '<em><b>Link System Data Stamp</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Link System Data Stamp</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Link System Data Stamp</em>' reference.
	 * @see #setLinkSystemDataStamp(PropertyInt32)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getDevice_LinkSystemDataStamp()
	 * @model
	 * @generated
	 */
	PropertyInt32 getLinkSystemDataStamp();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Device#getLinkSystemDataStamp <em>Link System Data Stamp</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Link System Data Stamp</em>' reference.
	 * @see #getLinkSystemDataStamp()
	 * @generated
	 */
	void setLinkSystemDataStamp(PropertyInt32 value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void run();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model exceptions="ch.thomson.ucs.tine.server.Exception"
	 * @generated
	 */
	void initialize() throws Exception;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	DataTable findDataTable(String name);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model exceptions="ch.thomson.ucs.tine.server.Exception"
	 * @generated
	 */
	void dataTableChanged(DataTable dataTable) throws Exception;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void startTransaction();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model exceptions="ch.thomson.ucs.tine.server.Exception"
	 * @generated
	 */
	void commit() throws Exception;

} // Device
