/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server;

import org.eclipse.emf.common.util.EList;

import de.desy.tine.server.equipment.TEquipmentBackgroundTask;
import de.desy.tine.server.equipment.TEquipmentModule;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Equipment Module</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getFrontEndController <em>Front End Controller</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getExportName <em>Export Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getLocalName <em>Local Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getTineEquipmentModule <em>Tine Equipment Module</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getDevices <em>Devices</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getProperties <em>Properties</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getTineBackgroundTask <em>Tine Background Task</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getDevicePollingRate <em>Device Polling Rate</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getDriverType <em>Driver Type</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getByteOrder <em>Byte Order</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getTinePath <em>Tine Path</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getActualState <em>Actual State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.EquipmentModule#getTargetState <em>Target State</em>}</li>
 * </ul>
 * </p>
 *
 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule()
 * @model
 * @generated
 */
public interface EquipmentModule extends Persistable {
	/**
	 * Returns the value of the '<em><b>Front End Controller</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.FrontEndController#getEquipmentModules <em>Equipment Modules</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Front End Controller</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Front End Controller</em>' container reference.
	 * @see #setFrontEndController(FrontEndController)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_FrontEndController()
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getEquipmentModules
	 * @model opposite="equipmentModules" required="true" transient="false"
	 * @generated
	 */
	FrontEndController getFrontEndController();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getFrontEndController <em>Front End Controller</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Front End Controller</em>' container reference.
	 * @see #getFrontEndController()
	 * @generated
	 */
	void setFrontEndController(FrontEndController value);

	/**
	 * Returns the value of the '<em><b>Export Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Export Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Export Name</em>' attribute.
	 * @see #setExportName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_ExportName()
	 * @model required="true"
	 * @generated
	 */
	String getExportName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getExportName <em>Export Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Export Name</em>' attribute.
	 * @see #getExportName()
	 * @generated
	 */
	void setExportName(String value);

	/**
	 * Returns the value of the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Local Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Local Name</em>' attribute.
	 * @see #setLocalName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_LocalName()
	 * @model required="true"
	 * @generated
	 */
	String getLocalName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getLocalName <em>Local Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Local Name</em>' attribute.
	 * @see #getLocalName()
	 * @generated
	 */
	void setLocalName(String value);

	/**
	 * Returns the value of the '<em><b>Tine Equipment Module</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Equipment Module</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Equipment Module</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_TineEquipmentModule()
	 * @model dataType="ch.thomson.ucs.tine.server.TEquipmentModule" transient="true" changeable="false"
	 * @generated
	 */
	TEquipmentModule getTineEquipmentModule();

	/**
	 * Returns the value of the '<em><b>Devices</b></em>' containment reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.server.Device}.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.Device#getEquipmentModule <em>Equipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Devices</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Devices</em>' containment reference list.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_Devices()
	 * @see ch.thomson.ucs.tine.server.Device#getEquipmentModule
	 * @model opposite="equipmentModule" containment="true" keys="name" required="true"
	 * @generated
	 */
	EList<Device> getDevices();

	/**
	 * Returns the value of the '<em><b>Properties</b></em>' containment reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.server.Property}.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.Property#getEquipmentModule <em>Equipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Properties</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Properties</em>' containment reference list.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_Properties()
	 * @see ch.thomson.ucs.tine.server.Property#getEquipmentModule
	 * @model opposite="equipmentModule" containment="true" keys="name" required="true"
	 * @generated
	 */
	EList<Property> getProperties();

	/**
	 * Returns the value of the '<em><b>Tine Background Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Background Task</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Background Task</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_TineBackgroundTask()
	 * @model dataType="ch.thomson.ucs.tine.server.TEquipmentBackgroundTask" transient="true" changeable="false"
	 * @generated
	 */
	TEquipmentBackgroundTask getTineBackgroundTask();

	/**
	 * Returns the value of the '<em><b>Device Polling Rate</b></em>' attribute.
	 * The default value is <code>"100"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Device Polling Rate</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Device Polling Rate</em>' attribute.
	 * @see #setDevicePollingRate(int)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_DevicePollingRate()
	 * @model default="100"
	 * @generated
	 */
	int getDevicePollingRate();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getDevicePollingRate <em>Device Polling Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Device Polling Rate</em>' attribute.
	 * @see #getDevicePollingRate()
	 * @generated
	 */
	void setDevicePollingRate(int value);

	/**
	 * Returns the value of the '<em><b>Driver Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Driver Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Driver Type</em>' attribute.
	 * @see #setDriverType(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_DriverType()
	 * @model required="true"
	 * @generated
	 */
	String getDriverType();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getDriverType <em>Driver Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Driver Type</em>' attribute.
	 * @see #getDriverType()
	 * @generated
	 */
	void setDriverType(String value);

	/**
	 * Returns the value of the '<em><b>Byte Order</b></em>' attribute.
	 * The literals are from the enumeration {@link ch.thomson.ucs.tine.server.ByteOrder}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Byte Order</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Byte Order</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ByteOrder
	 * @see #setByteOrder(ByteOrder)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_ByteOrder()
	 * @model
	 * @generated
	 */
	ByteOrder getByteOrder();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getByteOrder <em>Byte Order</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Byte Order</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ByteOrder
	 * @see #getByteOrder()
	 * @generated
	 */
	void setByteOrder(ByteOrder value);

	/**
	 * Returns the value of the '<em><b>Tine Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Path</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Path</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_TinePath()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	String getTinePath();

	/**
	 * Returns the value of the '<em><b>Actual State</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual State</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual State</em>' reference.
	 * @see #setActualState(PropertyNumeric)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_ActualState()
	 * @model
	 * @generated
	 */
	PropertyNumeric getActualState();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getActualState <em>Actual State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Actual State</em>' reference.
	 * @see #getActualState()
	 * @generated
	 */
	void setActualState(PropertyNumeric value);

	/**
	 * Returns the value of the '<em><b>Target State</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target State</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target State</em>' reference.
	 * @see #setTargetState(PropertyNumeric)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getEquipmentModule_TargetState()
	 * @model
	 * @generated
	 */
	PropertyNumeric getTargetState();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.EquipmentModule#getTargetState <em>Target State</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target State</em>' reference.
	 * @see #getTargetState()
	 * @generated
	 */
	void setTargetState(PropertyNumeric value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model exceptions="ch.thomson.ucs.tine.server.Exception"
	 * @generated
	 */
	void initialize() throws Exception;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	Device findDevice(String name);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	EList<RealProperty> collectRealProperties();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void scheduleProperty(Property property);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	Property findProperty(String name);

} // EquipmentModule
