/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server;

import de.desy.tine.server.equipment.TEquipmentModuleFactory;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Front End Controller</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getTineEquipmentModuleFactory <em>Tine Equipment Module Factory</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getEquipmentModules <em>Equipment Modules</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getSubSystemName <em>Sub System Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getContextName <em>Context Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getLocation <em>Location</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getLocalValue <em>Local Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#isLocalMode <em>Local Mode</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#isAccessAllowed <em>Access Allowed</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getAllowedHostsForLocalAccess <em>Allowed Hosts For Local Access</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#getLockWriteProperty <em>Lock Write Property</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#isWriteLocked <em>Write Locked</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.FrontEndController#isLocalCaller <em>Local Caller</em>}</li>
 * </ul>
 * </p>
 *
 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController()
 * @model
 * @generated
 */
public interface FrontEndController extends EObject {
	/**
	 * Returns the value of the '<em><b>Tine Equipment Module Factory</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Equipment Module Factory</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Equipment Module Factory</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_TineEquipmentModuleFactory()
	 * @model dataType="ch.thomson.ucs.tine.server.TEquipmentModuleFactory" transient="true" changeable="false"
	 * @generated
	 */
	TEquipmentModuleFactory getTineEquipmentModuleFactory();

	/**
	 * Returns the value of the '<em><b>Equipment Modules</b></em>' containment reference list.
	 * The list contents are of type {@link ch.thomson.ucs.tine.server.EquipmentModule}.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.EquipmentModule#getFrontEndController <em>Front End Controller</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Equipment Modules</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Equipment Modules</em>' containment reference list.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_EquipmentModules()
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getFrontEndController
	 * @model opposite="frontEndController" containment="true" keys="exportName" required="true"
	 * @generated
	 */
	EList<EquipmentModule> getEquipmentModules();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.FrontEndController#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Sub System Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sub System Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sub System Name</em>' attribute.
	 * @see #setSubSystemName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_SubSystemName()
	 * @model required="true"
	 * @generated
	 */
	String getSubSystemName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.FrontEndController#getSubSystemName <em>Sub System Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sub System Name</em>' attribute.
	 * @see #getSubSystemName()
	 * @generated
	 */
	void setSubSystemName(String value);

	/**
	 * Returns the value of the '<em><b>Context Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Context Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Context Name</em>' attribute.
	 * @see #setContextName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_ContextName()
	 * @model
	 * @generated
	 */
	String getContextName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.FrontEndController#getContextName <em>Context Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Context Name</em>' attribute.
	 * @see #getContextName()
	 * @generated
	 */
	void setContextName(String value);
	
	/**
	 * Returns the value of the '<em><b>Location</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Location</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Location</em>' reference.
	 * @see #setLocation(PropertyNumeric)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_Location()
	 * @model required="true"
	 * @generated
	 */
	PropertyNumeric getLocation();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.FrontEndController#getLocation <em>Location</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Location</em>' reference.
	 * @see #getLocation()
	 * @generated
	 */
	void setLocation(PropertyNumeric value);

	/**
	 * Returns the value of the '<em><b>Local Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Local Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Local Value</em>' attribute.
	 * @see #setLocalValue(int)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_LocalValue()
	 * @model
	 * @generated
	 */
	int getLocalValue();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.FrontEndController#getLocalValue <em>Local Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Local Value</em>' attribute.
	 * @see #getLocalValue()
	 * @generated
	 */
	void setLocalValue(int value);

	/**
	 * Returns the value of the '<em><b>Local Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Local Mode</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Local Mode</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_LocalMode()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	boolean isLocalMode();

	/**
	 * Returns the value of the '<em><b>Access Allowed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Access Allowed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Access Allowed</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_AccessAllowed()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	boolean isAccessAllowed();

	/**
	 * Returns the value of the '<em><b>Allowed Hosts For Local Access</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Allowed Hosts For Local Access</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Allowed Hosts For Local Access</em>' attribute list.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_AllowedHostsForLocalAccess()
	 * @model
	 * @generated
	 */
	EList<String> getAllowedHostsForLocalAccess();

	/**
	 * Returns the value of the '<em><b>Lock Write Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lock Write Property</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lock Write Property</em>' reference.
	 * @see #setLockWriteProperty(PropertyNumeric)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_LockWriteProperty()
	 * @model
	 * @generated
	 */
	PropertyNumeric getLockWriteProperty();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.FrontEndController#getLockWriteProperty <em>Lock Write Property</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lock Write Property</em>' reference.
	 * @see #getLockWriteProperty()
	 * @generated
	 */
	void setLockWriteProperty(PropertyNumeric value);

	/**
	 * Returns the value of the '<em><b>Write Locked</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Write Locked</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Write Locked</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_WriteLocked()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	boolean isWriteLocked();

	/**
	 * Returns the value of the '<em><b>Local Caller</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Local Caller</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Local Caller</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getFrontEndController_LocalCaller()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	boolean isLocalCaller();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model exceptions="ch.thomson.ucs.tine.server.Exception"
	 * @generated
	 */
	void initialize() throws Exception;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void run();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void shutdown();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	EquipmentModule findEquipmentModule(String exportName);

} // FrontEndController
