/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server;

import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.server.properties.TExportProperty;
import de.desy.tine.server.properties.TPropertyHandler;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Property</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getTineExportProperty <em>Tine Export Property</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getEquipmentModule <em>Equipment Module</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getTinePropertyHandler <em>Tine Property Handler</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getDescription <em>Description</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getTineAccess <em>Tine Access</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getLength <em>Length</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getMinimumValue <em>Minimum Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getMaximumValue <em>Maximum Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getUnit <em>Unit</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#isWritable <em>Writable</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getLogonLevel <em>Logon Level</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getMaxState <em>Max State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#isScheduled <em>Scheduled</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.Property#getRefreshRate <em>Refresh Rate</em>}</li>
 * </ul>
 * </p>
 *
 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty()
 * @model abstract="true"
 * @generated
 */
public interface Property extends Observable {
	/**
	 * Returns the value of the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Export Property</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Export Property</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_TineExportProperty()
	 * @model dataType="ch.thomson.ucs.tine.server.TExportProperty" transient="true" changeable="false"
	 * @generated
	 */
	TExportProperty getTineExportProperty();

	/**
	 * Returns the value of the '<em><b>Equipment Module</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ch.thomson.ucs.tine.server.EquipmentModule#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Equipment Module</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Equipment Module</em>' container reference.
	 * @see #setEquipmentModule(EquipmentModule)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_EquipmentModule()
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getProperties
	 * @model opposite="properties" required="true" transient="false"
	 * @generated
	 */
	EquipmentModule getEquipmentModule();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getEquipmentModule <em>Equipment Module</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Equipment Module</em>' container reference.
	 * @see #getEquipmentModule()
	 * @generated
	 */
	void setEquipmentModule(EquipmentModule value);

	/**
	 * Returns the value of the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Property Handler</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Property Handler</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_TinePropertyHandler()
	 * @model dataType="ch.thomson.ucs.tine.server.TPropertyHandler" transient="true" changeable="false"
	 * @generated
	 */
	TPropertyHandler getTinePropertyHandler();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_Name()
	 * @model required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * The default value is <code>"No description"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_Description()
	 * @model default="No description"
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Tine Access</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * The literals are from the enumeration {@link ch.thomson.ucs.tine.server.TineAccess}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tine Access</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tine Access</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.TineAccess
	 * @see #setTineAccess(TineAccess)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_TineAccess()
	 * @model default=""
	 * @generated
	 */
	TineAccess getTineAccess();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getTineAccess <em>Tine Access</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tine Access</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.TineAccess
	 * @see #getTineAccess()
	 * @generated
	 */
	void setTineAccess(TineAccess value);

	/**
	 * Returns the value of the '<em><b>Length</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Length</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Length</em>' attribute.
	 * @see #setLength(int)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_Length()
	 * @model default="1"
	 * @generated
	 */
	int getLength();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getLength <em>Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Length</em>' attribute.
	 * @see #getLength()
	 * @generated
	 */
	void setLength(int value);

	/**
	 * Returns the value of the '<em><b>Minimum Value</b></em>' attribute.
	 * The default value is <code>"-2147483648.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Minimum Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Minimum Value</em>' attribute.
	 * @see #setMinimumValue(float)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_MinimumValue()
	 * @model default="-2147483648.0"
	 * @generated
	 */
	float getMinimumValue();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getMinimumValue <em>Minimum Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Minimum Value</em>' attribute.
	 * @see #getMinimumValue()
	 * @generated
	 */
	void setMinimumValue(float value);

	/**
	 * Returns the value of the '<em><b>Maximum Value</b></em>' attribute.
	 * The default value is <code>"2147483647.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Maximum Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Maximum Value</em>' attribute.
	 * @see #setMaximumValue(float)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_MaximumValue()
	 * @model default="2147483647.0"
	 * @generated
	 */
	float getMaximumValue();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getMaximumValue <em>Maximum Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Maximum Value</em>' attribute.
	 * @see #getMaximumValue()
	 * @generated
	 */
	void setMaximumValue(float value);

	/**
	 * Returns the value of the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Unit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unit</em>' attribute.
	 * @see #setUnit(String)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_Unit()
	 * @model
	 * @generated
	 */
	String getUnit();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getUnit <em>Unit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unit</em>' attribute.
	 * @see #getUnit()
	 * @generated
	 */
	void setUnit(String value);

	/**
	 * Returns the value of the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Writable</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Writable</em>' attribute.
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_Writable()
	 * @model transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	boolean isWritable();

	/**
	 * Returns the value of the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Logon Level</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Logon Level</em>' attribute.
	 * @see #setLogonLevel(int)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_LogonLevel()
	 * @model
	 * @generated
	 */
	int getLogonLevel();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getLogonLevel <em>Logon Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Logon Level</em>' attribute.
	 * @see #getLogonLevel()
	 * @generated
	 */
	void setLogonLevel(int value);

	/**
	 * Returns the value of the '<em><b>Max State</b></em>' attribute.
	 * The default value is <code>"2147483647"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max State</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max State</em>' attribute.
	 * @see #setMaxState(int)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_MaxState()
	 * @model default="2147483647"
	 * @generated
	 */
	int getMaxState();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getMaxState <em>Max State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max State</em>' attribute.
	 * @see #getMaxState()
	 * @generated
	 */
	void setMaxState(int value);

	/**
	 * Returns the value of the '<em><b>Scheduled</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Scheduled</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scheduled</em>' attribute.
	 * @see #setScheduled(boolean)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_Scheduled()
	 * @model default="false"
	 * @generated
	 */
	boolean isScheduled();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#isScheduled <em>Scheduled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scheduled</em>' attribute.
	 * @see #isScheduled()
	 * @generated
	 */
	void setScheduled(boolean value);

	/**
	 * Returns the value of the '<em><b>Refresh Rate</b></em>' attribute.
	 * The default value is <code>"1000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Refresh Rate</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Refresh Rate</em>' attribute.
	 * @see #setRefreshRate(int)
	 * @see ch.thomson.ucs.tine.server.ServerPackage#getProperty_RefreshRate()
	 * @model default="1000"
	 * @generated
	 */
	int getRefreshRate();

	/**
	 * Sets the value of the '{@link ch.thomson.ucs.tine.server.Property#getRefreshRate <em>Refresh Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Refresh Rate</em>' attribute.
	 * @see #getRefreshRate()
	 * @generated
	 */
	void setRefreshRate(int value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model exceptions="ch.thomson.ucs.tine.server.Exception"
	 * @generated
	 */
	void initialize() throws Exception;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	int getTypeSize();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	int getByteSize();
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean isOutOfRange(float value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model dataType="ch.thomson.ucs.tine.server.TDataType"
	 * @generated
	 */
	TDataType createTDataType();

	short getTineTypeCode();
	
	int writeData(Device device, TDataType din);
	int readData(Device device, TDataType dout);
	
} // Property
