/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.Driver;
import ch.thomson.ucs.tine.server.EquipmentModule;
import ch.thomson.ucs.tine.server.PropertyInt32;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.ServerFactory;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener;
import ch.thomson.ucs.tine.server.util.Activator;
import ch.thomson.ucs.tine.server.util.IDriverFactory;
import ch.thomson.ucs.tine.server.util.UCSConfig;
import de.desy.tine.server.devices.TDevice;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Device</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getTineDevice <em>Tine Device</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getEquipmentModule <em>Equipment Module</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getDataTables <em>Data Tables</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getDriver <em>Driver</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getAddress <em>Address</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getActualError <em>Actual Error</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getUserDataStamp <em>User Data Stamp</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getSystemDataStamp <em>System Data Stamp</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#isTransaction <em>Transaction</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getDeviceUpdateListeners <em>Device Update Listeners</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getLinkUserDataStamp <em>Link User Data Stamp</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DeviceImpl#getLinkSystemDataStamp <em>Link System Data Stamp</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DeviceImpl extends EObjectImpl implements Device {
	/**
	 * The default value of the '{@link #getTineDevice() <em>Tine Device</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineDevice()
	 * @generated
	 * @ordered
	 */
	protected static final TDevice TINE_DEVICE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTineDevice() <em>Tine Device</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineDevice()
	 * @generated
	 * @ordered
	 */
	protected TDevice tineDevice = TINE_DEVICE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDataTables() <em>Data Tables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataTables()
	 * @generated
	 * @ordered
	 */
	protected EList<DataTable> dataTables;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDriver() <em>Driver</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDriver()
	 * @generated
	 * @ordered
	 */
	protected Driver driver;

	/**
	 * The default value of the '{@link #getAddress() <em>Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress()
	 * @generated
	 * @ordered
	 */
	protected static final String ADDRESS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAddress() <em>Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress()
	 * @generated
	 * @ordered
	 */
	protected String address = ADDRESS_EDEFAULT;

	/**
	 * The default value of the '{@link #getActualError() <em>Actual Error</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualError()
	 * @generated
	 * @ordered
	 */
	protected static final Exception ACTUAL_ERROR_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getActualError() <em>Actual Error</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualError()
	 * @generated
	 * @ordered
	 */
	protected Exception actualError = ACTUAL_ERROR_EDEFAULT;

	/**
	 * The default value of the '{@link #getUserDataStamp() <em>User Data Stamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUserDataStamp()
	 * @generated
	 * @ordered
	 */
	protected static final int USER_DATA_STAMP_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getUserDataStamp() <em>User Data Stamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUserDataStamp()
	 * @generated
	 * @ordered
	 */
	protected int userDataStamp = USER_DATA_STAMP_EDEFAULT;

	/**
	 * The default value of the '{@link #getSystemDataStamp() <em>System Data Stamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSystemDataStamp()
	 * @generated
	 * @ordered
	 */
	protected static final int SYSTEM_DATA_STAMP_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getSystemDataStamp() <em>System Data Stamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSystemDataStamp()
	 * @generated
	 * @ordered
	 */
	protected int systemDataStamp = SYSTEM_DATA_STAMP_EDEFAULT;

	/**
	 * The default value of the '{@link #isTransaction() <em>Transaction</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isTransaction()
	 * @generated
	 * @ordered
	 */
	protected static final boolean TRANSACTION_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isTransaction() <em>Transaction</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isTransaction()
	 * @generated
	 * @ordered
	 */
	protected boolean transaction = TRANSACTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDeviceUpdateListeners() <em>Device Update Listeners</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeviceUpdateListeners()
	 * @generated
	 * @ordered
	 */
	protected EList<DeviceUpdateListener> deviceUpdateListeners;

	/**
	 * The cached value of the '{@link #getLinkUserDataStamp() <em>Link User Data Stamp</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkUserDataStamp()
	 * @generated
	 * @ordered
	 */
	protected PropertyInt32 linkUserDataStamp;

	/**
	 * The cached value of the '{@link #getLinkSystemDataStamp() <em>Link System Data Stamp</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLinkSystemDataStamp()
	 * @generated
	 * @ordered
	 */
	protected PropertyInt32 linkSystemDataStamp;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DeviceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.DEVICE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TDevice getTineDevice() {
		return tineDevice;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EquipmentModule getEquipmentModule() {
		if (eContainerFeatureID() != ServerPackage.DEVICE__EQUIPMENT_MODULE) return null;
		return (EquipmentModule)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEquipmentModule(EquipmentModule newEquipmentModule, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newEquipmentModule, ServerPackage.DEVICE__EQUIPMENT_MODULE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEquipmentModule(EquipmentModule newEquipmentModule) {
		if (newEquipmentModule != eInternalContainer() || (eContainerFeatureID() != ServerPackage.DEVICE__EQUIPMENT_MODULE && newEquipmentModule != null)) {
			if (EcoreUtil.isAncestor(this, newEquipmentModule))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newEquipmentModule != null)
				msgs = ((InternalEObject)newEquipmentModule).eInverseAdd(this, ServerPackage.EQUIPMENT_MODULE__DEVICES, EquipmentModule.class, msgs);
			msgs = basicSetEquipmentModule(newEquipmentModule, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DEVICE__EQUIPMENT_MODULE, newEquipmentModule, newEquipmentModule));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DataTable> getDataTables() {
		if (dataTables == null) {
			dataTables = new EObjectContainmentWithInverseEList<DataTable>(DataTable.class, this, ServerPackage.DEVICE__DATA_TABLES, ServerPackage.DATA_TABLE__DEVICE);
		}
		return dataTables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DEVICE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Driver getDriver() {
		return driver;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDriver(Driver newDriver, NotificationChain msgs) {
		Driver oldDriver = driver;
		driver = newDriver;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServerPackage.DEVICE__DRIVER, oldDriver, newDriver);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDriver(Driver newDriver) {
		if (newDriver != driver) {
			NotificationChain msgs = null;
			if (driver != null)
				msgs = ((InternalEObject)driver).eInverseRemove(this, ServerPackage.DRIVER__DEVICE, Driver.class, msgs);
			if (newDriver != null)
				msgs = ((InternalEObject)newDriver).eInverseAdd(this, ServerPackage.DRIVER__DEVICE, Driver.class, msgs);
			msgs = basicSetDriver(newDriver, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DEVICE__DRIVER, newDriver, newDriver));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAddress() {
		return address;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAddress(String newAddress) {
		String oldAddress = address;
		address = newAddress;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DEVICE__ADDRESS, oldAddress, address));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Exception getActualError() {
		return actualError;
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getUserDataStamp() {
		return userDataStamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSystemDataStamp() {
		return systemDataStamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isTransaction() {
		return transaction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DeviceUpdateListener> getDeviceUpdateListeners() {
		if (deviceUpdateListeners == null) {
			deviceUpdateListeners = new EDataTypeUniqueEList<DeviceUpdateListener>(DeviceUpdateListener.class, this, ServerPackage.DEVICE__DEVICE_UPDATE_LISTENERS);
		}
		return deviceUpdateListeners;
	}
	
//	public long highDriver;
	
/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyInt32 getLinkUserDataStamp() {
		if (linkUserDataStamp != null && linkUserDataStamp.eIsProxy()) {
			InternalEObject oldLinkUserDataStamp = (InternalEObject)linkUserDataStamp;
			linkUserDataStamp = (PropertyInt32)eResolveProxy(oldLinkUserDataStamp);
			if (linkUserDataStamp != oldLinkUserDataStamp) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServerPackage.DEVICE__LINK_USER_DATA_STAMP, oldLinkUserDataStamp, linkUserDataStamp));
			}
		}
		return linkUserDataStamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyInt32 basicGetLinkUserDataStamp() {
		return linkUserDataStamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLinkUserDataStamp(PropertyInt32 newLinkUserDataStamp) {
		PropertyInt32 oldLinkUserDataStamp = linkUserDataStamp;
		linkUserDataStamp = newLinkUserDataStamp;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DEVICE__LINK_USER_DATA_STAMP, oldLinkUserDataStamp, linkUserDataStamp));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyInt32 getLinkSystemDataStamp() {
		if (linkSystemDataStamp != null && linkSystemDataStamp.eIsProxy()) {
			InternalEObject oldLinkSystemDataStamp = (InternalEObject)linkSystemDataStamp;
			linkSystemDataStamp = (PropertyInt32)eResolveProxy(oldLinkSystemDataStamp);
			if (linkSystemDataStamp != oldLinkSystemDataStamp) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServerPackage.DEVICE__LINK_SYSTEM_DATA_STAMP, oldLinkSystemDataStamp, linkSystemDataStamp));
			}
		}
		return linkSystemDataStamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyInt32 basicGetLinkSystemDataStamp() {
		return linkSystemDataStamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLinkSystemDataStamp(PropertyInt32 newLinkSystemDataStamp) {
		PropertyInt32 oldLinkSystemDataStamp = linkSystemDataStamp;
		linkSystemDataStamp = newLinkSystemDataStamp;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DEVICE__LINK_SYSTEM_DATA_STAMP, oldLinkSystemDataStamp, linkSystemDataStamp));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void run() {
		for(DataTable dataTable : this.getDataTables()) {
			synchronized(dataTable) {
				try {
					// In einem Fehlerfall muss zuerst versucht werden, die
					// schreibbaren Tabellen wieder auf die Hardware zu schreiben.
					if(this.actualError != null) {
						if(dataTable.isWritable()) {
							dataTable.setDirty(true);
							this.writeDataTable(dataTable);
						}
					}
				
					// Schreibbare Datentabellen und Dummies werden nicht gelesen.
					if (dataTable.isWritable() || dataTable.isDummy())
						continue;
					
					boolean dataToRead = true;

					while(dataToRead) {
						// Buffer der Datentabelle fr den Vergleich klonen
						byte[] bufferBefore = dataTable.getByteBuffer().array().clone();
				
						//long start = System.nanoTime();
						dataToRead = this.getDriver().readData(dataTable) > 0;					
						//long time = (System.nanoTime() - start) / 1000;
						//if(time > highDriver)
						//	highDriver = time;
				
						// Observers nur benachrichtigen, wenn sich wirklich was gendert hat.
						if(!Arrays.equals(bufferBefore, dataTable.getByteBuffer().array()) || this.actualError != null) {
							
							// Zeitstempel setzen
							userDataStamp = getDataStampValue(getLinkUserDataStamp(), dataTable);
							systemDataStamp = getDataStampValue(getLinkSystemDataStamp(), dataTable);
							
							dataTable.notifyObservers();
						
							// Die schnellen DeviceUpdateListeners updaten
							Iterator<DeviceUpdateListener> it = this.getDeviceUpdateListeners().iterator();
							while(it.hasNext()) {	
								it.next().postUpdate();
							}
						}
				
						// Fehler ist wieder gegangen.
						this.actualError = null;
					}
		
				} catch (Exception e) {
					// Fehler ist zum 1. Mal aufgetreten -> Observers informieren
					if(this.actualError == null) {
						Activator.getLogger().error(this.getName()+ ": " + e);
					
						// Die Observers aller Tabellen informieren
						for(DataTable d : this.getDataTables()) {
							d.notifyObservers();
						}
					}
					this.actualError = e;
				}
			}
		}
	}
	
	// Instanzenzhler fr ID
	private static int id = 0;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void initialize() throws Exception {
		UCSConfig config = UCSConfig.getInstance();
		
		String externalDeviceName = config.getDeviceName(this.getName());
		this.tineDevice = new TDevice(externalDeviceName, id++);
		
		this.setDriver(getDriverFromExtensionPoint());
		if(this.getDriver() != null)
			this.getDriver().initialize();
		
		else
			throw new Exception("Plugin for Device Driver \"" + this.getEquipmentModule().getDriverType() + "\" not found");
		
		EList<RealProperty> realProperties = this.getEquipmentModule().collectRealProperties();
		
		for(RealProperty realProperty : realProperties) {
			
			DataTable dataTable = this.findDataTable(realProperty.getDataTableName());
			
			if(dataTable == null) {
				// Nicht vorhanden, muss erzeugt werden
				dataTable = ServerFactory.eINSTANCE.createDataTable();
				dataTable.setName(realProperty.getDataTableName());
				dataTable.setDevice(this);
				getDataTables().add(dataTable);
			}
			
			dataTable.getProperties().add(realProperty);
			
			// Address-String parsen, wenn das UserDefinedObject noch nicht erstellt wurde.
			if(realProperty.getUserDefinedAddressObject() == null) {
				this.getDriver().parseAddressString(realProperty);
			}
		}
		
		// Data Tables initialisieren
		for(DataTable dt : this.getDataTables()) {
			dt.initialize();
		}
	}

	protected Map<String, DataTable> dataTableCacheMap = null; 
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public DataTable findDataTable(String name) {
		if(dataTableCacheMap == null) {
			dataTableCacheMap = new HashMap<String, DataTable>();
		}
		
		DataTable dataTable = dataTableCacheMap.get(name);
		
		if(dataTable != null)
			return dataTable;
		
		// Nicht im Cache, muss also gesucht werden, und abgelegt werden.
		for(DataTable dt : this.getDataTables()) {
			if(dt.getName().equals(name)) {
				dataTableCacheMap.put(dt.getName(), dt);
				dataTable = dt;
				break;
			}
		}
		
		return dataTable;
	}
	
	private void writeDataTable(DataTable dataTable) throws Exception {
		synchronized(dataTable) {
			if(!dataTable.isDummy()) {
				long time = System.currentTimeMillis();
				this.getDriver().writeData(dataTable);
				Activator.getLogger().info("Writing of data block " + dataTable.getName() + " lasted " + (System.currentTimeMillis() - time) + "ms.");
			}
		
			// Alle Properties sind nun wieder clean
			for(RealProperty rp : dataTable.getProperties())
				rp.setDirty(false);
		
			// Die Datentabelle ist auch wieder clean
			dataTable.setDirty(false);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @throws Exception 
	 * @generated NOT
	 */
	public void dataTableChanged(DataTable dataTable) throws Exception {
		synchronized(dataTable) {
			dataTable.setDirty(true);
		
			if(this.isTransaction())
				return;
		
			this.writeDataTable(dataTable);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void startTransaction() {
		this.transaction = true;
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void commit() throws Exception {
		for(DataTable dt : this.getDataTables()) {
			synchronized(dt) {
			if(dt.isDirty())
				this.writeDataTable(dt);
			}
		}
		this.transaction = false;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.DEVICE__EQUIPMENT_MODULE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetEquipmentModule((EquipmentModule)otherEnd, msgs);
			case ServerPackage.DEVICE__DATA_TABLES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getDataTables()).basicAdd(otherEnd, msgs);
			case ServerPackage.DEVICE__DRIVER:
				if (driver != null)
					msgs = ((InternalEObject)driver).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServerPackage.DEVICE__DRIVER, null, msgs);
				return basicSetDriver((Driver)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.DEVICE__EQUIPMENT_MODULE:
				return basicSetEquipmentModule(null, msgs);
			case ServerPackage.DEVICE__DATA_TABLES:
				return ((InternalEList<?>)getDataTables()).basicRemove(otherEnd, msgs);
			case ServerPackage.DEVICE__DRIVER:
				return basicSetDriver(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ServerPackage.DEVICE__EQUIPMENT_MODULE:
				return eInternalContainer().eInverseRemove(this, ServerPackage.EQUIPMENT_MODULE__DEVICES, EquipmentModule.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.DEVICE__TINE_DEVICE:
				return getTineDevice();
			case ServerPackage.DEVICE__EQUIPMENT_MODULE:
				return getEquipmentModule();
			case ServerPackage.DEVICE__DATA_TABLES:
				return getDataTables();
			case ServerPackage.DEVICE__NAME:
				return getName();
			case ServerPackage.DEVICE__DRIVER:
				return getDriver();
			case ServerPackage.DEVICE__ADDRESS:
				return getAddress();
			case ServerPackage.DEVICE__ACTUAL_ERROR:
				return getActualError();
			case ServerPackage.DEVICE__USER_DATA_STAMP:
				return getUserDataStamp();
			case ServerPackage.DEVICE__SYSTEM_DATA_STAMP:
				return getSystemDataStamp();
			case ServerPackage.DEVICE__TRANSACTION:
				return isTransaction();
			case ServerPackage.DEVICE__DEVICE_UPDATE_LISTENERS:
				return getDeviceUpdateListeners();
			case ServerPackage.DEVICE__LINK_USER_DATA_STAMP:
				if (resolve) return getLinkUserDataStamp();
				return basicGetLinkUserDataStamp();
			case ServerPackage.DEVICE__LINK_SYSTEM_DATA_STAMP:
				if (resolve) return getLinkSystemDataStamp();
				return basicGetLinkSystemDataStamp();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.DEVICE__EQUIPMENT_MODULE:
				setEquipmentModule((EquipmentModule)newValue);
				return;
			case ServerPackage.DEVICE__DATA_TABLES:
				getDataTables().clear();
				getDataTables().addAll((Collection<? extends DataTable>)newValue);
				return;
			case ServerPackage.DEVICE__NAME:
				setName((String)newValue);
				return;
			case ServerPackage.DEVICE__DRIVER:
				setDriver((Driver)newValue);
				return;
			case ServerPackage.DEVICE__ADDRESS:
				setAddress((String)newValue);
				return;
			case ServerPackage.DEVICE__DEVICE_UPDATE_LISTENERS:
				getDeviceUpdateListeners().clear();
				getDeviceUpdateListeners().addAll((Collection<? extends DeviceUpdateListener>)newValue);
				return;
			case ServerPackage.DEVICE__LINK_USER_DATA_STAMP:
				setLinkUserDataStamp((PropertyInt32)newValue);
				return;
			case ServerPackage.DEVICE__LINK_SYSTEM_DATA_STAMP:
				setLinkSystemDataStamp((PropertyInt32)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.DEVICE__EQUIPMENT_MODULE:
				setEquipmentModule((EquipmentModule)null);
				return;
			case ServerPackage.DEVICE__DATA_TABLES:
				getDataTables().clear();
				return;
			case ServerPackage.DEVICE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ServerPackage.DEVICE__DRIVER:
				setDriver((Driver)null);
				return;
			case ServerPackage.DEVICE__ADDRESS:
				setAddress(ADDRESS_EDEFAULT);
				return;
			case ServerPackage.DEVICE__DEVICE_UPDATE_LISTENERS:
				getDeviceUpdateListeners().clear();
				return;
			case ServerPackage.DEVICE__LINK_USER_DATA_STAMP:
				setLinkUserDataStamp((PropertyInt32)null);
				return;
			case ServerPackage.DEVICE__LINK_SYSTEM_DATA_STAMP:
				setLinkSystemDataStamp((PropertyInt32)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.DEVICE__TINE_DEVICE:
				return TINE_DEVICE_EDEFAULT == null ? tineDevice != null : !TINE_DEVICE_EDEFAULT.equals(tineDevice);
			case ServerPackage.DEVICE__EQUIPMENT_MODULE:
				return getEquipmentModule() != null;
			case ServerPackage.DEVICE__DATA_TABLES:
				return dataTables != null && !dataTables.isEmpty();
			case ServerPackage.DEVICE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ServerPackage.DEVICE__DRIVER:
				return driver != null;
			case ServerPackage.DEVICE__ADDRESS:
				return ADDRESS_EDEFAULT == null ? address != null : !ADDRESS_EDEFAULT.equals(address);
			case ServerPackage.DEVICE__ACTUAL_ERROR:
				return ACTUAL_ERROR_EDEFAULT == null ? actualError != null : !ACTUAL_ERROR_EDEFAULT.equals(actualError);
			case ServerPackage.DEVICE__USER_DATA_STAMP:
				return userDataStamp != USER_DATA_STAMP_EDEFAULT;
			case ServerPackage.DEVICE__SYSTEM_DATA_STAMP:
				return systemDataStamp != SYSTEM_DATA_STAMP_EDEFAULT;
			case ServerPackage.DEVICE__TRANSACTION:
				return transaction != TRANSACTION_EDEFAULT;
			case ServerPackage.DEVICE__DEVICE_UPDATE_LISTENERS:
				return deviceUpdateListeners != null && !deviceUpdateListeners.isEmpty();
			case ServerPackage.DEVICE__LINK_USER_DATA_STAMP:
				return linkUserDataStamp != null;
			case ServerPackage.DEVICE__LINK_SYSTEM_DATA_STAMP:
				return linkSystemDataStamp != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (tineDevice: ");
		result.append(tineDevice);
		result.append(", name: ");
		result.append(name);
		result.append(", address: ");
		result.append(address);
		result.append(", actualError: ");
		result.append(actualError);
		result.append(", userDataStamp: ");
		result.append(userDataStamp);
		result.append(", systemDataStamp: ");
		result.append(systemDataStamp);
		result.append(", transaction: ");
		result.append(transaction);
		result.append(", deviceUpdateListeners: ");
		result.append(deviceUpdateListeners);
		result.append(')');
		return result.toString();
	}
	
	public static final String DRIVER_FACTORY = "ch.thomson.ucs.tine.server.driver_factory";
	
	private Driver getDriverFromExtensionPoint() {
		
		Driver driver = null;
		
		IConfigurationElement[] config = Platform.getExtensionRegistry().getConfigurationElementsFor(DRIVER_FACTORY);
		
		try {
			for (IConfigurationElement e : config) {
				Object o = e.createExecutableExtension("class");
				if(o instanceof IDriverFactory) {
					IDriverFactory driverFactory = (IDriverFactory) o;
					
					if(this.getEquipmentModule().getDriverType().equals(driverFactory.getDriverType())) {						
							driver = driverFactory.createDriver();
							driver.setAddress(this.getAddress());
					}					
				}
			}
		} catch(CoreException e) {
			e.printStackTrace();
		}
		
		return driver;
	}
	
	private int getDataStampValue(PropertyInt32 p, DataTable d) {
		int result = 0;
		
		if(p != null) {
			if(findDataTable(p.getDataTableName()) == d) {
				result = ((int[])((RealPropertyImpl) p).readNonCachedData(d))[0];
			}
		} 

		return result;
	}
	
} //DeviceImpl
