/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.Driver;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.ServerPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * Diese abstrakte Klasse muss durch eine konkrete Treiberklasse erweitert werden.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DriverImpl#getDevice <em>Device</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.DriverImpl#getAddress <em>Address</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class DriverImpl extends EObjectImpl implements Driver {
	/**
	 * The default value of the '{@link #getAddress() <em>Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress()
	 * @generated
	 * @ordered
	 */
	protected static final String ADDRESS_EDEFAULT = null;
	/**
	 * The cached value of the '{@link #getAddress() <em>Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddress()
	 * @generated
	 * @ordered
	 */
	protected String address = ADDRESS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DriverImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.DRIVER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Device getDevice() {
		if (eContainerFeatureID() != ServerPackage.DRIVER__DEVICE) return null;
		return (Device)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDevice(Device newDevice, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newDevice, ServerPackage.DRIVER__DEVICE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDevice(Device newDevice) {
		if (newDevice != eInternalContainer() || (eContainerFeatureID() != ServerPackage.DRIVER__DEVICE && newDevice != null)) {
			if (EcoreUtil.isAncestor(this, newDevice))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newDevice != null)
				msgs = ((InternalEObject)newDevice).eInverseAdd(this, ServerPackage.DEVICE__DRIVER, Device.class, msgs);
			msgs = basicSetDevice(newDevice, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DRIVER__DEVICE, newDevice, newDevice));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAddress() {
		return address;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAddress(String newAddress) {
		String oldAddress = address;
		address = newAddress;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.DRIVER__ADDRESS, oldAddress, address));
	}

	/**
	 * <!-- begin-user-doc --> Diese Methode wird einmalig in der
	 * Initialisierungsphase des TINE-Servers aufgerufen. Hier kann der Treiber
	 * die ntigen Initialisierungsschritte erledigen.
	 * 
	 * @throws Exception
	 *             Falls ein Fehler auftritt, soll dies mit einer geworfenen
	 *             Exception gemeldet werden. <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public abstract void initialize() throws Exception;

	/**
	 * <!-- begin-user-doc --> Diese Methode wird aufgerufen, wenn der
	 * TINE-Server neue Daten von einem Client empfangen und diese in die
	 * entsprechende DataTable geschrieben hat. Der Treiber muss nun den neuen
	 * Datensatz an die Hardware weiterreichen.
	 * <p>
	 * Das DataTable Objekt beinhaltet eine Liste mit allen Properties, die
	 * diese DataTable referenzieren. Diese Property-Liste kann gebenenfalls
	 * iteriert werden und jede einzelne Property ber die Methode isDirty()
	 * abgefragt werden, ob sie neu geschrieben wurde. Dadurch kann festgestellt
	 * werden, ob die ganze Datentabelle oder nur der Teilbereich der Property
	 * auf die Hardware geschrieben wird. Somit ist es auch mglich, eine
	 * Typenwandlung durchzufhren, wenn beispielsweise ein Bit auf der Hardware
	 * in der entsprechenden Property als ganzes Byte reprsentiert ist.
	 * 
	 * @param dataTable
	 *            Die Datentabelle (Speicherabbild), an welcher die nderungen
	 *            vorgenommen wurde.
	 * 
	 * @throws Exception
	 *             Im Falle eines Fehlers muss der Treiber eine Exception
	 *             werfen. <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract void writeData(DataTable dataTable) throws Exception; 

	/**
	 * <!-- begin-user-doc -->
	 * Diese Methode wird einmalig in der Initialisierungsphase des TINE-Servers aufgerufen. Der Treiber bekommt 
	 * so die Mglichkeit, den Adress-String fr jede registrierte Property zu parsen. Fr die geparsten Daten kann der Treiber 
	 * beispielsweise eine eigene Klasse implementieren, diese Instanzieren, die Daten darin ablegen und anschliessend 
	 * die Objektreferenz in der Property speichern (@see {@link RealProperty#setUserDefinedAddressObject(Object)}). 
	 * @param realProperty Die Property, bei welcher der Adress-String geparst werden soll.
	 * @throws Exception Im Falle eines Fehlers muss der Treiber eine Exception werfen.
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract void parseAddressString(RealProperty realProperty) throws Exception;

	/**
	 * <!-- begin-user-doc --> Diese Methode wird zyklisch fr jede registrierte
	 * DataTable aufgerufen. Die Zykluszeit wird ber Device Polling Rate im
	 * {@link EquipmentModule} festgelegt. Der Treiber muss die Daten von der
	 * Hardware lesen und diese in die DataTable schreiben. Falls
	 * property-abhngige Informationen bentigt werden, kann die Liste der
	 * beteiligten Properties von der DataTable geholt werden (@link
	 * {@link DataTable#getProperties()}). </br>Wenn der Rckgabewert dieser
	 * Methode gleich 0 ist, gibt es keine weiteren Daten zum Lesen. Wenn der
	 * Rckgabewert grsser 0 ist, sind noch weitere Daten zu lesen
	 * (beispielsweise im FIFO des Gerts). Der Treiber ruft dann die Methode
	 * solange in einer Schlaufe auf, bis eine 0 zurckgeben wird (FIFO_LEER).
	 * Achtung: Falls das Gert kein FIFO hat, muss unbedingt immer eine 0
	 * zurckgeben werden!
	 * 
	 * @param dataTable
	 *            Datentabelle, welche aktualisiert werden soll.
	 * @return int Wert gleich 0: Keine Daten mehr zum Lesen. Wert grsser 0: Es
	 *         hat noch Daten zum Lesen
	 * @throws Exception
	 *             Im Falle eines Fehlers muss der Treiber eine Exception
	 *             werfen. <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract int readData(DataTable dataTable) throws Exception;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.DRIVER__DEVICE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetDevice((Device)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.DRIVER__DEVICE:
				return basicSetDevice(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ServerPackage.DRIVER__DEVICE:
				return eInternalContainer().eInverseRemove(this, ServerPackage.DEVICE__DRIVER, Device.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.DRIVER__DEVICE:
				return getDevice();
			case ServerPackage.DRIVER__ADDRESS:
				return getAddress();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.DRIVER__DEVICE:
				setDevice((Device)newValue);
				return;
			case ServerPackage.DRIVER__ADDRESS:
				setAddress((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.DRIVER__DEVICE:
				setDevice((Device)null);
				return;
			case ServerPackage.DRIVER__ADDRESS:
				setAddress(ADDRESS_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.DRIVER__DEVICE:
				return getDevice() != null;
			case ServerPackage.DRIVER__ADDRESS:
				return ADDRESS_EDEFAULT == null ? address != null : !ADDRESS_EDEFAULT.equals(address);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (address: ");
		result.append(address);
		result.append(')');
		return result.toString();
	}

} //DriverImpl
