/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import ch.thomson.ucs.tine.server.EquipmentModule;
import ch.thomson.ucs.tine.server.FrontEndController;
import ch.thomson.ucs.tine.server.PropertyNumeric;
import ch.thomson.ucs.tine.server.RealPropertyDAO;
import ch.thomson.ucs.tine.server.ServerFactory;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.tine.server.util.Activator;
import ch.thomson.ucs.tine.server.util.UCSConfig;
import de.desy.tine.server.connections.TClient;
import de.desy.tine.server.equipment.TEquipmentModuleFactory;
import de.desy.tine.startup.TInitializerFactory;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Front End Controller</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getTineEquipmentModuleFactory <em>Tine Equipment Module Factory</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getEquipmentModules <em>Equipment Modules</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getSubSystemName <em>Sub System Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getContextName <em>Context Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getLocation <em>Location</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getLocalValue <em>Local Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#isLocalMode <em>Local Mode</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#isAccessAllowed <em>Access Allowed</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getAllowedHostsForLocalAccess <em>Allowed Hosts For Local Access</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#getLockWriteProperty <em>Lock Write Property</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#isWriteLocked <em>Write Locked</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl#isLocalCaller <em>Local Caller</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FrontEndControllerImpl extends EObjectImpl implements FrontEndController {
	/**
	 * The default value of the '{@link #getTineEquipmentModuleFactory() <em>Tine Equipment Module Factory</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineEquipmentModuleFactory()
	 * @generated
	 * @ordered
	 */
	protected static final TEquipmentModuleFactory TINE_EQUIPMENT_MODULE_FACTORY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTineEquipmentModuleFactory() <em>Tine Equipment Module Factory</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineEquipmentModuleFactory()
	 * @generated
	 * @ordered
	 */
	protected TEquipmentModuleFactory tineEquipmentModuleFactory = TINE_EQUIPMENT_MODULE_FACTORY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getEquipmentModules() <em>Equipment Modules</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEquipmentModules()
	 * @generated
	 * @ordered
	 */
	protected EList<EquipmentModule> equipmentModules;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getSubSystemName() <em>Sub System Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubSystemName()
	 * @generated
	 * @ordered
	 */
	protected static final String SUB_SYSTEM_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSubSystemName() <em>Sub System Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubSystemName()
	 * @generated
	 * @ordered
	 */
	protected String subSystemName = SUB_SYSTEM_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getContextName() <em>Context Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContextName()
	 * @generated
	 * @ordered
	 */
	protected static final String CONTEXT_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getContextName() <em>Context Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContextName()
	 * @generated
	 * @ordered
	 */
	protected String contextName = CONTEXT_NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getLocation() <em>Location</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocation()
	 * @generated
	 * @ordered
	 */
	protected PropertyNumeric location;

	/**
	 * The default value of the '{@link #getLocalValue() <em>Local Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocalValue()
	 * @generated
	 * @ordered
	 */
	protected static final int LOCAL_VALUE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getLocalValue() <em>Local Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocalValue()
	 * @generated
	 * @ordered
	 */
	protected int localValue = LOCAL_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #isLocalMode() <em>Local Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLocalMode()
	 * @generated
	 * @ordered
	 */
	protected static final boolean LOCAL_MODE_EDEFAULT = false;

	/**
	 * The default value of the '{@link #isAccessAllowed() <em>Access Allowed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAccessAllowed()
	 * @generated
	 * @ordered
	 */
	protected static final boolean ACCESS_ALLOWED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #getAllowedHostsForLocalAccess() <em>Allowed Hosts For Local Access</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAllowedHostsForLocalAccess()
	 * @generated
	 * @ordered
	 */
	protected EList<String> allowedHostsForLocalAccess;

	/**
	 * The cached value of the '{@link #getLockWriteProperty() <em>Lock Write Property</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLockWriteProperty()
	 * @generated
	 * @ordered
	 */
	protected PropertyNumeric lockWriteProperty;

	/**
	 * The default value of the '{@link #isWriteLocked() <em>Write Locked</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWriteLocked()
	 * @generated
	 * @ordered
	 */
	protected static final boolean WRITE_LOCKED_EDEFAULT = false;

	/**
	 * The default value of the '{@link #isLocalCaller() <em>Local Caller</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLocalCaller()
	 * @generated
	 * @ordered
	 */
	protected static final boolean LOCAL_CALLER_EDEFAULT = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FrontEndControllerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.FRONT_END_CONTROLLER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TEquipmentModuleFactory getTineEquipmentModuleFactory() {
		return tineEquipmentModuleFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<EquipmentModule> getEquipmentModules() {
		if (equipmentModules == null) {
			equipmentModules = new EObjectContainmentWithInverseEList<EquipmentModule>(EquipmentModule.class, this, ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES, ServerPackage.EQUIPMENT_MODULE__FRONT_END_CONTROLLER);
		}
		return equipmentModules;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.FRONT_END_CONTROLLER__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getSubSystemName() {
		return subSystemName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSubSystemName(String newSubSystemName) {
		String oldSubSystemName = subSystemName;
		subSystemName = newSubSystemName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.FRONT_END_CONTROLLER__SUB_SYSTEM_NAME, oldSubSystemName, subSystemName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getContextName() {
		return contextName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContextName(String newContextName) {
		String oldContextName = contextName;
		contextName = newContextName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.FRONT_END_CONTROLLER__CONTEXT_NAME, oldContextName, contextName));
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyNumeric getLocation() {
		if (location != null && location.eIsProxy()) {
			InternalEObject oldLocation = (InternalEObject)location;
			location = (PropertyNumeric)eResolveProxy(oldLocation);
			if (location != oldLocation) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServerPackage.FRONT_END_CONTROLLER__LOCATION, oldLocation, location));
			}
		}
		return location;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyNumeric basicGetLocation() {
		return location;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLocation(PropertyNumeric newLocation) {
		PropertyNumeric oldLocation = location;
		location = newLocation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.FRONT_END_CONTROLLER__LOCATION, oldLocation, location));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getLocalValue() {
		return localValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLocalValue(int newLocalValue) {
		int oldLocalValue = localValue;
		localValue = newLocalValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.FRONT_END_CONTROLLER__LOCAL_VALUE, oldLocalValue, localValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isLocalMode() {
		return this.getLocation().getValuesAsInt(getLocation().getEquipmentModule().getDevices().get(0))[0] == this.getLocalValue();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isAccessAllowed() {
		TClient caller = TEquipmentModuleFactory.getCaller();
		if(caller == null)
			return false;
	
		return !(isLocalCaller() ^ isLocalMode());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getAllowedHostsForLocalAccess() {
		if (allowedHostsForLocalAccess == null) {
			allowedHostsForLocalAccess = new EDataTypeUniqueEList<String>(String.class, this, ServerPackage.FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS);
		}
		return allowedHostsForLocalAccess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyNumeric getLockWriteProperty() {
		if (lockWriteProperty != null && lockWriteProperty.eIsProxy()) {
			InternalEObject oldLockWriteProperty = (InternalEObject)lockWriteProperty;
			lockWriteProperty = (PropertyNumeric)eResolveProxy(oldLockWriteProperty);
			if (lockWriteProperty != oldLockWriteProperty) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ServerPackage.FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY, oldLockWriteProperty, lockWriteProperty));
			}
		}
		return lockWriteProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyNumeric basicGetLockWriteProperty() {
		return lockWriteProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLockWriteProperty(PropertyNumeric newLockWriteProperty) {
		PropertyNumeric oldLockWriteProperty = lockWriteProperty;
		lockWriteProperty = newLockWriteProperty;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY, oldLockWriteProperty, lockWriteProperty));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isWriteLocked() {
		if(this.getLockWriteProperty() == null)
			return false;
		return this.getLockWriteProperty().getValuesAsInt(getLockWriteProperty().getEquipmentModule().getDevices().get(0))[0] != 0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isLocalCaller() {
		TClient caller = TEquipmentModuleFactory.getCaller();
		if(caller == null)
			return true; // Es ist ein interner Aufruf durch den Server selbst
		
		// Ist es ein lokaler Host?
		try {
			if (NetworkInterface.getByInetAddress(caller.IPaddress) != null)
				return true;
		} catch (SocketException e) {
			// Nichts tun
		}

		// Liste der zustzlich erlaubten Remote Hosts, die als "lokale" Benutzer agieren, checken
		for (String local : this.getAllowedHostsForLocalAccess()) {
			// IP-Adresse prfen
			if (local.equals(caller.IPaddress))
				return true;
			// Hostname prfen
			if (local.equals(caller.IPaddress))
				return true;
		}

		return false;
	}

	private boolean initialized = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public synchronized void initialize() throws Exception {
		if(!initialized) {
			TInitializerFactory.getInstance().getInitializer().setSrvSndBufferSize(100000); 
			TEquipmentModuleFactory.setRenewalLength((short) 2000);
			tineEquipmentModuleFactory = TEquipmentModuleFactory.getInstance();
			
			UCSConfig config = UCSConfig.getInstance();
			
			// Wenn ein Ini-File vorhanden ist, diese Namen verwenden
			if(config.hasIniFile()) {
				this.setName(config.getFecName());
				this.setContextName(config.getContextName());
				this.setSubSystemName(config.getFecSubSystem());
			}
			
			else {		
				// Local Host ermitteln
				InetAddress addr = InetAddress.getLocalHost();
				
				// Kein FecName konfiguriert? -> Hostname verwenden
				if(this.getName() == null || "".equals(this.getName()))
					this.setName(addr.getHostName());
				
				// Kein ContextName konfiguriert? -> Hostname verwenden
				if(this.getContextName() == null || "".equals(this.getContextName()))
					this.setContextName(addr.getHostName());
			}
			
			tineEquipmentModuleFactory.setFecContext(this.getContextName());
			tineEquipmentModuleFactory.setFecName(this.getName());
			tineEquipmentModuleFactory.setFecSubsystem(this.getSubSystemName());
			
			tineEquipmentModuleFactory.setFecDescription(config.getFecDescription());
			tineEquipmentModuleFactory.setFecResponsible(config.getFecResponsible());
			tineEquipmentModuleFactory.setFecLocation(config.getFecLocation());
	
			for (EquipmentModule eqm : this.getEquipmentModules()) {
				eqm.initialize();
			}
			
			// Verwaiste Eintrge aus der Datenbank entfernen.
			getDefaultRealPropertyDAO().clean();
			initialized = true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void run() {
		tineEquipmentModuleFactory.systemInit(19);
		
		/*
		 * TODO: Muss das in RCP wirklich ber einen Shutdown-Hook gemacht werden?
		 */
		Runtime.getRuntime().addShutdownHook(new Thread(new Runnable() {
			@Override
			public void run() {
				shutdown();
			}
		}));
		
		tineEquipmentModuleFactory.systemWait(-1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void shutdown() {
		// TODO: Sollte die TINE Engine auch sauber beendet werden? Leider bleibt aber diese Scheisse hngen...
		// tineEquipmentModuleFactory.shutdown();
		try {
			getDefaultRealPropertyDAO().close();
				
		} catch (Exception e) {
			Activator.getLogger().error(e);
		}
	}

	private Map<String, EquipmentModule> eqmCacheMap = null;
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public EquipmentModule findEquipmentModule(String exportName) {
		if(eqmCacheMap == null) {
			eqmCacheMap = new HashMap<String, EquipmentModule>();
		}
		
		EquipmentModule eqm = eqmCacheMap.get(exportName);
		
		if(eqm != null)
			return eqm;
		
		// Nicht im Cache, muss also gesucht werden, und abgelegt werden.
		for(EquipmentModule e : this.getEquipmentModules()) {
			if(e.getExportName().equals(exportName)) {
				eqmCacheMap.put(e.getExportName(), e);
				eqm = e;
				break;
			}
		}
		
		return eqm;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getEquipmentModules()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES:
				return ((InternalEList<?>)getEquipmentModules()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.FRONT_END_CONTROLLER__TINE_EQUIPMENT_MODULE_FACTORY:
				return getTineEquipmentModuleFactory();
			case ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES:
				return getEquipmentModules();
			case ServerPackage.FRONT_END_CONTROLLER__NAME:
				return getName();
			case ServerPackage.FRONT_END_CONTROLLER__SUB_SYSTEM_NAME:
				return getSubSystemName();
			case ServerPackage.FRONT_END_CONTROLLER__CONTEXT_NAME:
				return getContextName();
			case ServerPackage.FRONT_END_CONTROLLER__LOCATION:
				if (resolve) return getLocation();
				return basicGetLocation();
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_VALUE:
				return getLocalValue();
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_MODE:
				return isLocalMode();
			case ServerPackage.FRONT_END_CONTROLLER__ACCESS_ALLOWED:
				return isAccessAllowed();
			case ServerPackage.FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS:
				return getAllowedHostsForLocalAccess();
			case ServerPackage.FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY:
				if (resolve) return getLockWriteProperty();
				return basicGetLockWriteProperty();
			case ServerPackage.FRONT_END_CONTROLLER__WRITE_LOCKED:
				return isWriteLocked();
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_CALLER:
				return isLocalCaller();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES:
				getEquipmentModules().clear();
				getEquipmentModules().addAll((Collection<? extends EquipmentModule>)newValue);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__NAME:
				setName((String)newValue);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__SUB_SYSTEM_NAME:
				setSubSystemName((String)newValue);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__CONTEXT_NAME:
				setContextName((String)newValue);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__LOCATION:
				setLocation((PropertyNumeric)newValue);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_VALUE:
				setLocalValue((Integer)newValue);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS:
				getAllowedHostsForLocalAccess().clear();
				getAllowedHostsForLocalAccess().addAll((Collection<? extends String>)newValue);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY:
				setLockWriteProperty((PropertyNumeric)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES:
				getEquipmentModules().clear();
				return;
			case ServerPackage.FRONT_END_CONTROLLER__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__SUB_SYSTEM_NAME:
				setSubSystemName(SUB_SYSTEM_NAME_EDEFAULT);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__CONTEXT_NAME:
				setContextName(CONTEXT_NAME_EDEFAULT);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__LOCATION:
				setLocation((PropertyNumeric)null);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_VALUE:
				setLocalValue(LOCAL_VALUE_EDEFAULT);
				return;
			case ServerPackage.FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS:
				getAllowedHostsForLocalAccess().clear();
				return;
			case ServerPackage.FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY:
				setLockWriteProperty((PropertyNumeric)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.FRONT_END_CONTROLLER__TINE_EQUIPMENT_MODULE_FACTORY:
				return TINE_EQUIPMENT_MODULE_FACTORY_EDEFAULT == null ? tineEquipmentModuleFactory != null : !TINE_EQUIPMENT_MODULE_FACTORY_EDEFAULT.equals(tineEquipmentModuleFactory);
			case ServerPackage.FRONT_END_CONTROLLER__EQUIPMENT_MODULES:
				return equipmentModules != null && !equipmentModules.isEmpty();
			case ServerPackage.FRONT_END_CONTROLLER__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ServerPackage.FRONT_END_CONTROLLER__SUB_SYSTEM_NAME:
				return SUB_SYSTEM_NAME_EDEFAULT == null ? subSystemName != null : !SUB_SYSTEM_NAME_EDEFAULT.equals(subSystemName);
			case ServerPackage.FRONT_END_CONTROLLER__CONTEXT_NAME:
				return CONTEXT_NAME_EDEFAULT == null ? contextName != null : !CONTEXT_NAME_EDEFAULT.equals(contextName);
			case ServerPackage.FRONT_END_CONTROLLER__LOCATION:
				return location != null;
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_VALUE:
				return localValue != LOCAL_VALUE_EDEFAULT;
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_MODE:
				return isLocalMode() != LOCAL_MODE_EDEFAULT;
			case ServerPackage.FRONT_END_CONTROLLER__ACCESS_ALLOWED:
				return isAccessAllowed() != ACCESS_ALLOWED_EDEFAULT;
			case ServerPackage.FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS:
				return allowedHostsForLocalAccess != null && !allowedHostsForLocalAccess.isEmpty();
			case ServerPackage.FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY:
				return lockWriteProperty != null;
			case ServerPackage.FRONT_END_CONTROLLER__WRITE_LOCKED:
				return isWriteLocked() != WRITE_LOCKED_EDEFAULT;
			case ServerPackage.FRONT_END_CONTROLLER__LOCAL_CALLER:
				return isLocalCaller() != LOCAL_CALLER_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (tineEquipmentModuleFactory: ");
		result.append(tineEquipmentModuleFactory);
		result.append(", name: ");
		result.append(name);
		result.append(", subSystemName: ");
		result.append(subSystemName);
		result.append(", contextName: ");
		result.append(contextName);
		result.append(", localValue: ");
		result.append(localValue);
		result.append(", allowedHostsForLocalAccess: ");
		result.append(allowedHostsForLocalAccess);
		result.append(')');
		return result.toString();
	}
	
	static public final String DEFAULT_DB_CONNECTION_STRING = "jdbc:postgresql://localhost/ucs";
	
	private static RealPropertyDAO defaultRealPropertyDAO = null;
	
	public static synchronized RealPropertyDAO getDefaultRealPropertyDAO() throws Exception {
		if(defaultRealPropertyDAO == null) {
			defaultRealPropertyDAO = createAndOpenRealPropertyDAO(DEFAULT_DB_CONNECTION_STRING);
		}
		return defaultRealPropertyDAO;
	}
	
	public static RealPropertyDAO createAndOpenRealPropertyDAO(String path) throws Exception {
		RealPropertyDAO dao = ServerFactory.eINSTANCE.createRealPropertyDAO_Postgres();
		dao.open(path);
		return dao;
	}

} //FrontEndControllerImpl
