/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.GroupProperty;
import ch.thomson.ucs.tine.server.Observable;
import ch.thomson.ucs.tine.server.Property;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.ServerPackage;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Group Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.GroupPropertyImpl#getProperties <em>Properties</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class GroupPropertyImpl extends PropertyImpl implements GroupProperty {
	/**
	 * The cached value of the '{@link #getProperties() <em>Properties</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProperties()
	 * @generated
	 * @ordered
	 */
	protected EList<Property> properties;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GroupPropertyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.GROUP_PROPERTY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Property> getProperties() {
		if (properties == null) {
			properties = new EObjectResolvingEList<Property>(Property.class, this, ServerPackage.GROUP_PROPERTY__PROPERTIES);
		}
		return properties;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update(Observable observable) {
		this.notifyObservers();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.GROUP_PROPERTY__PROPERTIES:
				return getProperties();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.GROUP_PROPERTY__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection<? extends Property>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.GROUP_PROPERTY__PROPERTIES:
				getProperties().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.GROUP_PROPERTY__PROPERTIES:
				return properties != null && !properties.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	@Override
	public short getTineTypeCode() {
		return TFormat.CF_FLOAT;
	}

	@Override
	public int writeData(Device device, TDataType din) {
		return TErrorList.not_implemented;
	}
	
	private float[] groupedValues;

	@Override
	public int readData(Device device, TDataType dout) {
		if(groupedValues == null)
			groupedValues = new float[getLength()];
		
		int offset = 0, result;
				
		for(Property p : this.getProperties()) {
			/*
			 * Hier kommt eine hssliche Fallunterscheidung: Die TDataType
			 * Klasse von TINE kann zwar einige Datentypen casten, aber bei
			 * einer TEXT-Property kann nicht mit einem Float-Buffer ausgelesen
			 * werden. Deshalb wird dies in diesem speziellen Fall mit einem
			 * Integer-Buffer gemacht.
			 */
			if(p.getTineTypeCode() == TFormat.CF_TEXT) {
				int[] values = new int[p.getLength()];
				TDataType data = new TDataType(values);
				if((result = p.readData(device, data)) != TErrorList.success)
					return result;
				
				// Kopiere die Daten in den Gruppenpuffer
				for(int i=0; i<values.length; ++i) {
					groupedValues[i + offset] = values[i];
				}
			}
			
			else {
				float[] values = new float[p.getLength()];
				TDataType data = new TDataType(values);
				if((result = p.readData(device, data)) != TErrorList.success)
					return result;
				
				// Kopiere die Daten in den Gruppenpuffer
				for(int i=0; i<values.length; ++i) {
					groupedValues[i + offset] = values[i];
				}
			}
			
			offset += p.getLength();
		}
		
		return dout.putData(groupedValues);
	}

	@Override
	public TDataType createTDataType() {
		return new TDataType(new float[this.getLength()]);
	}

	@Override
	public void initialize() throws Exception {
		int length = 0;
		for(Property p : this.getProperties()) {
			length += p.getLength();
			
			// Bei den RealProperties den Observer bei der DataTable registrieren
			if(p instanceof RealProperty) {
				RealProperty rp = (RealProperty) p;
				String dataTableName = rp.getDataTableName();
				
				for(Device d : this.getEquipmentModule().getDevices()) {
					d.findDataTable(dataTableName).addObserver(this);
				}
			}
			
			// Sonst den Observer direkt bei der Property registrieren
			else {
				p.addObserver(this);
			}
		}
		
		this.setLength(length);		
		super.initialize();
	}
} //GroupPropertyImpl
