/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.io.IOException;

import org.eclipse.emf.ecore.EClass;

import ch.thomson.ucs.tine.server.PropertyByte;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.utils.logic.ByteOrderedDataInputStream;
import ch.thomson.ucs.utils.logic.ByteOrderedDataOutputStream;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property Byte</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class PropertyByteImpl extends RealPropertyImpl implements PropertyByte {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyByteImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.PROPERTY_BYTE;
	}

	@Override
	public short getTineTypeCode() {
		return TFormat.CF_BYTE;
	}

	@Override
	public int write(TDataType din, ByteOrderedDataOutputStream dos) throws IOException {
		int result = 0;
		
		byte[] values = new byte[din.getArrayLength()];
		
		if ((result = din.getData(values)) == 0) {
			for (byte val : values) {
				
				// Range Check
				if(isOutOfRange(val))
					return TErrorList.out_of_range;
				
				dos.writeByte(val);
			}
		}
		
		return result;
	}

	@Override
	public void read(ByteOrderedDataInputStream source, Object target) throws IOException {
		byte[] values = (byte[]) target;
		
		for(int i=0; i<values.length; i++) {
			values[i] = source.readByte();
		}
	}

	@Override
	public TDataType createTDataType() {
		return new TDataType(new byte[this.getLength()]);
	}

	@Override
	public TDataType getDefaultValueAsTDataType() {
		byte[] values = new byte[getLength()];
		for(int i=0; i<values.length; ++i)
			values[i] = Byte.parseByte(getDefaultValue());
		return new TDataType(values);
	}

	@Override
	public Object createDataCacheBuffer() {
		return new byte[getLength()];
	}

} //PropertyByteImpl
