/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.io.IOException;

import org.eclipse.emf.ecore.EClass;

import ch.thomson.ucs.tine.server.PropertyDouble;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.utils.logic.ByteOrderedDataInputStream;
import ch.thomson.ucs.utils.logic.ByteOrderedDataOutputStream;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property Double</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class PropertyDoubleImpl extends PropertyNumericImpl implements PropertyDouble {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyDoubleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.PROPERTY_DOUBLE;
	}

	@Override
	public short getTineTypeCode() {
		return TFormat.CF_DOUBLE;
	}

	@Override
	public int write(TDataType din, ByteOrderedDataOutputStream dos) throws IOException {
		int result = 0;
		double[] values = new double[din.getArrayLength()];
		if ((result = din.getData(values)) == 0) {
			for (double val : values) {

				// Range Check
				if (isOutOfRange((float) val))
					return TErrorList.out_of_range;

				dos.writeDouble(roundScale(val * getFactor() + getOffset()));
			}
		}

		return result;
	}

	@Override
	public void read(ByteOrderedDataInputStream source, Object target) throws IOException {
		double[] values = (double[]) target;

		for (int i = 0; i < values.length; i++) {
			values[i] = roundScale((source.readDouble() - getOffset()) / getFactor());
		}
	}

	@Override
	public TDataType createTDataType() {
		return new TDataType(new double[this.getLength()]);
	}

	@Override
	public Object createDataCacheBuffer() {
		return new double[getLength()];
	}

} //PropertyDoubleImpl
