/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.io.IOException;

import org.eclipse.emf.ecore.EClass;

import ch.thomson.ucs.tine.server.PropertyFloat;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.utils.logic.ByteOrderedDataInputStream;
import ch.thomson.ucs.utils.logic.ByteOrderedDataOutputStream;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property Float</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class PropertyFloatImpl extends PropertyNumericImpl implements PropertyFloat {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyFloatImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.PROPERTY_FLOAT;
	}
	
	private double[] writeBuffer;
	
	private double[] getWriteBuffer(int size) {
		
		if(writeBuffer == null || writeBuffer.length != size)
			writeBuffer = new double[size];
		
		return writeBuffer;
	}

	@Override
	public synchronized int write(TDataType din, ByteOrderedDataOutputStream dos) throws IOException {
		int result = 0;
		
		double[] values = getWriteBuffer(din.getArrayLength());
		
		if ((result = din.getData(values)) == 0) {
			for (double val : values) {

				// Range Check
				if (isOutOfRange((float) val))
					return TErrorList.out_of_range;

				dos.writeFloat((float) roundScale(val * getFactor() + getOffset()));
			}
		}

		return result;
	}

	@Override
	public void read(ByteOrderedDataInputStream source, Object target) throws IOException {
		double[] values = (double[]) target;

		for (int i = 0; i < values.length; i++) {
			values[i] = roundScale(((double) source.readFloat() - getOffset()) / getFactor());
		}
	}

	@Override
	public short getTineTypeCode() {
		return TFormat.CF_FLOAT;
	}

	@Override
	public TDataType createTDataType() {
		return new TDataType(new float[this.getLength()]);
	}

	@Override
	public Object createDataCacheBuffer() {
		return new double[getLength()];
	}

} //PropertyFloatImpl
