/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.util.Collection;

import org.apache.log4j.Logger;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;

import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.EquipmentModule;
import ch.thomson.ucs.tine.server.FrontEndController;
import ch.thomson.ucs.tine.server.Observer;
import ch.thomson.ucs.tine.server.Property;
import ch.thomson.ucs.tine.server.PropertyNumeric;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.tine.server.TineAccess;
import ch.thomson.ucs.tine.server.util.UCSConfig;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TAccess;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.server.connections.TClient;
import de.desy.tine.server.equipment.TEquipmentModuleFactory;
import de.desy.tine.server.properties.TExportProperty;
import de.desy.tine.server.properties.TPropertyDescription;
import de.desy.tine.server.properties.TPropertyHandler;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getObservers <em>Observers</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getTineExportProperty <em>Tine Export Property</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getEquipmentModule <em>Equipment Module</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getTinePropertyHandler <em>Tine Property Handler</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getName <em>Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getTineAccess <em>Tine Access</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getLength <em>Length</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getMinimumValue <em>Minimum Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getMaximumValue <em>Maximum Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getUnit <em>Unit</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#isWritable <em>Writable</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getLogonLevel <em>Logon Level</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getMaxState <em>Max State</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#isScheduled <em>Scheduled</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyImpl#getRefreshRate <em>Refresh Rate</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class PropertyImpl extends EObjectImpl implements Property {
	/**
	 * The cached value of the '{@link #getObservers() <em>Observers</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObservers()
	 * @generated
	 * @ordered
	 */
	protected EList<Observer> observers;

	/**
	 * The default value of the '{@link #getTineExportProperty() <em>Tine Export Property</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineExportProperty()
	 * @generated
	 * @ordered
	 */
	protected static final TExportProperty TINE_EXPORT_PROPERTY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTineExportProperty() <em>Tine Export Property</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineExportProperty()
	 * @generated
	 * @ordered
	 */
	protected TExportProperty tineExportProperty = TINE_EXPORT_PROPERTY_EDEFAULT;

	/**
	 * The default value of the '{@link #getTinePropertyHandler() <em>Tine Property Handler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTinePropertyHandler()
	 * @generated
	 * @ordered
	 */
	protected static final TPropertyHandler TINE_PROPERTY_HANDLER_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTinePropertyHandler() <em>Tine Property Handler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTinePropertyHandler()
	 * @generated
	 * @ordered
	 */
	protected TPropertyHandler tinePropertyHandler = TINE_PROPERTY_HANDLER_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = "No description";

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getTineAccess() <em>Tine Access</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineAccess()
	 * @generated
	 * @ordered
	 */
	protected static final TineAccess TINE_ACCESS_EDEFAULT = TineAccess.READ;

	/**
	 * The cached value of the '{@link #getTineAccess() <em>Tine Access</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTineAccess()
	 * @generated
	 * @ordered
	 */
	protected TineAccess tineAccess = TINE_ACCESS_EDEFAULT;

	/**
	 * The default value of the '{@link #getLength() <em>Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLength()
	 * @generated
	 * @ordered
	 */
	protected static final int LENGTH_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getLength() <em>Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLength()
	 * @generated
	 * @ordered
	 */
	protected int length = LENGTH_EDEFAULT;

	/**
	 * The default value of the '{@link #getMinimumValue() <em>Minimum Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinimumValue()
	 * @generated
	 * @ordered
	 */
	protected static final float MINIMUM_VALUE_EDEFAULT = -2.14748365E9F;

	/**
	 * The cached value of the '{@link #getMinimumValue() <em>Minimum Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinimumValue()
	 * @generated
	 * @ordered
	 */
	protected float minimumValue = MINIMUM_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaximumValue() <em>Maximum Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaximumValue()
	 * @generated
	 * @ordered
	 */
	protected static final float MAXIMUM_VALUE_EDEFAULT = 2.14748365E9F;

	/**
	 * The cached value of the '{@link #getMaximumValue() <em>Maximum Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaximumValue()
	 * @generated
	 * @ordered
	 */
	protected float maximumValue = MAXIMUM_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getUnit() <em>Unit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnit()
	 * @generated
	 * @ordered
	 */
	protected static final String UNIT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUnit() <em>Unit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnit()
	 * @generated
	 * @ordered
	 */
	protected String unit = UNIT_EDEFAULT;

	/**
	 * The default value of the '{@link #isWritable() <em>Writable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWritable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean WRITABLE_EDEFAULT = false;

	/**
	 * The default value of the '{@link #getLogonLevel() <em>Logon Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLogonLevel()
	 * @generated
	 * @ordered
	 */
	protected static final int LOGON_LEVEL_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getLogonLevel() <em>Logon Level</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLogonLevel()
	 * @generated
	 * @ordered
	 */
	protected int logonLevel = LOGON_LEVEL_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxState() <em>Max State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxState()
	 * @generated
	 * @ordered
	 */
	protected static final int MAX_STATE_EDEFAULT = 2147483647;

	/**
	 * The cached value of the '{@link #getMaxState() <em>Max State</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxState()
	 * @generated
	 * @ordered
	 */
	protected int maxState = MAX_STATE_EDEFAULT;

	/**
	 * The default value of the '{@link #isScheduled() <em>Scheduled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isScheduled()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SCHEDULED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isScheduled() <em>Scheduled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isScheduled()
	 * @generated
	 * @ordered
	 */
	protected boolean scheduled = SCHEDULED_EDEFAULT;

	/**
	 * The default value of the '{@link #getRefreshRate() <em>Refresh Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRefreshRate()
	 * @generated
	 * @ordered
	 */
	protected static final int REFRESH_RATE_EDEFAULT = 1000;

	/**
	 * The cached value of the '{@link #getRefreshRate() <em>Refresh Rate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRefreshRate()
	 * @generated
	 * @ordered
	 */
	protected int refreshRate = REFRESH_RATE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.PROPERTY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Observer> getObservers() {
		if (observers == null) {
			observers = new EObjectResolvingEList<Observer>(Observer.class, this, ServerPackage.PROPERTY__OBSERVERS);
		}
		return observers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TExportProperty getTineExportProperty() {
		return tineExportProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EquipmentModule getEquipmentModule() {
		if (eContainerFeatureID() != ServerPackage.PROPERTY__EQUIPMENT_MODULE) return null;
		return (EquipmentModule)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEquipmentModule(EquipmentModule newEquipmentModule, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newEquipmentModule, ServerPackage.PROPERTY__EQUIPMENT_MODULE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEquipmentModule(EquipmentModule newEquipmentModule) {
		if (newEquipmentModule != eInternalContainer() || (eContainerFeatureID() != ServerPackage.PROPERTY__EQUIPMENT_MODULE && newEquipmentModule != null)) {
			if (EcoreUtil.isAncestor(this, newEquipmentModule))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newEquipmentModule != null)
				msgs = ((InternalEObject)newEquipmentModule).eInverseAdd(this, ServerPackage.EQUIPMENT_MODULE__PROPERTIES, EquipmentModule.class, msgs);
			msgs = basicSetEquipmentModule(newEquipmentModule, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__EQUIPMENT_MODULE, newEquipmentModule, newEquipmentModule));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TPropertyHandler getTinePropertyHandler() {
		return tinePropertyHandler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TineAccess getTineAccess() {
		return tineAccess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTineAccess(TineAccess newTineAccess) {
		TineAccess oldTineAccess = tineAccess;
		tineAccess = newTineAccess == null ? TINE_ACCESS_EDEFAULT : newTineAccess;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__TINE_ACCESS, oldTineAccess, tineAccess));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getLength() {
		return length;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLength(int newLength) {
		int oldLength = length;
		length = newLength;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__LENGTH, oldLength, length));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getMinimumValue() {
		return minimumValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMinimumValue(float newMinimumValue) {
		float oldMinimumValue = minimumValue;
		minimumValue = newMinimumValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__MINIMUM_VALUE, oldMinimumValue, minimumValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public float getMaximumValue() {
		return maximumValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaximumValue(float newMaximumValue) {
		float oldMaximumValue = maximumValue;
		maximumValue = newMaximumValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__MAXIMUM_VALUE, oldMaximumValue, maximumValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUnit() {
		return unit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnit(String newUnit) {
		String oldUnit = unit;
		unit = newUnit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__UNIT, oldUnit, unit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isWritable() {
		return TineAccess.READ_WRITE.equals(this.getTineAccess());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getLogonLevel() {
		return logonLevel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLogonLevel(int newLogonLevel) {
		int oldLogonLevel = logonLevel;
		logonLevel = newLogonLevel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__LOGON_LEVEL, oldLogonLevel, logonLevel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getMaxState() {
		return maxState;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxState(int newMaxState) {
		int oldMaxState = maxState;
		maxState = newMaxState;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__MAX_STATE, oldMaxState, maxState));
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isScheduled() {
		return scheduled;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setScheduled(boolean newScheduled) {
		boolean oldScheduled = scheduled;
		scheduled = newScheduled;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__SCHEDULED, oldScheduled, scheduled));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getRefreshRate() {
		return refreshRate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRefreshRate(int newRefreshRate) {
		int oldRefreshRate = refreshRate;
		refreshRate = newRefreshRate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY__REFRESH_RATE, oldRefreshRate, refreshRate));
	}

	protected static Logger logger = Logger.getLogger(Property.class);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void initialize() throws Exception {
		UCSConfig config = UCSConfig.getInstance();
		/* TINE Property erzeugen. Diese erhlt, falls es sich um eine interne Property handelt (LogonLevel > 0) einen Prefix.
		 * Dieser Prefix darf nur fr die TINE Umgebung sichtbar sein, wegen den Primary Keys fr die Datenbank. Der Prefix wird 
		 * ber das externe Ini-File festgelegt.
		 */
		this.tineExportProperty = new TExportProperty();
		this.getTineExportProperty().setName(config.getPropertyNamePrefixed(this));
		
		// TINE Spezial Syntax fr Beschreibung
		StringBuilder sb = new StringBuilder();
		sb.append("[");
		sb.append(getMinimumValue());
		sb.append(":");
		sb.append(getMaximumValue());
		if(getUnit() != null) {
			sb.append(" ");
			sb.append(getUnit());
		}
		sb.append("]");
		sb.append(this.getDescription());
		this.getTineExportProperty().setDescription(new TPropertyDescription(sb.toString()));	
		this.getTineExportProperty().getDescription().parseComplexString(sb.toString());
		
		this.getTineExportProperty().setOutputSize(this.getLength());
		this.getTineExportProperty().setInputSize(this.getLength());
		
		// Bei Numerischen Properties muss das Darstellungsformat in Abhngigkeit der Nachkommastellen eingestellt werden
		if(this instanceof PropertyNumeric) {
			int decimalPlaces = ((PropertyNumeric) this).getDecimalPlaces();
			
			if(decimalPlaces == 0) {
				// Properties ohne Nachkommastellen sollen ihr Ursprungsformat behalten
				this.getTineExportProperty().setOutputFormat(this.getTineTypeCode());
				this.getTineExportProperty().setInputFormat(this.getTineTypeCode());
			}
			else {
				// Properties mit Nachkommastellen sollen immer Floats sein
				this.getTineExportProperty().setOutputFormat(TFormat.CF_FLOAT);
				this.getTineExportProperty().setInputFormat(TFormat.CF_FLOAT);
			}
		}
		
		else {
			// Nicht numerische Properties sollen ihr Ursprungsformat behalten
			this.getTineExportProperty().setOutputFormat(this.getTineTypeCode());
			this.getTineExportProperty().setInputFormat(this.getTineTypeCode());
		}
		
		this.getTineExportProperty().setAccessMode((short) this.getTineAccess().getValue());
		this.tinePropertyHandler = new TPropertyHandler() {

			@Override
			protected int call(String devName, TDataType dout, TDataType din, TAccess devAccess) {
				// Device holen (Mapping auf internen Namen, dann Device suchen
				String internalDeviceName = UCSConfig.getInstance().getDeviceNameExternalToInternalMap().get(devName);
				Device device = getEquipmentModule().findDevice(internalDeviceName);
				if(device == null)
					return TErrorList.illegal_equipment_name;
				
				int result = 0;
				
				// Write Access
				if(din != null && devAccess.isWrite()) {
					
					EquipmentModule eqm = getEquipmentModule();
					FrontEndController fec = eqm.getFrontEndController();
					
					// Stateberwachung aktiv?
					if(eqm.getActualState() != null && eqm.getTargetState() != null) {
						int actState = eqm.getActualState().getValuesAsInt(device)[0];
						int targetState = eqm.getTargetState().getValuesAsInt(device)[0];
						int maxState = PropertyImpl.this.getMaxState();
						
						if(actState > maxState || targetState > maxState)
							return EquipmentModuleImpl.makeUserDefinedTineError(eqm, EquipmentModuleImpl.TINE_OPERATING_STATE_TOO_HIGH);
					}
					
					// LogonLevel Check fr Remote Zugriffe (notOK = !localCaller && logonLevel > 0)
					if(!fec.isLocalCaller() && getLogonLevel() > 0)
						return EquipmentModuleImpl.makeUserDefinedTineError(eqm, EquipmentModuleImpl.TINE_REMOTE_WRITE_ACCESS_DENIED);					
					
					// Write locked Check
					if(fec.isWriteLocked() && PropertyImpl.this != fec.getLockWriteProperty())
						return EquipmentModuleImpl.makeUserDefinedTineError(getEquipmentModule(), EquipmentModuleImpl.TINE_MODULATOR_LOCKED);
											
					// Control Location Check
					if(!fec.isAccessAllowed())
						return EquipmentModuleImpl.makeUserDefinedTineError(getEquipmentModule(), EquipmentModuleImpl.TINE_WRONG_OPERATION_LOCATION);
					
					// Read only Check
					if(!TAccess.isWrite((byte) getTineAccess().getValue())) 
						return TErrorList.illegal_read_write;
					
					if(din.getArrayLength() > getLength())
						return TErrorList.illegal_data_size;
					
					// Der Caller muss hier gerettet werden, da er nach dem writeData() unter Umstnden nicht mehr vorhanden ist (Schedulen der Contracts)
					TClient caller = TEquipmentModuleFactory.getCaller();
					
					result = writeData(device, din);
								
					// Das Schreiben wird geloggt
					if(logger.isInfoEnabled() && result == TErrorList.success) {
						caller = TEquipmentModuleFactory.getCaller();
						logger.info(getName() + "=" + din.toString().trim() + " modified by " + (caller == null ? "unknown" : caller.userName));
					}
				}	
				
				// Read Access
				if(dout != null && devAccess.isRead() && result == 0) {
					if(dout.getArrayLength() > getLength())
						return TErrorList.illegal_data_size;
					
					result = readData(device, dout);
				}
		
				return result;
			}		
		};
		
		this.getEquipmentModule().getTineEquipmentModule().registerProperty(this.getTineExportProperty(), this.getTinePropertyHandler());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int getTypeSize() {
		return TFormat.formatSizeOf(getTineTypeCode());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int getByteSize() {
		return getTypeSize() * getLength();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isOutOfRange(float value) {
		return ((value < getMinimumValue()) || (value > getMaximumValue()));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract TDataType createTDataType();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void addObserver(Observer observer) {
		this.getObservers().add(observer);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void removeObserver(Observer observer) {
		this.getObservers().remove(observer);
	}

	/**
	 * <!-- begin-user-doc --> 
	 * <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void notifyObservers() {
		// Normale Observers informieren
		for(int i=0; i < this.getObservers().size(); ++i) {
			this.getObservers().get(i).update(this);
		}

		if(isScheduled())
			getEquipmentModule().scheduleProperty(this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.PROPERTY__EQUIPMENT_MODULE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetEquipmentModule((EquipmentModule)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServerPackage.PROPERTY__EQUIPMENT_MODULE:
				return basicSetEquipmentModule(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ServerPackage.PROPERTY__EQUIPMENT_MODULE:
				return eInternalContainer().eInverseRemove(this, ServerPackage.EQUIPMENT_MODULE__PROPERTIES, EquipmentModule.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.PROPERTY__OBSERVERS:
				return getObservers();
			case ServerPackage.PROPERTY__TINE_EXPORT_PROPERTY:
				return getTineExportProperty();
			case ServerPackage.PROPERTY__EQUIPMENT_MODULE:
				return getEquipmentModule();
			case ServerPackage.PROPERTY__TINE_PROPERTY_HANDLER:
				return getTinePropertyHandler();
			case ServerPackage.PROPERTY__NAME:
				return getName();
			case ServerPackage.PROPERTY__DESCRIPTION:
				return getDescription();
			case ServerPackage.PROPERTY__TINE_ACCESS:
				return getTineAccess();
			case ServerPackage.PROPERTY__LENGTH:
				return getLength();
			case ServerPackage.PROPERTY__MINIMUM_VALUE:
				return getMinimumValue();
			case ServerPackage.PROPERTY__MAXIMUM_VALUE:
				return getMaximumValue();
			case ServerPackage.PROPERTY__UNIT:
				return getUnit();
			case ServerPackage.PROPERTY__WRITABLE:
				return isWritable();
			case ServerPackage.PROPERTY__LOGON_LEVEL:
				return getLogonLevel();
			case ServerPackage.PROPERTY__MAX_STATE:
				return getMaxState();
			case ServerPackage.PROPERTY__SCHEDULED:
				return isScheduled();
			case ServerPackage.PROPERTY__REFRESH_RATE:
				return getRefreshRate();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.PROPERTY__OBSERVERS:
				getObservers().clear();
				getObservers().addAll((Collection<? extends Observer>)newValue);
				return;
			case ServerPackage.PROPERTY__EQUIPMENT_MODULE:
				setEquipmentModule((EquipmentModule)newValue);
				return;
			case ServerPackage.PROPERTY__NAME:
				setName((String)newValue);
				return;
			case ServerPackage.PROPERTY__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case ServerPackage.PROPERTY__TINE_ACCESS:
				setTineAccess((TineAccess)newValue);
				return;
			case ServerPackage.PROPERTY__LENGTH:
				setLength((Integer)newValue);
				return;
			case ServerPackage.PROPERTY__MINIMUM_VALUE:
				setMinimumValue((Float)newValue);
				return;
			case ServerPackage.PROPERTY__MAXIMUM_VALUE:
				setMaximumValue((Float)newValue);
				return;
			case ServerPackage.PROPERTY__UNIT:
				setUnit((String)newValue);
				return;
			case ServerPackage.PROPERTY__LOGON_LEVEL:
				setLogonLevel((Integer)newValue);
				return;
			case ServerPackage.PROPERTY__MAX_STATE:
				setMaxState((Integer)newValue);
				return;
			case ServerPackage.PROPERTY__SCHEDULED:
				setScheduled((Boolean)newValue);
				return;
			case ServerPackage.PROPERTY__REFRESH_RATE:
				setRefreshRate((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.PROPERTY__OBSERVERS:
				getObservers().clear();
				return;
			case ServerPackage.PROPERTY__EQUIPMENT_MODULE:
				setEquipmentModule((EquipmentModule)null);
				return;
			case ServerPackage.PROPERTY__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__TINE_ACCESS:
				setTineAccess(TINE_ACCESS_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__LENGTH:
				setLength(LENGTH_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__MINIMUM_VALUE:
				setMinimumValue(MINIMUM_VALUE_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__MAXIMUM_VALUE:
				setMaximumValue(MAXIMUM_VALUE_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__UNIT:
				setUnit(UNIT_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__LOGON_LEVEL:
				setLogonLevel(LOGON_LEVEL_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__MAX_STATE:
				setMaxState(MAX_STATE_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__SCHEDULED:
				setScheduled(SCHEDULED_EDEFAULT);
				return;
			case ServerPackage.PROPERTY__REFRESH_RATE:
				setRefreshRate(REFRESH_RATE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.PROPERTY__OBSERVERS:
				return observers != null && !observers.isEmpty();
			case ServerPackage.PROPERTY__TINE_EXPORT_PROPERTY:
				return TINE_EXPORT_PROPERTY_EDEFAULT == null ? tineExportProperty != null : !TINE_EXPORT_PROPERTY_EDEFAULT.equals(tineExportProperty);
			case ServerPackage.PROPERTY__EQUIPMENT_MODULE:
				return getEquipmentModule() != null;
			case ServerPackage.PROPERTY__TINE_PROPERTY_HANDLER:
				return TINE_PROPERTY_HANDLER_EDEFAULT == null ? tinePropertyHandler != null : !TINE_PROPERTY_HANDLER_EDEFAULT.equals(tinePropertyHandler);
			case ServerPackage.PROPERTY__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ServerPackage.PROPERTY__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case ServerPackage.PROPERTY__TINE_ACCESS:
				return tineAccess != TINE_ACCESS_EDEFAULT;
			case ServerPackage.PROPERTY__LENGTH:
				return length != LENGTH_EDEFAULT;
			case ServerPackage.PROPERTY__MINIMUM_VALUE:
				return minimumValue != MINIMUM_VALUE_EDEFAULT;
			case ServerPackage.PROPERTY__MAXIMUM_VALUE:
				return maximumValue != MAXIMUM_VALUE_EDEFAULT;
			case ServerPackage.PROPERTY__UNIT:
				return UNIT_EDEFAULT == null ? unit != null : !UNIT_EDEFAULT.equals(unit);
			case ServerPackage.PROPERTY__WRITABLE:
				return isWritable() != WRITABLE_EDEFAULT;
			case ServerPackage.PROPERTY__LOGON_LEVEL:
				return logonLevel != LOGON_LEVEL_EDEFAULT;
			case ServerPackage.PROPERTY__MAX_STATE:
				return maxState != MAX_STATE_EDEFAULT;
			case ServerPackage.PROPERTY__SCHEDULED:
				return scheduled != SCHEDULED_EDEFAULT;
			case ServerPackage.PROPERTY__REFRESH_RATE:
				return refreshRate != REFRESH_RATE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (tineExportProperty: ");
		result.append(tineExportProperty);
		result.append(", tinePropertyHandler: ");
		result.append(tinePropertyHandler);
		result.append(", name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", tineAccess: ");
		result.append(tineAccess);
		result.append(", length: ");
		result.append(length);
		result.append(", minimumValue: ");
		result.append(minimumValue);
		result.append(", maximumValue: ");
		result.append(maximumValue);
		result.append(", unit: ");
		result.append(unit);
		result.append(", logonLevel: ");
		result.append(logonLevel);
		result.append(", maxState: ");
		result.append(maxState);
		result.append(", scheduled: ");
		result.append(scheduled);
		result.append(", refreshRate: ");
		result.append(refreshRate);
		result.append(')');
		return result.toString();
	}

} //PropertyImpl
