/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.math.BigDecimal;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.PropertyNumeric;
import ch.thomson.ucs.tine.server.Scalable;
import ch.thomson.ucs.tine.server.ServerPackage;
import de.desy.tine.dataUtils.TDataType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property Numeric</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyNumericImpl#getFactor <em>Factor</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyNumericImpl#getOffset <em>Offset</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyNumericImpl#getPrecision <em>Precision</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.PropertyNumericImpl#getDecimalPlaces <em>Decimal Places</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class PropertyNumericImpl extends RealPropertyImpl implements PropertyNumeric {
	/**
	 * The default value of the '{@link #getFactor() <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactor()
	 * @generated
	 * @ordered
	 */
	protected static final double FACTOR_EDEFAULT = 1.0;

	/**
	 * The cached value of the '{@link #getFactor() <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactor()
	 * @generated
	 * @ordered
	 */
	protected double factor = FACTOR_EDEFAULT;

	/**
	 * The default value of the '{@link #getOffset() <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOffset()
	 * @generated
	 * @ordered
	 */
	protected static final double OFFSET_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getOffset() <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOffset()
	 * @generated
	 * @ordered
	 */
	protected double offset = OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getPrecision() <em>Precision</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrecision()
	 * @generated
	 * @ordered
	 */
	protected static final String PRECISION_EDEFAULT = "1.0";

	/**
	 * The cached value of the '{@link #getPrecision() <em>Precision</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrecision()
	 * @generated
	 * @ordered
	 */
	protected String precision = PRECISION_EDEFAULT;

	/**
	 * The default value of the '{@link #getDecimalPlaces() <em>Decimal Places</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDecimalPlaces()
	 * @generated
	 * @ordered
	 */
	protected static final int DECIMAL_PLACES_EDEFAULT = 0;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyNumericImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.PROPERTY_NUMERIC;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getFactor() {
		return factor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFactor(double newFactor) {
		double oldFactor = factor;
		factor = newFactor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY_NUMERIC__FACTOR, oldFactor, factor));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getOffset() {
		return offset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOffset(double newOffset) {
		double oldOffset = offset;
		offset = newOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY_NUMERIC__OFFSET, oldOffset, offset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPrecision() {
		return precision;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrecision(String newPrecision) {
		String oldPrecision = precision;
		precision = newPrecision;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.PROPERTY_NUMERIC__PRECISION, oldPrecision, precision));
	}
	
	private Integer decimalPlaces;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int getDecimalPlaces() {
		if(decimalPlaces == null) {		
			int dp;
			// Geforderte Nachkommastellen berechnen anhand des Precision Werts
			BigDecimal bdPrecision = new BigDecimal(getPrecision());
			dp = bdPrecision.scale();

			// Prfen ob erste Nachkommastelle 0 auch ist, weil bdPrecision.scale()
			// in diesem Fall 1 zurck gibt.
			if (dp == 1 && ((bdPrecision.doubleValue() * 10.0) % 10.0) == 0.0)
				dp = 0;
			
			decimalPlaces = dp;
		}
		
		return decimalPlaces;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.PROPERTY_NUMERIC__FACTOR:
				return getFactor();
			case ServerPackage.PROPERTY_NUMERIC__OFFSET:
				return getOffset();
			case ServerPackage.PROPERTY_NUMERIC__PRECISION:
				return getPrecision();
			case ServerPackage.PROPERTY_NUMERIC__DECIMAL_PLACES:
				return getDecimalPlaces();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.PROPERTY_NUMERIC__FACTOR:
				setFactor((Double)newValue);
				return;
			case ServerPackage.PROPERTY_NUMERIC__OFFSET:
				setOffset((Double)newValue);
				return;
			case ServerPackage.PROPERTY_NUMERIC__PRECISION:
				setPrecision((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.PROPERTY_NUMERIC__FACTOR:
				setFactor(FACTOR_EDEFAULT);
				return;
			case ServerPackage.PROPERTY_NUMERIC__OFFSET:
				setOffset(OFFSET_EDEFAULT);
				return;
			case ServerPackage.PROPERTY_NUMERIC__PRECISION:
				setPrecision(PRECISION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.PROPERTY_NUMERIC__FACTOR:
				return factor != FACTOR_EDEFAULT;
			case ServerPackage.PROPERTY_NUMERIC__OFFSET:
				return offset != OFFSET_EDEFAULT;
			case ServerPackage.PROPERTY_NUMERIC__PRECISION:
				return PRECISION_EDEFAULT == null ? precision != null : !PRECISION_EDEFAULT.equals(precision);
			case ServerPackage.PROPERTY_NUMERIC__DECIMAL_PLACES:
				return getDecimalPlaces() != DECIMAL_PLACES_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Scalable.class) {
			switch (derivedFeatureID) {
				case ServerPackage.PROPERTY_NUMERIC__FACTOR: return ServerPackage.SCALABLE__FACTOR;
				case ServerPackage.PROPERTY_NUMERIC__OFFSET: return ServerPackage.SCALABLE__OFFSET;
				case ServerPackage.PROPERTY_NUMERIC__PRECISION: return ServerPackage.SCALABLE__PRECISION;
				case ServerPackage.PROPERTY_NUMERIC__DECIMAL_PLACES: return ServerPackage.SCALABLE__DECIMAL_PLACES;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Scalable.class) {
			switch (baseFeatureID) {
				case ServerPackage.SCALABLE__FACTOR: return ServerPackage.PROPERTY_NUMERIC__FACTOR;
				case ServerPackage.SCALABLE__OFFSET: return ServerPackage.PROPERTY_NUMERIC__OFFSET;
				case ServerPackage.SCALABLE__PRECISION: return ServerPackage.PROPERTY_NUMERIC__PRECISION;
				case ServerPackage.SCALABLE__DECIMAL_PLACES: return ServerPackage.PROPERTY_NUMERIC__DECIMAL_PLACES;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (factor: ");
		result.append(factor);
		result.append(", offset: ");
		result.append(offset);
		result.append(", precision: ");
		result.append(precision);
		result.append(')');
		return result.toString();
	}
	
	private Long decimalPlacesFactor;
	
	/**
	 * Aus Performancegrnden wird der Factor nur beim 1. Aufruf berechnet und anschliessend gecached.
	 * @return Gecachter Dezimalstellenfaktor
	 */
	private long getDecimalPlacesFactor() {
		if(decimalPlacesFactor == null) {
			decimalPlacesFactor = (long) Math.pow(10.0, getDecimalPlaces());
		}
		return decimalPlacesFactor;
	}
	
	/**
	 * Diese Methode wurde zuerst mit Hilfe der Java-Klasse BigDecimal
	 * implementiert. Danach wurde festgestellt, dass die Methoden der
	 * BigDecimal-Klasse sehr teuer sind, was zu betrchtlichen
	 * Performance-Einbussen fhrte. Deshalb wird die Rundung nun "altgebacken"
	 * mit Kommaverschiebung gemacht.
	 * 
	 * @param d Wert, welcher auf die geforderte Przision gerundet werden soll
	 * @return Gerundeter Wert mit der erforderlichen Pzision
	 */
	protected double roundScale(double d) {
		long value = Math.round(d * getDecimalPlacesFactor());		
		return (((double)value) / getDecimalPlacesFactor());
	}

	@Override
	public int[] getValuesAsInt(Device device) {
		TDataType dout = new TDataType(new int[getLength()]);
		this.readData(device, dout);
		dout.getData();
		return (int[]) dout.getDataObject();
	}

	@Override
	public float[] getValuesAsFloat(Device device) {
		TDataType dout = new TDataType(new float[getLength()]);
		this.readData(device, dout);
		dout.getData();
		return (float[]) dout.getDataObject();
	}

	@Override
	public TDataType getDefaultValueAsTDataType() {
		double[] values = new double[getLength()];
		for(int i=0; i<values.length; ++i)
			values[i] = Double.parseDouble(getDefaultValue());
		return new TDataType(values);
	}

} //PropertyNumericImpl
