/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.io.IOException;

import org.eclipse.emf.ecore.EClass;

import ch.thomson.ucs.tine.server.PropertyShort16;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.utils.logic.ByteOrderedDataInputStream;
import ch.thomson.ucs.utils.logic.ByteOrderedDataOutputStream;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Property Short16</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class PropertyShort16Impl extends PropertyNumericImpl implements PropertyShort16 {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyShort16Impl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.PROPERTY_SHORT16;
	}

	@Override
	public short getTineTypeCode() {
		return TFormat.CF_SHORT;
	}

	@Override
	public int write(TDataType din, ByteOrderedDataOutputStream dos) throws IOException {
		int result = 0;
		double[] values = new double[din.getArrayLength()];
		if ((result = din.getData(values)) == 0) {
			for (double val : values) {
				
				// Range Check
				if(isOutOfRange((float) val))
					return TErrorList.out_of_range;
				
				dos.writeShort((int) Math.round((val * getFactor() + getOffset())));
			}
		}		
		return result;
	}

	@Override
	public void read(ByteOrderedDataInputStream source, Object target) throws IOException {
		double[] values = (double[]) target;
		
		for(int i=0; i<values.length; i++) {
			values[i] = roundScale(((double) source.readShort() - getOffset()) / getFactor());
		}
	}

	@Override
	public TDataType createTDataType() {
		return new TDataType(new short[this.getLength()]);
	}

	@Override
	public Object createDataCacheBuffer() {
		return new double[getLength()];
	}

} //PropertyShort16Impl
