/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.Date;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.tine.server.util.Activator;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Real Property DAO HSQLDB</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyDAO_PostgresImpl#getConnection <em>Connection</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyDAO_PostgresImpl#getTimestamp <em>Timestamp</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RealPropertyDAO_PostgresImpl extends EObjectImpl implements RealPropertyDAO_Postgres {
	/**
	 * The default value of the '{@link #getConnection() <em>Connection</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnection()
	 * @generated
	 * @ordered
	 */
	protected static final Connection CONNECTION_EDEFAULT = null;
	/**
	 * The cached value of the '{@link #getConnection() <em>Connection</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnection()
	 * @generated
	 * @ordered
	 */
	protected Connection connection = CONNECTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimestamp()
	 * @generated
	 * @ordered
	 */
	protected static final Timestamp TIMESTAMP_EDEFAULT = null;
	/**
	 * The cached value of the '{@link #getTimestamp() <em>Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimestamp()
	 * @generated
	 * @ordered
	 */
	protected Timestamp timestamp = TIMESTAMP_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RealPropertyDAO_PostgresImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.REAL_PROPERTY_DAO_POSTGRES;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Connection getConnection() {
		return connection;
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Timestamp getTimestamp() {
		return timestamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void open(String path) throws Exception {
		Class.forName("org.postgresql.Driver");
		connection = DriverManager.getConnection(path, "ucs", "ucs");
		timestamp = new java.sql.Timestamp(new Date().getTime());
		createDataTable();
	}
	
	private void createDataTable() {
		StringBuilder query = new StringBuilder();
		query.append("CREATE TABLE property_data (");
		query.append("eqm_name VARCHAR(255) NOT NULL, ");
		query.append("dev_name VARCHAR(255) NOT NULL, ");
		query.append("prop_name VARCHAR(255) NOT NULL, ");
		query.append("index INTEGER NOT NULL, ");
		query.append("numeric_value DOUBLE PRECISION, ");
		query.append("string_value VARCHAR(255), ");
		query.append("session_timestamp TIMESTAMP NOT NULL, ");
		query.append("PRIMARY KEY (eqm_name, dev_name, prop_name, index));");

		try {
			Statement st = connection.createStatement();
			st.executeUpdate(query.toString());
			
		} catch (SQLException ex) {
			// Nur loggen, da kein Fehler wenn Tabelle bereits existiert.
			Activator.getLogger().info(ex.getMessage());
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void close() throws Exception {
		if(isOpen()) {
			connection.close();
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void saveData(Device device, RealProperty property, TDataType tDataType) throws Exception {
		
		// Nummerische Daten
		double[] values = new double[tDataType.dArrayLength];
		String text = null;
		
		int result = tDataType.getData(values);
		
		// Fehlgeschlagen? Als String versuchen
		if(result == TErrorList.illegal_format) {
			values = null;
			char[] s = new char[tDataType.dArrayLength];
			tDataType.getData(s);
			text = new String(s);
		}
		
		String update = "UPDATE property_data SET numeric_value=?, string_value=?, session_timestamp=? WHERE eqm_name=? AND dev_name=? AND prop_name=? AND index=?;";
		String insert = "INSERT INTO property_data VALUES (?, ?, ?, ?, ?, ?, ?);";
		PreparedStatement pstmtUpdate = null;
		PreparedStatement pstmtInsert = null;
		
		try {
			connection.setAutoCommit(false);
			pstmtUpdate = connection.prepareStatement(update);
		
			for(int i=0; i<(values == null ? 1 : values.length); i++) {
			
				// numeric_value
				if (values == null)
					pstmtUpdate.setNull(1, java.sql.Types.DOUBLE);
				else
					pstmtUpdate.setDouble(1, values[i]);
			
				// string_value
				if (text == null)
					pstmtUpdate.setNull(2, java.sql.Types.VARCHAR);
				else
					pstmtUpdate.setString(2, text);
			
				pstmtUpdate.setTimestamp(3, getTimestamp());
				pstmtUpdate.setString(4, device.getEquipmentModule().getExportName());
				pstmtUpdate.setString(5, device.getName());
				pstmtUpdate.setString(6, property.getName());
				pstmtUpdate.setInt(7, i);
	
				result = pstmtUpdate.executeUpdate();
			
				// Falls kein Update durchgefhrt wurde, muss der Eintrag erstellt werden
				if(result == 0) {
				
					if(pstmtInsert == null)	
						pstmtInsert = connection.prepareStatement(insert);
				
					pstmtInsert.setString(1, device.getEquipmentModule().getExportName());
					pstmtInsert.setString(2, device.getName());
					pstmtInsert.setString(3, property.getName());
					pstmtInsert.setInt(4, i);
					if(values == null)
						pstmtInsert.setNull(5, java.sql.Types.DOUBLE);
					else
						pstmtInsert.setDouble(5, values[i]);
				
					if(text == null)
						pstmtInsert.setNull(6, java.sql.Types.VARCHAR);
					else
						pstmtInsert.setString(6, text);
				
					pstmtInsert.setTimestamp(7, getTimestamp());
					pstmtInsert.executeUpdate();
				}
			}
			connection.commit();
		} finally {
			if(pstmtUpdate != null)
				pstmtUpdate.close();
			
			if(pstmtInsert != null)
				pstmtInsert.close();
			
			connection.setAutoCommit(true);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public TDataType loadData(Device device, RealProperty property) throws Exception {
		// Grsse ermitteln
		String querySize = "SELECT COUNT(index) AS size FROM property_data WHERE eqm_name=? AND dev_name=? AND prop_name=?;";
		PreparedStatement pstmtSize = connection.prepareStatement(querySize);
		int size = 0;
		
		pstmtSize.setString(1, device.getEquipmentModule().getExportName());
		pstmtSize.setString(2, device.getName());
		pstmtSize.setString(3, property.getName());
		
		ResultSet rs = pstmtSize.executeQuery();
		
		if(rs.next())
			size = rs.getInt("size");
		
		pstmtSize.close();
		
		// Nichts gefunden, dann mit Default Wert initialisieren
		if(size == 0) {
			return property.getDefaultValueAsTDataType();
		}
		
		// Werte lesen
		String queryValues = "SELECT index, numeric_value, string_value FROM property_data WHERE eqm_name=? AND dev_name=? AND prop_name=? ORDER BY index;";
		PreparedStatement pstmtValues = connection.prepareStatement(queryValues);
		
		pstmtValues.setString(1, device.getEquipmentModule().getExportName());
		pstmtValues.setString(2, device.getName());
		pstmtValues.setString(3, property.getName());
		
		rs = pstmtValues.executeQuery();		
		
		double[] values = new double[size];
		String text = null;
		
		int index = 0;
		while(rs.next()) {
			// Versuche mal, den nummerischen Wert zu lesen...
			values[index++] = rs.getDouble("numeric_value");
			
			if(rs.wasNull()) {
				text = rs.getString("string_value"); // Ja, dann muss es sich um einen String handeln
				values = null;
				pstmtValues.close();
				return new TDataType(text.toCharArray()); // Keine weiteren Aktionen ntig, da bereits ganzes Char-Array ausgelesen wurde.
			}
		}
		
		pstmtValues.close();
		return new TDataType(values);
	}

	/**
	 * <!-- begin-user-doc --> 
	 * Diese Methode sucht die veralteten Eintrge ber
	 * den Session-Timestamp und lscht diese. Der Timestamp-Mechanismus ist
	 * folgender: Beim Initialisieren wird der Datensatz geladen und
	 * anschliessend wieder mit dem akutellen Session-Timestamp geschrieben. Bei
	 * Datenstzen, die nie geladen werden (aufgrund einer Signallistennderung)
	 * weisen einen alten Session-Timestamp auf und knnen somit gelscht werden. 
	 * <!--end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void clean() throws Exception {
		String delete = "DELETE FROM property_data WHERE session_timestamp < ?;";
		PreparedStatement pstmt = connection.prepareStatement(delete);
		
		pstmt.setTimestamp(1, getTimestamp());
		int result = pstmt.executeUpdate();
		pstmt.close();
		Activator.getLogger().info(result + " entries cleaned.");
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isOpen() throws Exception {
		return connection != null && !connection.isClosed();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.REAL_PROPERTY_DAO_POSTGRES__CONNECTION:
				return getConnection();
			case ServerPackage.REAL_PROPERTY_DAO_POSTGRES__TIMESTAMP:
				return getTimestamp();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.REAL_PROPERTY_DAO_POSTGRES__CONNECTION:
				return CONNECTION_EDEFAULT == null ? connection != null : !CONNECTION_EDEFAULT.equals(connection);
			case ServerPackage.REAL_PROPERTY_DAO_POSTGRES__TIMESTAMP:
				return TIMESTAMP_EDEFAULT == null ? timestamp != null : !TIMESTAMP_EDEFAULT.equals(timestamp);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (connection: ");
		result.append(connection);
		result.append(", timestamp: ");
		result.append(timestamp);
		result.append(')');
		return result.toString();
	}

} //RealPropertyDAO_HSQLDBImpl
