/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.RealPropertyDAO;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.tine.server.util.Activator;
import ch.thomson.ucs.tine.server.util.DataCacheObject;
import ch.thomson.ucs.utils.logic.ByteOrderedDataInputStream;
import ch.thomson.ucs.utils.logic.ByteOrderedDataOutputStream;
import de.desy.tine.dataUtils.TDataTime;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Real Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#getDataTableName <em>Data Table Name</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#getAddressOffset <em>Address Offset</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#getDefaultValue <em>Default Value</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#getDriverAddress <em>Driver Address</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#getUserDefinedAddressObject <em>User Defined Address Object</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#isPersistent <em>Persistent</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#isDirty <em>Dirty</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl#isDummy <em>Dummy</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class RealPropertyImpl extends PropertyImpl implements RealProperty {
	/**
	 * The default value of the '{@link #getDataTableName() <em>Data Table Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataTableName()
	 * @generated
	 * @ordered
	 */
	protected static final String DATA_TABLE_NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDataTableName() <em>Data Table Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDataTableName()
	 * @generated
	 * @ordered
	 */
	protected String dataTableName = DATA_TABLE_NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getAddressOffset() <em>Address Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddressOffset()
	 * @generated
	 * @ordered
	 */
	protected static final int ADDRESS_OFFSET_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getAddressOffset() <em>Address Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAddressOffset()
	 * @generated
	 * @ordered
	 */
	protected int addressOffset = ADDRESS_OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getDefaultValue() <em>Default Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultValue()
	 * @generated
	 * @ordered
	 */
	protected static final String DEFAULT_VALUE_EDEFAULT = "0.0";

	/**
	 * The cached value of the '{@link #getDefaultValue() <em>Default Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultValue()
	 * @generated
	 * @ordered
	 */
	protected String defaultValue = DEFAULT_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getDriverAddress() <em>Driver Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDriverAddress()
	 * @generated
	 * @ordered
	 */
	protected static final String DRIVER_ADDRESS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDriverAddress() <em>Driver Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDriverAddress()
	 * @generated
	 * @ordered
	 */
	protected String driverAddress = DRIVER_ADDRESS_EDEFAULT;

	/**
	 * The default value of the '{@link #getUserDefinedAddressObject() <em>User Defined Address Object</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUserDefinedAddressObject()
	 * @generated
	 * @ordered
	 */
	protected static final Object USER_DEFINED_ADDRESS_OBJECT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUserDefinedAddressObject() <em>User Defined Address Object</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUserDefinedAddressObject()
	 * @generated
	 * @ordered
	 */
	protected Object userDefinedAddressObject = USER_DEFINED_ADDRESS_OBJECT_EDEFAULT;

	/**
	 * The default value of the '{@link #isPersistent() <em>Persistent</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPersistent()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PERSISTENT_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isPersistent() <em>Persistent</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPersistent()
	 * @generated
	 * @ordered
	 */
	protected boolean persistent = PERSISTENT_EDEFAULT;

	/**
	 * The default value of the '{@link #isDirty() <em>Dirty</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDirty()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DIRTY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDirty() <em>Dirty</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDirty()
	 * @generated
	 * @ordered
	 */
	protected boolean dirty = DIRTY_EDEFAULT;

	/**
	 * The default value of the '{@link #isDummy() <em>Dummy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDummy()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DUMMY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDummy() <em>Dummy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDummy()
	 * @generated
	 * @ordered
	 */
	protected boolean dummy = DUMMY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RealPropertyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.REAL_PROPERTY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDataTableName() {
		return dataTableName;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataTableName(String newDataTableName) {
		String oldDataTableName = dataTableName;
		dataTableName = newDataTableName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__DATA_TABLE_NAME, oldDataTableName, dataTableName));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getAddressOffset() {
		return addressOffset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAddressOffset(int newAddressOffset) {
		int oldAddressOffset = addressOffset;
		addressOffset = newAddressOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__ADDRESS_OFFSET, oldAddressOffset, addressOffset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDefaultValue() {
		return defaultValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDefaultValue(String newDefaultValue) {
		String oldDefaultValue = defaultValue;
		defaultValue = newDefaultValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__DEFAULT_VALUE, oldDefaultValue, defaultValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDriverAddress() {
		return driverAddress;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDriverAddress(String newDriverAddress) {
		String oldDriverAddress = driverAddress;
		driverAddress = newDriverAddress;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__DRIVER_ADDRESS, oldDriverAddress, driverAddress));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getUserDefinedAddressObject() {
		return userDefinedAddressObject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUserDefinedAddressObject(Object newUserDefinedAddressObject) {
		Object oldUserDefinedAddressObject = userDefinedAddressObject;
		userDefinedAddressObject = newUserDefinedAddressObject;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT, oldUserDefinedAddressObject, userDefinedAddressObject));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean isPersistent() {
		return persistent && this.isWritable();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPersistent(boolean newPersistent) {
		boolean oldPersistent = persistent;
		persistent = newPersistent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__PERSISTENT, oldPersistent, persistent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDirty() {
		return dirty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDirty(boolean newDirty) {
		boolean oldDirty = dirty;
		dirty = newDirty;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__DIRTY, oldDirty, dirty));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDummy() {
		return dummy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDummy(boolean newDummy) {
		boolean oldDummy = dummy;
		dummy = newDummy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.REAL_PROPERTY__DUMMY, oldDummy, dummy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @throws Exception 
	 * @generated NOT
	 */
	public void readFromDataTable(Device device, byte[] buffer) throws Exception {
		
		Exception e = null;
		if((e = device.getActualError()) != null) {
			throw new Exception(e.getMessage());
		}
		
		DataTable dataTable = device.findDataTable(getDataTableName());
		dataTable.read(buffer, getAddressOffset());
	}
	
	private boolean initialized = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @throws Exception 
	 * @generated NOT
	 */
	public void writeToDataTable(Device device, byte[] buffer) throws Exception {
		DataTable dataTable = device.findDataTable(getDataTableName());
		
		// Buffer der Tabelle vor dem Schreiben klonen um vergleichen zu knnen
		byte[] bufferBefore = dataTable.getByteBuffer().array().clone();
		
		synchronized(dataTable) {
			dataTable.write(buffer, getAddressOffset());
		}
		
		// Hat sich wirklich etwas gendert -> Device nur dann informieren! (Beim Initialisieren wird es erzwungen)
		if(!Arrays.equals(bufferBefore, dataTable.getByteBuffer().array()) || !initialized) {
			this.setDirty(true);
			device.dataTableChanged(dataTable);
			initialized = true;
			dataTable.notifyObservers();
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public abstract TDataType getDefaultValueAsTDataType();
	
	private Map<Device, DataCacheObject> dataCacheMap;
	
	protected Map<Device, DataCacheObject> getDataCacheMap() {
		if(dataCacheMap == null) {
			dataCacheMap = new HashMap<Device, DataCacheObject>();
		}
		
		return dataCacheMap;
	}
	
	private final ReentrantReadWriteLock cacheLock = new ReentrantReadWriteLock();
	private final Lock readCacheLock  = cacheLock.readLock();
	private final Lock writeCacheLock = cacheLock.writeLock();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void refreshCache(DataTable dataTable) {
		if(readBuffer == null)
			readBuffer = new byte[this.getByteSize()];
		
		dataTable.read(readBuffer, getAddressOffset());
		
		ByteArrayInputStream bais = new ByteArrayInputStream(readBuffer);
		ByteOrderedDataInputStream in = new ByteOrderedDataInputStream(bais);
		in.setByteOrder(getEquipmentModule().getByteOrder().toJavaByteOrderEnum());
		
		DataCacheObject dataCache = getDataCacheMap().get(dataTable.getDevice());
		
		try {	
			writeCacheLock.lock();
			read(in, dataCache.cache);
			dataCache.timeStamp = TDataTime.getDataTimeStamp();
			dataCache.userDataStamp = dataTable.getDevice().getUserDataStamp();
			dataCache.systemDataStamp = dataTable.getDevice().getSystemDataStamp();
		} catch (IOException e) {
			e.printStackTrace(); // Sollte nie passieren
		} finally {
			writeCacheLock.unlock();
		}
	}
	
	public Object readNonCachedData(DataTable dataTable) {
		byte[] buf = new byte[getByteSize()];
		dataTable.read(buf, getAddressOffset());
		
		ByteArrayInputStream bais = new ByteArrayInputStream(buf);
		ByteOrderedDataInputStream in = new ByteOrderedDataInputStream(bais);
		in.setByteOrder(getEquipmentModule().getByteOrder().toJavaByteOrderEnum());
		
		Object data = createDataCacheBuffer();
		try {
			read(in, data);
		} catch (IOException e) {
			e.printStackTrace(); // Sollte nie passieren
		}
		return data;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void loadData(RealPropertyDAO dao) throws Exception {
		for(Device device : this.getEquipmentModule().getDevices()) {
			TDataType din = null;
			
			if(this.isPersistent())
				din = dao.loadData(device, this);
			else
				din = this.getDefaultValueAsTDataType();
			
			if(din != null) {
				this.writeData(device, din);
			}
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void saveData(RealPropertyDAO dao) throws Exception {
		if(this.isPersistent()) {
			TDataType dout = createTDataType();
			for(Device device : this.getEquipmentModule().getDevices()) {
				readData(device, dout);
				dao.saveData(device, this, dout);
			}
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.REAL_PROPERTY__DATA_TABLE_NAME:
				return getDataTableName();
			case ServerPackage.REAL_PROPERTY__ADDRESS_OFFSET:
				return getAddressOffset();
			case ServerPackage.REAL_PROPERTY__DEFAULT_VALUE:
				return getDefaultValue();
			case ServerPackage.REAL_PROPERTY__DRIVER_ADDRESS:
				return getDriverAddress();
			case ServerPackage.REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT:
				return getUserDefinedAddressObject();
			case ServerPackage.REAL_PROPERTY__PERSISTENT:
				return isPersistent();
			case ServerPackage.REAL_PROPERTY__DIRTY:
				return isDirty();
			case ServerPackage.REAL_PROPERTY__DUMMY:
				return isDummy();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.REAL_PROPERTY__DATA_TABLE_NAME:
				setDataTableName((String)newValue);
				return;
			case ServerPackage.REAL_PROPERTY__ADDRESS_OFFSET:
				setAddressOffset((Integer)newValue);
				return;
			case ServerPackage.REAL_PROPERTY__DEFAULT_VALUE:
				setDefaultValue((String)newValue);
				return;
			case ServerPackage.REAL_PROPERTY__DRIVER_ADDRESS:
				setDriverAddress((String)newValue);
				return;
			case ServerPackage.REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT:
				setUserDefinedAddressObject(newValue);
				return;
			case ServerPackage.REAL_PROPERTY__PERSISTENT:
				setPersistent((Boolean)newValue);
				return;
			case ServerPackage.REAL_PROPERTY__DIRTY:
				setDirty((Boolean)newValue);
				return;
			case ServerPackage.REAL_PROPERTY__DUMMY:
				setDummy((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.REAL_PROPERTY__DATA_TABLE_NAME:
				setDataTableName(DATA_TABLE_NAME_EDEFAULT);
				return;
			case ServerPackage.REAL_PROPERTY__ADDRESS_OFFSET:
				setAddressOffset(ADDRESS_OFFSET_EDEFAULT);
				return;
			case ServerPackage.REAL_PROPERTY__DEFAULT_VALUE:
				setDefaultValue(DEFAULT_VALUE_EDEFAULT);
				return;
			case ServerPackage.REAL_PROPERTY__DRIVER_ADDRESS:
				setDriverAddress(DRIVER_ADDRESS_EDEFAULT);
				return;
			case ServerPackage.REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT:
				setUserDefinedAddressObject(USER_DEFINED_ADDRESS_OBJECT_EDEFAULT);
				return;
			case ServerPackage.REAL_PROPERTY__PERSISTENT:
				setPersistent(PERSISTENT_EDEFAULT);
				return;
			case ServerPackage.REAL_PROPERTY__DIRTY:
				setDirty(DIRTY_EDEFAULT);
				return;
			case ServerPackage.REAL_PROPERTY__DUMMY:
				setDummy(DUMMY_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.REAL_PROPERTY__DATA_TABLE_NAME:
				return DATA_TABLE_NAME_EDEFAULT == null ? dataTableName != null : !DATA_TABLE_NAME_EDEFAULT.equals(dataTableName);
			case ServerPackage.REAL_PROPERTY__ADDRESS_OFFSET:
				return addressOffset != ADDRESS_OFFSET_EDEFAULT;
			case ServerPackage.REAL_PROPERTY__DEFAULT_VALUE:
				return DEFAULT_VALUE_EDEFAULT == null ? defaultValue != null : !DEFAULT_VALUE_EDEFAULT.equals(defaultValue);
			case ServerPackage.REAL_PROPERTY__DRIVER_ADDRESS:
				return DRIVER_ADDRESS_EDEFAULT == null ? driverAddress != null : !DRIVER_ADDRESS_EDEFAULT.equals(driverAddress);
			case ServerPackage.REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT:
				return USER_DEFINED_ADDRESS_OBJECT_EDEFAULT == null ? userDefinedAddressObject != null : !USER_DEFINED_ADDRESS_OBJECT_EDEFAULT.equals(userDefinedAddressObject);
			case ServerPackage.REAL_PROPERTY__PERSISTENT:
				return persistent != PERSISTENT_EDEFAULT;
			case ServerPackage.REAL_PROPERTY__DIRTY:
				return dirty != DIRTY_EDEFAULT;
			case ServerPackage.REAL_PROPERTY__DUMMY:
				return dummy != DUMMY_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (dataTableName: ");
		result.append(dataTableName);
		result.append(", addressOffset: ");
		result.append(addressOffset);
		result.append(", defaultValue: ");
		result.append(defaultValue);
		result.append(", driverAddress: ");
		result.append(driverAddress);
		result.append(", userDefinedAddressObject: ");
		result.append(userDefinedAddressObject);
		result.append(", persistent: ");
		result.append(persistent);
		result.append(", dirty: ");
		result.append(dirty);
		result.append(", dummy: ");
		result.append(dummy);
		result.append(')');
		return result.toString();
	}
	
	public abstract int write(TDataType din, ByteOrderedDataOutputStream dos) throws IOException;
	public abstract void read(ByteOrderedDataInputStream source, Object target) throws IOException;
	public abstract Object createDataCacheBuffer();
	
	private byte[] readBuffer = null;
	
	@Override
	public int readData(Device device, TDataType dout) {
		//System.out.println("Read " + Thread.currentThread().getName() + ": "+ getEquipmentModule().getExportName() + "/" + getName());

		if((device.getActualError()) != null) 
			return TErrorList.hardware_error;
		
		DataCacheObject dataCache = getDataCacheMap().get(device);
		int result;

		readCacheLock.lock();
		result = dout.putData(dataCache.cache);
		dout.setDataTimeStamp(dataCache.timeStamp);
		dout.setUserDataStamp(dataCache.userDataStamp);
		dout.setSystemDataStamp(dataCache.systemDataStamp);
		readCacheLock.unlock();		
		
		return result;
	}
	
	@Override
	public int writeData(Device device, TDataType din) {
		//System.out.println("Write " + Thread.currentThread().getName() + ": "+ getEquipmentModule().getExportName() + "/" + getName());
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ByteOrderedDataOutputStream out = new ByteOrderedDataOutputStream(baos);
		out.setByteOrder(getEquipmentModule().getByteOrder().toJavaByteOrderEnum());
		
		int result = TErrorList.illegal_format;
		
		try {
			result = write(din, out);
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		if(result == 0) {
			try {
				// Auf die Hardware-Tabelle schreiben
				writeToDataTable(device, baos.toByteArray());
				
				// In Datenbank speichern
				if(this.isPersistent())
					FrontEndControllerImpl.getDefaultRealPropertyDAO().saveData(device, this, din);
			
			} catch (Exception e) {
				Activator.getLogger().error(e);
				return TErrorList.hardware_error;
			}
		}
		
		return result;
	}

	@Override
	public void initialize() throws Exception {
		// Data Cache fr jedes Device erzeugen
		for(Device device : this.getEquipmentModule().getDevices()) {
			getDataCacheMap().put(device, new DataCacheObject(createDataCacheBuffer()));
		}
		
		this.loadData(FrontEndControllerImpl.getDefaultRealPropertyDAO());
		super.initialize();
	}

} //RealPropertyImpl
