/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.math.BigDecimal;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.Scalable;
import ch.thomson.ucs.tine.server.ScaledProperty;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.tine.server.TineAccess;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scaled Property</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl#getFactor <em>Factor</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl#getOffset <em>Offset</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl#getPrecision <em>Precision</em>}</li>
 *   <li>{@link ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl#getDecimalPlaces <em>Decimal Places</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ScaledPropertyImpl extends DecoratedPropertyImpl implements ScaledProperty {
	/**
	 * The default value of the '{@link #getFactor() <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactor()
	 * @generated
	 * @ordered
	 */
	protected static final double FACTOR_EDEFAULT = 1.0;
	/**
	 * The cached value of the '{@link #getFactor() <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactor()
	 * @generated
	 * @ordered
	 */
	protected double factor = FACTOR_EDEFAULT;

	/**
	 * The default value of the '{@link #getOffset() <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOffset()
	 * @generated
	 * @ordered
	 */
	protected static final double OFFSET_EDEFAULT = 0.0;
	/**
	 * The cached value of the '{@link #getOffset() <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOffset()
	 * @generated
	 * @ordered
	 */
	protected double offset = OFFSET_EDEFAULT;
	/**
	 * The default value of the '{@link #getPrecision() <em>Precision</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrecision()
	 * @generated
	 * @ordered
	 */
	protected static final String PRECISION_EDEFAULT = "1.0";
	/**
	 * The cached value of the '{@link #getPrecision() <em>Precision</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrecision()
	 * @generated
	 * @ordered
	 */
	protected String precision = PRECISION_EDEFAULT;
	/**
	 * The default value of the '{@link #getDecimalPlaces() <em>Decimal Places</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDecimalPlaces()
	 * @generated
	 * @ordered
	 */
	protected static final int DECIMAL_PLACES_EDEFAULT = 0;
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ScaledPropertyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServerPackage.Literals.SCALED_PROPERTY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getFactor() {
		return factor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setFactor(double newFactor) {
		double oldFactor = factor;
		factor = newFactor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.SCALED_PROPERTY__FACTOR, oldFactor, factor));
		
		if(realProperty != null)
			this.updateProperty(realProperty);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getOffset() {
		return offset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOffset(double newOffset) {
		double oldOffset = offset;
		offset = newOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.SCALED_PROPERTY__OFFSET, oldOffset, offset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPrecision() {
		return precision;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrecision(String newPrecision) {
		String oldPrecision = precision;
		precision = newPrecision;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServerPackage.SCALED_PROPERTY__PRECISION, oldPrecision, precision));
	}
	
	private Integer decimalPlaces;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int getDecimalPlaces() {
		if(decimalPlaces == null) {
			int dp;
			// Geforderte Nachkommastellen berechnen anhand des Precision Werts
			BigDecimal bdPrecision = new BigDecimal(getPrecision());
			dp = bdPrecision.scale();
				
			// Prfen ob erste Nachkommastelle 0 auch ist, weil bdPrecision.scale() in diesem Fall 1 zurck gibt.
			if(dp == 1 && ((bdPrecision.doubleValue() * 10.0) % 10.0) == 0.0)
				dp = 0;
			decimalPlaces = dp;
		}
				
		return decimalPlaces;
	}
	
	private Long decimalPlacesFactor;
	
	/**
	 * Aus Performancegrnden wird der Factor nur beim 1. Aufruf berechnet und anschliessend gecached.
	 * @return Gecachter Dezimalstellenfaktor
	 */
	private long getDecimalPlacesFactor() {
		if(decimalPlacesFactor == null) {
			decimalPlacesFactor = (long) Math.pow(10.0, getDecimalPlaces());
		}
		return decimalPlacesFactor;
	}

	/**
	 * Diese Methode wurde zuerst mit Hilfe der Java-Klasse BigDecimal
	 * implementiert. Danach wurde festgestellt, dass die Methoden der
	 * BigDecimal-Klasse sehr teuer sind, was zu betrchtlichen
	 * Performance-Einbussen fhrte. Deshalb wird die Rundung nun "altgebacken"
	 * mit Kommaverschiebung gemacht.
	 * 
	 * @param d Wert, welcher auf die geforderte Przision gerundet werden soll
	 * @param decimalPlaces Anzahl geforderte Nachkommastellen
	 * @return Gerundeter Wert mit der erforderlichen Pzision
	 */
	private double round(double d, int decimalPlaces) {
		long value = Math.round(d * getDecimalPlacesFactor());		
		return (((double)value) / getDecimalPlacesFactor());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public double scale(double rawValue) {
		return round(((double) rawValue - getOffset()) / getFactor(), getDecimalPlaces());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public double unscale(double scaledValue) {
		int decimalPlaces = 0;
		
		if(this.getRealProperty() instanceof Scalable)
			decimalPlaces = ((Scalable) getRealProperty()).getDecimalPlaces();
		
		return round((scaledValue * getFactor() + getOffset()), decimalPlaces);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServerPackage.SCALED_PROPERTY__FACTOR:
				return getFactor();
			case ServerPackage.SCALED_PROPERTY__OFFSET:
				return getOffset();
			case ServerPackage.SCALED_PROPERTY__PRECISION:
				return getPrecision();
			case ServerPackage.SCALED_PROPERTY__DECIMAL_PLACES:
				return getDecimalPlaces();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServerPackage.SCALED_PROPERTY__FACTOR:
				setFactor((Double)newValue);
				return;
			case ServerPackage.SCALED_PROPERTY__OFFSET:
				setOffset((Double)newValue);
				return;
			case ServerPackage.SCALED_PROPERTY__PRECISION:
				setPrecision((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServerPackage.SCALED_PROPERTY__FACTOR:
				setFactor(FACTOR_EDEFAULT);
				return;
			case ServerPackage.SCALED_PROPERTY__OFFSET:
				setOffset(OFFSET_EDEFAULT);
				return;
			case ServerPackage.SCALED_PROPERTY__PRECISION:
				setPrecision(PRECISION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServerPackage.SCALED_PROPERTY__FACTOR:
				return factor != FACTOR_EDEFAULT;
			case ServerPackage.SCALED_PROPERTY__OFFSET:
				return offset != OFFSET_EDEFAULT;
			case ServerPackage.SCALED_PROPERTY__PRECISION:
				return PRECISION_EDEFAULT == null ? precision != null : !PRECISION_EDEFAULT.equals(precision);
			case ServerPackage.SCALED_PROPERTY__DECIMAL_PLACES:
				return getDecimalPlaces() != DECIMAL_PLACES_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Scalable.class) {
			switch (derivedFeatureID) {
				case ServerPackage.SCALED_PROPERTY__FACTOR: return ServerPackage.SCALABLE__FACTOR;
				case ServerPackage.SCALED_PROPERTY__OFFSET: return ServerPackage.SCALABLE__OFFSET;
				case ServerPackage.SCALED_PROPERTY__PRECISION: return ServerPackage.SCALABLE__PRECISION;
				case ServerPackage.SCALED_PROPERTY__DECIMAL_PLACES: return ServerPackage.SCALABLE__DECIMAL_PLACES;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Scalable.class) {
			switch (baseFeatureID) {
				case ServerPackage.SCALABLE__FACTOR: return ServerPackage.SCALED_PROPERTY__FACTOR;
				case ServerPackage.SCALABLE__OFFSET: return ServerPackage.SCALED_PROPERTY__OFFSET;
				case ServerPackage.SCALABLE__PRECISION: return ServerPackage.SCALED_PROPERTY__PRECISION;
				case ServerPackage.SCALABLE__DECIMAL_PLACES: return ServerPackage.SCALED_PROPERTY__DECIMAL_PLACES;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (factor: ");
		result.append(factor);
		result.append(", offset: ");
		result.append(offset);
		result.append(", precision: ");
		result.append(precision);
		result.append(')');
		return result.toString();
	}

	@Override
	public short getTineTypeCode() {
		return TFormat.CF_DOUBLE;
	}

	@Override
	public int writeData(Device device, TDataType din) {
		int result = 0;
		double[] values = new double[din.getArrayLength()];
		
		if ((result = din.getData(values)) == 0) {
			
			for (int i=0; i<values.length; ++i) {

				// Range Check
				if (isOutOfRange((float) values[i]))
					return TErrorList.out_of_range;
				
				values[i] = unscale(values[i]);
			}
			
			result = getRealProperty().writeData(device, new TDataType(values));
			
			if(result == TErrorList.success)
				getRealProperty().notifyObservers();
		}

		return result;
	}

	@Override
	public int readData(Device device, TDataType dout) {
		double[] values = new double[getRealProperty().getLength()];
		TDataType data = new TDataType(values);
		getRealProperty().readData(device, data);

		for (int i = 0; i < values.length; ++i) {
			values[i] = scale(values[i]);
		}

		return dout.putData(values);
	}
	
	private void updateProperty(RealProperty newRealProperty) {
		
		if(newRealProperty != null) {			
			this.setMaximumValue((float) scale((int) newRealProperty.getMaximumValue()));
			this.setMinimumValue((float) scale((int) newRealProperty.getMinimumValue()));
			this.setLength(newRealProperty.getLength());
			this.setTineAccess(newRealProperty.getTineAccess());
		}
		else {
			this.setMaximumValue(0.0f);
			this.setMinimumValue(0.0f);
			this.setLength(1);
			this.setTineAccess(TineAccess.READ);
		}
	}

	@Override
	public void setRealProperty(RealProperty newRealProperty) {
		updateProperty(newRealProperty);
		super.setRealProperty(newRealProperty);
	}

	@Override
	public TDataType createTDataType() {
		return new TDataType(new double[this.getLength()]);
	}

} //ScaledPropertyImpl
