/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import ch.thomson.ucs.tine.server.*;

import java.sql.Connection;
import java.sql.Timestamp;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ServerFactoryImpl extends EFactoryImpl implements ServerFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ServerFactory init() {
		try {
			ServerFactory theServerFactory = (ServerFactory)EPackage.Registry.INSTANCE.getEFactory("http://tineserver/1.0"); 
			if (theServerFactory != null) {
				return theServerFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new ServerFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServerFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case ServerPackage.FRONT_END_CONTROLLER: return createFrontEndController();
			case ServerPackage.EQUIPMENT_MODULE: return createEquipmentModule();
			case ServerPackage.DEVICE: return createDevice();
			case ServerPackage.SCALED_PROPERTY: return createScaledProperty();
			case ServerPackage.ALIAS_PROPERTY: return createAliasProperty();
			case ServerPackage.PROPERTY_INT32: return createPropertyInt32();
			case ServerPackage.PROPERTY_FLOAT: return createPropertyFloat();
			case ServerPackage.DATA_TABLE: return createDataTable();
			case ServerPackage.PROPERTY_BYTE: return createPropertyByte();
			case ServerPackage.PROPERTY_TEXT: return createPropertyText();
			case ServerPackage.PROPERTY_DOUBLE: return createPropertyDouble();
			case ServerPackage.PROPERTY_SHORT16: return createPropertyShort16();
			case ServerPackage.GROUP_PROPERTY: return createGroupProperty();
			case ServerPackage.REAL_PROPERTY_DAO_POSTGRES: return createRealPropertyDAO_Postgres();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case ServerPackage.TINE_ACCESS:
				return createTineAccessFromString(eDataType, initialValue);
			case ServerPackage.BYTE_ORDER:
				return createByteOrderFromString(eDataType, initialValue);
			case ServerPackage.DB_CONNECTION:
				return createDBConnectionFromString(eDataType, initialValue);
			case ServerPackage.TIMESTAMP:
				return createTimestampFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case ServerPackage.TINE_ACCESS:
				return convertTineAccessToString(eDataType, instanceValue);
			case ServerPackage.BYTE_ORDER:
				return convertByteOrderToString(eDataType, instanceValue);
			case ServerPackage.DB_CONNECTION:
				return convertDBConnectionToString(eDataType, instanceValue);
			case ServerPackage.TIMESTAMP:
				return convertTimestampToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FrontEndController createFrontEndController() {
		FrontEndControllerImpl frontEndController = new FrontEndControllerImpl();
		return frontEndController;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EquipmentModule createEquipmentModule() {
		EquipmentModuleImpl equipmentModule = new EquipmentModuleImpl();
		return equipmentModule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Device createDevice() {
		DeviceImpl device = new DeviceImpl();
		return device;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScaledProperty createScaledProperty() {
		ScaledPropertyImpl scaledProperty = new ScaledPropertyImpl();
		return scaledProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AliasProperty createAliasProperty() {
		AliasPropertyImpl aliasProperty = new AliasPropertyImpl();
		return aliasProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyInt32 createPropertyInt32() {
		PropertyInt32Impl propertyInt32 = new PropertyInt32Impl();
		return propertyInt32;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyFloat createPropertyFloat() {
		PropertyFloatImpl propertyFloat = new PropertyFloatImpl();
		return propertyFloat;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataTable createDataTable() {
		DataTableImpl dataTable = new DataTableImpl();
		return dataTable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyByte createPropertyByte() {
		PropertyByteImpl propertyByte = new PropertyByteImpl();
		return propertyByte;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyText createPropertyText() {
		PropertyTextImpl propertyText = new PropertyTextImpl();
		return propertyText;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyDouble createPropertyDouble() {
		PropertyDoubleImpl propertyDouble = new PropertyDoubleImpl();
		return propertyDouble;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyShort16 createPropertyShort16() {
		PropertyShort16Impl propertyShort16 = new PropertyShort16Impl();
		return propertyShort16;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GroupProperty createGroupProperty() {
		GroupPropertyImpl groupProperty = new GroupPropertyImpl();
		return groupProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RealPropertyDAO_Postgres createRealPropertyDAO_Postgres() {
		RealPropertyDAO_PostgresImpl realPropertyDAO_Postgres = new RealPropertyDAO_PostgresImpl();
		return realPropertyDAO_Postgres;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TineAccess createTineAccessFromString(EDataType eDataType, String initialValue) {
		TineAccess result = TineAccess.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertTineAccessToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ByteOrder createByteOrderFromString(EDataType eDataType, String initialValue) {
		ByteOrder result = ByteOrder.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertByteOrderToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Connection createDBConnectionFromString(EDataType eDataType, String initialValue) {
		return (Connection)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertDBConnectionToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Timestamp createTimestampFromString(EDataType eDataType, String initialValue) {
		return (Timestamp)super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertTimestampToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServerPackage getServerPackage() {
		return (ServerPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static ServerPackage getPackage() {
		return ServerPackage.eINSTANCE;
	}

} //ServerFactoryImpl
