/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.impl;

import java.nio.ByteBuffer;
import java.sql.Connection;
import java.sql.Timestamp;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import ch.thomson.ucs.tine.server.AliasProperty;
import ch.thomson.ucs.tine.server.ByteOrder;
import ch.thomson.ucs.tine.server.DataTable;
import ch.thomson.ucs.tine.server.DecoratedProperty;
import ch.thomson.ucs.tine.server.Device;
import ch.thomson.ucs.tine.server.Driver;
import ch.thomson.ucs.tine.server.EquipmentModule;
import ch.thomson.ucs.tine.server.FrontEndController;
import ch.thomson.ucs.tine.server.GroupProperty;
import ch.thomson.ucs.tine.server.Observable;
import ch.thomson.ucs.tine.server.Observer;
import ch.thomson.ucs.tine.server.Persistable;
import ch.thomson.ucs.tine.server.Property;
import ch.thomson.ucs.tine.server.PropertyByte;
import ch.thomson.ucs.tine.server.PropertyDouble;
import ch.thomson.ucs.tine.server.PropertyFloat;
import ch.thomson.ucs.tine.server.PropertyInt32;
import ch.thomson.ucs.tine.server.PropertyNumeric;
import ch.thomson.ucs.tine.server.PropertyShort16;
import ch.thomson.ucs.tine.server.PropertyText;
import ch.thomson.ucs.tine.server.RealProperty;
import ch.thomson.ucs.tine.server.RealPropertyDAO;
import ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres;
import ch.thomson.ucs.tine.server.Scalable;
import ch.thomson.ucs.tine.server.ScaledProperty;
import ch.thomson.ucs.tine.server.ServerFactory;
import ch.thomson.ucs.tine.server.ServerPackage;
import ch.thomson.ucs.tine.server.TineAccess;
import ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.server.devices.TDevice;
import de.desy.tine.server.equipment.TEquipmentBackgroundTask;
import de.desy.tine.server.equipment.TEquipmentModule;
import de.desy.tine.server.equipment.TEquipmentModuleFactory;
import de.desy.tine.server.properties.TExportProperty;
import de.desy.tine.server.properties.TPropertyHandler;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ServerPackageImpl extends EPackageImpl implements ServerPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass frontEndControllerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass equipmentModuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deviceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass decoratedPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass realPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scaledPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass aliasPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyInt32EClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyFloatEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dataTableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyByteEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyTextEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyDoubleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass driverEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyShort16EClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass observerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass observableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass groupPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass realPropertyDAOEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass realPropertyDAO_PostgresEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass persistableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scalableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyNumericEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum tineAccessEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum byteOrderEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType tEquipmentModuleFactoryEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType tEquipmentModuleEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType tDeviceEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType tExportPropertyEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType tPropertyHandlerEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType tEquipmentBackgroundTaskEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType objectEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType exceptionEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType tDataTypeEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType dbConnectionEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType timestampEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType byteBufferEDataType = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType deviceUpdateListenerEDataType = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see ch.thomson.ucs.tine.server.ServerPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private ServerPackageImpl() {
		super(eNS_URI, ServerFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link ServerPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static ServerPackage init() {
		if (isInited) return (ServerPackage)EPackage.Registry.INSTANCE.getEPackage(ServerPackage.eNS_URI);

		// Obtain or create and register package
		ServerPackageImpl theServerPackage = (ServerPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof ServerPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new ServerPackageImpl());

		isInited = true;

		// Create package meta-data objects
		theServerPackage.createPackageContents();

		// Initialize created meta-data
		theServerPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theServerPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(ServerPackage.eNS_URI, theServerPackage);
		return theServerPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFrontEndController() {
		return frontEndControllerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_TineEquipmentModuleFactory() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFrontEndController_EquipmentModules() {
		return (EReference)frontEndControllerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_Name() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_SubSystemName() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_ContextName() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFrontEndController_Location() {
		return (EReference)frontEndControllerEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_LocalValue() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_LocalMode() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_AccessAllowed() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_AllowedHostsForLocalAccess() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFrontEndController_LockWriteProperty() {
		return (EReference)frontEndControllerEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_WriteLocked() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFrontEndController_LocalCaller() {
		return (EAttribute)frontEndControllerEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEquipmentModule() {
		return equipmentModuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEquipmentModule_FrontEndController() {
		return (EReference)equipmentModuleEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_ExportName() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_LocalName() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_TineEquipmentModule() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEquipmentModule_Devices() {
		return (EReference)equipmentModuleEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEquipmentModule_Properties() {
		return (EReference)equipmentModuleEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_TineBackgroundTask() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_DevicePollingRate() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_DriverType() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_ByteOrder() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEquipmentModule_TinePath() {
		return (EAttribute)equipmentModuleEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEquipmentModule_ActualState() {
		return (EReference)equipmentModuleEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEquipmentModule_TargetState() {
		return (EReference)equipmentModuleEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDevice() {
		return deviceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_TineDevice() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDevice_EquipmentModule() {
		return (EReference)deviceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDevice_DataTables() {
		return (EReference)deviceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_Name() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDevice_Driver() {
		return (EReference)deviceEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_Address() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_ActualError() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_UserDataStamp() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_SystemDataStamp() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_Transaction() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDevice_DeviceUpdateListeners() {
		return (EAttribute)deviceEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDevice_LinkUserDataStamp() {
		return (EReference)deviceEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDevice_LinkSystemDataStamp() {
		return (EReference)deviceEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getProperty() {
		return propertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_TineExportProperty() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getProperty_EquipmentModule() {
		return (EReference)propertyEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_TinePropertyHandler() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_Name() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_Description() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_TineAccess() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_Length() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_MinimumValue() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_MaximumValue() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_Unit() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_Writable() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_LogonLevel() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_MaxState() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_Scheduled() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getProperty_RefreshRate() {
		return (EAttribute)propertyEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDecoratedProperty() {
		return decoratedPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDecoratedProperty_RealProperty() {
		return (EReference)decoratedPropertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRealProperty() {
		return realPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_DataTableName() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_AddressOffset() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_DefaultValue() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_DriverAddress() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_UserDefinedAddressObject() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_Persistent() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_Dirty() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealProperty_Dummy() {
		return (EAttribute)realPropertyEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScaledProperty() {
		return scaledPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAliasProperty() {
		return aliasPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyInt32() {
		return propertyInt32EClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyFloat() {
		return propertyFloatEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDataTable() {
		return dataTableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataTable_Device() {
		return (EReference)dataTableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDataTable_Properties() {
		return (EReference)dataTableEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataTable_Name() {
		return (EAttribute)dataTableEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataTable_ByteBuffer() {
		return (EAttribute)dataTableEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataTable_AbsoluteAddress() {
		return (EAttribute)dataTableEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataTable_Dirty() {
		return (EAttribute)dataTableEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataTable_Writable() {
		return (EAttribute)dataTableEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataTable_Dummy() {
		return (EAttribute)dataTableEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDataTable_ObserverNotificationEnabled() {
		return (EAttribute)dataTableEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyByte() {
		return propertyByteEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyText() {
		return propertyTextEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyDouble() {
		return propertyDoubleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDriver() {
		return driverEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDriver_Device() {
		return (EReference)driverEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDriver_Address() {
		return (EAttribute)driverEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyShort16() {
		return propertyShort16EClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getObserver() {
		return observerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getObservable() {
		return observableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getObservable_Observers() {
		return (EReference)observableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGroupProperty() {
		return groupPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGroupProperty_Properties() {
		return (EReference)groupPropertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRealPropertyDAO() {
		return realPropertyDAOEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealPropertyDAO_Connection() {
		return (EAttribute)realPropertyDAOEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRealPropertyDAO_Timestamp() {
		return (EAttribute)realPropertyDAOEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRealPropertyDAO_Postgres() {
		return realPropertyDAO_PostgresEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPersistable() {
		return persistableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScalable() {
		return scalableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalable_Factor() {
		return (EAttribute)scalableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalable_Offset() {
		return (EAttribute)scalableEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalable_Precision() {
		return (EAttribute)scalableEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalable_DecimalPlaces() {
		return (EAttribute)scalableEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyNumeric() {
		return propertyNumericEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTineAccess() {
		return tineAccessEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getByteOrder() {
		return byteOrderEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTEquipmentModuleFactory() {
		return tEquipmentModuleFactoryEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTEquipmentModule() {
		return tEquipmentModuleEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTDevice() {
		return tDeviceEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTExportProperty() {
		return tExportPropertyEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTPropertyHandler() {
		return tPropertyHandlerEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTEquipmentBackgroundTask() {
		return tEquipmentBackgroundTaskEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getObject() {
		return objectEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getException() {
		return exceptionEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTDataType() {
		return tDataTypeEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getDBConnection() {
		return dbConnectionEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getTimestamp() {
		return timestampEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getByteBuffer() {
		return byteBufferEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getDeviceUpdateListener() {
		return deviceUpdateListenerEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServerFactory getServerFactory() {
		return (ServerFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		frontEndControllerEClass = createEClass(FRONT_END_CONTROLLER);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__TINE_EQUIPMENT_MODULE_FACTORY);
		createEReference(frontEndControllerEClass, FRONT_END_CONTROLLER__EQUIPMENT_MODULES);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__NAME);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__SUB_SYSTEM_NAME);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__CONTEXT_NAME);
		createEReference(frontEndControllerEClass, FRONT_END_CONTROLLER__LOCATION);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__LOCAL_VALUE);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__LOCAL_MODE);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__ACCESS_ALLOWED);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS);
		createEReference(frontEndControllerEClass, FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__WRITE_LOCKED);
		createEAttribute(frontEndControllerEClass, FRONT_END_CONTROLLER__LOCAL_CALLER);

		equipmentModuleEClass = createEClass(EQUIPMENT_MODULE);
		createEReference(equipmentModuleEClass, EQUIPMENT_MODULE__FRONT_END_CONTROLLER);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__EXPORT_NAME);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__LOCAL_NAME);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__TINE_EQUIPMENT_MODULE);
		createEReference(equipmentModuleEClass, EQUIPMENT_MODULE__DEVICES);
		createEReference(equipmentModuleEClass, EQUIPMENT_MODULE__PROPERTIES);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__TINE_BACKGROUND_TASK);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__DEVICE_POLLING_RATE);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__DRIVER_TYPE);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__BYTE_ORDER);
		createEAttribute(equipmentModuleEClass, EQUIPMENT_MODULE__TINE_PATH);
		createEReference(equipmentModuleEClass, EQUIPMENT_MODULE__ACTUAL_STATE);
		createEReference(equipmentModuleEClass, EQUIPMENT_MODULE__TARGET_STATE);

		deviceEClass = createEClass(DEVICE);
		createEAttribute(deviceEClass, DEVICE__TINE_DEVICE);
		createEReference(deviceEClass, DEVICE__EQUIPMENT_MODULE);
		createEReference(deviceEClass, DEVICE__DATA_TABLES);
		createEAttribute(deviceEClass, DEVICE__NAME);
		createEReference(deviceEClass, DEVICE__DRIVER);
		createEAttribute(deviceEClass, DEVICE__ADDRESS);
		createEAttribute(deviceEClass, DEVICE__ACTUAL_ERROR);
		createEAttribute(deviceEClass, DEVICE__USER_DATA_STAMP);
		createEAttribute(deviceEClass, DEVICE__SYSTEM_DATA_STAMP);
		createEAttribute(deviceEClass, DEVICE__TRANSACTION);
		createEAttribute(deviceEClass, DEVICE__DEVICE_UPDATE_LISTENERS);
		createEReference(deviceEClass, DEVICE__LINK_USER_DATA_STAMP);
		createEReference(deviceEClass, DEVICE__LINK_SYSTEM_DATA_STAMP);

		propertyEClass = createEClass(PROPERTY);
		createEAttribute(propertyEClass, PROPERTY__TINE_EXPORT_PROPERTY);
		createEReference(propertyEClass, PROPERTY__EQUIPMENT_MODULE);
		createEAttribute(propertyEClass, PROPERTY__TINE_PROPERTY_HANDLER);
		createEAttribute(propertyEClass, PROPERTY__NAME);
		createEAttribute(propertyEClass, PROPERTY__DESCRIPTION);
		createEAttribute(propertyEClass, PROPERTY__TINE_ACCESS);
		createEAttribute(propertyEClass, PROPERTY__LENGTH);
		createEAttribute(propertyEClass, PROPERTY__MINIMUM_VALUE);
		createEAttribute(propertyEClass, PROPERTY__MAXIMUM_VALUE);
		createEAttribute(propertyEClass, PROPERTY__UNIT);
		createEAttribute(propertyEClass, PROPERTY__WRITABLE);
		createEAttribute(propertyEClass, PROPERTY__LOGON_LEVEL);
		createEAttribute(propertyEClass, PROPERTY__MAX_STATE);
		createEAttribute(propertyEClass, PROPERTY__SCHEDULED);
		createEAttribute(propertyEClass, PROPERTY__REFRESH_RATE);

		decoratedPropertyEClass = createEClass(DECORATED_PROPERTY);
		createEReference(decoratedPropertyEClass, DECORATED_PROPERTY__REAL_PROPERTY);

		realPropertyEClass = createEClass(REAL_PROPERTY);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__DATA_TABLE_NAME);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__ADDRESS_OFFSET);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__DEFAULT_VALUE);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__DRIVER_ADDRESS);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__PERSISTENT);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__DIRTY);
		createEAttribute(realPropertyEClass, REAL_PROPERTY__DUMMY);

		scaledPropertyEClass = createEClass(SCALED_PROPERTY);

		aliasPropertyEClass = createEClass(ALIAS_PROPERTY);

		propertyInt32EClass = createEClass(PROPERTY_INT32);

		propertyFloatEClass = createEClass(PROPERTY_FLOAT);

		dataTableEClass = createEClass(DATA_TABLE);
		createEReference(dataTableEClass, DATA_TABLE__DEVICE);
		createEReference(dataTableEClass, DATA_TABLE__PROPERTIES);
		createEAttribute(dataTableEClass, DATA_TABLE__NAME);
		createEAttribute(dataTableEClass, DATA_TABLE__BYTE_BUFFER);
		createEAttribute(dataTableEClass, DATA_TABLE__ABSOLUTE_ADDRESS);
		createEAttribute(dataTableEClass, DATA_TABLE__DIRTY);
		createEAttribute(dataTableEClass, DATA_TABLE__WRITABLE);
		createEAttribute(dataTableEClass, DATA_TABLE__DUMMY);
		createEAttribute(dataTableEClass, DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED);

		propertyByteEClass = createEClass(PROPERTY_BYTE);

		propertyTextEClass = createEClass(PROPERTY_TEXT);

		propertyDoubleEClass = createEClass(PROPERTY_DOUBLE);

		driverEClass = createEClass(DRIVER);
		createEReference(driverEClass, DRIVER__DEVICE);
		createEAttribute(driverEClass, DRIVER__ADDRESS);

		propertyShort16EClass = createEClass(PROPERTY_SHORT16);

		observerEClass = createEClass(OBSERVER);

		observableEClass = createEClass(OBSERVABLE);
		createEReference(observableEClass, OBSERVABLE__OBSERVERS);

		groupPropertyEClass = createEClass(GROUP_PROPERTY);
		createEReference(groupPropertyEClass, GROUP_PROPERTY__PROPERTIES);

		realPropertyDAOEClass = createEClass(REAL_PROPERTY_DAO);
		createEAttribute(realPropertyDAOEClass, REAL_PROPERTY_DAO__CONNECTION);
		createEAttribute(realPropertyDAOEClass, REAL_PROPERTY_DAO__TIMESTAMP);

		realPropertyDAO_PostgresEClass = createEClass(REAL_PROPERTY_DAO_POSTGRES);

		persistableEClass = createEClass(PERSISTABLE);

		scalableEClass = createEClass(SCALABLE);
		createEAttribute(scalableEClass, SCALABLE__FACTOR);
		createEAttribute(scalableEClass, SCALABLE__OFFSET);
		createEAttribute(scalableEClass, SCALABLE__PRECISION);
		createEAttribute(scalableEClass, SCALABLE__DECIMAL_PLACES);

		propertyNumericEClass = createEClass(PROPERTY_NUMERIC);

		// Create enums
		tineAccessEEnum = createEEnum(TINE_ACCESS);
		byteOrderEEnum = createEEnum(BYTE_ORDER);

		// Create data types
		tEquipmentModuleFactoryEDataType = createEDataType(TEQUIPMENT_MODULE_FACTORY);
		tEquipmentModuleEDataType = createEDataType(TEQUIPMENT_MODULE);
		tDeviceEDataType = createEDataType(TDEVICE);
		tExportPropertyEDataType = createEDataType(TEXPORT_PROPERTY);
		tPropertyHandlerEDataType = createEDataType(TPROPERTY_HANDLER);
		tEquipmentBackgroundTaskEDataType = createEDataType(TEQUIPMENT_BACKGROUND_TASK);
		objectEDataType = createEDataType(OBJECT);
		exceptionEDataType = createEDataType(EXCEPTION);
		tDataTypeEDataType = createEDataType(TDATA_TYPE);
		dbConnectionEDataType = createEDataType(DB_CONNECTION);
		timestampEDataType = createEDataType(TIMESTAMP);
		byteBufferEDataType = createEDataType(BYTE_BUFFER);
		deviceUpdateListenerEDataType = createEDataType(DEVICE_UPDATE_LISTENER);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		equipmentModuleEClass.getESuperTypes().add(this.getPersistable());
		propertyEClass.getESuperTypes().add(this.getObservable());
		decoratedPropertyEClass.getESuperTypes().add(this.getProperty());
		decoratedPropertyEClass.getESuperTypes().add(this.getObserver());
		realPropertyEClass.getESuperTypes().add(this.getProperty());
		realPropertyEClass.getESuperTypes().add(this.getPersistable());
		scaledPropertyEClass.getESuperTypes().add(this.getDecoratedProperty());
		scaledPropertyEClass.getESuperTypes().add(this.getScalable());
		aliasPropertyEClass.getESuperTypes().add(this.getDecoratedProperty());
		propertyInt32EClass.getESuperTypes().add(this.getPropertyNumeric());
		propertyFloatEClass.getESuperTypes().add(this.getPropertyNumeric());
		dataTableEClass.getESuperTypes().add(this.getObservable());
		propertyByteEClass.getESuperTypes().add(this.getRealProperty());
		propertyTextEClass.getESuperTypes().add(this.getRealProperty());
		propertyDoubleEClass.getESuperTypes().add(this.getPropertyNumeric());
		propertyShort16EClass.getESuperTypes().add(this.getPropertyNumeric());
		groupPropertyEClass.getESuperTypes().add(this.getProperty());
		groupPropertyEClass.getESuperTypes().add(this.getObserver());
		realPropertyDAO_PostgresEClass.getESuperTypes().add(this.getRealPropertyDAO());
		propertyNumericEClass.getESuperTypes().add(this.getRealProperty());
		propertyNumericEClass.getESuperTypes().add(this.getScalable());

		// Initialize classes and features; add operations and parameters
		initEClass(frontEndControllerEClass, FrontEndController.class, "FrontEndController", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFrontEndController_TineEquipmentModuleFactory(), this.getTEquipmentModuleFactory(), "tineEquipmentModuleFactory", null, 0, 1, FrontEndController.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFrontEndController_EquipmentModules(), this.getEquipmentModule(), this.getEquipmentModule_FrontEndController(), "equipmentModules", null, 1, -1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getFrontEndController_EquipmentModules().getEKeys().add(this.getEquipmentModule_ExportName());
		initEAttribute(getFrontEndController_Name(), ecorePackage.getEString(), "name", null, 0, 1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_SubSystemName(), ecorePackage.getEString(), "subSystemName", null, 1, 1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_ContextName(), ecorePackage.getEString(), "contextName", null, 0, 1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFrontEndController_Location(), this.getPropertyNumeric(), null, "location", null, 1, 1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_LocalValue(), ecorePackage.getEInt(), "localValue", null, 0, 1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_LocalMode(), ecorePackage.getEBoolean(), "localMode", null, 0, 1, FrontEndController.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_AccessAllowed(), ecorePackage.getEBoolean(), "accessAllowed", null, 0, 1, FrontEndController.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_AllowedHostsForLocalAccess(), ecorePackage.getEString(), "allowedHostsForLocalAccess", null, 0, -1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFrontEndController_LockWriteProperty(), this.getPropertyNumeric(), null, "lockWriteProperty", null, 0, 1, FrontEndController.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_WriteLocked(), ecorePackage.getEBoolean(), "writeLocked", null, 0, 1, FrontEndController.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getFrontEndController_LocalCaller(), ecorePackage.getEBoolean(), "localCaller", null, 0, 1, FrontEndController.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(frontEndControllerEClass, null, "initialize", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		addEOperation(frontEndControllerEClass, null, "run", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(frontEndControllerEClass, null, "shutdown", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(frontEndControllerEClass, this.getEquipmentModule(), "findEquipmentModule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "exportName", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(equipmentModuleEClass, EquipmentModule.class, "EquipmentModule", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEquipmentModule_FrontEndController(), this.getFrontEndController(), this.getFrontEndController_EquipmentModules(), "frontEndController", null, 1, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEquipmentModule_ExportName(), ecorePackage.getEString(), "exportName", null, 1, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEquipmentModule_LocalName(), ecorePackage.getEString(), "localName", null, 1, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEquipmentModule_TineEquipmentModule(), this.getTEquipmentModule(), "tineEquipmentModule", null, 0, 1, EquipmentModule.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEquipmentModule_Devices(), this.getDevice(), this.getDevice_EquipmentModule(), "devices", null, 1, -1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getEquipmentModule_Devices().getEKeys().add(this.getDevice_Name());
		initEReference(getEquipmentModule_Properties(), this.getProperty(), this.getProperty_EquipmentModule(), "properties", null, 1, -1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getEquipmentModule_Properties().getEKeys().add(this.getProperty_Name());
		initEAttribute(getEquipmentModule_TineBackgroundTask(), this.getTEquipmentBackgroundTask(), "tineBackgroundTask", null, 0, 1, EquipmentModule.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEquipmentModule_DevicePollingRate(), ecorePackage.getEInt(), "devicePollingRate", "100", 0, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEquipmentModule_DriverType(), ecorePackage.getEString(), "driverType", null, 1, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEquipmentModule_ByteOrder(), this.getByteOrder(), "byteOrder", null, 0, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEquipmentModule_TinePath(), ecorePackage.getEString(), "tinePath", null, 0, 1, EquipmentModule.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getEquipmentModule_ActualState(), this.getPropertyNumeric(), null, "actualState", null, 0, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getEquipmentModule_TargetState(), this.getPropertyNumeric(), null, "targetState", null, 0, 1, EquipmentModule.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(equipmentModuleEClass, null, "initialize", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(equipmentModuleEClass, this.getDevice(), "findDevice", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(equipmentModuleEClass, this.getRealProperty(), "collectRealProperties", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(equipmentModuleEClass, null, "scheduleProperty", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getProperty(), "property", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(equipmentModuleEClass, this.getProperty(), "findProperty", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deviceEClass, Device.class, "Device", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDevice_TineDevice(), this.getTDevice(), "tineDevice", null, 0, 1, Device.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDevice_EquipmentModule(), this.getEquipmentModule(), this.getEquipmentModule_Devices(), "equipmentModule", null, 1, 1, Device.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDevice_DataTables(), this.getDataTable(), this.getDataTable_Device(), "dataTables", null, 0, -1, Device.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDevice_Name(), ecorePackage.getEString(), "name", null, 1, 1, Device.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDevice_Driver(), this.getDriver(), this.getDriver_Device(), "driver", null, 0, 1, Device.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDevice_Address(), ecorePackage.getEString(), "address", null, 0, 1, Device.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDevice_ActualError(), this.getException(), "actualError", null, 0, 1, Device.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDevice_UserDataStamp(), ecorePackage.getEInt(), "userDataStamp", null, 0, 1, Device.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDevice_SystemDataStamp(), ecorePackage.getEInt(), "systemDataStamp", null, 0, 1, Device.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDevice_Transaction(), ecorePackage.getEBoolean(), "transaction", null, 0, 1, Device.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDevice_DeviceUpdateListeners(), this.getDeviceUpdateListener(), "deviceUpdateListeners", null, 0, -1, Device.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDevice_LinkUserDataStamp(), this.getPropertyInt32(), null, "linkUserDataStamp", null, 0, 1, Device.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDevice_LinkSystemDataStamp(), this.getPropertyInt32(), null, "linkSystemDataStamp", null, 0, 1, Device.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		addEOperation(deviceEClass, null, "run", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deviceEClass, null, "initialize", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(deviceEClass, this.getDataTable(), "findDataTable", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deviceEClass, null, "dataTableChanged", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDataTable(), "dataTable", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		addEOperation(deviceEClass, null, "startTransaction", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deviceEClass, null, "commit", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		initEClass(propertyEClass, Property.class, "Property", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getProperty_TineExportProperty(), this.getTExportProperty(), "tineExportProperty", null, 0, 1, Property.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getProperty_EquipmentModule(), this.getEquipmentModule(), this.getEquipmentModule_Properties(), "equipmentModule", null, 1, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_TinePropertyHandler(), this.getTPropertyHandler(), "tinePropertyHandler", null, 0, 1, Property.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_Name(), ecorePackage.getEString(), "name", null, 1, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_Description(), ecorePackage.getEString(), "description", "No description", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_TineAccess(), this.getTineAccess(), "tineAccess", "", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_Length(), ecorePackage.getEInt(), "length", "1", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_MinimumValue(), ecorePackage.getEFloat(), "minimumValue", "-2147483648.0", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_MaximumValue(), ecorePackage.getEFloat(), "maximumValue", "2147483647.0", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_Unit(), ecorePackage.getEString(), "unit", null, 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_Writable(), ecorePackage.getEBoolean(), "writable", null, 0, 1, Property.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_LogonLevel(), ecorePackage.getEInt(), "logonLevel", null, 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_MaxState(), ecorePackage.getEInt(), "maxState", "2147483647", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_Scheduled(), ecorePackage.getEBoolean(), "scheduled", "false", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getProperty_RefreshRate(), ecorePackage.getEInt(), "refreshRate", "1000", 0, 1, Property.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(propertyEClass, null, "initialize", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		addEOperation(propertyEClass, ecorePackage.getEInt(), "getTypeSize", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(propertyEClass, ecorePackage.getEInt(), "getByteSize", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(propertyEClass, ecorePackage.getEBoolean(), "isOutOfRange", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEFloat(), "value", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(propertyEClass, this.getTDataType(), "createTDataType", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(decoratedPropertyEClass, DecoratedProperty.class, "DecoratedProperty", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDecoratedProperty_RealProperty(), this.getRealProperty(), null, "realProperty", null, 1, 1, DecoratedProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(realPropertyEClass, RealProperty.class, "RealProperty", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRealProperty_DataTableName(), ecorePackage.getEString(), "dataTableName", null, 1, 1, RealProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealProperty_AddressOffset(), ecorePackage.getEInt(), "addressOffset", null, 1, 1, RealProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealProperty_DefaultValue(), ecorePackage.getEString(), "defaultValue", "0.0", 0, 1, RealProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealProperty_DriverAddress(), ecorePackage.getEString(), "driverAddress", null, 0, 1, RealProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealProperty_UserDefinedAddressObject(), this.getObject(), "userDefinedAddressObject", null, 0, 1, RealProperty.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealProperty_Persistent(), ecorePackage.getEBoolean(), "persistent", "true", 0, 1, RealProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealProperty_Dirty(), ecorePackage.getEBoolean(), "dirty", null, 0, 1, RealProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealProperty_Dummy(), ecorePackage.getEBoolean(), "dummy", "false", 0, 1, RealProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(realPropertyEClass, null, "readFromDataTable", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDevice(), "device", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEByteArray(), "buffer", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(realPropertyEClass, null, "writeToDataTable", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDevice(), "device", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEByteArray(), "buffer", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		addEOperation(realPropertyEClass, this.getTDataType(), "getDefaultValueAsTDataType", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(realPropertyEClass, null, "refreshCache", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDataTable(), "dataTable", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(scaledPropertyEClass, ScaledProperty.class, "ScaledProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(scaledPropertyEClass, ecorePackage.getEDouble(), "scale", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "rawValue", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(scaledPropertyEClass, ecorePackage.getEDouble(), "unscale", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "scaledValue", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(aliasPropertyEClass, AliasProperty.class, "AliasProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(propertyInt32EClass, PropertyInt32.class, "PropertyInt32", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(propertyFloatEClass, PropertyFloat.class, "PropertyFloat", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(dataTableEClass, DataTable.class, "DataTable", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDataTable_Device(), this.getDevice(), this.getDevice_DataTables(), "device", null, 1, 1, DataTable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDataTable_Properties(), this.getRealProperty(), null, "properties", null, 0, -1, DataTable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataTable_Name(), ecorePackage.getEString(), "name", null, 0, 1, DataTable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataTable_ByteBuffer(), this.getByteBuffer(), "byteBuffer", null, 0, 1, DataTable.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataTable_AbsoluteAddress(), ecorePackage.getEInt(), "absoluteAddress", null, 0, 1, DataTable.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataTable_Dirty(), ecorePackage.getEBoolean(), "dirty", null, 0, 1, DataTable.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataTable_Writable(), ecorePackage.getEBoolean(), "writable", null, 0, 1, DataTable.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataTable_Dummy(), ecorePackage.getEBoolean(), "dummy", null, 0, 1, DataTable.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDataTable_ObserverNotificationEnabled(), ecorePackage.getEBoolean(), "observerNotificationEnabled", "true", 0, 1, DataTable.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(dataTableEClass, null, "write", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEByteArray(), "buffer", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEInt(), "offset", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(dataTableEClass, null, "read", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEByteArray(), "buffer", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEInt(), "offset", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(dataTableEClass, null, "initialize", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		initEClass(propertyByteEClass, PropertyByte.class, "PropertyByte", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(propertyTextEClass, PropertyText.class, "PropertyText", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(propertyDoubleEClass, PropertyDouble.class, "PropertyDouble", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(driverEClass, Driver.class, "Driver", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDriver_Device(), this.getDevice(), this.getDevice_Driver(), "device", null, 1, 1, Driver.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDriver_Address(), ecorePackage.getEString(), "address", null, 0, 1, Driver.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(driverEClass, null, "initialize", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(driverEClass, null, "writeData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDataTable(), "dataTable", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(driverEClass, null, "parseAddressString", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRealProperty(), "realProperty", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(driverEClass, ecorePackage.getEInt(), "readData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDataTable(), "dataTable", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		initEClass(propertyShort16EClass, PropertyShort16.class, "PropertyShort16", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(observerEClass, Observer.class, "Observer", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(observerEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getObservable(), "observable", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(observableEClass, Observable.class, "Observable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getObservable_Observers(), this.getObserver(), null, "observers", null, 0, -1, Observable.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(observableEClass, null, "addObserver", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getObserver(), "observer", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(observableEClass, null, "removeObserver", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getObserver(), "observer", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(observableEClass, null, "notifyObservers", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(groupPropertyEClass, GroupProperty.class, "GroupProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getGroupProperty_Properties(), this.getProperty(), null, "properties", null, 1, -1, GroupProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(realPropertyDAOEClass, RealPropertyDAO.class, "RealPropertyDAO", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRealPropertyDAO_Connection(), this.getDBConnection(), "connection", null, 0, 1, RealPropertyDAO.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRealPropertyDAO_Timestamp(), this.getTimestamp(), "timestamp", null, 0, 1, RealPropertyDAO.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(realPropertyDAOEClass, null, "open", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "path", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(realPropertyDAOEClass, null, "close", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(realPropertyDAOEClass, null, "saveData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDevice(), "device", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRealProperty(), "property", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getTDataType(), "tDataType", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(realPropertyDAOEClass, this.getTDataType(), "loadData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDevice(), "device", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRealProperty(), "property", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(realPropertyDAOEClass, null, "clean", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(realPropertyDAOEClass, ecorePackage.getEBoolean(), "isOpen", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		initEClass(realPropertyDAO_PostgresEClass, RealPropertyDAO_Postgres.class, "RealPropertyDAO_Postgres", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(persistableEClass, Persistable.class, "Persistable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(persistableEClass, null, "loadData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRealPropertyDAO(), "dao", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		op = addEOperation(persistableEClass, null, "saveData", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRealPropertyDAO(), "dao", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEException(op, this.getException());

		initEClass(scalableEClass, Scalable.class, "Scalable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getScalable_Factor(), ecorePackage.getEDouble(), "factor", "1.0", 0, 1, Scalable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScalable_Offset(), ecorePackage.getEDouble(), "offset", "0.0", 0, 1, Scalable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScalable_Precision(), ecorePackage.getEString(), "precision", "1.0", 0, 1, Scalable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScalable_DecimalPlaces(), ecorePackage.getEInt(), "decimalPlaces", null, 0, 1, Scalable.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(propertyNumericEClass, PropertyNumeric.class, "PropertyNumeric", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize enums and add enum literals
		initEEnum(tineAccessEEnum, TineAccess.class, "TineAccess");
		addEEnumLiteral(tineAccessEEnum, TineAccess.READ);
		addEEnumLiteral(tineAccessEEnum, TineAccess.READ_WRITE);

		initEEnum(byteOrderEEnum, ByteOrder.class, "ByteOrder");
		addEEnumLiteral(byteOrderEEnum, ByteOrder.BIG_ENDIAN);
		addEEnumLiteral(byteOrderEEnum, ByteOrder.LITTLE_ENDIAN);

		// Initialize data types
		initEDataType(tEquipmentModuleFactoryEDataType, TEquipmentModuleFactory.class, "TEquipmentModuleFactory", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(tEquipmentModuleEDataType, TEquipmentModule.class, "TEquipmentModule", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(tDeviceEDataType, TDevice.class, "TDevice", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(tExportPropertyEDataType, TExportProperty.class, "TExportProperty", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(tPropertyHandlerEDataType, TPropertyHandler.class, "TPropertyHandler", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(tEquipmentBackgroundTaskEDataType, TEquipmentBackgroundTask.class, "TEquipmentBackgroundTask", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(objectEDataType, Object.class, "Object", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(exceptionEDataType, Exception.class, "Exception", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(tDataTypeEDataType, TDataType.class, "TDataType", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(dbConnectionEDataType, Connection.class, "DBConnection", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(timestampEDataType, Timestamp.class, "Timestamp", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(byteBufferEDataType, ByteBuffer.class, "ByteBuffer", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
		initEDataType(deviceUpdateListenerEDataType, DeviceUpdateListener.class, "DeviceUpdateListener", !IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);

		// Create resource
		createResource(eNS_URI);
	}

} //ServerPackageImpl
