package ch.thomson.ucs.tine.server.internal.client;

/**
 * Klassen, die dieses Interface implementieren, mssen unbedingt sicherstellen,
 * dass in den implementierten Methoden keine blockierenden oder langedauernden
 * Operationen ausgefhrt werden. Die Methoden werden synchron vom
 * Device-Polling-Thread aufgerufen und dieser darf auf keinen Fall gebremst
 * werden, da sonst das geforderte Polling-Intervall nicht mehr eingehalten
 * werden kann.
 * 
 * @author FischerU
 * 
 */
public interface DeviceUpdateListener {
	public void postUpdate();

	public String getName();
}
