package ch.thomson.ucs.tine.server.internal.client;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class ThreadPool {
	protected static ThreadPool instance;
	protected ExecutorService pool;
	
	private ThreadPool() {
		pool = Executors.newFixedThreadPool(10);
	}
	
	public static synchronized ThreadPool getInstance() {
		if(instance == null) {
			instance = new ThreadPool();
		}
		return instance;
	}
	
	public void execute(Runnable command) {
		pool.execute(command);
	}
}
