/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.util;

import ch.thomson.ucs.tine.server.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see ch.thomson.ucs.tine.server.ServerPackage
 * @generated
 */
public class ServerAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static ServerPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServerAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = ServerPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ServerSwitch<Adapter> modelSwitch =
		new ServerSwitch<Adapter>() {
			@Override
			public Adapter caseFrontEndController(FrontEndController object) {
				return createFrontEndControllerAdapter();
			}
			@Override
			public Adapter caseEquipmentModule(EquipmentModule object) {
				return createEquipmentModuleAdapter();
			}
			@Override
			public Adapter caseDevice(Device object) {
				return createDeviceAdapter();
			}
			@Override
			public Adapter caseProperty(Property object) {
				return createPropertyAdapter();
			}
			@Override
			public Adapter caseDecoratedProperty(DecoratedProperty object) {
				return createDecoratedPropertyAdapter();
			}
			@Override
			public Adapter caseRealProperty(RealProperty object) {
				return createRealPropertyAdapter();
			}
			@Override
			public Adapter caseScaledProperty(ScaledProperty object) {
				return createScaledPropertyAdapter();
			}
			@Override
			public Adapter caseAliasProperty(AliasProperty object) {
				return createAliasPropertyAdapter();
			}
			@Override
			public Adapter casePropertyInt32(PropertyInt32 object) {
				return createPropertyInt32Adapter();
			}
			@Override
			public Adapter casePropertyFloat(PropertyFloat object) {
				return createPropertyFloatAdapter();
			}
			@Override
			public Adapter caseDataTable(DataTable object) {
				return createDataTableAdapter();
			}
			@Override
			public Adapter casePropertyByte(PropertyByte object) {
				return createPropertyByteAdapter();
			}
			@Override
			public Adapter casePropertyText(PropertyText object) {
				return createPropertyTextAdapter();
			}
			@Override
			public Adapter casePropertyDouble(PropertyDouble object) {
				return createPropertyDoubleAdapter();
			}
			@Override
			public Adapter caseDriver(Driver object) {
				return createDriverAdapter();
			}
			@Override
			public Adapter casePropertyShort16(PropertyShort16 object) {
				return createPropertyShort16Adapter();
			}
			@Override
			public Adapter caseObserver(Observer object) {
				return createObserverAdapter();
			}
			@Override
			public Adapter caseObservable(Observable object) {
				return createObservableAdapter();
			}
			@Override
			public Adapter caseGroupProperty(GroupProperty object) {
				return createGroupPropertyAdapter();
			}
			@Override
			public Adapter caseRealPropertyDAO(RealPropertyDAO object) {
				return createRealPropertyDAOAdapter();
			}
			@Override
			public Adapter caseRealPropertyDAO_Postgres(RealPropertyDAO_Postgres object) {
				return createRealPropertyDAO_PostgresAdapter();
			}
			@Override
			public Adapter casePersistable(Persistable object) {
				return createPersistableAdapter();
			}
			@Override
			public Adapter caseScalable(Scalable object) {
				return createScalableAdapter();
			}
			@Override
			public Adapter casePropertyNumeric(PropertyNumeric object) {
				return createPropertyNumericAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.FrontEndController <em>Front End Controller</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.FrontEndController
	 * @generated
	 */
	public Adapter createFrontEndControllerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.EquipmentModule <em>Equipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule
	 * @generated
	 */
	public Adapter createEquipmentModuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.Device <em>Device</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.Device
	 * @generated
	 */
	public Adapter createDeviceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.Property <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.Property
	 * @generated
	 */
	public Adapter createPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.DecoratedProperty <em>Decorated Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.DecoratedProperty
	 * @generated
	 */
	public Adapter createDecoratedPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.RealProperty <em>Real Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.RealProperty
	 * @generated
	 */
	public Adapter createRealPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.ScaledProperty <em>Scaled Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.ScaledProperty
	 * @generated
	 */
	public Adapter createScaledPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.AliasProperty <em>Alias Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.AliasProperty
	 * @generated
	 */
	public Adapter createAliasPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.PropertyInt32 <em>Property Int32</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.PropertyInt32
	 * @generated
	 */
	public Adapter createPropertyInt32Adapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.PropertyFloat <em>Property Float</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.PropertyFloat
	 * @generated
	 */
	public Adapter createPropertyFloatAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.DataTable <em>Data Table</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.DataTable
	 * @generated
	 */
	public Adapter createDataTableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.PropertyByte <em>Property Byte</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.PropertyByte
	 * @generated
	 */
	public Adapter createPropertyByteAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.PropertyText <em>Property Text</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.PropertyText
	 * @generated
	 */
	public Adapter createPropertyTextAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.PropertyDouble <em>Property Double</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.PropertyDouble
	 * @generated
	 */
	public Adapter createPropertyDoubleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.Driver <em>Driver</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.Driver
	 * @generated
	 */
	public Adapter createDriverAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.PropertyShort16 <em>Property Short16</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.PropertyShort16
	 * @generated
	 */
	public Adapter createPropertyShort16Adapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.Observer <em>Observer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.Observer
	 * @generated
	 */
	public Adapter createObserverAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.Observable <em>Observable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.Observable
	 * @generated
	 */
	public Adapter createObservableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.GroupProperty <em>Group Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.GroupProperty
	 * @generated
	 */
	public Adapter createGroupPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.RealPropertyDAO <em>Real Property DAO</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.RealPropertyDAO
	 * @generated
	 */
	public Adapter createRealPropertyDAOAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres <em>Real Property DAO Postgres</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres
	 * @generated
	 */
	public Adapter createRealPropertyDAO_PostgresAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.Persistable <em>Persistable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.Persistable
	 * @generated
	 */
	public Adapter createPersistableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.Scalable <em>Scalable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.Scalable
	 * @generated
	 */
	public Adapter createScalableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link ch.thomson.ucs.tine.server.PropertyNumeric <em>Property Numeric</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see ch.thomson.ucs.tine.server.PropertyNumeric
	 * @generated
	 */
	public Adapter createPropertyNumericAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //ServerAdapterFactory
