/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server.util;

import ch.thomson.ucs.tine.server.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see ch.thomson.ucs.tine.server.ServerPackage
 * @generated
 */
public class ServerSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static ServerPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServerSwitch() {
		if (modelPackage == null) {
			modelPackage = ServerPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case ServerPackage.FRONT_END_CONTROLLER: {
				FrontEndController frontEndController = (FrontEndController)theEObject;
				T result = caseFrontEndController(frontEndController);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.EQUIPMENT_MODULE: {
				EquipmentModule equipmentModule = (EquipmentModule)theEObject;
				T result = caseEquipmentModule(equipmentModule);
				if (result == null) result = casePersistable(equipmentModule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.DEVICE: {
				Device device = (Device)theEObject;
				T result = caseDevice(device);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY: {
				Property property = (Property)theEObject;
				T result = caseProperty(property);
				if (result == null) result = caseObservable(property);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.DECORATED_PROPERTY: {
				DecoratedProperty decoratedProperty = (DecoratedProperty)theEObject;
				T result = caseDecoratedProperty(decoratedProperty);
				if (result == null) result = caseProperty(decoratedProperty);
				if (result == null) result = caseObserver(decoratedProperty);
				if (result == null) result = caseObservable(decoratedProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.REAL_PROPERTY: {
				RealProperty realProperty = (RealProperty)theEObject;
				T result = caseRealProperty(realProperty);
				if (result == null) result = caseProperty(realProperty);
				if (result == null) result = casePersistable(realProperty);
				if (result == null) result = caseObservable(realProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.SCALED_PROPERTY: {
				ScaledProperty scaledProperty = (ScaledProperty)theEObject;
				T result = caseScaledProperty(scaledProperty);
				if (result == null) result = caseDecoratedProperty(scaledProperty);
				if (result == null) result = caseScalable(scaledProperty);
				if (result == null) result = caseProperty(scaledProperty);
				if (result == null) result = caseObserver(scaledProperty);
				if (result == null) result = caseObservable(scaledProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.ALIAS_PROPERTY: {
				AliasProperty aliasProperty = (AliasProperty)theEObject;
				T result = caseAliasProperty(aliasProperty);
				if (result == null) result = caseDecoratedProperty(aliasProperty);
				if (result == null) result = caseProperty(aliasProperty);
				if (result == null) result = caseObserver(aliasProperty);
				if (result == null) result = caseObservable(aliasProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY_INT32: {
				PropertyInt32 propertyInt32 = (PropertyInt32)theEObject;
				T result = casePropertyInt32(propertyInt32);
				if (result == null) result = casePropertyNumeric(propertyInt32);
				if (result == null) result = caseRealProperty(propertyInt32);
				if (result == null) result = caseScalable(propertyInt32);
				if (result == null) result = caseProperty(propertyInt32);
				if (result == null) result = casePersistable(propertyInt32);
				if (result == null) result = caseObservable(propertyInt32);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY_FLOAT: {
				PropertyFloat propertyFloat = (PropertyFloat)theEObject;
				T result = casePropertyFloat(propertyFloat);
				if (result == null) result = casePropertyNumeric(propertyFloat);
				if (result == null) result = caseRealProperty(propertyFloat);
				if (result == null) result = caseScalable(propertyFloat);
				if (result == null) result = caseProperty(propertyFloat);
				if (result == null) result = casePersistable(propertyFloat);
				if (result == null) result = caseObservable(propertyFloat);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.DATA_TABLE: {
				DataTable dataTable = (DataTable)theEObject;
				T result = caseDataTable(dataTable);
				if (result == null) result = caseObservable(dataTable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY_BYTE: {
				PropertyByte propertyByte = (PropertyByte)theEObject;
				T result = casePropertyByte(propertyByte);
				if (result == null) result = caseRealProperty(propertyByte);
				if (result == null) result = caseProperty(propertyByte);
				if (result == null) result = casePersistable(propertyByte);
				if (result == null) result = caseObservable(propertyByte);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY_TEXT: {
				PropertyText propertyText = (PropertyText)theEObject;
				T result = casePropertyText(propertyText);
				if (result == null) result = caseRealProperty(propertyText);
				if (result == null) result = caseProperty(propertyText);
				if (result == null) result = casePersistable(propertyText);
				if (result == null) result = caseObservable(propertyText);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY_DOUBLE: {
				PropertyDouble propertyDouble = (PropertyDouble)theEObject;
				T result = casePropertyDouble(propertyDouble);
				if (result == null) result = casePropertyNumeric(propertyDouble);
				if (result == null) result = caseRealProperty(propertyDouble);
				if (result == null) result = caseScalable(propertyDouble);
				if (result == null) result = caseProperty(propertyDouble);
				if (result == null) result = casePersistable(propertyDouble);
				if (result == null) result = caseObservable(propertyDouble);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.DRIVER: {
				Driver driver = (Driver)theEObject;
				T result = caseDriver(driver);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY_SHORT16: {
				PropertyShort16 propertyShort16 = (PropertyShort16)theEObject;
				T result = casePropertyShort16(propertyShort16);
				if (result == null) result = casePropertyNumeric(propertyShort16);
				if (result == null) result = caseRealProperty(propertyShort16);
				if (result == null) result = caseScalable(propertyShort16);
				if (result == null) result = caseProperty(propertyShort16);
				if (result == null) result = casePersistable(propertyShort16);
				if (result == null) result = caseObservable(propertyShort16);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.OBSERVER: {
				Observer observer = (Observer)theEObject;
				T result = caseObserver(observer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.OBSERVABLE: {
				Observable observable = (Observable)theEObject;
				T result = caseObservable(observable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.GROUP_PROPERTY: {
				GroupProperty groupProperty = (GroupProperty)theEObject;
				T result = caseGroupProperty(groupProperty);
				if (result == null) result = caseProperty(groupProperty);
				if (result == null) result = caseObserver(groupProperty);
				if (result == null) result = caseObservable(groupProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.REAL_PROPERTY_DAO: {
				RealPropertyDAO realPropertyDAO = (RealPropertyDAO)theEObject;
				T result = caseRealPropertyDAO(realPropertyDAO);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.REAL_PROPERTY_DAO_POSTGRES: {
				RealPropertyDAO_Postgres realPropertyDAO_Postgres = (RealPropertyDAO_Postgres)theEObject;
				T result = caseRealPropertyDAO_Postgres(realPropertyDAO_Postgres);
				if (result == null) result = caseRealPropertyDAO(realPropertyDAO_Postgres);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PERSISTABLE: {
				Persistable persistable = (Persistable)theEObject;
				T result = casePersistable(persistable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.SCALABLE: {
				Scalable scalable = (Scalable)theEObject;
				T result = caseScalable(scalable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case ServerPackage.PROPERTY_NUMERIC: {
				PropertyNumeric propertyNumeric = (PropertyNumeric)theEObject;
				T result = casePropertyNumeric(propertyNumeric);
				if (result == null) result = caseRealProperty(propertyNumeric);
				if (result == null) result = caseScalable(propertyNumeric);
				if (result == null) result = caseProperty(propertyNumeric);
				if (result == null) result = casePersistable(propertyNumeric);
				if (result == null) result = caseObservable(propertyNumeric);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Front End Controller</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Front End Controller</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFrontEndController(FrontEndController object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Equipment Module</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Equipment Module</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEquipmentModule(EquipmentModule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Device</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Device</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDevice(Device object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseProperty(Property object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Decorated Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Decorated Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDecoratedProperty(DecoratedProperty object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Real Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Real Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRealProperty(RealProperty object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Scaled Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Scaled Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseScaledProperty(ScaledProperty object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Alias Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Alias Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAliasProperty(AliasProperty object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Int32</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Int32</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyInt32(PropertyInt32 object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Float</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Float</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyFloat(PropertyFloat object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Table</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Table</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataTable(DataTable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Byte</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Byte</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyByte(PropertyByte object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Text</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Text</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyText(PropertyText object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Double</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Double</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyDouble(PropertyDouble object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Driver</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Driver</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDriver(Driver object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Short16</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Short16</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyShort16(PropertyShort16 object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Observer</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Observer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseObserver(Observer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Observable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Observable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseObservable(Observable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Group Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Group Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGroupProperty(GroupProperty object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Real Property DAO</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Real Property DAO</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRealPropertyDAO(RealPropertyDAO object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Real Property DAO Postgres</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Real Property DAO Postgres</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRealPropertyDAO_Postgres(RealPropertyDAO_Postgres object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Persistable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Persistable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePersistable(Persistable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Scalable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Scalable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseScalable(Scalable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Property Numeric</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Property Numeric</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePropertyNumeric(PropertyNumeric object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //ServerSwitch
