package ch.thomson.ucs.utils.logic;



public class WordSwapper {	
	
	public static int swap(int value) {
		int w1 = (value >> 0) & 0xffff;
		int w2 = (value >> 16) & 0xffff;

		return w1 << 16 | w2 << 0;
	}
	
	public static long swap(long value) {
		long w1 = (value >> 0) & 0xffff;
		long w2 = (value >> 16) & 0xffff;
		long w3 = (value >> 32) & 0xffff;
		long w4 = (value >> 48) & 0xffff;
	
		return w1 << 48 | w2 << 32 | w3 << 16 | w4 << 0;
	}
	
	public static float swap(float value) {
		int intValue = Float.floatToIntBits(value);
		intValue = swap(intValue);
		return Float.intBitsToFloat(intValue);
	}
	
	public static double swap(double value) {
		long longValue = Double.doubleToLongBits(value);
		longValue = swap(longValue);
		return Double.longBitsToDouble(longValue);
	}

	public static void swap(int[] array) {
		for (int i = 0; i < array.length; i++)
			array[i] = swap(array[i]);
	}

	public static void swap(long[] array) {
		for (int i = 0; i < array.length; i++)
			array[i] = swap(array[i]);
	}

	public static void swap(float[] array) {
		for (int i = 0; i < array.length; i++)
			array[i] = swap(array[i]);
	}

	public static void swap(double[] array) {
		for (int i = 0; i < array.length; i++)
			array[i] = swap(array[i]);
	}
}
