package de.desy.acop.video.analysis.decoders;

import de.desy.acop.video.analysis.ColorDecoder;

/**
 * 
 * <code>RGBColorDecoder</code> is a decoder which transforms
 * the raw values into rgb values.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public class RGBColorDecoder implements ColorDecoder {

	/* (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int)
	 */
	@Override
	@Deprecated
	public double transform(int code) {
		return code & 0xFF;
	}

	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int[])
	 */
	@Override
	public double[] transform(int[] data) {
		int length = data.length;
		double[] ret = new double[length];
		for (int i = 0; i < length; i++) {
			ret[i] = data[i] & 0xFF;
		}
		return ret;
	}
}
