package de.desy.acop.video.timageio.test;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;

import javax.swing.JFrame;
import javax.swing.JPanel;

import de.desy.acop.video.displayer.ImageParser;
import de.desy.acop.video.displayer.timage.TImageConverter;
import de.desy.acop.video.displayer.timage.TImageUtils;
import de.desy.tine.types.IMAGE;

public class TestTImageConvertor {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TestTImageConvertor app = new TestTImageConvertor();
		try {
			app.test();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@SuppressWarnings("deprecation")
	private void test() throws Exception {
		IMAGE timage = new IMAGE(0);
		ImageParser.loadImageFile("splash.png", timage);

		// timage.getFrameHeader().aoiWidth = 700;
		// timage.getFrameHeader().aoiHeight = 500;
		// timage.getFrameHeader().xStart = 34;
		// timage.getFrameHeader().yStart = 38;

		// [width=768,height=576]

		// test
		TImageConverter converter = new TImageConverter();
		Image imageTest = converter.parseTineImage(timage, true);
		System.out.println("imageTest : " + imageTest);

		BufferedImage bi = TImageUtils.toBufferedImage(imageTest);

		int[] rgbArray = bi.getRGB(0, 0, bi.getWidth(), bi.getHeight(), null, 0, bi.getWidth());
		// int[] intArray = TImageUtils.getImageIntArray(bi);
		// byte[] rawbytes = TImageUtils.toRawBytes(bi, "jpeg");

		// BufferedImage bitmapImage = TImageUtils.bitmapToImage(rawbytes, "jpeg");

		System.out.println("<<< mdavid >>> Transfer type: " + bi.getColorModel().getTransferType());
		System.out.println("<<< mdavid >>> Image type: " + bi.getType());
		System.out.println("<<< mdavid >>> rgbArray: " + rgbArray);

		BufferedImage biGray = TImageUtils.convertToGrayscale(bi);
		int[] rgbArrayGray = biGray.getRGB(0, 0, biGray.getWidth(), biGray.getHeight(), null, 0, biGray.getWidth());
		// byte[] byteArrayGray = TImageUtils.getImageByteArray(biGray);
		// byte[] rawbytesGray = TImageUtils.toRawBytes(biGray, "jpeg");

		// timage.setImageFrameBuffer(byteArrayGray);
		// BufferedImage b2 = TImageUtils.toBufferedImage(TImageConverter.parseTineImage(timage, false));

		System.out.println("<<< mdavid >>> biGray Transfer type: " + biGray.getColorModel().getTransferType());
		System.out.println("<<< mdavid >>> biGray Image type: " + biGray.getType());
		System.out.println("<<< mdavid >>> rgbArrayGray: " + rgbArrayGray);

		MyPanel panel = new MyPanel(bi);
		JFrame frame = new JFrame("Test");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.add(panel);
		frame.setSize(1024, 800);
		frame.setVisible(true);

	}

	class MyPanel extends JPanel {

		private BufferedImage bi;

		public MyPanel(BufferedImage bi) {
			super();
			this.bi = bi;
		}

		private static final long serialVersionUID = 1L;

		@Override
		protected void paintComponent(Graphics g) {
			super.paintComponent(g); // paint background
			Graphics2D g2 = (Graphics2D) g;

			if (bi == null) {
				int w = this.getWidth();
				int h = this.getHeight();
				bi = (BufferedImage) (this.createImage(w, h));
				Graphics2D gc = bi.createGraphics();
				for (int x = 0; x < w; x += 10) {
					gc.drawLine(x, 0, x, h);
				}
				for (int y = 0; y < h; y += 10) {
					gc.drawLine(0, y, w, y);
				}
			}
			g2.drawImage(bi, null, 0, 0);
		}
	}
}
