/**
 * 
 */
package de.desy.acop.video.timageio.test;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import junit.framework.TestCase;
import de.desy.acop.video.displayer.timage.TImageUtils;
import de.desy.acop.video.timageio.TBufferedImage;
import de.desy.acop.video.timageio.TImageIO;
import de.desy.tine.types.IMAGE;

/**
 * @author mdavid
 * 
 */
public class TestTImageIO extends TestCase {

	private static final String[] IMAGE_TEST = { "C:/test/png/background.png" //		
	};

	private static final String[] IMAGE_JPEG = { "H:/public/PngSuite/jpeg/background.jpg" //		
	};

	private static final String[] IMAGE_GIF = {
	//
			"H:/public/PngSuite/gif/basi0g01.gif", //
			"H:/public/PngSuite/gif/basi0g02.gif", //
			"H:/public/PngSuite/gif/basi0g04.gif", //
			"H:/public/PngSuite/gif/basi0g08.gif", //
			"H:/public/PngSuite/gif/basi0g16.gif", //
			"H:/public/PngSuite/gif/basi2c08.gif", //
			"H:/public/PngSuite/gif/basi2c16.gif", //
			"H:/public/PngSuite/gif/basi3p01.gif", //
			"H:/public/PngSuite/gif/basi3p02.gif", //
			"H:/public/PngSuite/gif/basi3p04.gif", //
			"H:/public/PngSuite/gif/basi3p08.gif", //
			"H:/public/PngSuite/gif/basi4a08.gif", //
			"H:/public/PngSuite/gif/basi4a16.gif", //
			"H:/public/PngSuite/gif/basi6a08.gif", //
			"H:/public/PngSuite/gif/basi6a16.gif", //
			"H:/public/PngSuite/gif/basn0g01.gif", //
			"H:/public/PngSuite/gif/basn0g02.gif", //
			"H:/public/PngSuite/gif/basn0g04.gif", //
			"H:/public/PngSuite/gif/basn0g08.gif", //
			"H:/public/PngSuite/gif/basn0g16.gif", //
			"H:/public/PngSuite/gif/basn2c08.gif", //
			"H:/public/PngSuite/gif/basn2c16.gif", //
			"H:/public/PngSuite/gif/basn3p01.gif", //
			"H:/public/PngSuite/gif/basn3p02.gif", //
			"H:/public/PngSuite/gif/basn3p04.gif", //
			"H:/public/PngSuite/gif/basn3p08.gif", //
			"H:/public/PngSuite/gif/basn4a08.gif", //
			"H:/public/PngSuite/gif/basn4a16.gif", //
			"H:/public/PngSuite/gif/basn6a08.gif", //
			"H:/public/PngSuite/gif/basn6a16.gif", //
			"H:/public/PngSuite/gif/bgai4a08.gif", //
			"H:/public/PngSuite/gif/bgai4a16.gif", //
			"H:/public/PngSuite/gif/bgan6a08.gif", //
			"H:/public/PngSuite/gif/bgan6a16.gif", //
			"H:/public/PngSuite/gif/bgbn4a08.gif", //
			"H:/public/PngSuite/gif/bggn4a16.gif", //
			"H:/public/PngSuite/gif/bgwn6a08.gif", //
			"H:/public/PngSuite/gif/bgyn6a16.gif", //
			"H:/public/PngSuite/gif/ccwn2c08.gif", //
			"H:/public/PngSuite/gif/ccwn3p08.gif", //
			"H:/public/PngSuite/gif/cdfn2c08.gif", //
			"H:/public/PngSuite/gif/cdhn2c08.gif", //
			"H:/public/PngSuite/gif/cdsn2c08.gif", //
			"H:/public/PngSuite/gif/cdun2c08.gif", //
			"H:/public/PngSuite/gif/ch1n3p04.gif", //
			"H:/public/PngSuite/gif/ch2n3p08.gif", //
			"H:/public/PngSuite/gif/cm0n0g04.gif", //
			"H:/public/PngSuite/gif/cm7n0g04.gif", //
			"H:/public/PngSuite/gif/cm9n0g04.gif", //
			"H:/public/PngSuite/gif/cs3n2c16.gif", //
			"H:/public/PngSuite/gif/cs3n3p08.gif", //
			"H:/public/PngSuite/gif/cs5n2c08.gif", //
			"H:/public/PngSuite/gif/cs5n3p08.gif", //
			"H:/public/PngSuite/gif/cs8n2c08.gif", //
			"H:/public/PngSuite/gif/cs8n3p08.gif", //
			"H:/public/PngSuite/gif/ct0n0g04.gif", //
			"H:/public/PngSuite/gif/ct1n0g04.gif", //
			"H:/public/PngSuite/gif/ctzn0g04.gif", //
			"H:/public/PngSuite/gif/f00n0g08.gif", //
			"H:/public/PngSuite/gif/f00n2c08.gif", //
			"H:/public/PngSuite/gif/f01n0g08.gif", //
			"H:/public/PngSuite/gif/f01n2c08.gif", //
			"H:/public/PngSuite/gif/f02n0g08.gif", //
			"H:/public/PngSuite/gif/f02n2c08.gif", //
			"H:/public/PngSuite/gif/f03n0g08.gif", //
			"H:/public/PngSuite/gif/f03n2c08.gif", //
			"H:/public/PngSuite/gif/f04n0g08.gif", //
			"H:/public/PngSuite/gif/f04n2c08.gif", //
			"H:/public/PngSuite/gif/g03n0g16.gif", //
			"H:/public/PngSuite/gif/g03n0g16_mac.gif", //
			"H:/public/PngSuite/gif/g03n0g16_next.gif", //
			"H:/public/PngSuite/gif/g03n2c08.gif", //
			"H:/public/PngSuite/gif/g03n2c08_mac.gif", //
			"H:/public/PngSuite/gif/g03n2c08_next.gif", //
			"H:/public/PngSuite/gif/g03n3p04.gif", //
			"H:/public/PngSuite/gif/g03n3p04_mac.gif", //
			"H:/public/PngSuite/gif/g03n3p04_next.gif", //
			"H:/public/PngSuite/gif/g04n0g16.gif", //
			"H:/public/PngSuite/gif/g04n0g16_mac.gif", //
			"H:/public/PngSuite/gif/g04n0g16_next.gif", //
			"H:/public/PngSuite/gif/g04n2c08.gif", //
			"H:/public/PngSuite/gif/g04n2c08_mac.gif", //
			"H:/public/PngSuite/gif/g04n2c08_next.gif", //
			"H:/public/PngSuite/gif/g04n3p04.gif", //
			"H:/public/PngSuite/gif/g04n3p04_mac.gif", //
			"H:/public/PngSuite/gif/g04n3p04_next.gif", //
			"H:/public/PngSuite/gif/g05n0g16.gif", //
			"H:/public/PngSuite/gif/g05n0g16_mac.gif", //
			"H:/public/PngSuite/gif/g05n0g16_next.gif", //
			"H:/public/PngSuite/gif/g05n2c08.gif", //
			"H:/public/PngSuite/gif/g05n2c08_mac.gif", //
			"H:/public/PngSuite/gif/g05n2c08_next.gif", //
			"H:/public/PngSuite/gif/g05n3p04.gif", //
			"H:/public/PngSuite/gif/g05n3p04_mac.gif", //
			"H:/public/PngSuite/gif/g05n3p04_next.gif", //
			"H:/public/PngSuite/gif/g07n0g16.gif", //
			"H:/public/PngSuite/gif/g07n0g16_mac.gif", //
			"H:/public/PngSuite/gif/g07n0g16_next.gif", //
			"H:/public/PngSuite/gif/g07n2c08.gif", //
			"H:/public/PngSuite/gif/g07n2c08_mac.gif", //
			"H:/public/PngSuite/gif/g07n2c08_next.gif", //
			"H:/public/PngSuite/gif/g07n3p04.gif", //
			"H:/public/PngSuite/gif/g07n3p04_mac.gif", //
			"H:/public/PngSuite/gif/g07n3p04_next.gif", //
			"H:/public/PngSuite/gif/g10n0g16.gif", //
			"H:/public/PngSuite/gif/g10n0g16_mac.gif", //
			"H:/public/PngSuite/gif/g10n0g16_next.gif", //
			"H:/public/PngSuite/gif/g10n2c08.gif", //
			"H:/public/PngSuite/gif/g10n2c08_mac.gif", //
			"H:/public/PngSuite/gif/g10n2c08_next.gif", //
			"H:/public/PngSuite/gif/g10n3p04.gif", //
			"H:/public/PngSuite/gif/g10n3p04_mac.gif", //
			"H:/public/PngSuite/gif/g10n3p04_next.gif", //
			"H:/public/PngSuite/gif/g25n0g16.gif", //
			"H:/public/PngSuite/gif/g25n0g16_mac.gif", //
			"H:/public/PngSuite/gif/g25n0g16_next.gif", //
			"H:/public/PngSuite/gif/g25n2c08.gif", //
			"H:/public/PngSuite/gif/g25n2c08_mac.gif", //
			"H:/public/PngSuite/gif/g25n2c08_next.gif", //
			"H:/public/PngSuite/gif/g25n3p04.gif", //
			"H:/public/PngSuite/gif/g25n3p04_mac.gif", //
			"H:/public/PngSuite/gif/g25n3p04_next.gif", //
			"H:/public/PngSuite/gif/oi1n0g16.gif", //
			"H:/public/PngSuite/gif/oi1n2c16.gif", //
			"H:/public/PngSuite/gif/oi2n0g16.gif", //
			"H:/public/PngSuite/gif/oi2n2c16.gif", //
			"H:/public/PngSuite/gif/oi4n0g16.gif", //
			"H:/public/PngSuite/gif/oi4n2c16.gif", //
			"H:/public/PngSuite/gif/oi9n0g16.gif", //
			"H:/public/PngSuite/gif/oi9n2c16.gif", //
			"H:/public/PngSuite/gif/pngsuite_icon.gif", //
			"H:/public/PngSuite/gif/pngsuite_logo.gif", //
			"H:/public/PngSuite/gif/pp0n2c16.gif", //
			"H:/public/PngSuite/gif/pp0n6a08.gif", //
			"H:/public/PngSuite/gif/ps1n0g08.gif", //
			"H:/public/PngSuite/gif/ps1n2c16.gif", //
			"H:/public/PngSuite/gif/ps2n0g08.gif", //
			"H:/public/PngSuite/gif/ps2n2c16.gif", //
			"H:/public/PngSuite/gif/s01i3p01.gif", //
			"H:/public/PngSuite/gif/s01n3p01.gif", //
			"H:/public/PngSuite/gif/s02i3p01.gif", //
			"H:/public/PngSuite/gif/s02n3p01.gif", //
			"H:/public/PngSuite/gif/s03i3p01.gif", //
			"H:/public/PngSuite/gif/s03n3p01.gif", //
			"H:/public/PngSuite/gif/s04i3p01.gif", //
			"H:/public/PngSuite/gif/s04n3p01.gif", //
			"H:/public/PngSuite/gif/s05i3p02.gif", //
			"H:/public/PngSuite/gif/s05n3p02.gif", //
			"H:/public/PngSuite/gif/s06i3p02.gif", //
			"H:/public/PngSuite/gif/s06n3p02.gif", //
			"H:/public/PngSuite/gif/s07i3p02.gif", //
			"H:/public/PngSuite/gif/s07n3p02.gif", //
			"H:/public/PngSuite/gif/s08i3p02.gif", //
			"H:/public/PngSuite/gif/s08n3p02.gif", //
			"H:/public/PngSuite/gif/s09i3p02.gif", //
			"H:/public/PngSuite/gif/s09n3p02.gif", //
			"H:/public/PngSuite/gif/s32i3p04.gif", //
			"H:/public/PngSuite/gif/s32n3p04.gif", //
			"H:/public/PngSuite/gif/s33i3p04.gif", //
			"H:/public/PngSuite/gif/s33n3p04.gif", //
			"H:/public/PngSuite/gif/s34i3p04.gif", //
			"H:/public/PngSuite/gif/s34n3p04.gif", //
			"H:/public/PngSuite/gif/s35i3p04.gif", //
			"H:/public/PngSuite/gif/s35n3p04.gif", //
			"H:/public/PngSuite/gif/s36i3p04.gif", //
			"H:/public/PngSuite/gif/s36n3p04.gif", //
			"H:/public/PngSuite/gif/s37i3p04.gif", //
			"H:/public/PngSuite/gif/s37n3p04.gif", //
			"H:/public/PngSuite/gif/s38i3p04.gif", //
			"H:/public/PngSuite/gif/s38n3p04.gif", //
			"H:/public/PngSuite/gif/s39i3p04.gif", //
			"H:/public/PngSuite/gif/s39n3p04.gif", //
			"H:/public/PngSuite/gif/s40i3p04.gif", //
			"H:/public/PngSuite/gif/s40n3p04.gif", //
			"H:/public/PngSuite/gif/tbbn1g04.gif", //
			"H:/public/PngSuite/gif/tbbn2c16.gif", //
			"H:/public/PngSuite/gif/tbbn3p08.gif", //
			"H:/public/PngSuite/gif/tbgn2c16.gif", //
			"H:/public/PngSuite/gif/tbgn3p08.gif", //
			"H:/public/PngSuite/gif/tbrn2c08.gif", //
			"H:/public/PngSuite/gif/tbwn1g16.gif", //
			"H:/public/PngSuite/gif/tbwn3p08.gif", //
			"H:/public/PngSuite/gif/tbyn3p08.gif", //
			"H:/public/PngSuite/gif/tp0n1g08.gif", //
			"H:/public/PngSuite/gif/tp0n2c08.gif", //
			"H:/public/PngSuite/gif/tp0n3p08.gif", //
			"H:/public/PngSuite/gif/tp1n3p08.gif", //
			"H:/public/PngSuite/gif/x00n0g01.gif", //
			"H:/public/PngSuite/gif/xcrn0g04.gif", //
			"H:/public/PngSuite/gif/xlfn0g04.gif", //
			"H:/public/PngSuite/gif/z00n2c08.gif", //
			"H:/public/PngSuite/gif/z03n2c08.gif", //
			"H:/public/PngSuite/gif/z06n2c08.gif", //
			"H:/public/PngSuite/gif/z09n2c08.gif" //
	};
	private static final String[] IMAGE_GRAY = {
	//
			"N:/mdavid/public/PngSuite/png/grayscale/basi0g01.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basi0g02.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basi0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basi0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basi0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basn0g01.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basn0g02.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basn0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basn0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/basn0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/cm0n0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/cm7n0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/cm9n0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/ct0n0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/ct1n0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/ctzn0g04.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/f00n0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/f01n0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/f02n0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/f03n0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/f04n0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/g03n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/g04n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/g05n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/g07n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/g10n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/g25n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/oi1n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/oi2n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/oi4n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/oi9n0g16.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/ps1n0g08.png", //
			"N:/mdavid/public/PngSuite/png/grayscale/ps2n0g08.png" // 
	};

	private static final String[] IMAGE_RGB = { //
	//
			"N:/mdavid/public/PngSuite/png/rgb/basi2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/basi2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/basn2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/basn2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/ccwn2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/cdfn2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/cdhn2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/cdsn2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/cdun2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/cs3n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/cs5n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/cs8n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/f00n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/f01n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/f02n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/f03n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/f04n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/g03n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/g04n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/g05n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/g07n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/g10n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/g25n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/oi1n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/oi2n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/oi4n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/oi9n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/pp0n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/ps1n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/ps2n2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/tbbn2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/tbgn2c16.png", //
			"N:/mdavid/public/PngSuite/png/rgb/tbrn2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/tp0n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/z00n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/z03n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/z06n2c08.png", //
			"N:/mdavid/public/PngSuite/png/rgb/z09n2c08.png" //
	};

	private static final String[] IMAGE_RGB_ALPHA = {
	//
			"N:/mdavid/public/PngSuite/png/rgbAlpha/basi6a08.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/basi6a16.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/basn6a08.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/basn6a16.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/bgan6a08.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/bgan6a16.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/bgwn6a08.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/bgyn6a16.png", //
			"N:/mdavid/public/PngSuite/png/rgbAlpha/pp0n6a08.png" //
	};

	private static final String[] IMAGE_PALLETED = {
	//
			"N:/mdavid/public/PngSuite/png/paletted/basi3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/basi3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/basi3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/basi3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/basn3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/basn3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/basn3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/basn3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/ccwn3p08.png", //
			// "N:/mdavid/public/PngSuite/png/paletted/ch1n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/ch2n3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/cs3n3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/cs5n3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/cs8n3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/g03n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/g04n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/g05n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/g07n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/g10n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/g25n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s01i3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s01n3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s02i3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s02n3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s03i3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s03n3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s04i3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s04n3p01.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s05i3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s05n3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s06i3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s06n3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s07i3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s07n3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s08i3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s08n3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s09i3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s09n3p02.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s32i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s32n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s33i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s33n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s34i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s34n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s35i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s35n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s36i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s36n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s37i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s37n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s38i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s38n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s39i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s39n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s40i3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/s40n3p04.png", //
			"N:/mdavid/public/PngSuite/png/paletted/tbbn3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/tbgn3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/tbwn3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/tbyn3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/tp0n3p08.png", //
			"N:/mdavid/public/PngSuite/png/paletted/tp1n3p08.png" //
	};

	public void test() {
		try {
			for (String pathname : IMAGE_TEST) {
				System.out.print(pathname);
				System.out.println(" : " + testFile0(pathname));
			}

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	boolean testFile0(String pathname) throws IOException {
		File fileOrg = new File(pathname);

		TBufferedImage tbiOrg = TImageIO.read(fileOrg);
		IMAGE tiOrg = tbiOrg.toIMAGE();

		File fileNew = new File("C://test//png", "new_" + fileOrg.getName());
		TImageIO.write(tbiOrg, fileNew);

		TBufferedImage tbiNew = TImageIO.read(fileNew);
		IMAGE tiNew = tbiNew.toIMAGE();

		return TImageUtils.compare(tiOrg, tiNew);
	}

	boolean testFile2(String pathname) throws IOException {
		File fileOrg = new File(pathname);
		BufferedImage biOrg = ImageIO.read(fileOrg);
		IMAGE tiOrg = TBufferedImage.toIMAGE(biOrg);
		BufferedImage biNew = TBufferedImage.toBufferedImage(tiOrg);

		File fileNew = new File("C:/test/png", fileOrg.getName());
		TImageIO.write(new TBufferedImage(tiOrg), fileNew);

		return TImageUtils.compare(tiOrg, TBufferedImage.toIMAGE(biNew));
	}

	boolean testFile(String pathname) throws IOException {
		File fileOrg = new File(pathname);
		BufferedImage biOrg = ImageIO.read(fileOrg);
		IMAGE tiOrg = TBufferedImage.toIMAGE(biOrg);

		BufferedImage biNew = TBufferedImage.toBufferedImage(tiOrg);
		File fileNew = new File("C:/test/png", fileOrg.getName());
		ImageIO.write(biNew, fileNew.getName().substring(fileNew.getName().length() - 3), fileNew);

		// TImageIO.write(new TBufferedImage(tiOrg), fileNew);

		return TImageUtils.compare(tiOrg, TBufferedImage.toIMAGE(biNew));
	}

}
