package de.desy.tine.histUtils;

import de.desy.tine.structUtils.TTaggedStructure;

public class PrfCfg extends TTaggedStructure
{
  public void clear()
  {
    nameString = null;
    typeString = null;
    statesString = null;
    colorString = null;
  }
  private char[] name = new char[64];
  private String nameString;
  private char[] type = new char[16];
  private String typeString;
  private char[] statesBuffer = new char[512];
  private String statesString;
  private char[] color = new char[16];
  private String colorString;
  private void initStructure()
  {
    addField(name,"name");
    addField(type,"type");
    addField(statesBuffer,"states");
    addField(color,"color");
    initDone();    
  }
  public PrfCfg()
  {
    super();
    initStructure();
  }
  public PrfCfg(PrfCfg reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.name, 0, name, 0, 64);    
    System.arraycopy(reference.type, 0, type, 0, 16);    
    System.arraycopy(reference.statesBuffer, 0, statesBuffer, 0, 512);    
    System.arraycopy(reference.color, 0, color, 0, 16);    
  }
  public String getProfileName()
  {
    if (nameString == null) nameString = new String(name).trim();
    return nameString;
  }
  public String getType()
  {
    if (typeString == null) typeString = new String(type).trim();
    return typeString;
  }
  public String getStatesString()
  {
    if (statesString == null) statesString = new String(statesBuffer).trim();
    return statesString;
  }
  public String[] getStates()
  {
    if (statesString == null) statesString = new String(statesBuffer).trim();
    return statesString.split(",");
  }
  public String getColor()
  {
    if (colorString == null) colorString = new String(color).trim();
    return colorString;
  }
}
