/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package ch.thomson.ucs.tine.server;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see ch.thomson.ucs.tine.server.ServerFactory
 * @model kind="package"
 * @generated
 */
public interface ServerPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "server";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://tineserver/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "ch.thomson.ucs.tine";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ServerPackage eINSTANCE = ch.thomson.ucs.tine.server.impl.ServerPackageImpl.init();

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl <em>Front End Controller</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getFrontEndController()
	 * @generated
	 */
	int FRONT_END_CONTROLLER = 0;

	/**
	 * The feature id for the '<em><b>Tine Equipment Module Factory</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__TINE_EQUIPMENT_MODULE_FACTORY = 0;

	/**
	 * The feature id for the '<em><b>Equipment Modules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__EQUIPMENT_MODULES = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__NAME = 2;

	/**
	 * The feature id for the '<em><b>Sub System Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__SUB_SYSTEM_NAME = 3;

	/**
	 * The feature id for the '<em><b>Context Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__CONTEXT_NAME = 4;

	/**
	 * The feature id for the '<em><b>Location</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__LOCATION = 5;

	/**
	 * The feature id for the '<em><b>Local Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__LOCAL_VALUE = 6;

	/**
	 * The feature id for the '<em><b>Local Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__LOCAL_MODE = 7;

	/**
	 * The feature id for the '<em><b>Access Allowed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__ACCESS_ALLOWED = 8;

	/**
	 * The feature id for the '<em><b>Allowed Hosts For Local Access</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS = 9;

	/**
	 * The feature id for the '<em><b>Lock Write Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY = 10;

	/**
	 * The feature id for the '<em><b>Write Locked</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__WRITE_LOCKED = 11;

	/**
	 * The feature id for the '<em><b>Local Caller</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER__LOCAL_CALLER = 12;

	/**
	 * The number of structural features of the '<em>Front End Controller</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FRONT_END_CONTROLLER_FEATURE_COUNT = 13;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.EquipmentModuleImpl <em>Equipment Module</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.EquipmentModuleImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getEquipmentModule()
	 * @generated
	 */
	int EQUIPMENT_MODULE = 1;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.DeviceImpl <em>Device</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.DeviceImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDevice()
	 * @generated
	 */
	int DEVICE = 2;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyImpl <em>Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getProperty()
	 * @generated
	 */
	int PROPERTY = 3;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.DecoratedPropertyImpl <em>Decorated Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.DecoratedPropertyImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDecoratedProperty()
	 * @generated
	 */
	int DECORATED_PROPERTY = 4;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl <em>Real Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.RealPropertyImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getRealProperty()
	 * @generated
	 */
	int REAL_PROPERTY = 5;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl <em>Scaled Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getScaledProperty()
	 * @generated
	 */
	int SCALED_PROPERTY = 6;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.AliasPropertyImpl <em>Alias Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.AliasPropertyImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getAliasProperty()
	 * @generated
	 */
	int ALIAS_PROPERTY = 7;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyInt32Impl <em>Property Int32</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyInt32Impl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyInt32()
	 * @generated
	 */
	int PROPERTY_INT32 = 8;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyFloatImpl <em>Property Float</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyFloatImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyFloat()
	 * @generated
	 */
	int PROPERTY_FLOAT = 9;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.Observable <em>Observable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.Observable
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getObservable()
	 * @generated
	 */
	int OBSERVABLE = 17;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.DataTableImpl <em>Data Table</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.DataTableImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDataTable()
	 * @generated
	 */
	int DATA_TABLE = 10;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyByteImpl <em>Property Byte</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyByteImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyByte()
	 * @generated
	 */
	int PROPERTY_BYTE = 11;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyTextImpl <em>Property Text</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyTextImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyText()
	 * @generated
	 */
	int PROPERTY_TEXT = 12;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyDoubleImpl <em>Property Double</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyDoubleImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyDouble()
	 * @generated
	 */
	int PROPERTY_DOUBLE = 13;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.DriverImpl <em>Driver</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.DriverImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDriver()
	 * @generated
	 */
	int DRIVER = 14;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyShort16Impl <em>Property Short16</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyShort16Impl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyShort16()
	 * @generated
	 */
	int PROPERTY_SHORT16 = 15;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.Observer <em>Observer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.Observer
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getObserver()
	 * @generated
	 */
	int OBSERVER = 16;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.GroupPropertyImpl <em>Group Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.GroupPropertyImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getGroupProperty()
	 * @generated
	 */
	int GROUP_PROPERTY = 18;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.RealPropertyDAO <em>Real Property DAO</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.RealPropertyDAO
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getRealPropertyDAO()
	 * @generated
	 */
	int REAL_PROPERTY_DAO = 19;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.Persistable <em>Persistable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.Persistable
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPersistable()
	 * @generated
	 */
	int PERSISTABLE = 21;

	/**
	 * The number of structural features of the '<em>Persistable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PERSISTABLE_FEATURE_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Front End Controller</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__FRONT_END_CONTROLLER = PERSISTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Export Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__EXPORT_NAME = PERSISTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__LOCAL_NAME = PERSISTABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Tine Equipment Module</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__TINE_EQUIPMENT_MODULE = PERSISTABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Devices</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__DEVICES = PERSISTABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__PROPERTIES = PERSISTABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Tine Background Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__TINE_BACKGROUND_TASK = PERSISTABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Device Polling Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__DEVICE_POLLING_RATE = PERSISTABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Driver Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__DRIVER_TYPE = PERSISTABLE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Byte Order</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__BYTE_ORDER = PERSISTABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Tine Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__TINE_PATH = PERSISTABLE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Actual State</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__ACTUAL_STATE = PERSISTABLE_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Target State</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE__TARGET_STATE = PERSISTABLE_FEATURE_COUNT + 12;

	/**
	 * The number of structural features of the '<em>Equipment Module</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUIPMENT_MODULE_FEATURE_COUNT = PERSISTABLE_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Tine Device</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__TINE_DEVICE = 0;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__EQUIPMENT_MODULE = 1;

	/**
	 * The feature id for the '<em><b>Data Tables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__DATA_TABLES = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__NAME = 3;

	/**
	 * The feature id for the '<em><b>Driver</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__DRIVER = 4;

	/**
	 * The feature id for the '<em><b>Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__ADDRESS = 5;

	/**
	 * The feature id for the '<em><b>Actual Error</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__ACTUAL_ERROR = 6;

	/**
	 * The feature id for the '<em><b>User Data Stamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__USER_DATA_STAMP = 7;

	/**
	 * The feature id for the '<em><b>System Data Stamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__SYSTEM_DATA_STAMP = 8;

	/**
	 * The feature id for the '<em><b>Transaction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__TRANSACTION = 9;

	/**
	 * The feature id for the '<em><b>Device Update Listeners</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__DEVICE_UPDATE_LISTENERS = 10;

	/**
	 * The feature id for the '<em><b>Link User Data Stamp</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__LINK_USER_DATA_STAMP = 11;

	/**
	 * The feature id for the '<em><b>Link System Data Stamp</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE__LINK_SYSTEM_DATA_STAMP = 12;

	/**
	 * The number of structural features of the '<em>Device</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEVICE_FEATURE_COUNT = 13;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVABLE__OBSERVERS = 0;

	/**
	 * The number of structural features of the '<em>Observable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVABLE_FEATURE_COUNT = 1;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__OBSERVERS = OBSERVABLE__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__TINE_EXPORT_PROPERTY = OBSERVABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__EQUIPMENT_MODULE = OBSERVABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__TINE_PROPERTY_HANDLER = OBSERVABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__NAME = OBSERVABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__DESCRIPTION = OBSERVABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__TINE_ACCESS = OBSERVABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__LENGTH = OBSERVABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__MINIMUM_VALUE = OBSERVABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__MAXIMUM_VALUE = OBSERVABLE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__UNIT = OBSERVABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__WRITABLE = OBSERVABLE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__LOGON_LEVEL = OBSERVABLE_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__MAX_STATE = OBSERVABLE_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__SCHEDULED = OBSERVABLE_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__REFRESH_RATE = OBSERVABLE_FEATURE_COUNT + 14;

	/**
	 * The number of structural features of the '<em>Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FEATURE_COUNT = OBSERVABLE_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__OBSERVERS = PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__TINE_EXPORT_PROPERTY = PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__EQUIPMENT_MODULE = PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__TINE_PROPERTY_HANDLER = PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__NAME = PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__DESCRIPTION = PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__TINE_ACCESS = PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__LENGTH = PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__MINIMUM_VALUE = PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__MAXIMUM_VALUE = PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__UNIT = PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__WRITABLE = PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__LOGON_LEVEL = PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__MAX_STATE = PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__SCHEDULED = PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__REFRESH_RATE = PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Real Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY__REAL_PROPERTY = PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Decorated Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECORATED_PROPERTY_FEATURE_COUNT = PROPERTY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__OBSERVERS = PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__TINE_EXPORT_PROPERTY = PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__EQUIPMENT_MODULE = PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__TINE_PROPERTY_HANDLER = PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__NAME = PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__DESCRIPTION = PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__TINE_ACCESS = PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__LENGTH = PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__MINIMUM_VALUE = PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__MAXIMUM_VALUE = PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__UNIT = PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__WRITABLE = PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__LOGON_LEVEL = PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__MAX_STATE = PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__SCHEDULED = PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__REFRESH_RATE = PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__DATA_TABLE_NAME = PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__ADDRESS_OFFSET = PROPERTY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__DEFAULT_VALUE = PROPERTY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__DRIVER_ADDRESS = PROPERTY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT = PROPERTY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__PERSISTENT = PROPERTY_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__DIRTY = PROPERTY_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY__DUMMY = PROPERTY_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Real Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY_FEATURE_COUNT = PROPERTY_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__OBSERVERS = DECORATED_PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__TINE_EXPORT_PROPERTY = DECORATED_PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__EQUIPMENT_MODULE = DECORATED_PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__TINE_PROPERTY_HANDLER = DECORATED_PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__NAME = DECORATED_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__DESCRIPTION = DECORATED_PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__TINE_ACCESS = DECORATED_PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__LENGTH = DECORATED_PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__MINIMUM_VALUE = DECORATED_PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__MAXIMUM_VALUE = DECORATED_PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__UNIT = DECORATED_PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__WRITABLE = DECORATED_PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__LOGON_LEVEL = DECORATED_PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__MAX_STATE = DECORATED_PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__SCHEDULED = DECORATED_PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__REFRESH_RATE = DECORATED_PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Real Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__REAL_PROPERTY = DECORATED_PROPERTY__REAL_PROPERTY;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__FACTOR = DECORATED_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__OFFSET = DECORATED_PROPERTY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__PRECISION = DECORATED_PROPERTY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Decimal Places</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY__DECIMAL_PLACES = DECORATED_PROPERTY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Scaled Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALED_PROPERTY_FEATURE_COUNT = DECORATED_PROPERTY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__OBSERVERS = DECORATED_PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__TINE_EXPORT_PROPERTY = DECORATED_PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__EQUIPMENT_MODULE = DECORATED_PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__TINE_PROPERTY_HANDLER = DECORATED_PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__NAME = DECORATED_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__DESCRIPTION = DECORATED_PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__TINE_ACCESS = DECORATED_PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__LENGTH = DECORATED_PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__MINIMUM_VALUE = DECORATED_PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__MAXIMUM_VALUE = DECORATED_PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__UNIT = DECORATED_PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__WRITABLE = DECORATED_PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__LOGON_LEVEL = DECORATED_PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__MAX_STATE = DECORATED_PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__SCHEDULED = DECORATED_PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__REFRESH_RATE = DECORATED_PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Real Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY__REAL_PROPERTY = DECORATED_PROPERTY__REAL_PROPERTY;

	/**
	 * The number of structural features of the '<em>Alias Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALIAS_PROPERTY_FEATURE_COUNT = DECORATED_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.Scalable <em>Scalable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.Scalable
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getScalable()
	 * @generated
	 */
	int SCALABLE = 22;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.PropertyNumericImpl <em>Property Numeric</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.PropertyNumericImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyNumeric()
	 * @generated
	 */
	int PROPERTY_NUMERIC = 23;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__OBSERVERS = REAL_PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__TINE_EXPORT_PROPERTY = REAL_PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__EQUIPMENT_MODULE = REAL_PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__TINE_PROPERTY_HANDLER = REAL_PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__NAME = REAL_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__DESCRIPTION = REAL_PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__TINE_ACCESS = REAL_PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__LENGTH = REAL_PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__MINIMUM_VALUE = REAL_PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__MAXIMUM_VALUE = REAL_PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__UNIT = REAL_PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__WRITABLE = REAL_PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__LOGON_LEVEL = REAL_PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__MAX_STATE = REAL_PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__SCHEDULED = REAL_PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__REFRESH_RATE = REAL_PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__DATA_TABLE_NAME = REAL_PROPERTY__DATA_TABLE_NAME;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__ADDRESS_OFFSET = REAL_PROPERTY__ADDRESS_OFFSET;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__DEFAULT_VALUE = REAL_PROPERTY__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__DRIVER_ADDRESS = REAL_PROPERTY__DRIVER_ADDRESS;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__USER_DEFINED_ADDRESS_OBJECT = REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__PERSISTENT = REAL_PROPERTY__PERSISTENT;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__DIRTY = REAL_PROPERTY__DIRTY;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__DUMMY = REAL_PROPERTY__DUMMY;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__FACTOR = REAL_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__OFFSET = REAL_PROPERTY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__PRECISION = REAL_PROPERTY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Decimal Places</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC__DECIMAL_PLACES = REAL_PROPERTY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Property Numeric</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NUMERIC_FEATURE_COUNT = REAL_PROPERTY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__OBSERVERS = PROPERTY_NUMERIC__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__TINE_EXPORT_PROPERTY = PROPERTY_NUMERIC__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__EQUIPMENT_MODULE = PROPERTY_NUMERIC__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__TINE_PROPERTY_HANDLER = PROPERTY_NUMERIC__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__NAME = PROPERTY_NUMERIC__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__DESCRIPTION = PROPERTY_NUMERIC__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__TINE_ACCESS = PROPERTY_NUMERIC__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__LENGTH = PROPERTY_NUMERIC__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__MINIMUM_VALUE = PROPERTY_NUMERIC__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__MAXIMUM_VALUE = PROPERTY_NUMERIC__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__UNIT = PROPERTY_NUMERIC__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__WRITABLE = PROPERTY_NUMERIC__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__LOGON_LEVEL = PROPERTY_NUMERIC__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__MAX_STATE = PROPERTY_NUMERIC__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__SCHEDULED = PROPERTY_NUMERIC__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__REFRESH_RATE = PROPERTY_NUMERIC__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__DATA_TABLE_NAME = PROPERTY_NUMERIC__DATA_TABLE_NAME;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__ADDRESS_OFFSET = PROPERTY_NUMERIC__ADDRESS_OFFSET;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__DEFAULT_VALUE = PROPERTY_NUMERIC__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__DRIVER_ADDRESS = PROPERTY_NUMERIC__DRIVER_ADDRESS;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__USER_DEFINED_ADDRESS_OBJECT = PROPERTY_NUMERIC__USER_DEFINED_ADDRESS_OBJECT;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__PERSISTENT = PROPERTY_NUMERIC__PERSISTENT;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__DIRTY = PROPERTY_NUMERIC__DIRTY;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__DUMMY = PROPERTY_NUMERIC__DUMMY;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__FACTOR = PROPERTY_NUMERIC__FACTOR;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__OFFSET = PROPERTY_NUMERIC__OFFSET;

	/**
	 * The feature id for the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__PRECISION = PROPERTY_NUMERIC__PRECISION;

	/**
	 * The feature id for the '<em><b>Decimal Places</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32__DECIMAL_PLACES = PROPERTY_NUMERIC__DECIMAL_PLACES;

	/**
	 * The number of structural features of the '<em>Property Int32</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_INT32_FEATURE_COUNT = PROPERTY_NUMERIC_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__OBSERVERS = PROPERTY_NUMERIC__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__TINE_EXPORT_PROPERTY = PROPERTY_NUMERIC__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__EQUIPMENT_MODULE = PROPERTY_NUMERIC__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__TINE_PROPERTY_HANDLER = PROPERTY_NUMERIC__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__NAME = PROPERTY_NUMERIC__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__DESCRIPTION = PROPERTY_NUMERIC__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__TINE_ACCESS = PROPERTY_NUMERIC__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__LENGTH = PROPERTY_NUMERIC__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__MINIMUM_VALUE = PROPERTY_NUMERIC__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__MAXIMUM_VALUE = PROPERTY_NUMERIC__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__UNIT = PROPERTY_NUMERIC__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__WRITABLE = PROPERTY_NUMERIC__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__LOGON_LEVEL = PROPERTY_NUMERIC__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__MAX_STATE = PROPERTY_NUMERIC__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__SCHEDULED = PROPERTY_NUMERIC__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__REFRESH_RATE = PROPERTY_NUMERIC__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__DATA_TABLE_NAME = PROPERTY_NUMERIC__DATA_TABLE_NAME;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__ADDRESS_OFFSET = PROPERTY_NUMERIC__ADDRESS_OFFSET;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__DEFAULT_VALUE = PROPERTY_NUMERIC__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__DRIVER_ADDRESS = PROPERTY_NUMERIC__DRIVER_ADDRESS;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__USER_DEFINED_ADDRESS_OBJECT = PROPERTY_NUMERIC__USER_DEFINED_ADDRESS_OBJECT;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__PERSISTENT = PROPERTY_NUMERIC__PERSISTENT;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__DIRTY = PROPERTY_NUMERIC__DIRTY;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__DUMMY = PROPERTY_NUMERIC__DUMMY;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__FACTOR = PROPERTY_NUMERIC__FACTOR;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__OFFSET = PROPERTY_NUMERIC__OFFSET;

	/**
	 * The feature id for the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__PRECISION = PROPERTY_NUMERIC__PRECISION;

	/**
	 * The feature id for the '<em><b>Decimal Places</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT__DECIMAL_PLACES = PROPERTY_NUMERIC__DECIMAL_PLACES;

	/**
	 * The number of structural features of the '<em>Property Float</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FLOAT_FEATURE_COUNT = PROPERTY_NUMERIC_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__OBSERVERS = OBSERVABLE__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Device</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__DEVICE = OBSERVABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__PROPERTIES = OBSERVABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__NAME = OBSERVABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Byte Buffer</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__BYTE_BUFFER = OBSERVABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Absolute Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__ABSOLUTE_ADDRESS = OBSERVABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__DIRTY = OBSERVABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__WRITABLE = OBSERVABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__DUMMY = OBSERVABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Observer Notification Enabled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED = OBSERVABLE_FEATURE_COUNT + 8;

	/**
	 * The number of structural features of the '<em>Data Table</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_TABLE_FEATURE_COUNT = OBSERVABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__OBSERVERS = REAL_PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__TINE_EXPORT_PROPERTY = REAL_PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__EQUIPMENT_MODULE = REAL_PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__TINE_PROPERTY_HANDLER = REAL_PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__NAME = REAL_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__DESCRIPTION = REAL_PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__TINE_ACCESS = REAL_PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__LENGTH = REAL_PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__MINIMUM_VALUE = REAL_PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__MAXIMUM_VALUE = REAL_PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__UNIT = REAL_PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__WRITABLE = REAL_PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__LOGON_LEVEL = REAL_PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__MAX_STATE = REAL_PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__SCHEDULED = REAL_PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__REFRESH_RATE = REAL_PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__DATA_TABLE_NAME = REAL_PROPERTY__DATA_TABLE_NAME;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__ADDRESS_OFFSET = REAL_PROPERTY__ADDRESS_OFFSET;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__DEFAULT_VALUE = REAL_PROPERTY__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__DRIVER_ADDRESS = REAL_PROPERTY__DRIVER_ADDRESS;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__USER_DEFINED_ADDRESS_OBJECT = REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__PERSISTENT = REAL_PROPERTY__PERSISTENT;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__DIRTY = REAL_PROPERTY__DIRTY;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE__DUMMY = REAL_PROPERTY__DUMMY;

	/**
	 * The number of structural features of the '<em>Property Byte</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_BYTE_FEATURE_COUNT = REAL_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__OBSERVERS = REAL_PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__TINE_EXPORT_PROPERTY = REAL_PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__EQUIPMENT_MODULE = REAL_PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__TINE_PROPERTY_HANDLER = REAL_PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__NAME = REAL_PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__DESCRIPTION = REAL_PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__TINE_ACCESS = REAL_PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__LENGTH = REAL_PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__MINIMUM_VALUE = REAL_PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__MAXIMUM_VALUE = REAL_PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__UNIT = REAL_PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__WRITABLE = REAL_PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__LOGON_LEVEL = REAL_PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__MAX_STATE = REAL_PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__SCHEDULED = REAL_PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__REFRESH_RATE = REAL_PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__DATA_TABLE_NAME = REAL_PROPERTY__DATA_TABLE_NAME;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__ADDRESS_OFFSET = REAL_PROPERTY__ADDRESS_OFFSET;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__DEFAULT_VALUE = REAL_PROPERTY__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__DRIVER_ADDRESS = REAL_PROPERTY__DRIVER_ADDRESS;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__USER_DEFINED_ADDRESS_OBJECT = REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__PERSISTENT = REAL_PROPERTY__PERSISTENT;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__DIRTY = REAL_PROPERTY__DIRTY;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT__DUMMY = REAL_PROPERTY__DUMMY;

	/**
	 * The number of structural features of the '<em>Property Text</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_TEXT_FEATURE_COUNT = REAL_PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__OBSERVERS = PROPERTY_NUMERIC__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__TINE_EXPORT_PROPERTY = PROPERTY_NUMERIC__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__EQUIPMENT_MODULE = PROPERTY_NUMERIC__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__TINE_PROPERTY_HANDLER = PROPERTY_NUMERIC__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__NAME = PROPERTY_NUMERIC__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__DESCRIPTION = PROPERTY_NUMERIC__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__TINE_ACCESS = PROPERTY_NUMERIC__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__LENGTH = PROPERTY_NUMERIC__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__MINIMUM_VALUE = PROPERTY_NUMERIC__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__MAXIMUM_VALUE = PROPERTY_NUMERIC__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__UNIT = PROPERTY_NUMERIC__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__WRITABLE = PROPERTY_NUMERIC__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__LOGON_LEVEL = PROPERTY_NUMERIC__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__MAX_STATE = PROPERTY_NUMERIC__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__SCHEDULED = PROPERTY_NUMERIC__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__REFRESH_RATE = PROPERTY_NUMERIC__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__DATA_TABLE_NAME = PROPERTY_NUMERIC__DATA_TABLE_NAME;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__ADDRESS_OFFSET = PROPERTY_NUMERIC__ADDRESS_OFFSET;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__DEFAULT_VALUE = PROPERTY_NUMERIC__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__DRIVER_ADDRESS = PROPERTY_NUMERIC__DRIVER_ADDRESS;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__USER_DEFINED_ADDRESS_OBJECT = PROPERTY_NUMERIC__USER_DEFINED_ADDRESS_OBJECT;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__PERSISTENT = PROPERTY_NUMERIC__PERSISTENT;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__DIRTY = PROPERTY_NUMERIC__DIRTY;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__DUMMY = PROPERTY_NUMERIC__DUMMY;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__FACTOR = PROPERTY_NUMERIC__FACTOR;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__OFFSET = PROPERTY_NUMERIC__OFFSET;

	/**
	 * The feature id for the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__PRECISION = PROPERTY_NUMERIC__PRECISION;

	/**
	 * The feature id for the '<em><b>Decimal Places</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE__DECIMAL_PLACES = PROPERTY_NUMERIC__DECIMAL_PLACES;

	/**
	 * The number of structural features of the '<em>Property Double</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_DOUBLE_FEATURE_COUNT = PROPERTY_NUMERIC_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Device</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIVER__DEVICE = 0;

	/**
	 * The feature id for the '<em><b>Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIVER__ADDRESS = 1;

	/**
	 * The number of structural features of the '<em>Driver</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DRIVER_FEATURE_COUNT = 2;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__OBSERVERS = PROPERTY_NUMERIC__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__TINE_EXPORT_PROPERTY = PROPERTY_NUMERIC__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__EQUIPMENT_MODULE = PROPERTY_NUMERIC__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__TINE_PROPERTY_HANDLER = PROPERTY_NUMERIC__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__NAME = PROPERTY_NUMERIC__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__DESCRIPTION = PROPERTY_NUMERIC__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__TINE_ACCESS = PROPERTY_NUMERIC__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__LENGTH = PROPERTY_NUMERIC__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__MINIMUM_VALUE = PROPERTY_NUMERIC__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__MAXIMUM_VALUE = PROPERTY_NUMERIC__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__UNIT = PROPERTY_NUMERIC__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__WRITABLE = PROPERTY_NUMERIC__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__LOGON_LEVEL = PROPERTY_NUMERIC__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__MAX_STATE = PROPERTY_NUMERIC__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__SCHEDULED = PROPERTY_NUMERIC__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__REFRESH_RATE = PROPERTY_NUMERIC__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Data Table Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__DATA_TABLE_NAME = PROPERTY_NUMERIC__DATA_TABLE_NAME;

	/**
	 * The feature id for the '<em><b>Address Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__ADDRESS_OFFSET = PROPERTY_NUMERIC__ADDRESS_OFFSET;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__DEFAULT_VALUE = PROPERTY_NUMERIC__DEFAULT_VALUE;

	/**
	 * The feature id for the '<em><b>Driver Address</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__DRIVER_ADDRESS = PROPERTY_NUMERIC__DRIVER_ADDRESS;

	/**
	 * The feature id for the '<em><b>User Defined Address Object</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__USER_DEFINED_ADDRESS_OBJECT = PROPERTY_NUMERIC__USER_DEFINED_ADDRESS_OBJECT;

	/**
	 * The feature id for the '<em><b>Persistent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__PERSISTENT = PROPERTY_NUMERIC__PERSISTENT;

	/**
	 * The feature id for the '<em><b>Dirty</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__DIRTY = PROPERTY_NUMERIC__DIRTY;

	/**
	 * The feature id for the '<em><b>Dummy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__DUMMY = PROPERTY_NUMERIC__DUMMY;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__FACTOR = PROPERTY_NUMERIC__FACTOR;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__OFFSET = PROPERTY_NUMERIC__OFFSET;

	/**
	 * The feature id for the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__PRECISION = PROPERTY_NUMERIC__PRECISION;

	/**
	 * The feature id for the '<em><b>Decimal Places</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16__DECIMAL_PLACES = PROPERTY_NUMERIC__DECIMAL_PLACES;

	/**
	 * The number of structural features of the '<em>Property Short16</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SHORT16_FEATURE_COUNT = PROPERTY_NUMERIC_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Observer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVER_FEATURE_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Observers</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__OBSERVERS = PROPERTY__OBSERVERS;

	/**
	 * The feature id for the '<em><b>Tine Export Property</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__TINE_EXPORT_PROPERTY = PROPERTY__TINE_EXPORT_PROPERTY;

	/**
	 * The feature id for the '<em><b>Equipment Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__EQUIPMENT_MODULE = PROPERTY__EQUIPMENT_MODULE;

	/**
	 * The feature id for the '<em><b>Tine Property Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__TINE_PROPERTY_HANDLER = PROPERTY__TINE_PROPERTY_HANDLER;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__NAME = PROPERTY__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__DESCRIPTION = PROPERTY__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tine Access</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__TINE_ACCESS = PROPERTY__TINE_ACCESS;

	/**
	 * The feature id for the '<em><b>Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__LENGTH = PROPERTY__LENGTH;

	/**
	 * The feature id for the '<em><b>Minimum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__MINIMUM_VALUE = PROPERTY__MINIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Maximum Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__MAXIMUM_VALUE = PROPERTY__MAXIMUM_VALUE;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__UNIT = PROPERTY__UNIT;

	/**
	 * The feature id for the '<em><b>Writable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__WRITABLE = PROPERTY__WRITABLE;

	/**
	 * The feature id for the '<em><b>Logon Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__LOGON_LEVEL = PROPERTY__LOGON_LEVEL;

	/**
	 * The feature id for the '<em><b>Max State</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__MAX_STATE = PROPERTY__MAX_STATE;

	/**
	 * The feature id for the '<em><b>Scheduled</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__SCHEDULED = PROPERTY__SCHEDULED;

	/**
	 * The feature id for the '<em><b>Refresh Rate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__REFRESH_RATE = PROPERTY__REFRESH_RATE;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY__PROPERTIES = PROPERTY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Group Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GROUP_PROPERTY_FEATURE_COUNT = PROPERTY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY_DAO__CONNECTION = 0;

	/**
	 * The feature id for the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY_DAO__TIMESTAMP = 1;

	/**
	 * The number of structural features of the '<em>Real Property DAO</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY_DAO_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.impl.RealPropertyDAO_PostgresImpl <em>Real Property DAO Postgres</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.impl.RealPropertyDAO_PostgresImpl
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getRealPropertyDAO_Postgres()
	 * @generated
	 */
	int REAL_PROPERTY_DAO_POSTGRES = 20;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY_DAO_POSTGRES__CONNECTION = REAL_PROPERTY_DAO__CONNECTION;

	/**
	 * The feature id for the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY_DAO_POSTGRES__TIMESTAMP = REAL_PROPERTY_DAO__TIMESTAMP;

	/**
	 * The number of structural features of the '<em>Real Property DAO Postgres</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_PROPERTY_DAO_POSTGRES_FEATURE_COUNT = REAL_PROPERTY_DAO_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Factor</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALABLE__FACTOR = 0;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALABLE__OFFSET = 1;

	/**
	 * The feature id for the '<em><b>Precision</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALABLE__PRECISION = 2;

	/**
	 * The feature id for the '<em><b>Decimal Places</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALABLE__DECIMAL_PLACES = 3;

	/**
	 * The number of structural features of the '<em>Scalable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCALABLE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.TineAccess <em>Tine Access</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.TineAccess
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTineAccess()
	 * @generated
	 */
	int TINE_ACCESS = 24;

	/**
	 * The meta object id for the '{@link ch.thomson.ucs.tine.server.ByteOrder <em>Byte Order</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.ByteOrder
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getByteOrder()
	 * @generated
	 */
	int BYTE_ORDER = 25;

	/**
	 * The meta object id for the '<em>TEquipment Module Factory</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.desy.tine.server.equipment.TEquipmentModuleFactory
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTEquipmentModuleFactory()
	 * @generated
	 */
	int TEQUIPMENT_MODULE_FACTORY = 26;

	/**
	 * The meta object id for the '<em>TEquipment Module</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.desy.tine.server.equipment.TEquipmentModule
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTEquipmentModule()
	 * @generated
	 */
	int TEQUIPMENT_MODULE = 27;

	/**
	 * The meta object id for the '<em>TDevice</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.desy.tine.server.devices.TDevice
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTDevice()
	 * @generated
	 */
	int TDEVICE = 28;

	/**
	 * The meta object id for the '<em>TExport Property</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.desy.tine.server.properties.TExportProperty
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTExportProperty()
	 * @generated
	 */
	int TEXPORT_PROPERTY = 29;

	/**
	 * The meta object id for the '<em>TProperty Handler</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.desy.tine.server.properties.TPropertyHandler
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTPropertyHandler()
	 * @generated
	 */
	int TPROPERTY_HANDLER = 30;

	/**
	 * The meta object id for the '<em>TEquipment Background Task</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.desy.tine.server.equipment.TEquipmentBackgroundTask
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTEquipmentBackgroundTask()
	 * @generated
	 */
	int TEQUIPMENT_BACKGROUND_TASK = 31;


	/**
	 * The meta object id for the '<em>Object</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.lang.Object
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getObject()
	 * @generated
	 */
	int OBJECT = 32;


	/**
	 * The meta object id for the '<em>Exception</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.lang.Exception
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getException()
	 * @generated
	 */
	int EXCEPTION = 33;


	/**
	 * The meta object id for the '<em>TData Type</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.desy.tine.dataUtils.TDataType
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTDataType()
	 * @generated
	 */
	int TDATA_TYPE = 34;


	/**
	 * The meta object id for the '<em>DB Connection</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.sql.Connection
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDBConnection()
	 * @generated
	 */
	int DB_CONNECTION = 35;


	/**
	 * The meta object id for the '<em>Timestamp</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.sql.Timestamp
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTimestamp()
	 * @generated
	 */
	int TIMESTAMP = 36;


	/**
	 * The meta object id for the '<em>Byte Buffer</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.nio.ByteBuffer
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getByteBuffer()
	 * @generated
	 */
	int BYTE_BUFFER = 37;


	/**
	 * The meta object id for the '<em>Device Update Listener</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener
	 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDeviceUpdateListener()
	 * @generated
	 */
	int DEVICE_UPDATE_LISTENER = 38;


	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.FrontEndController <em>Front End Controller</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Front End Controller</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController
	 * @generated
	 */
	EClass getFrontEndController();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#getTineEquipmentModuleFactory <em>Tine Equipment Module Factory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Equipment Module Factory</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getTineEquipmentModuleFactory()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_TineEquipmentModuleFactory();

	/**
	 * Returns the meta object for the containment reference list '{@link ch.thomson.ucs.tine.server.FrontEndController#getEquipmentModules <em>Equipment Modules</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Equipment Modules</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getEquipmentModules()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EReference getFrontEndController_EquipmentModules();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getName()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_Name();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#getSubSystemName <em>Sub System Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sub System Name</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getSubSystemName()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_SubSystemName();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#getContextName <em>Context Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Context Name</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getContextName()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_ContextName();

	/**
	 * Returns the meta object for the reference '{@link ch.thomson.ucs.tine.server.FrontEndController#getLocation <em>Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Location</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getLocation()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EReference getFrontEndController_Location();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#getLocalValue <em>Local Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Value</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getLocalValue()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_LocalValue();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#isLocalMode <em>Local Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Mode</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#isLocalMode()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_LocalMode();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#isAccessAllowed <em>Access Allowed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Access Allowed</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#isAccessAllowed()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_AccessAllowed();

	/**
	 * Returns the meta object for the attribute list '{@link ch.thomson.ucs.tine.server.FrontEndController#getAllowedHostsForLocalAccess <em>Allowed Hosts For Local Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Allowed Hosts For Local Access</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getAllowedHostsForLocalAccess()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_AllowedHostsForLocalAccess();

	/**
	 * Returns the meta object for the reference '{@link ch.thomson.ucs.tine.server.FrontEndController#getLockWriteProperty <em>Lock Write Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Lock Write Property</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#getLockWriteProperty()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EReference getFrontEndController_LockWriteProperty();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#isWriteLocked <em>Write Locked</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Write Locked</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#isWriteLocked()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_WriteLocked();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.FrontEndController#isLocalCaller <em>Local Caller</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Caller</em>'.
	 * @see ch.thomson.ucs.tine.server.FrontEndController#isLocalCaller()
	 * @see #getFrontEndController()
	 * @generated
	 */
	EAttribute getFrontEndController_LocalCaller();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.EquipmentModule <em>Equipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equipment Module</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule
	 * @generated
	 */
	EClass getEquipmentModule();

	/**
	 * Returns the meta object for the container reference '{@link ch.thomson.ucs.tine.server.EquipmentModule#getFrontEndController <em>Front End Controller</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Front End Controller</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getFrontEndController()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EReference getEquipmentModule_FrontEndController();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getExportName <em>Export Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Export Name</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getExportName()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_ExportName();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getLocalName()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_LocalName();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getTineEquipmentModule <em>Tine Equipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Equipment Module</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getTineEquipmentModule()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_TineEquipmentModule();

	/**
	 * Returns the meta object for the containment reference list '{@link ch.thomson.ucs.tine.server.EquipmentModule#getDevices <em>Devices</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Devices</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getDevices()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EReference getEquipmentModule_Devices();

	/**
	 * Returns the meta object for the containment reference list '{@link ch.thomson.ucs.tine.server.EquipmentModule#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Properties</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getProperties()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EReference getEquipmentModule_Properties();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getTineBackgroundTask <em>Tine Background Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Background Task</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getTineBackgroundTask()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_TineBackgroundTask();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getDevicePollingRate <em>Device Polling Rate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Device Polling Rate</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getDevicePollingRate()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_DevicePollingRate();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getDriverType <em>Driver Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Driver Type</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getDriverType()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_DriverType();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getByteOrder <em>Byte Order</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Byte Order</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getByteOrder()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_ByteOrder();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.EquipmentModule#getTinePath <em>Tine Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Path</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getTinePath()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EAttribute getEquipmentModule_TinePath();

	/**
	 * Returns the meta object for the reference '{@link ch.thomson.ucs.tine.server.EquipmentModule#getActualState <em>Actual State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Actual State</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getActualState()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EReference getEquipmentModule_ActualState();

	/**
	 * Returns the meta object for the reference '{@link ch.thomson.ucs.tine.server.EquipmentModule#getTargetState <em>Target State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target State</em>'.
	 * @see ch.thomson.ucs.tine.server.EquipmentModule#getTargetState()
	 * @see #getEquipmentModule()
	 * @generated
	 */
	EReference getEquipmentModule_TargetState();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.Device <em>Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Device</em>'.
	 * @see ch.thomson.ucs.tine.server.Device
	 * @generated
	 */
	EClass getDevice();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Device#getTineDevice <em>Tine Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Device</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getTineDevice()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_TineDevice();

	/**
	 * Returns the meta object for the container reference '{@link ch.thomson.ucs.tine.server.Device#getEquipmentModule <em>Equipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Equipment Module</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getEquipmentModule()
	 * @see #getDevice()
	 * @generated
	 */
	EReference getDevice_EquipmentModule();

	/**
	 * Returns the meta object for the containment reference list '{@link ch.thomson.ucs.tine.server.Device#getDataTables <em>Data Tables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Data Tables</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getDataTables()
	 * @see #getDevice()
	 * @generated
	 */
	EReference getDevice_DataTables();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Device#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getName()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_Name();

	/**
	 * Returns the meta object for the containment reference '{@link ch.thomson.ucs.tine.server.Device#getDriver <em>Driver</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Driver</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getDriver()
	 * @see #getDevice()
	 * @generated
	 */
	EReference getDevice_Driver();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Device#getAddress <em>Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Address</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getAddress()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_Address();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Device#getActualError <em>Actual Error</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Actual Error</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getActualError()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_ActualError();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Device#getUserDataStamp <em>User Data Stamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>User Data Stamp</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getUserDataStamp()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_UserDataStamp();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Device#getSystemDataStamp <em>System Data Stamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>System Data Stamp</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getSystemDataStamp()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_SystemDataStamp();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Device#isTransaction <em>Transaction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Transaction</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#isTransaction()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_Transaction();

	/**
	 * Returns the meta object for the attribute list '{@link ch.thomson.ucs.tine.server.Device#getDeviceUpdateListeners <em>Device Update Listeners</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Device Update Listeners</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getDeviceUpdateListeners()
	 * @see #getDevice()
	 * @generated
	 */
	EAttribute getDevice_DeviceUpdateListeners();

	/**
	 * Returns the meta object for the reference '{@link ch.thomson.ucs.tine.server.Device#getLinkUserDataStamp <em>Link User Data Stamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Link User Data Stamp</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getLinkUserDataStamp()
	 * @see #getDevice()
	 * @generated
	 */
	EReference getDevice_LinkUserDataStamp();

	/**
	 * Returns the meta object for the reference '{@link ch.thomson.ucs.tine.server.Device#getLinkSystemDataStamp <em>Link System Data Stamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Link System Data Stamp</em>'.
	 * @see ch.thomson.ucs.tine.server.Device#getLinkSystemDataStamp()
	 * @see #getDevice()
	 * @generated
	 */
	EReference getDevice_LinkSystemDataStamp();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.Property <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property</em>'.
	 * @see ch.thomson.ucs.tine.server.Property
	 * @generated
	 */
	EClass getProperty();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getTineExportProperty <em>Tine Export Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Export Property</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getTineExportProperty()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_TineExportProperty();

	/**
	 * Returns the meta object for the container reference '{@link ch.thomson.ucs.tine.server.Property#getEquipmentModule <em>Equipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Equipment Module</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getEquipmentModule()
	 * @see #getProperty()
	 * @generated
	 */
	EReference getProperty_EquipmentModule();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getTinePropertyHandler <em>Tine Property Handler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Property Handler</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getTinePropertyHandler()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_TinePropertyHandler();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getName()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Name();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getDescription()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Description();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getTineAccess <em>Tine Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tine Access</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getTineAccess()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_TineAccess();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getLength <em>Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Length</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getLength()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Length();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getMinimumValue <em>Minimum Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Minimum Value</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getMinimumValue()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_MinimumValue();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getMaximumValue <em>Maximum Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Maximum Value</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getMaximumValue()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_MaximumValue();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getUnit()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Unit();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#isWritable <em>Writable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Writable</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#isWritable()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Writable();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getLogonLevel <em>Logon Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Logon Level</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getLogonLevel()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_LogonLevel();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getMaxState <em>Max State</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max State</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getMaxState()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_MaxState();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#isScheduled <em>Scheduled</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Scheduled</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#isScheduled()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Scheduled();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Property#getRefreshRate <em>Refresh Rate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Refresh Rate</em>'.
	 * @see ch.thomson.ucs.tine.server.Property#getRefreshRate()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_RefreshRate();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.DecoratedProperty <em>Decorated Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Decorated Property</em>'.
	 * @see ch.thomson.ucs.tine.server.DecoratedProperty
	 * @generated
	 */
	EClass getDecoratedProperty();

	/**
	 * Returns the meta object for the reference '{@link ch.thomson.ucs.tine.server.DecoratedProperty#getRealProperty <em>Real Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Real Property</em>'.
	 * @see ch.thomson.ucs.tine.server.DecoratedProperty#getRealProperty()
	 * @see #getDecoratedProperty()
	 * @generated
	 */
	EReference getDecoratedProperty_RealProperty();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.RealProperty <em>Real Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Real Property</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty
	 * @generated
	 */
	EClass getRealProperty();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#getDataTableName <em>Data Table Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Table Name</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#getDataTableName()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_DataTableName();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#getAddressOffset <em>Address Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Address Offset</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#getAddressOffset()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_AddressOffset();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#getDefaultValue <em>Default Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default Value</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#getDefaultValue()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_DefaultValue();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#getDriverAddress <em>Driver Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Driver Address</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#getDriverAddress()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_DriverAddress();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#getUserDefinedAddressObject <em>User Defined Address Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>User Defined Address Object</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#getUserDefinedAddressObject()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_UserDefinedAddressObject();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#isPersistent <em>Persistent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Persistent</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#isPersistent()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_Persistent();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#isDirty <em>Dirty</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dirty</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#isDirty()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_Dirty();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealProperty#isDummy <em>Dummy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dummy</em>'.
	 * @see ch.thomson.ucs.tine.server.RealProperty#isDummy()
	 * @see #getRealProperty()
	 * @generated
	 */
	EAttribute getRealProperty_Dummy();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.ScaledProperty <em>Scaled Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scaled Property</em>'.
	 * @see ch.thomson.ucs.tine.server.ScaledProperty
	 * @generated
	 */
	EClass getScaledProperty();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.AliasProperty <em>Alias Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alias Property</em>'.
	 * @see ch.thomson.ucs.tine.server.AliasProperty
	 * @generated
	 */
	EClass getAliasProperty();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.PropertyInt32 <em>Property Int32</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Int32</em>'.
	 * @see ch.thomson.ucs.tine.server.PropertyInt32
	 * @generated
	 */
	EClass getPropertyInt32();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.PropertyFloat <em>Property Float</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Float</em>'.
	 * @see ch.thomson.ucs.tine.server.PropertyFloat
	 * @generated
	 */
	EClass getPropertyFloat();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.DataTable <em>Data Table</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Table</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable
	 * @generated
	 */
	EClass getDataTable();

	/**
	 * Returns the meta object for the container reference '{@link ch.thomson.ucs.tine.server.DataTable#getDevice <em>Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Device</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#getDevice()
	 * @see #getDataTable()
	 * @generated
	 */
	EReference getDataTable_Device();

	/**
	 * Returns the meta object for the reference list '{@link ch.thomson.ucs.tine.server.DataTable#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Properties</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#getProperties()
	 * @see #getDataTable()
	 * @generated
	 */
	EReference getDataTable_Properties();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.DataTable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#getName()
	 * @see #getDataTable()
	 * @generated
	 */
	EAttribute getDataTable_Name();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.DataTable#getByteBuffer <em>Byte Buffer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Byte Buffer</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#getByteBuffer()
	 * @see #getDataTable()
	 * @generated
	 */
	EAttribute getDataTable_ByteBuffer();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.DataTable#getAbsoluteAddress <em>Absolute Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Absolute Address</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#getAbsoluteAddress()
	 * @see #getDataTable()
	 * @generated
	 */
	EAttribute getDataTable_AbsoluteAddress();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.DataTable#isDirty <em>Dirty</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dirty</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#isDirty()
	 * @see #getDataTable()
	 * @generated
	 */
	EAttribute getDataTable_Dirty();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.DataTable#isWritable <em>Writable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Writable</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#isWritable()
	 * @see #getDataTable()
	 * @generated
	 */
	EAttribute getDataTable_Writable();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.DataTable#isDummy <em>Dummy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dummy</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#isDummy()
	 * @see #getDataTable()
	 * @generated
	 */
	EAttribute getDataTable_Dummy();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.DataTable#isObserverNotificationEnabled <em>Observer Notification Enabled</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Observer Notification Enabled</em>'.
	 * @see ch.thomson.ucs.tine.server.DataTable#isObserverNotificationEnabled()
	 * @see #getDataTable()
	 * @generated
	 */
	EAttribute getDataTable_ObserverNotificationEnabled();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.PropertyByte <em>Property Byte</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Byte</em>'.
	 * @see ch.thomson.ucs.tine.server.PropertyByte
	 * @generated
	 */
	EClass getPropertyByte();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.PropertyText <em>Property Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Text</em>'.
	 * @see ch.thomson.ucs.tine.server.PropertyText
	 * @generated
	 */
	EClass getPropertyText();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.PropertyDouble <em>Property Double</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Double</em>'.
	 * @see ch.thomson.ucs.tine.server.PropertyDouble
	 * @generated
	 */
	EClass getPropertyDouble();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.Driver <em>Driver</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Driver</em>'.
	 * @see ch.thomson.ucs.tine.server.Driver
	 * @generated
	 */
	EClass getDriver();

	/**
	 * Returns the meta object for the container reference '{@link ch.thomson.ucs.tine.server.Driver#getDevice <em>Device</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Device</em>'.
	 * @see ch.thomson.ucs.tine.server.Driver#getDevice()
	 * @see #getDriver()
	 * @generated
	 */
	EReference getDriver_Device();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Driver#getAddress <em>Address</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Address</em>'.
	 * @see ch.thomson.ucs.tine.server.Driver#getAddress()
	 * @see #getDriver()
	 * @generated
	 */
	EAttribute getDriver_Address();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.PropertyShort16 <em>Property Short16</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Short16</em>'.
	 * @see ch.thomson.ucs.tine.server.PropertyShort16
	 * @generated
	 */
	EClass getPropertyShort16();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.Observer <em>Observer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Observer</em>'.
	 * @see ch.thomson.ucs.tine.server.Observer
	 * @generated
	 */
	EClass getObserver();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.Observable <em>Observable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Observable</em>'.
	 * @see ch.thomson.ucs.tine.server.Observable
	 * @generated
	 */
	EClass getObservable();

	/**
	 * Returns the meta object for the reference list '{@link ch.thomson.ucs.tine.server.Observable#getObservers <em>Observers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Observers</em>'.
	 * @see ch.thomson.ucs.tine.server.Observable#getObservers()
	 * @see #getObservable()
	 * @generated
	 */
	EReference getObservable_Observers();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.GroupProperty <em>Group Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Group Property</em>'.
	 * @see ch.thomson.ucs.tine.server.GroupProperty
	 * @generated
	 */
	EClass getGroupProperty();

	/**
	 * Returns the meta object for the reference list '{@link ch.thomson.ucs.tine.server.GroupProperty#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Properties</em>'.
	 * @see ch.thomson.ucs.tine.server.GroupProperty#getProperties()
	 * @see #getGroupProperty()
	 * @generated
	 */
	EReference getGroupProperty_Properties();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.RealPropertyDAO <em>Real Property DAO</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Real Property DAO</em>'.
	 * @see ch.thomson.ucs.tine.server.RealPropertyDAO
	 * @generated
	 */
	EClass getRealPropertyDAO();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealPropertyDAO#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Connection</em>'.
	 * @see ch.thomson.ucs.tine.server.RealPropertyDAO#getConnection()
	 * @see #getRealPropertyDAO()
	 * @generated
	 */
	EAttribute getRealPropertyDAO_Connection();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.RealPropertyDAO#getTimestamp <em>Timestamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Timestamp</em>'.
	 * @see ch.thomson.ucs.tine.server.RealPropertyDAO#getTimestamp()
	 * @see #getRealPropertyDAO()
	 * @generated
	 */
	EAttribute getRealPropertyDAO_Timestamp();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres <em>Real Property DAO Postgres</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Real Property DAO Postgres</em>'.
	 * @see ch.thomson.ucs.tine.server.RealPropertyDAO_Postgres
	 * @generated
	 */
	EClass getRealPropertyDAO_Postgres();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.Persistable <em>Persistable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Persistable</em>'.
	 * @see ch.thomson.ucs.tine.server.Persistable
	 * @generated
	 */
	EClass getPersistable();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.Scalable <em>Scalable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scalable</em>'.
	 * @see ch.thomson.ucs.tine.server.Scalable
	 * @generated
	 */
	EClass getScalable();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Scalable#getFactor <em>Factor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Factor</em>'.
	 * @see ch.thomson.ucs.tine.server.Scalable#getFactor()
	 * @see #getScalable()
	 * @generated
	 */
	EAttribute getScalable_Factor();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Scalable#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see ch.thomson.ucs.tine.server.Scalable#getOffset()
	 * @see #getScalable()
	 * @generated
	 */
	EAttribute getScalable_Offset();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Scalable#getPrecision <em>Precision</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Precision</em>'.
	 * @see ch.thomson.ucs.tine.server.Scalable#getPrecision()
	 * @see #getScalable()
	 * @generated
	 */
	EAttribute getScalable_Precision();

	/**
	 * Returns the meta object for the attribute '{@link ch.thomson.ucs.tine.server.Scalable#getDecimalPlaces <em>Decimal Places</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Decimal Places</em>'.
	 * @see ch.thomson.ucs.tine.server.Scalable#getDecimalPlaces()
	 * @see #getScalable()
	 * @generated
	 */
	EAttribute getScalable_DecimalPlaces();

	/**
	 * Returns the meta object for class '{@link ch.thomson.ucs.tine.server.PropertyNumeric <em>Property Numeric</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Numeric</em>'.
	 * @see ch.thomson.ucs.tine.server.PropertyNumeric
	 * @generated
	 */
	EClass getPropertyNumeric();

	/**
	 * Returns the meta object for enum '{@link ch.thomson.ucs.tine.server.TineAccess <em>Tine Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Tine Access</em>'.
	 * @see ch.thomson.ucs.tine.server.TineAccess
	 * @generated
	 */
	EEnum getTineAccess();

	/**
	 * Returns the meta object for enum '{@link ch.thomson.ucs.tine.server.ByteOrder <em>Byte Order</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Byte Order</em>'.
	 * @see ch.thomson.ucs.tine.server.ByteOrder
	 * @generated
	 */
	EEnum getByteOrder();

	/**
	 * Returns the meta object for data type '{@link de.desy.tine.server.equipment.TEquipmentModuleFactory <em>TEquipment Module Factory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>TEquipment Module Factory</em>'.
	 * @see de.desy.tine.server.equipment.TEquipmentModuleFactory
	 * @model instanceClass="de.desy.tine.server.equipment.TEquipmentModuleFactory" serializeable="false"
	 * @generated
	 */
	EDataType getTEquipmentModuleFactory();

	/**
	 * Returns the meta object for data type '{@link de.desy.tine.server.equipment.TEquipmentModule <em>TEquipment Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>TEquipment Module</em>'.
	 * @see de.desy.tine.server.equipment.TEquipmentModule
	 * @model instanceClass="de.desy.tine.server.equipment.TEquipmentModule" serializeable="false"
	 * @generated
	 */
	EDataType getTEquipmentModule();

	/**
	 * Returns the meta object for data type '{@link de.desy.tine.server.devices.TDevice <em>TDevice</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>TDevice</em>'.
	 * @see de.desy.tine.server.devices.TDevice
	 * @model instanceClass="de.desy.tine.server.devices.TDevice" serializeable="false"
	 * @generated
	 */
	EDataType getTDevice();

	/**
	 * Returns the meta object for data type '{@link de.desy.tine.server.properties.TExportProperty <em>TExport Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>TExport Property</em>'.
	 * @see de.desy.tine.server.properties.TExportProperty
	 * @model instanceClass="de.desy.tine.server.properties.TExportProperty" serializeable="false"
	 * @generated
	 */
	EDataType getTExportProperty();

	/**
	 * Returns the meta object for data type '{@link de.desy.tine.server.properties.TPropertyHandler <em>TProperty Handler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>TProperty Handler</em>'.
	 * @see de.desy.tine.server.properties.TPropertyHandler
	 * @model instanceClass="de.desy.tine.server.properties.TPropertyHandler" serializeable="false"
	 * @generated
	 */
	EDataType getTPropertyHandler();

	/**
	 * Returns the meta object for data type '{@link de.desy.tine.server.equipment.TEquipmentBackgroundTask <em>TEquipment Background Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>TEquipment Background Task</em>'.
	 * @see de.desy.tine.server.equipment.TEquipmentBackgroundTask
	 * @model instanceClass="de.desy.tine.server.equipment.TEquipmentBackgroundTask" serializeable="false"
	 * @generated
	 */
	EDataType getTEquipmentBackgroundTask();

	/**
	 * Returns the meta object for data type '{@link java.lang.Object <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Object</em>'.
	 * @see java.lang.Object
	 * @model instanceClass="java.lang.Object" serializeable="false"
	 * @generated
	 */
	EDataType getObject();

	/**
	 * Returns the meta object for data type '{@link java.lang.Exception <em>Exception</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Exception</em>'.
	 * @see java.lang.Exception
	 * @model instanceClass="java.lang.Exception" serializeable="false"
	 * @generated
	 */
	EDataType getException();

	/**
	 * Returns the meta object for data type '{@link de.desy.tine.dataUtils.TDataType <em>TData Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>TData Type</em>'.
	 * @see de.desy.tine.dataUtils.TDataType
	 * @model instanceClass="de.desy.tine.dataUtils.TDataType" serializeable="false"
	 * @generated
	 */
	EDataType getTDataType();

	/**
	 * Returns the meta object for data type '{@link java.sql.Connection <em>DB Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>DB Connection</em>'.
	 * @see java.sql.Connection
	 * @model instanceClass="java.sql.Connection"
	 * @generated
	 */
	EDataType getDBConnection();

	/**
	 * Returns the meta object for data type '{@link java.sql.Timestamp <em>Timestamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Timestamp</em>'.
	 * @see java.sql.Timestamp
	 * @model instanceClass="java.sql.Timestamp"
	 * @generated
	 */
	EDataType getTimestamp();

	/**
	 * Returns the meta object for data type '{@link java.nio.ByteBuffer <em>Byte Buffer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Byte Buffer</em>'.
	 * @see java.nio.ByteBuffer
	 * @model instanceClass="java.nio.ByteBuffer" serializeable="false"
	 * @generated
	 */
	EDataType getByteBuffer();

	/**
	 * Returns the meta object for data type '{@link ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener <em>Device Update Listener</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Device Update Listener</em>'.
	 * @see ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener
	 * @model instanceClass="ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener" serializeable="false"
	 * @generated
	 */
	EDataType getDeviceUpdateListener();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ServerFactory getServerFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl <em>Front End Controller</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.FrontEndControllerImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getFrontEndController()
		 * @generated
		 */
		EClass FRONT_END_CONTROLLER = eINSTANCE.getFrontEndController();

		/**
		 * The meta object literal for the '<em><b>Tine Equipment Module Factory</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__TINE_EQUIPMENT_MODULE_FACTORY = eINSTANCE.getFrontEndController_TineEquipmentModuleFactory();

		/**
		 * The meta object literal for the '<em><b>Equipment Modules</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FRONT_END_CONTROLLER__EQUIPMENT_MODULES = eINSTANCE.getFrontEndController_EquipmentModules();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__NAME = eINSTANCE.getFrontEndController_Name();

		/**
		 * The meta object literal for the '<em><b>Sub System Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__SUB_SYSTEM_NAME = eINSTANCE.getFrontEndController_SubSystemName();

		/**
		 * The meta object literal for the '<em><b>Context Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__CONTEXT_NAME = eINSTANCE.getFrontEndController_ContextName();

		/**
		 * The meta object literal for the '<em><b>Location</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FRONT_END_CONTROLLER__LOCATION = eINSTANCE.getFrontEndController_Location();

		/**
		 * The meta object literal for the '<em><b>Local Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__LOCAL_VALUE = eINSTANCE.getFrontEndController_LocalValue();

		/**
		 * The meta object literal for the '<em><b>Local Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__LOCAL_MODE = eINSTANCE.getFrontEndController_LocalMode();

		/**
		 * The meta object literal for the '<em><b>Access Allowed</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__ACCESS_ALLOWED = eINSTANCE.getFrontEndController_AccessAllowed();

		/**
		 * The meta object literal for the '<em><b>Allowed Hosts For Local Access</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__ALLOWED_HOSTS_FOR_LOCAL_ACCESS = eINSTANCE.getFrontEndController_AllowedHostsForLocalAccess();

		/**
		 * The meta object literal for the '<em><b>Lock Write Property</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FRONT_END_CONTROLLER__LOCK_WRITE_PROPERTY = eINSTANCE.getFrontEndController_LockWriteProperty();

		/**
		 * The meta object literal for the '<em><b>Write Locked</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__WRITE_LOCKED = eINSTANCE.getFrontEndController_WriteLocked();

		/**
		 * The meta object literal for the '<em><b>Local Caller</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FRONT_END_CONTROLLER__LOCAL_CALLER = eINSTANCE.getFrontEndController_LocalCaller();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.EquipmentModuleImpl <em>Equipment Module</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.EquipmentModuleImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getEquipmentModule()
		 * @generated
		 */
		EClass EQUIPMENT_MODULE = eINSTANCE.getEquipmentModule();

		/**
		 * The meta object literal for the '<em><b>Front End Controller</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EQUIPMENT_MODULE__FRONT_END_CONTROLLER = eINSTANCE.getEquipmentModule_FrontEndController();

		/**
		 * The meta object literal for the '<em><b>Export Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__EXPORT_NAME = eINSTANCE.getEquipmentModule_ExportName();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__LOCAL_NAME = eINSTANCE.getEquipmentModule_LocalName();

		/**
		 * The meta object literal for the '<em><b>Tine Equipment Module</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__TINE_EQUIPMENT_MODULE = eINSTANCE.getEquipmentModule_TineEquipmentModule();

		/**
		 * The meta object literal for the '<em><b>Devices</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EQUIPMENT_MODULE__DEVICES = eINSTANCE.getEquipmentModule_Devices();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EQUIPMENT_MODULE__PROPERTIES = eINSTANCE.getEquipmentModule_Properties();

		/**
		 * The meta object literal for the '<em><b>Tine Background Task</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__TINE_BACKGROUND_TASK = eINSTANCE.getEquipmentModule_TineBackgroundTask();

		/**
		 * The meta object literal for the '<em><b>Device Polling Rate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__DEVICE_POLLING_RATE = eINSTANCE.getEquipmentModule_DevicePollingRate();

		/**
		 * The meta object literal for the '<em><b>Driver Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__DRIVER_TYPE = eINSTANCE.getEquipmentModule_DriverType();

		/**
		 * The meta object literal for the '<em><b>Byte Order</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__BYTE_ORDER = eINSTANCE.getEquipmentModule_ByteOrder();

		/**
		 * The meta object literal for the '<em><b>Tine Path</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUIPMENT_MODULE__TINE_PATH = eINSTANCE.getEquipmentModule_TinePath();

		/**
		 * The meta object literal for the '<em><b>Actual State</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EQUIPMENT_MODULE__ACTUAL_STATE = eINSTANCE.getEquipmentModule_ActualState();

		/**
		 * The meta object literal for the '<em><b>Target State</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EQUIPMENT_MODULE__TARGET_STATE = eINSTANCE.getEquipmentModule_TargetState();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.DeviceImpl <em>Device</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.DeviceImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDevice()
		 * @generated
		 */
		EClass DEVICE = eINSTANCE.getDevice();

		/**
		 * The meta object literal for the '<em><b>Tine Device</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__TINE_DEVICE = eINSTANCE.getDevice_TineDevice();

		/**
		 * The meta object literal for the '<em><b>Equipment Module</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEVICE__EQUIPMENT_MODULE = eINSTANCE.getDevice_EquipmentModule();

		/**
		 * The meta object literal for the '<em><b>Data Tables</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEVICE__DATA_TABLES = eINSTANCE.getDevice_DataTables();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__NAME = eINSTANCE.getDevice_Name();

		/**
		 * The meta object literal for the '<em><b>Driver</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEVICE__DRIVER = eINSTANCE.getDevice_Driver();

		/**
		 * The meta object literal for the '<em><b>Address</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__ADDRESS = eINSTANCE.getDevice_Address();

		/**
		 * The meta object literal for the '<em><b>Actual Error</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__ACTUAL_ERROR = eINSTANCE.getDevice_ActualError();

		/**
		 * The meta object literal for the '<em><b>User Data Stamp</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__USER_DATA_STAMP = eINSTANCE.getDevice_UserDataStamp();

		/**
		 * The meta object literal for the '<em><b>System Data Stamp</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__SYSTEM_DATA_STAMP = eINSTANCE.getDevice_SystemDataStamp();

		/**
		 * The meta object literal for the '<em><b>Transaction</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__TRANSACTION = eINSTANCE.getDevice_Transaction();

		/**
		 * The meta object literal for the '<em><b>Device Update Listeners</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEVICE__DEVICE_UPDATE_LISTENERS = eINSTANCE.getDevice_DeviceUpdateListeners();

		/**
		 * The meta object literal for the '<em><b>Link User Data Stamp</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEVICE__LINK_USER_DATA_STAMP = eINSTANCE.getDevice_LinkUserDataStamp();

		/**
		 * The meta object literal for the '<em><b>Link System Data Stamp</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEVICE__LINK_SYSTEM_DATA_STAMP = eINSTANCE.getDevice_LinkSystemDataStamp();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyImpl <em>Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getProperty()
		 * @generated
		 */
		EClass PROPERTY = eINSTANCE.getProperty();

		/**
		 * The meta object literal for the '<em><b>Tine Export Property</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__TINE_EXPORT_PROPERTY = eINSTANCE.getProperty_TineExportProperty();

		/**
		 * The meta object literal for the '<em><b>Equipment Module</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY__EQUIPMENT_MODULE = eINSTANCE.getProperty_EquipmentModule();

		/**
		 * The meta object literal for the '<em><b>Tine Property Handler</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__TINE_PROPERTY_HANDLER = eINSTANCE.getProperty_TinePropertyHandler();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__NAME = eINSTANCE.getProperty_Name();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__DESCRIPTION = eINSTANCE.getProperty_Description();

		/**
		 * The meta object literal for the '<em><b>Tine Access</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__TINE_ACCESS = eINSTANCE.getProperty_TineAccess();

		/**
		 * The meta object literal for the '<em><b>Length</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__LENGTH = eINSTANCE.getProperty_Length();

		/**
		 * The meta object literal for the '<em><b>Minimum Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__MINIMUM_VALUE = eINSTANCE.getProperty_MinimumValue();

		/**
		 * The meta object literal for the '<em><b>Maximum Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__MAXIMUM_VALUE = eINSTANCE.getProperty_MaximumValue();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__UNIT = eINSTANCE.getProperty_Unit();

		/**
		 * The meta object literal for the '<em><b>Writable</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__WRITABLE = eINSTANCE.getProperty_Writable();

		/**
		 * The meta object literal for the '<em><b>Logon Level</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__LOGON_LEVEL = eINSTANCE.getProperty_LogonLevel();

		/**
		 * The meta object literal for the '<em><b>Max State</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__MAX_STATE = eINSTANCE.getProperty_MaxState();

		/**
		 * The meta object literal for the '<em><b>Scheduled</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__SCHEDULED = eINSTANCE.getProperty_Scheduled();

		/**
		 * The meta object literal for the '<em><b>Refresh Rate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__REFRESH_RATE = eINSTANCE.getProperty_RefreshRate();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.DecoratedPropertyImpl <em>Decorated Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.DecoratedPropertyImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDecoratedProperty()
		 * @generated
		 */
		EClass DECORATED_PROPERTY = eINSTANCE.getDecoratedProperty();

		/**
		 * The meta object literal for the '<em><b>Real Property</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DECORATED_PROPERTY__REAL_PROPERTY = eINSTANCE.getDecoratedProperty_RealProperty();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.RealPropertyImpl <em>Real Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.RealPropertyImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getRealProperty()
		 * @generated
		 */
		EClass REAL_PROPERTY = eINSTANCE.getRealProperty();

		/**
		 * The meta object literal for the '<em><b>Data Table Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__DATA_TABLE_NAME = eINSTANCE.getRealProperty_DataTableName();

		/**
		 * The meta object literal for the '<em><b>Address Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__ADDRESS_OFFSET = eINSTANCE.getRealProperty_AddressOffset();

		/**
		 * The meta object literal for the '<em><b>Default Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__DEFAULT_VALUE = eINSTANCE.getRealProperty_DefaultValue();

		/**
		 * The meta object literal for the '<em><b>Driver Address</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__DRIVER_ADDRESS = eINSTANCE.getRealProperty_DriverAddress();

		/**
		 * The meta object literal for the '<em><b>User Defined Address Object</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__USER_DEFINED_ADDRESS_OBJECT = eINSTANCE.getRealProperty_UserDefinedAddressObject();

		/**
		 * The meta object literal for the '<em><b>Persistent</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__PERSISTENT = eINSTANCE.getRealProperty_Persistent();

		/**
		 * The meta object literal for the '<em><b>Dirty</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__DIRTY = eINSTANCE.getRealProperty_Dirty();

		/**
		 * The meta object literal for the '<em><b>Dummy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY__DUMMY = eINSTANCE.getRealProperty_Dummy();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl <em>Scaled Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.ScaledPropertyImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getScaledProperty()
		 * @generated
		 */
		EClass SCALED_PROPERTY = eINSTANCE.getScaledProperty();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.AliasPropertyImpl <em>Alias Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.AliasPropertyImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getAliasProperty()
		 * @generated
		 */
		EClass ALIAS_PROPERTY = eINSTANCE.getAliasProperty();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyInt32Impl <em>Property Int32</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyInt32Impl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyInt32()
		 * @generated
		 */
		EClass PROPERTY_INT32 = eINSTANCE.getPropertyInt32();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyFloatImpl <em>Property Float</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyFloatImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyFloat()
		 * @generated
		 */
		EClass PROPERTY_FLOAT = eINSTANCE.getPropertyFloat();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.DataTableImpl <em>Data Table</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.DataTableImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDataTable()
		 * @generated
		 */
		EClass DATA_TABLE = eINSTANCE.getDataTable();

		/**
		 * The meta object literal for the '<em><b>Device</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_TABLE__DEVICE = eINSTANCE.getDataTable_Device();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_TABLE__PROPERTIES = eINSTANCE.getDataTable_Properties();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_TABLE__NAME = eINSTANCE.getDataTable_Name();

		/**
		 * The meta object literal for the '<em><b>Byte Buffer</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_TABLE__BYTE_BUFFER = eINSTANCE.getDataTable_ByteBuffer();

		/**
		 * The meta object literal for the '<em><b>Absolute Address</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_TABLE__ABSOLUTE_ADDRESS = eINSTANCE.getDataTable_AbsoluteAddress();

		/**
		 * The meta object literal for the '<em><b>Dirty</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_TABLE__DIRTY = eINSTANCE.getDataTable_Dirty();

		/**
		 * The meta object literal for the '<em><b>Writable</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_TABLE__WRITABLE = eINSTANCE.getDataTable_Writable();

		/**
		 * The meta object literal for the '<em><b>Dummy</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_TABLE__DUMMY = eINSTANCE.getDataTable_Dummy();

		/**
		 * The meta object literal for the '<em><b>Observer Notification Enabled</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_TABLE__OBSERVER_NOTIFICATION_ENABLED = eINSTANCE.getDataTable_ObserverNotificationEnabled();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyByteImpl <em>Property Byte</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyByteImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyByte()
		 * @generated
		 */
		EClass PROPERTY_BYTE = eINSTANCE.getPropertyByte();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyTextImpl <em>Property Text</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyTextImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyText()
		 * @generated
		 */
		EClass PROPERTY_TEXT = eINSTANCE.getPropertyText();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyDoubleImpl <em>Property Double</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyDoubleImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyDouble()
		 * @generated
		 */
		EClass PROPERTY_DOUBLE = eINSTANCE.getPropertyDouble();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.DriverImpl <em>Driver</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.DriverImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDriver()
		 * @generated
		 */
		EClass DRIVER = eINSTANCE.getDriver();

		/**
		 * The meta object literal for the '<em><b>Device</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DRIVER__DEVICE = eINSTANCE.getDriver_Device();

		/**
		 * The meta object literal for the '<em><b>Address</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DRIVER__ADDRESS = eINSTANCE.getDriver_Address();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyShort16Impl <em>Property Short16</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyShort16Impl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyShort16()
		 * @generated
		 */
		EClass PROPERTY_SHORT16 = eINSTANCE.getPropertyShort16();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.Observer <em>Observer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.Observer
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getObserver()
		 * @generated
		 */
		EClass OBSERVER = eINSTANCE.getObserver();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.Observable <em>Observable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.Observable
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getObservable()
		 * @generated
		 */
		EClass OBSERVABLE = eINSTANCE.getObservable();

		/**
		 * The meta object literal for the '<em><b>Observers</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVABLE__OBSERVERS = eINSTANCE.getObservable_Observers();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.GroupPropertyImpl <em>Group Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.GroupPropertyImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getGroupProperty()
		 * @generated
		 */
		EClass GROUP_PROPERTY = eINSTANCE.getGroupProperty();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GROUP_PROPERTY__PROPERTIES = eINSTANCE.getGroupProperty_Properties();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.RealPropertyDAO <em>Real Property DAO</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.RealPropertyDAO
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getRealPropertyDAO()
		 * @generated
		 */
		EClass REAL_PROPERTY_DAO = eINSTANCE.getRealPropertyDAO();

		/**
		 * The meta object literal for the '<em><b>Connection</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY_DAO__CONNECTION = eINSTANCE.getRealPropertyDAO_Connection();

		/**
		 * The meta object literal for the '<em><b>Timestamp</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_PROPERTY_DAO__TIMESTAMP = eINSTANCE.getRealPropertyDAO_Timestamp();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.RealPropertyDAO_PostgresImpl <em>Real Property DAO Postgres</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.RealPropertyDAO_PostgresImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getRealPropertyDAO_Postgres()
		 * @generated
		 */
		EClass REAL_PROPERTY_DAO_POSTGRES = eINSTANCE.getRealPropertyDAO_Postgres();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.Persistable <em>Persistable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.Persistable
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPersistable()
		 * @generated
		 */
		EClass PERSISTABLE = eINSTANCE.getPersistable();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.Scalable <em>Scalable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.Scalable
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getScalable()
		 * @generated
		 */
		EClass SCALABLE = eINSTANCE.getScalable();

		/**
		 * The meta object literal for the '<em><b>Factor</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALABLE__FACTOR = eINSTANCE.getScalable_Factor();

		/**
		 * The meta object literal for the '<em><b>Offset</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALABLE__OFFSET = eINSTANCE.getScalable_Offset();

		/**
		 * The meta object literal for the '<em><b>Precision</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALABLE__PRECISION = eINSTANCE.getScalable_Precision();

		/**
		 * The meta object literal for the '<em><b>Decimal Places</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCALABLE__DECIMAL_PLACES = eINSTANCE.getScalable_DecimalPlaces();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.impl.PropertyNumericImpl <em>Property Numeric</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.impl.PropertyNumericImpl
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getPropertyNumeric()
		 * @generated
		 */
		EClass PROPERTY_NUMERIC = eINSTANCE.getPropertyNumeric();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.TineAccess <em>Tine Access</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.TineAccess
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTineAccess()
		 * @generated
		 */
		EEnum TINE_ACCESS = eINSTANCE.getTineAccess();

		/**
		 * The meta object literal for the '{@link ch.thomson.ucs.tine.server.ByteOrder <em>Byte Order</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.ByteOrder
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getByteOrder()
		 * @generated
		 */
		EEnum BYTE_ORDER = eINSTANCE.getByteOrder();

		/**
		 * The meta object literal for the '<em>TEquipment Module Factory</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.desy.tine.server.equipment.TEquipmentModuleFactory
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTEquipmentModuleFactory()
		 * @generated
		 */
		EDataType TEQUIPMENT_MODULE_FACTORY = eINSTANCE.getTEquipmentModuleFactory();

		/**
		 * The meta object literal for the '<em>TEquipment Module</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.desy.tine.server.equipment.TEquipmentModule
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTEquipmentModule()
		 * @generated
		 */
		EDataType TEQUIPMENT_MODULE = eINSTANCE.getTEquipmentModule();

		/**
		 * The meta object literal for the '<em>TDevice</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.desy.tine.server.devices.TDevice
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTDevice()
		 * @generated
		 */
		EDataType TDEVICE = eINSTANCE.getTDevice();

		/**
		 * The meta object literal for the '<em>TExport Property</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.desy.tine.server.properties.TExportProperty
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTExportProperty()
		 * @generated
		 */
		EDataType TEXPORT_PROPERTY = eINSTANCE.getTExportProperty();

		/**
		 * The meta object literal for the '<em>TProperty Handler</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.desy.tine.server.properties.TPropertyHandler
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTPropertyHandler()
		 * @generated
		 */
		EDataType TPROPERTY_HANDLER = eINSTANCE.getTPropertyHandler();

		/**
		 * The meta object literal for the '<em>TEquipment Background Task</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.desy.tine.server.equipment.TEquipmentBackgroundTask
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTEquipmentBackgroundTask()
		 * @generated
		 */
		EDataType TEQUIPMENT_BACKGROUND_TASK = eINSTANCE.getTEquipmentBackgroundTask();

		/**
		 * The meta object literal for the '<em>Object</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.lang.Object
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getObject()
		 * @generated
		 */
		EDataType OBJECT = eINSTANCE.getObject();

		/**
		 * The meta object literal for the '<em>Exception</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.lang.Exception
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getException()
		 * @generated
		 */
		EDataType EXCEPTION = eINSTANCE.getException();

		/**
		 * The meta object literal for the '<em>TData Type</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.desy.tine.dataUtils.TDataType
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTDataType()
		 * @generated
		 */
		EDataType TDATA_TYPE = eINSTANCE.getTDataType();

		/**
		 * The meta object literal for the '<em>DB Connection</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.sql.Connection
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDBConnection()
		 * @generated
		 */
		EDataType DB_CONNECTION = eINSTANCE.getDBConnection();

		/**
		 * The meta object literal for the '<em>Timestamp</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.sql.Timestamp
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getTimestamp()
		 * @generated
		 */
		EDataType TIMESTAMP = eINSTANCE.getTimestamp();

		/**
		 * The meta object literal for the '<em>Byte Buffer</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.nio.ByteBuffer
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getByteBuffer()
		 * @generated
		 */
		EDataType BYTE_BUFFER = eINSTANCE.getByteBuffer();

		/**
		 * The meta object literal for the '<em>Device Update Listener</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see ch.thomson.ucs.tine.server.internal.client.DeviceUpdateListener
		 * @see ch.thomson.ucs.tine.server.impl.ServerPackageImpl#getDeviceUpdateListener()
		 * @generated
		 */
		EDataType DEVICE_UPDATE_LISTENER = eINSTANCE.getDeviceUpdateListener();

	}

} //ServerPackage
